/* 
	Mango Paola Ajedrez 2.0
	Licencia: GPLv3   
    	Copyright (c) 2012-2013 - Mango Computer c.a 

    	El Programa Mango Paola Ajedrez ésta basado en la investigación de Jose Andres Morales Linares.

	Nadie debería estar restringido por el software que utilizan. Hay cuatro libertades que cada usuario debe tener:
	* La libertad de usar el programa para cualquier propósito,
	* La libertad de cambiar el software para satisfacer sus necesidades,
	* La libertad de compartir el software con sus amigos y vecinos.
	* La libertad de compartir los cambios que realice.

	Cuando un programa se ofrece a los usuarios todas estas libertades, lo llamamos software libre.

	El programa es software libre. Usted puede redistribuirlo y/o modificarlo bajo los términos de la Licencia Pública 
	General de GNU según es publicada por la Free Software Foundation, bien de la versión 3 de la Licencia, o (a su elección)
	cualquier versión posterior. El programa se distribuye con la esperanza de que sea útil, pero SIN NINGUNA GARANTÍA, incluso
	sin la garantía implícita de COMERCIALIZACIÓN o IDONEIDAD PARA UN PROPÓSITO PARTICULAR. Vea la Licencia Pública General de GNU
	para más detalles: http://www.gnu.org/licenses/

	Existen muchos avances en la forma de escribir motores de ajedrez, estos dos sitios web 
	fueron de mucha ayuda durante el proceso de investigación y desarrollo. 
	* http://chessprogramming.wikispaces.com
	* https://sites.google.com/site/danasah/
    	* http://www.sluijten.com/winglet/

    	Información de contacto:
	comprasmangocomputer@gmail.com
	http://mangocomputerca.blogspot.com/
*/

#ifndef DATA_H
#define DATA_H


// PARTE GRAFICA
 typedef char strNivel[8];
 strNivel pcNivel2str[9] = {"Nivel-0","Nivel-1","Nivel-2","Nivel-3","Nivel-4","Nivel-5","Nivel-6","Nivel-7","Nivel-8"};

 TABLERO tableroVista2     = TABLERO_VISTA_INICIAL;
 char NUM2ALG[64][2]       = {
				 	/* 0 */{'a','1'},
					/* 1 */{'b','1'},
					/* 2 */{'c','1'},
					/* 3 */{'d','1'},
					/* 4 */{'e','1'},
					/* 5 */{'f','1'},
					/* 6 */{'g','1'},
					/* 7 */{'h','1'},
					/* 8 */{'a','2'},
					/* 9 */{'b','2'},
					/* 10*/{'c','2'},
					/* 11*/{'d','2'},
					/* 12*/{'e','2'},
					/* 13*/{'f','2'},
					/* 14*/{'g','2'},
					/* 15*/{'h','2'},
					/* 16*/{'a','3'},
					/* 17*/{'b','3'},
					/* 18*/{'c','3'},
					/* 19*/{'d','3'},
					/* 20*/{'e','3'},
					/* 21*/{'f','3'},
					/* 22*/{'g','3'},
					/* 23*/{'h','3'},
					/* 24*/{'a','4'},
					/* 25*/{'b','4'},
					/* 26*/{'c','4'},
					/* 27*/{'d','4'},
					/* 28*/{'e','4'},
					/* 29*/{'f','4'},
					/* 30*/{'g','4'},
					/* 31*/{'h','4'},
					/* 32*/{'a','5'},
					/* 33*/{'b','5'},
					/* 34*/{'c','5'},
					/* 35*/{'d','5'},
					/* 36*/{'e','5'},
					/* 37*/{'f','5'},
					/* 38*/{'g','5'},
					/* 39*/{'h','5'},
					/* 40*/{'a','6'},
					/* 41*/{'b','6'},
					/* 42*/{'c','6'},
					/* 43*/{'d','6'},
					/* 44*/{'e','6'},
					/* 45*/{'f','6'},
					/* 46*/{'g','6'},
					/* 47*/{'h','6'},
					/* 48*/{'a','7'},
					/* 49*/{'b','7'},
					/* 50*/{'c','7'},
					/* 51*/{'d','7'},
					/* 52*/{'e','7'},
					/* 53*/{'f','7'},
					/* 54*/{'g','7'},
					/* 55*/{'h','7'},
					/* 56*/{'a','8'},
					/* 57*/{'b','8'},
					/* 58*/{'c','8'},
					/* 59*/{'d','8'},
					/* 60*/{'e','8'},
					/* 61*/{'f','8'},
					/* 62*/{'g','8'},
					/* 63*/{'h','8'}
							};

// FIN PARTE GRAFICA

int adjuste_caballo[9] = { -20, -16, -12, -8, -4, 0,  4,  8, 12};
int adjuste_torre[9]   = {  15,  12,   9,  6,  3, 0, -3, -6, -9};
int margen_poda[8]     = { 0, 120, 140, 310, 310, 400, 400, 500};
//int margen_poda[4] = { 0, 120, 140, 160 };

uint32 septimoRank[2] = {7,2};
uint32 sextoRank[2] = {6,3};


uint64 tableroBitRank8[2]	= {0xff00000000000000ull, 0xffull};
uint64 posIniDamaNegra 		= 0x800000000000000ull;

uint64 tableroCentral 		= 0x3c3c3c3c0000ull;
uint64 tableroExterior 		= 0xffffc3c3c3c3ffffull;

uint64 MASCARA_MOV_CA[4] = {0xFF818181818181FFull, 0x007E424242427E00ull, 0x00003C24243C0000ull, 0x0000001818000000ull};
uint64 MASCARA_MOV_T[4]  = {0x8181818181818181ull, 0x4242424242424242ull,0x2424242424242424ull, 0x1818181818181818ull};


uint64 mascaraABCD 			= 0xf0f0f0f0f0f0f0full;
uint64 mascaraEFGH 			= 0xf0f0f0f0f0f0f0f0ull;
uint64 mascaraABC  			= 0x707070707070707ull; //FILEBIT[1] | FILEBIT[2] | FILEBIT[3];
uint64 mascaraFGH  			= 0xe0e0e0e0e0e0e0e0ull; //FILEBIT[8] | FILEBIT[7] | FILEBIT[6];
uint64 mascaraSinPeonTorre 		= 0x007e7e7e7e7e7e00ull;

TABLERO ESCAQUES = {
0x6,0x3,0x5,0x7,0x2,0x5,0x3,0x6,
0x1,0x1,0x1,0x1,0x1,0x1,0x1,0x1,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0x9,0x9,0x9,0x9,0x9,0x9,0x9,0x9,
0xe,0xb,0xd,0xf,0xa,0xd,0xb,0xe};

TABLERO ESCAQUES_INI = {
0x6,0x3,0x5,0x7,0x2,0x5,0x3,0x6,
0x1,0x1,0x1,0x1,0x1,0x1,0x1,0x1,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0x9,0x9,0x9,0x9,0x9,0x9,0x9,0x9,
0xe,0xb,0xd,0xf,0xa,0xd,0xb,0xe};

 char* NOMBRENIVELPC[4]  = {"Facil","Medio","Fuerte","Personalizado"};

 char* NOMBREPIEZA[16]  = {"  ","P ","R ","C ","  ","A ","T ","D ","  ","P*","R*","C*","  ","A*","T*","D*"};
 uint32 VALORPIEZA[16]  = {0,VALOR_PEON,VALOR_REY,VALOR_CABALLO,0,VALOR_ALFIL,VALOR_TORRE,VALOR_DAMA,0,
					VALOR_PEON,VALOR_REY,VALOR_CABALLO,0,VALOR_ALFIL,VALOR_TORRE,VALOR_DAMA};

 int VALORPIEZA_FASE[16]  = {0,1,10,3,0,3,5,9,0,
					1,10,3,0,3,5,9};

 uint32 COLORPIEZA[16]  = {0,BLANCO,BLANCO,BLANCO,0,BLANCO,BLANCO,BLANCO,0,
					NEGRO,NEGRO,NEGRO,0,NEGRO,NEGRO,NEGRO};


 char* NOMBRE_ESCAQUES[64] = {"a1","b1","c1","d1","e1","f1","g1","h1",
                           	   "a2","b2","c2","d2","e2","f2","g2","h2",
                           	   "a3","b3","c3","d3","e3","f3","g3","h3",
                           	   "a4","b4","c4","d4","e4","f4","g4","h4",
                           	   "a5","b5","c5","d5","e5","f5","g5","h5",
                           	   "a6","b6","c6","d6","e6","f6","g6","h6",
                           	   "a7","b7","c7","d7","e7","f7","g7","h7",
                           	   "a8","b8","c8","d8","e8","f8","g8","h8"};

  uint64 mascaraEnroque[2][2]  	= {{0x60ull, 0xeull}, {0x6000000000000000ull, 0xe00000000000000ull}};
  uint64 mascaraEnroqueMovRey[2][2] = {{0x70ull, 0x1cull},{0x7000000000000000ull, 0x1c00000000000000ull}}; 

  uint32 ENROQUE_BLANCO_OO	= 0x2002184;
  uint32 ENROQUE_BLANCO_OOO	= 0x3002084;
  uint32 ENROQUE_NEGRO_OO	= 0x200afbc; 
  uint32 ENROQUE_NEGRO_OOO	= 0x300aebc; 

 uint64 noAcol 		= 0xfefefefefefefefeull; // ~0x0101010101010101
 uint64 noHcol 		= 0x7f7f7f7f7f7f7f7full; // ~0x8080808080808080
 uint64 debruijn64  	= 0x07EDD5E59A4E28C2ull;
 uint64 ESCAQUES_BLANCOS= 0x55aa55aa55aa55aaull;
 uint64 ESCAQUES_NEGROS	= 0xaa55aa55aa55aa55ull;
int esquinaNegra[2]	= {8,1};
int esquinaBlanca[2]	= {1,8};


 uint8 POS2COLUMNAC[64] = {
				97,98,99,100,101,102,103,104,	
				97,98,99,100,101,102,103,104,	
				97,98,99,100,101,102,103,104,	
				97,98,99,100,101,102,103,104,	
				97,98,99,100,101,102,103,104,	
				97,98,99,100,101,102,103,104,	
				97,98,99,100,101,102,103,104,	
				97,98,99,100,101,102,103,104};	

 uint8 POS2FILAC[64] = {
				49,49,49,49,49,49,49,49,	
				50,50,50,50,50,50,50,50,	
				51,51,51,51,51,51,51,51,	
				52,52,52,52,52,52,52,52,	
				53,53,53,53,53,53,53,53,	
				54,54,54,54,54,54,54,54,	
				55,55,55,55,55,55,55,55,	
				56,56,56,56,56,56,56,56};	


  uint32 FILES[64] = {
       1, 2, 3, 4, 5, 6, 7, 8,
       1, 2, 3, 4, 5, 6, 7, 8,
       1, 2, 3, 4, 5, 6, 7, 8,
       1, 2, 3, 4, 5, 6, 7, 8,
       1, 2, 3, 4, 5, 6, 7, 8,
       1, 2, 3, 4, 5, 6, 7, 8,
       1, 2, 3, 4, 5, 6, 7, 8,
       1, 2, 3, 4, 5, 6, 7, 8
};

int CONVER_RANKS[2][9] = {{0,1,2,3,4,5,6,7,8},{0,8,7,6,5,4,3,2,1}};
 
  uint32 RANKS[64] = {
       1, 1, 1, 1, 1, 1, 1, 1,
       2, 2, 2, 2, 2, 2, 2, 2,
       3, 3, 3, 3, 3, 3, 3, 3,
       4, 4, 4, 4, 4, 4, 4, 4,
       5, 5, 5, 5, 5, 5, 5, 5,
       6, 6, 6, 6, 6, 6, 6, 6,
       7, 7, 7, 7, 7, 7, 7, 7,
       8, 8, 8, 8, 8, 8, 8, 8
};

int DIR[2] ={8,-8};

  uint32 POSCORONACION[2][64] = {{
					      56,57,58,59,60,61,62,63,
					      56,57,58,59,60,61,62,63,
					      56,57,58,59,60,61,62,63,
					      56,57,58,59,60,61,62,63,
					      56,57,58,59,60,61,62,63, /*Blancas*/
					      56,57,58,59,60,61,62,63,
					      56,57,58,59,60,61,62,63,
					      56,57,58,59,60,61,62,63},{
					       0, 1, 2, 3, 4, 5, 6, 7,
					       0, 1, 2, 3, 4, 5, 6, 7,
					       0, 1, 2, 3, 4, 5, 6, 7,
					       0, 1, 2, 3, 4, 5, 6, 7, /*Negras*/
					       0, 1, 2, 3, 4, 5, 6, 7,
					       0, 1, 2, 3, 4, 5, 6, 7,
					       0, 1, 2, 3, 4, 5, 6, 7,
					       0, 1, 2, 3, 4, 5, 6, 7}};

  uint32 POSRANK7[2][64] = {{
					      48,49,50,51,52,53,54,55,
					      48,49,50,51,52,53,54,55,
					      48,49,50,51,52,53,54,55,
					      48,49,50,51,52,53,54,55,
					      48,49,50,51,52,53,54,55,
					      48,49,50,51,52,53,54,55,
					      48,49,50,51,52,53,54,55,
					      48,49,50,51,52,53,54,55},{
					       8, 9,10,11,12,13,14,15,
					       8, 9,10,11,12,13,14,15,
					       8, 9,10,11,12,13,14,15,
					       8, 9,10,11,12,13,14,15,
					       8, 9,10,11,12,13,14,15,
					       8, 9,10,11,12,13,14,15,
					       8, 9,10,11,12,13,14,15,
					       8, 9,10,11,12,13,14,15}};

 uint64 FILEBIT[9] = {0, 0x101010101010101ull,  0x202020202020202ull,  0x404040404040404ull,  0x808080808080808ull,
		         0x1010101010101010ull, 0x2020202020202020ull, 0x4040404040404040ull, 0x8080808080808080ull};

 uint64 FILEBITMAP[64] = 
{0x101010101010101ull,0x202020202020202ull,0x404040404040404ull,0x808080808080808ull,0x1010101010101010ull,0x2020202020202020ull, 0x4040404040404040ull, 0x8080808080808080ull,
0x101010101010101ull,0x202020202020202ull,0x404040404040404ull,0x808080808080808ull,0x1010101010101010ull,0x2020202020202020ull, 0x4040404040404040ull, 0x8080808080808080ull,
0x101010101010101ull,0x202020202020202ull,0x404040404040404ull,0x808080808080808ull,0x1010101010101010ull,0x2020202020202020ull, 0x4040404040404040ull, 0x8080808080808080ull,
0x101010101010101ull,0x202020202020202ull,0x404040404040404ull,0x808080808080808ull,0x1010101010101010ull,0x2020202020202020ull, 0x4040404040404040ull, 0x8080808080808080ull,
0x101010101010101ull,0x202020202020202ull,0x404040404040404ull,0x808080808080808ull,0x1010101010101010ull,0x2020202020202020ull, 0x4040404040404040ull, 0x8080808080808080ull,
0x101010101010101ull,0x202020202020202ull,0x404040404040404ull,0x808080808080808ull,0x1010101010101010ull,0x2020202020202020ull, 0x4040404040404040ull, 0x8080808080808080ull,
0x101010101010101ull,0x202020202020202ull,0x404040404040404ull,0x808080808080808ull,0x1010101010101010ull,0x2020202020202020ull, 0x4040404040404040ull, 0x8080808080808080ull,
0x101010101010101ull,0x202020202020202ull,0x404040404040404ull,0x808080808080808ull,0x1010101010101010ull,0x2020202020202020ull, 0x4040404040404040ull, 0x8080808080808080ull};



 uint64 RANKBIT[9] = {0, 0xffull,	       0xff00ull,	 0xff0000ull,	 	0xff000000ull,
				     0xff00000000ull,  0xff0000000000ull,0xff000000000000ull,   0xff00000000000000ull};

 uint64 mas8dir[64] = {
0x101010101010100ull,0x202020202020200ull,0x404040404040400ull,0x808080808080800ull,0x1010101010101000ull,0x2020202020202000ull,0x4040404040404000ull,0x8080808080808000ull,
0x101010101010000ull,0x202020202020000ull,0x404040404040000ull,0x808080808080000ull,0x1010101010100000ull,0x2020202020200000ull,0x4040404040400000ull,0x8080808080800000ull,
0x101010101000000ull,0x202020202000000ull,0x404040404000000ull,0x808080808000000ull,0x1010101010000000ull,0x2020202020000000ull,0x4040404040000000ull,0x8080808080000000ull,
0x101010100000000ull,0x202020200000000ull,0x404040400000000ull,0x808080800000000ull,0x1010101000000000ull,0x2020202000000000ull,0x4040404000000000ull,0x8080808000000000ull,
0x101010000000000ull,0x202020000000000ull,0x404040000000000ull,0x808080000000000ull,0x1010100000000000ull,0x2020200000000000ull,0x4040400000000000ull,0x8080800000000000ull,
0x101000000000000ull,0x202000000000000ull,0x404000000000000ull,0x808000000000000ull,0x1010000000000000ull,0x2020000000000000ull,0x4040000000000000ull,0x8080000000000000ull,
0x100000000000000ull,0x200000000000000ull,0x400000000000000ull,0x800000000000000ull,0x1000000000000000ull,0x2000000000000000ull,0x4000000000000000ull,0x8000000000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull};

 uint64 menos8dir[64] = {
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x1ull,0x2ull,0x4ull,0x8ull,0x10ull,0x20ull,0x40ull,0x80ull,
0x101ull,0x202ull,0x404ull,0x808ull,0x1010ull,0x2020ull,0x4040ull,0x8080ull,
0x10101ull,0x20202ull,0x40404ull,0x80808ull,0x101010ull,0x202020ull,0x404040ull,0x808080ull,
0x1010101ull,0x2020202ull,0x4040404ull,0x8080808ull,0x10101010ull,0x20202020ull,0x40404040ull,0x80808080ull,
0x101010101ull,0x202020202ull,0x404040404ull,0x808080808ull,0x1010101010ull,0x2020202020ull,0x4040404040ull,0x8080808080ull,
0x10101010101ull,0x20202020202ull,0x40404040404ull,0x80808080808ull,0x101010101010ull,0x202020202020ull,0x404040404040ull,0x808080808080ull,
0x1010101010101ull,0x2020202020202ull,0x4040404040404ull,0x8080808080808ull,0x10101010101010ull,0x20202020202020ull,0x40404040404040ull,0x80808080808080ull};


 char num2charFiles[64] 	= {
			   97, 98, 99, 100, 101, 102, 103, 104,
			   97, 98, 99, 100, 101, 102, 103, 104,
			   97, 98, 99, 100, 101, 102, 103, 104,
			   97, 98, 99, 100, 101, 102, 103, 104,
			   97, 98, 99, 100, 101, 102, 103, 104,
			   97, 98, 99, 100, 101, 102, 103, 104,
			   97, 98, 99, 100, 101, 102, 103, 104,
			   97, 98, 99, 100, 101, 102, 103, 104};

 char num2charRank[64] 	= {
			   49, 49, 49, 49, 49, 49, 49, 49,
			   50, 50, 50, 50, 50, 50, 50, 50,
			   51, 51, 51, 51, 51, 51, 51, 51,
			   52, 52, 52, 52, 52, 52, 52, 52,
			   53, 53, 53, 53, 53, 53, 53, 53,
			   54, 54, 54, 54, 54, 54, 54, 54,
			   55, 55, 55, 55, 55, 55, 55, 55, 
			   56, 56, 56, 56, 56, 56, 56, 56}; 


 uint64 bitTableroCentral	= 0x1818000000ull; 

int imbalance[9][9] = {
/* n=-4  n=-3  n=-2  n=-1   n=0  n=+1  n=+2  n=+3 +n=+4 */
  {-126, -126, -126, -126, -126, -126, -126, -126,  -42 }, /* R=-4 */
  {-126, -126, -126, -126, -126, -126, -126,  -42,   42 }, /* R=-3 */
  {-126, -126, -126, -126, -126, -126,  -42,   42,   84 }, /* R=-2 */
  {-126, -126, -126, -126, -104,  -42,   42,   84,  126 }, /* R=-1 */
  {-126, -126, -126,  -88,    0,   88,  126,  126,  126 }, /*  R=0 */
  {-126,  -84,  -42,   42,  104,  126,  126,  126,  126 }, /* R=+1 */
  { -84,  -42,   42,  126,  126,  126,  126,  126,  126 }, /* R=+2 */
  { -42,   42,  126,  126,  126,  126,  126,  126,  126 }, /* R=+3 */
  {  42,  126,  126,  126,  126,  126,  126,  126,  126 }  /* R=+4 */
};

int peon_pasado_candidato[2][2][8] = {
 {{ 0,  4,  4,  8, 16, 36,  0, 0 },         //Blanco Medio
  { 0,  0, 36, 16,  8,  4,  4, 0 }},        //Negro Medio
 {{ 0,  9,  9, 16, 32, 48,  0, 0 },         //Blanco Final
  { 0,  0, 48, 32, 16,  9,  9, 0 }}         //Negro Final
};

const char alfil_mate_escaques_negros[64] = {
  99, 90, 80, 70, 60, 50, 40, 30,
  90, 80, 70, 60, 50, 40, 30, 40,
  80, 70, 60, 50, 40, 30, 40, 50,
  70, 60, 50, 40, 30, 40, 50, 60,
  60, 50, 40, 30, 40, 50, 60, 70,
  50, 40, 30, 40, 50, 60, 70, 80,
  40, 30, 40, 50, 60, 70, 80, 90,
  30, 40, 50, 60, 70, 80, 90, 99
};
const char alfil_mate_escaques_blancos[64] = {
  30, 40, 50, 60, 70, 80, 90, 99,
  40, 30, 40, 50, 60, 70, 80, 90,
  50, 40, 30, 40, 50, 60, 70, 80,
  60, 50, 40, 30, 40, 50, 60, 70,
  70, 60, 50, 40, 30, 40, 50, 60,
  80, 70, 60, 50, 40, 30, 40, 50,
  90, 80, 70, 60, 50, 40, 30, 40,
  99, 90, 80, 70, 60, 50, 40, 30
};
const int mate[64] = {
  200, 180, 160, 140, 140, 160, 180, 200,
  180, 160, 140, 120, 120, 140, 160, 180,
  160, 140, 120, 100, 100, 120, 140, 160,
  140, 120, 100, 100, 100, 100, 120, 140,
  140, 120, 100, 100, 100, 100, 120, 140,
  160, 140, 120, 100, 100, 120, 140, 160,
  180, 160, 140, 120, 120, 140, 160, 180,
  200, 180, 160, 140, 140, 160, 180, 200
};


int peon_pasado_escondido[2] = { 0, 40 };

int defectos_fila_abierta[9] = { 0, 6, 5, 4, 4, 4, 4, 5, 6 };
int defectos_media_fila_abierta[9] = { 0, 4, 4, 3, 3, 3, 3, 4, 4 };

int torre_7rank[2] 		= { 25, 35 };
int torre_fila_abierta[2] 	= { 35, 20 };
int torre_media_fila_abierta[2] = { 10, 10 };
int torre_detras_peon_pasado[2] = { 10, 36 };
int alfil_peon_ganador[2] 	= { 18, 36 };


int defectos_peon[2][9] = {
  { 0,0, 0, 3, 2, 1, 0, 0, 0 },                /* [white][8] */
  { 0,0, 0, 0, 1, 2, 3, 0, 0 }                /* [black][8] */
};


int BONO_TURNO[2] = { 5, 8 };

 int CABALLO_PUESTO_AVANZADA[2][64]	= {{
						    0, 0, 0, 0, 0, 0, 0, 0,
						    0, 0, 0, 0, 0, 0, 0, 0,
						    0, 0, 0, 0, 0, 0, 0, 0,
						    0, 1, 4, 4, 4, 4, 1, 0,
						    0, 2, 6, 8, 8, 6, 2, 0,   
						    0, 1, 4, 4, 4, 4, 1, 0,
						    0, 0, 0, 0, 0, 0, 0, 0,
						    0, 0, 0, 0, 0, 0, 0, 0},{
						    0, 0, 0, 0, 0, 0, 0, 0,
						    0, 0, 0, 0, 0, 0, 0, 0,
						    0, 1, 4, 4, 4, 4, 1, 0,
						    0, 2, 6, 8, 8, 6, 2, 0,
						    0, 1, 4, 4, 4, 4, 1, 0,   
						    0, 0, 0, 0, 0, 0, 0, 0,
						    0, 0, 0, 0, 0, 0, 0, 0,
						    0, 0, 0, 0, 0, 0, 0, 0}};

 int ALFIL_PUESTO_AVANZADA[2][64]	= {{
						    0, 0, 0, 0, 0, 0, 0, 0,
						    0, 0, 0, 0, 0, 0, 0, 0,
						    0, 1, 2, 2, 2, 2, 1, 0,
						    0, 3, 5, 5, 5, 5, 3, 0,
						    0, 1, 3, 3, 3, 3, 1, 0,   
						    0, 0, 1, 1, 1, 1, 0, 0,
						   -1, 0, 0, 0, 0, 0, 0,-1,
						    0, 0, 0, 0, 0, 0, 0, 0},{
						    0, 0, 0, 0, 0, 0, 0, 0,
						   -1, 0, 0, 0, 0, 0, 0,-1,
						    0, 0, 1, 1, 1, 1, 0, 0,
						    0, 1, 3, 3, 3, 3, 1, 0,
						    0, 3, 5, 5, 5, 5, 3, 0,   
						    0, 1, 2, 2, 2, 2, 1, 0,
						    0, 0, 0, 0, 0, 0, 0, 0,
						    0, 0, 0, 0, 0, 0, 0, 0}};
//*

int peon_duo[2] = { 4, 8 };
/*
 int PEON_DUO[2][64] = {{
	0, 0, 0, 0, 0, 0, 0, 0,
	2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2,
	3, 3, 3, 3, 3, 3, 3, 3,
	6, 6, 6, 6, 6, 6, 6, 6,
   	10,10,10,10,10,10,10,10,
	0, 0, 0, 0, 0, 0, 0, 0},{
	0, 0, 0, 0, 0, 0, 0, 0,
   	10,10,10,10,10,10,10,10,
	6, 6, 6, 6, 6, 6, 6, 6,
	3, 3, 3, 3, 3, 3, 3, 3,
	2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2,
	0, 0, 0, 0, 0, 0, 0, 0}};
//*/
//*
 int PEON_PUNTAJE_POS[2][64]	= {{
						 0,   0,   0,   0,   0,   0,   0,   0,
						 0,   0,   0,  -5,  -5,   0,   0,   0,
						 1,   2,   3,   4,   4,   3,   2,   1,
						 2,   4,   6,   8,   8,   6,   4,   2,
						 3,   6,   9,  12,  12,   9,   6,   3, //Blancas
						 4,   8,  12,  16,  16,  12,   8,   4,
						 5,  10,  15,  20,  20,  15,  10,   5,
						 0,   0,   0,   0,   0,   0,   0,   0},{
						 0,   0,   0,   0,   0,   0,   0,   0,
						 5,  10,  15,  20,  20,  15,  10,   5,
						 4,   8,  12,  16,  16,  12,   8,   4,
						 3,   6,   9,  12,  12,   9,   6,   3, //Negras
						 2,   4,   6,   8,   8,   6,   4,   2,
						 1,   2,   3,   4,   4,   3,   2,   1,
						 0,   0,   0,  -5,  -5,   0,   0,   0,
						 0,   0,   0,   0,   0,   0,   0,   0}};
 int CABALLO_PUNTAJE_POS[2][64]	= {{
						 -50, -40, -30, -25, -25, -30, -40, -50,
						 -35, -25, -15, -10, -10, -15, -25, -35,
						 -20, -10,   0,   5,   5,   0, -10, -20,
						 -10,   0,  10,  15,  15,  10,   0, -10, //Blanco
						  -5,   5,  15,  20,  20,  15,   5,  -5,
						  -5,   5,  15,  20,  20,  15,   5,  -5,
						 -20, -10,   0,   5,   5,   0, -10, -20,
						-135, -25, -15, -10, -10, -15, -25,-135},{
						-135, -25, -15, -10, -10, -15, -25,-135,
						 -20, -10,   0,   5,   5,   0, -10, -20,
						  -5,   5,  15,  20,  20,  15,   5,  -5, //Negro
						  -5,   5,  15,  20,  20,  15,   5,  -5,
						 -10,   0,  10,  15,  15,  10,   0, -10,
						 -20, -10,   0,   5,   5,   0, -10, -20,
						 -35, -25, -15, -10, -10, -15, -25, -35,
						 -50, -40, -30, -25, -25, -30, -40, -50}};

 int CABALLO_PUNTAJE_POS_FINAL[64]	= {
						 -40, -30, -20, -15, -15, -20, -30, -40,
						 -30, -20, -10,  -5,  -5, -10, -20, -30,
						 -20, -10,   0,   5,   5,   0, -10, -20,
						 -15,  -5,   5,  10,  10,   5,  -5, -15,
						 -15,  -5,   5,  10,  10,   5,  -5, -15,
						 -20, -10,   0,   5,   5,   0, -10, -20,
						 -30, -20, -10,  -5,  -5, -10, -20, -30,
						 -40, -30, -20, -15, -15, -20, -30, -40};

 int ALFIL_PUNTAJE_POS[2][64]	= {{
						 -18, -18, -16, -14, -14, -16, -18, -18,
						  -8,   0,  -2,   0,   0,  -2,   0,  -8,
						  -6,  -2,   4,   2,   2,   4,  -2,  -6,
						  -4,   0,   2,   8,   8,   2,   0,  -4, //Blanco
						  -4,   0,   2,   8,   8,   2,   0,  -4,
						  -6,  -2,   4,   2,   2,   4,  -2,  -6,
						  -8,   0,  -2,   0,   0,  -2,   0,  -8,
						  -8,  -8,  -6,  -4,  -4,  -6,  -8,  -8},{ 
						  -8,  -8,  -6,  -4,  -4,  -6,  -8,  -8,
						  -8,   0,  -2,   0,   0,  -2,   0,  -8,
						  -6,  -2,   4,   2,   2,   4,  -2,  -6,
						  -4,   0,   2,   8,   8,   2,   0,  -4, //Negro
						  -4,   0,   2,   8,   8,   2,   0,  -4,
						  -6,  -2,   4,   2,   2,   4,  -2,  -6,
						  -8,   0,  -2,   0,   0,  -2,   0,  -8,
						 -18, -18, -16, -14, -14, -16, -18, -18}};

 int ALFIL_PUNTAJE_POS_FINAL[64]	= {
						 -18, -12,  -9,  -6,  -6,  -9, -12, -18,
						 -12,  -6,  -3,   0,   0,  -3,  -6, -12,
						  -9,  -3,   0,   3,   3,   0,  -3,  -9,
						  -6,   0,   3,   6,   6,   3,   0,  -6,
						  -6,   0,   3,   6,   6,   3,   0,  -6,
						  -9,  -3,   0,   3,   3,   0,  -3,  -9,
						 -12,  -6,  -3,   0,   0,  -3,  -6, -12,
						 -18, -12,  -9,  -6,  -6,  -9, -12, -18};


int TORRE_PUNTAJE_POS[64]	= {
						  -6,  -3,   0,   3,   3,   0,  -3,  -6,
						  -6,  -3,   0,   3,   3,   0,  -3,  -6,
						  -6,  -3,   0,   3,   3,   0,  -3,  -6,
						  -6,  -3,   0,   3,   3,   0,  -3,  -6,
						  -6,  -3,   0,   3,   3,   0,  -3,  -6,
						  -6,  -3,   0,   3,   3,   0,  -3,  -6,
						  -6,  -3,   0,   3,   3,   0,  -3,  -6,
						  -6,  -3,   0,   3,   3,   0,  -3,  -6};

 int DAMA_PUNTAJE_POS[2][64] = {{
						  -5,  -5,  -5,  -5,  -5,  -5,  -5,  -5,
						   0,   0,   0,   0,   0,   0,   0,   0,
						   0,   0,   0,   0,   0,   0,   0,   0,
						   0,   0,   0,   0,   0,   0,   0,   0, //Blanco
						   0,   0,   0,   0,   0,   0,   0,   0,
						   0,   0,   0,   0,   0,   0,   0,   0,
						   0,   0,   0,   0,   0,   0,   0,   0,
						   0,   0,   0,   0,   0,   0,   0,   0},{
						   0,   0,   0,   0,   0,   0,   0,   0,
						   0,   0,   0,   0,   0,   0,   0,   0,
						   0,   0,   0,   0,   0,   0,   0,   0,
						   0,   0,   0,   0,   0,   0,   0,   0, //Negro
						   0,   0,   0,   0,   0,   0,   0,   0,
						   0,   0,   0,   0,   0,   0,   0,   0,
						   0,   0,   0,   0,   0,   0,   0,   0,
						  -5,  -5,  -5,  -5,  -5,  -5,  -5,  -5}};

 int DAMA_PUNTAJE_POS_FINAL[64] = {
						 -24, -16, -12,  -8,  -8, -12, -16, -24,
						 -16,  -8,  -4,   0,   0,  -4,  -8, -16,
						 -12,  -4,   0,   4,   4,   0,  -4, -12,
						  -8,   0,   4,   8,   8,   4,   0,  -8,
						  -8,   0,   4,   8,   8,   4,   0,  -8,
						 -12,  -4,   0,   4,   4,   0,  -4, -12,
						 -16,  -8,  -4,   0,   0,  -4,  -8, -16,
						 -24, -16, -12,  -8,  -8, -12, -16, -24};

 int REY_PUNTAJE_POS[2][64]	= {{
						  40,  50,  30,  10,  10,  30,  50,  40,
						  30,  40,  20,   0,   0,  20,  40,  30,
						  10,  20,   0, -20, -20,   0,  20,  10,
						 -10,   0, -20, -40, -40, -20,   0, -10,
						 -30, -20, -40, -60, -60, -40, -20, -30, 
						 -50, -40, -60, -80, -80, -60, -40, -50,
						 -70, -60, -80, -90, -90, -80, -60, -70,
						 -70, -60, -80, -90, -90, -80, -60, -70},{
						 -70, -60, -80, -90, -90, -80, -60, -70,
						 -70, -60, -80, -90, -90, -80, -60, -70,
						 -50, -40, -60, -80, -80, -60, -40, -50, 
						 -30, -20, -40, -60, -60, -40, -20, -30,
						 -10,   0, -20, -40, -40, -20,   0, -10,
						  10,  20,   0, -20, -20,   0,  20,  10,
						  30,  40,  20,   0,   0,  20,  40,  30,
						  40,  50,  30,  10,  10,  30,  50,  40}};


 int REY_PUNTAJE_POS_FINAL[64]	= {
						 -72, -48, -36, -24, -24, -36, -48, -72,
						 -48, -24, -12,   0,   0, -12, -24, -48,
						 -36, -12,   0,  12,  12,   0, -12, -36,
						 -24,   0,  12,  24,  24,  12,   0, -24,
						 -24,   0,  12,  24,  24,  12,   0, -24,
						 -36, -12,   0,  12,  12,   0, -12, -36,
						 -48, -24, -12,   0,   0, -12, -24, -48,
						 -72, -48, -36, -24, -24, -36, -48, -72};


//*/
/*
 int PEON_PUNTAJE_POS[2][64] = {{
      0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   0, -12, -12,   0,   0,   0,
      1,   1,   1,  10,  10,   1,   1,   1,
      3,   3,   3,  13,  13,   3,   3,   3,
      6,   6,   6,  16,  16,   6,   6,   6,   // [mg][white][64] 
     10,  10,  10,  30,  30,  10,  10,  10,
     66,  66,  66,  66,  66,  66,  66,  66,
      0,   0,   0,   0,   0,   0,   0,   0},{
      0,   0,   0,   0,   0,   0,   0,   0,
     66,  66,  66,  66,  66,  66,  66,  66,
     10,  10,  10,  30,  30,  10,  10,  10,
      6,   6,   6,  16,  16,   6,   6,   6,
      3,   3,   3,  13,  13,   3,   3,   3,   // [mg][black][64] 
      1,   1,   1,  10,  10,   1,   1,   1,
      0,   0,   0, -12, -12,   0,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0 }};

int CABALLO_PUNTAJE_POS[2][64] = 
  {{-19, -19, -19, -19, -19, -19, -19, -19,
      1,   2,   2,   2,   2,   2,   2,   1,
      1,   2,  19,  17,  17,  19,   2,   1,
      1,  12,  21,  24,  24,  21,  12,   1,
      1,  14,  23,  28,  28,  23,  14,   1,  
      1,  14,  23,  27,  27,  23,  14,   1,
      1,  12,  18,  22,  22,  18,  12,   1,
    -29, -19, -19,  -9,  -9, -19, -19, -29},

   {-29, -19, -19,  -9,  -9, -19, -19, -29,
      1,  12,  18,  22,  22,  18,  12,   1,
      1,  14,  23,  27,  27,  23,  14,   1,
      1,  14,  23,  28,  28,  23,  14,   1,
      1,  12,  21,  24,  24,  21,  12,   1,  
      1,   2,  19,  17,  17,  19,   2,   1,
      1,   2,   2,   2,   2,   2,   2,   1,
    -19, -19, -19, -19, -19, -19, -19, -19}};

 int ALFIL_PUNTAJE_POS[2][64] = 
  {{-10, -10,  -8,  -6,  -6,  -8, -10, -10,
      0,   8,   6,   8,   8,   6,   8,   0,
      2,   6,  12,  10,  10,  12,   6,   2,
      4,   8,  10,  16,  16,  10,   8,   4,
      4,   8,  10,  16,  16,  10,   8,   4,   
      2,   6,  12,  10,  10,  12,   6,   2,
      0,   8,   6,   8,   8,   6,   8,   0,
      0,   0,   2,   4,   4,   2,   0,   0},

    { 0,   0,   2,   4,   4,   2,   0,   0,
      0,   8,   6,   8,   8,   6,   8,   0,
      2,   6,  12,  10,  10,  12,   6,   2,
      4,   8,  10,  16,  16,  10,   8,   4,
      4,   8,  10,  16,  16,  10,   8,   4,   
      2,   6,  12,  10,  10,  12,   6,   2,
      0,   8,   6,   8,   8,   6,   8,   0,
    -10, -10,  -8,  -6,  -6,  -8, -10, -10}};

 int DAMA_PUNTAJE_POS[2][64] =
   {{ 0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,   
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0 },

    { 0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,   
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0 }};

//*/

int REY_PUNTAJE_RESGUARDO[2][64] = {
   {-40, -40, -40, -40, -40, -40, -40, -40,
    -40, -10, -10, -10, -10, -10, -10, -40,
    -40, -10,  20,  20,  20,  20, -10, -40,
    -40, -10,  40,  40,  40,  40, -10, -40,
    -40, -10,  60,  60,  60,  60, -10, -40,   /* [white][64] */
    -40, -10,  60,  60,  60,  60, -10, -40,
    -40, -10, -10, -10, -10, -10, -10, -40,
    -40, -40, -40, -40, -40, -40, -40, -40},

   {-40, -40, -40, -40, -40, -40, -40, -40,
    -40, -10, -10, -10, -10, -10, -10, -40,
    -40, -10,  60,  60,  60,  60, -10, -40,
    -40, -10,  60,  60,  60,  60, -10, -40,
    -40, -10,  40,  40,  40,  40, -10, -40,   /* [black][64] */
    -40, -10,  20,  20,  20,  20, -10, -40,
    -40, -10, -10, -10, -10, -10, -10, -40,
    -40, -40, -40, -40, -40, -40, -40, -40}
};
int REY_PUNTAJE_RESGUARDO_R[2][64] = {
   {-60, -40, -20, -20, -20, -20, -20, -20,
    -60, -40, -20,   0,   0,   0,   0,   0,
    -60, -40, -20,  20,  20,  20,  20,  20,
    -60, -40, -20,  20,  40,  40,  40,  40,
    -60, -40, -20,  20,  60,  60,  60,  40,   /* [white][64] */
    -60, -40, -20,  20,  60,  60,  60,  40,
    -60, -40, -20,  20,  40,  40,  40,  40,
    -60, -40, -20, -20, -20, -20, -20, -20},

   {-60, -40, -20, -20, -20, -20, -20, -20,
    -60, -40, -20,  20,  40,  40,  40,  40,
    -60, -40, -20,  20,  60,  60,  60,  40,
    -60, -40, -20,  20,  60,  60,  60,  40,
    -60, -40, -20,  20,  40,  40,  40,  40,   /* [black][64] */
    -60, -40, -20,  20,  20,  20,  20,  20,
    -60, -40, -20,   0,   0,   0,   0,   0,
    -60, -40, -20, -20, -20, -20, -20, -20}
};

int REY_PUNTAJE_RESGUARDO_D[2][64] = {
   {-20, -20, -20, -20, -20, -20, -40, -60,
     40,  40,  40,  40,  20, -20, -40, -60,
     40,  60,  60,  60,  20, -20, -40, -60,
     40,  60,  60,  60,  20, -20, -40, -60,
     40,  40,  40,  40,  20, -20, -40, -60,   /* [black][64] */
     20,  20,  20,  20,  20, -20, -40, -60,
      0,   0,   0,   0,   0, -20, -40, -60,
    -20, -20, -20, -20, -20, -20, -40, -60},

   {-20, -20, -20, -20, -20, -20, -40, -60,
      0,   0,   0,   0,   0, -20, -40, -60,
     20,  20,  20,  20,  20, -20, -40, -60,
     40,  40,  40,  40,  20, -20, -40, -60,
     40,  60,  60,  60,  20, -20, -40, -60,   /* [white][64] */
     40,  60,  60,  60,  20, -20, -40, -60,
     40,  40,  40,  40,  20, -20, -40, -60,
    -20, -20, -20, -20, -20, -20, -40, -60}
};


int peon_doblado[2] = { 5, 6 };
/*
 int  DESCUENTO_PEONES_DOBLADOS[64] = {
	0, 0, 0, 0, 0, 0, 0, 0,
	8, 8, 8,10,10, 8, 8, 8,
	8, 8, 8,10,10, 8, 8, 8,
	8, 8, 8,10,10, 8, 8, 8,
	8, 8, 8,10,10, 8, 8, 8,
	8, 8, 8,10,10, 8, 8, 8,
	8, 8, 8,10,10, 8, 8, 8,
	0, 0, 0, 0, 0, 0, 0, 0};
//*/

int peon_aislado[2] = { 18, 21 };
/*
 int  DESCUENTO_PEONES_AISLADOS[64] = {
	0, 0, 0, 0, 0, 0, 0, 0,
	8, 8, 8,10,10, 8, 8, 8,
	8, 8, 8,10,10, 8, 8, 8,
	8, 8, 8,10,10, 8, 8, 8,
	8, 8, 8,10,10, 8, 8, 8,
	8, 8, 8,10,10, 8, 8, 8,
	8, 8, 8,10,10, 8, 8, 8,
	0, 0, 0, 0, 0, 0, 0, 0};
//*/
/*
 int  DESCUENTO_PEONES_ATRASADOS[64] = {
	0, 0, 0, 0, 0, 0, 0, 0,
  	6, 8, 8,10,10, 8, 8, 6,
    	6, 8, 8,10,10, 8, 8, 6,
    	6, 8, 8,10,10, 8, 8, 6,
    	6, 8, 8,10,10, 8, 8, 6,
    	6, 8, 8,10,10, 8, 8, 6,
    	6, 8, 8,10,10, 8, 8, 6,
    	0, 0, 0, 0, 0, 0, 0, 0};
//*/

int BONO_FILA_PEON[2][9]   = {{ 0, 0, 0, 0, 1, 3,  6, 10, 0 },{ 0, 0, 10,  6, 3, 1, 0, 0, 0 }};
int BONO_PEON_DIST_CC[9] = { 0, 0, 0, 0, 2, 7, 19, 31, 0 };
int BONO_PEON_CC[9] = {0, 0, 3, 3, 15, 35, 60, 100, 0 };



 int PEON_DISTANCIA_REY_AMIGO[8]	= { 0,   8,  4,  2,  0,  0,  0,  0 };
 int PEON_DISTANCIA_REY_ENEMIGO[8] 	= { 0,   2,  1,  0,  0,  0,  0,  0 };
 int CABALLO_DISTANCIA[8]		= { 0,   4,  4,  0,  0,  0,  0,  0 };
 int ALFIL_DISTANCIA[8] 		= { 0,   5,  4,  3,  2,  1,  0,  0 };
 int TORRE_DISTANCIA[8] 		= { 0,   7,  5,  4,  3,  0,  0,  0 };
 int DAMA_DISTANCIA[8] 			= { 0,  10,  8,  5,  4,  0,  0,  0 };

int BONO_MOVILIDAD_CENTRAL[4]		= {1,2,3,4};
int BONO_MOVILIDAD_TABLA_TORRE[48] = {
  -27,-23,-21,-19,-15,-10, -9, -8,
   -7, -6, -5, -4, -3, -2, -1,  0,
    1,  2,  3,  4,  5,  6,  7,  8,
    9, 10, 11, 12, 13, 14, 15, 16,
   17, 18, 19, 20, 21, 22, 23, 24,
   25, 26, 27, 28, 29, 30, 31, 32
};

int outside_pp[2] = { 20, 60 };


int CABALLO_TROPISMO[8] = { 0, 3, 3, 2, 1, 0, 0, 0 };
int ALFIL_TROPISMO[8]   = { 0, 2, 2, 1, 0, 0, 0, 0 };
int TORRE_TROPISMO[8]   = { 0, 4, 3, 2, 1, 1, 1, 1 };
int DAMA_TROPISMO[8]    = { 0, 6, 5, 4, 3, 2, 2, 2 };


int VECTOR_TROPISMO[16]  = {0,  1,  2,  3,   4,   5,  11,  20, 32, 47, 65, 86, 110, 137, 167, 200};
int VECTOR_SEGURIDAD[16] = {0,  7, 14, 21, 28, 35, 42,  49, 56, 63, 70, 77, 84, 91, 98, 105};


 int INSEGURIDAD_REY[32] = {
	 0,  1,  2,  4, 15, 30, 50, 60,
	73, 85,100,125,150,175,200,225,
	250,275,300,325,350,375,400,425,
	450,475,500,525,550,575,600,600};
/*
 int AJUSTE_POS_REY[2][64] = {{
	2, 0, 0, 0, 0, 0, 0, 2,
	2, 1, 1, 1, 1, 1, 1, 2,
	4, 3, 3, 3, 3, 3, 3, 4,
	4, 4, 4, 4, 4, 4, 4, 4,
	4, 4, 4, 4, 4, 4, 4, 4,
	4, 4, 4, 4, 4, 4, 4, 4,
	4, 4, 4, 4, 4, 4, 4, 4,
	4, 4, 4, 4, 4, 4, 4, 4},{
	4, 4, 4, 4, 4, 4, 4, 4,
	4, 4, 4, 4, 4, 4, 4, 4,
	4, 4, 4, 4, 4, 4, 4, 4,
	4, 4, 4, 4, 4, 4, 4, 4,
	4, 4, 4, 4, 4, 4, 4, 4,
	4, 3, 3, 3, 3, 3, 3, 4,
	2, 1, 1, 1, 1, 1, 1, 2,
	2, 0, 0, 0, 0, 0, 0, 2}};
//*/
//*
 int ALFILMALO[9]		= { 0, 0, 0, -45, -60, -75, -90, -105, -120 };

 int PAREJA_ALFILES[17] 	= { 50, 50, 50, 50, 50, 45, 45, 40, 40,
                                    35, 35, 30, 30, 30, 30, 30, 30 };	

int movilidadCaballo[9]		= {-10, -4, 2, 8, 14, 18, 22, 24, 25};
int movilidadAlfil[16] 		= {-20, -10, 0, 10, 20, 30, 38, 44, 48, 52, 54, 57, 58, 59, 60, 60};
int movilidadTorre[16] 		= {-12, -8, -4, 0, 4, 8, 11, 14, 16, 18, 19, 20, 21, 22, 23, 24};
int movilidadTorreFinal[16] 	= {-20, -12, -4, 4, 12, 20, 28, 36, 44, 50, 54, 56, 57, 58, 59, 60};
int movilidadDama[32] 		= {-10, -8, -6, -4, -2, 0, 2, 4, 6, 8, 10, 12, 13, 14, 15, 16,
  			    	    16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16};
int movilidadDamaFinal[32] 	= {-20, -15, -10, -5, 0, 5, 10, 15, 19, 23, 27, 29, 30, 30, 30, 30,
				            30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30};
//*/

 uint32 ESPEJO[64] = {
        56,  57,  58,  59,  60,  61,  62,  63,
        48,  49,  50,  51,  52,  53,  54,  55,
        40,  41,  42,  43,  44,  45,  46,  47,
        32,  33,  34,  35,  36,  37,  38,  39,
        24,  25,  26,  27,  28,  29,  30,  31,
        16,  17,  18,  19,  20,  21,  22,  23,
         8,   9,  10,  11,  12,  13,  14,  15,  
         0,   1,   2,   3,   4,   5,   6,   7
};

 uint64 PASADO[2][64] = {{
0x3030303030300ull,0x7070707070700ull,0xe0e0e0e0e0e00ull,0x1c1c1c1c1c1c00ull,
0x38383838383800ull,0x70707070707000ull,0xe0e0e0e0e0e000ull,0xc0c0c0c0c0c000ull,
0x3030303030000ull,0x7070707070000ull,0xe0e0e0e0e0000ull,0x1c1c1c1c1c0000ull,
0x38383838380000ull,0x70707070700000ull,0xe0e0e0e0e00000ull,0xc0c0c0c0c00000ull,
0x3030303000000ull,0x7070707000000ull,0xe0e0e0e000000ull,0x1c1c1c1c000000ull,
0x38383838000000ull,0x70707070000000ull,0xe0e0e0e0000000ull,0xc0c0c0c0000000ull,
0x3030300000000ull,0x7070700000000ull,0xe0e0e00000000ull,0x1c1c1c00000000ull,
0x38383800000000ull,0x70707000000000ull,0xe0e0e000000000ull,0xc0c0c000000000ull,
0x3030000000000ull,0x7070000000000ull,0xe0e0000000000ull,0x1c1c0000000000ull,
0x38380000000000ull,0x70700000000000ull,0xe0e00000000000ull,0xc0c00000000000ull,
0x3000000000000ull,0x7000000000000ull,0xe000000000000ull,0x1c000000000000ull,
0x38000000000000ull,0x70000000000000ull,0xe0000000000000ull,0xc0000000000000ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull},{
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0x300ull,0x700ull,0xe00ull,0x1c00ull,
0x3800ull,0x7000ull,0xe000ull,0xc000ull,
0x30300ull,0x70700ull,0xe0e00ull,0x1c1c00ull,
0x383800ull,0x707000ull,0xe0e000ull,0xc0c000ull,
0x3030300ull,0x7070700ull,0xe0e0e00ull,0x1c1c1c00ull,
0x38383800ull,0x70707000ull,0xe0e0e000ull,0xc0c0c000ull,
0x303030300ull,0x707070700ull,0xe0e0e0e00ull,0x1c1c1c1c00ull,
0x3838383800ull,0x7070707000ull,0xe0e0e0e000ull,0xc0c0c0c000ull,
0x30303030300ull,0x70707070700ull,0xe0e0e0e0e00ull,0x1c1c1c1c1c00ull,
0x383838383800ull,0x707070707000ull,0xe0e0e0e0e000ull,0xc0c0c0c0c000ull,
0x3030303030300ull,0x7070707070700ull,0xe0e0e0e0e0e00ull,0x1c1c1c1c1c1c00ull,
0x38383838383800ull,0x70707070707000ull,0xe0e0e0e0e0e000ull,0xc0c0c0c0c0c000ull}};


 uint64 AISLADO[64] = {
0x2020202020200ull,0x5050505050500ull,0xa0a0a0a0a0a00ull,0x14141414141400ull,
0x28282828282800ull,0x50505050505000ull,0xa0a0a0a0a0a000ull,0x40404040404000ull,
0x2020202020200ull,0x5050505050500ull,0xa0a0a0a0a0a00ull,0x14141414141400ull,
0x28282828282800ull,0x50505050505000ull,0xa0a0a0a0a0a000ull,0x40404040404000ull,
0x2020202020200ull,0x5050505050500ull,0xa0a0a0a0a0a00ull,0x14141414141400ull,
0x28282828282800ull,0x50505050505000ull,0xa0a0a0a0a0a000ull,0x40404040404000ull,
0x2020202020200ull,0x5050505050500ull,0xa0a0a0a0a0a00ull,0x14141414141400ull,
0x28282828282800ull,0x50505050505000ull,0xa0a0a0a0a0a000ull,0x40404040404000ull,
0x2020202020200ull,0x5050505050500ull,0xa0a0a0a0a0a00ull,0x14141414141400ull,
0x28282828282800ull,0x50505050505000ull,0xa0a0a0a0a0a000ull,0x40404040404000ull,
0x2020202020200ull,0x5050505050500ull,0xa0a0a0a0a0a00ull,0x14141414141400ull,
0x28282828282800ull,0x50505050505000ull,0xa0a0a0a0a0a000ull,0x40404040404000ull,
0x2020202020200ull,0x5050505050500ull,0xa0a0a0a0a0a00ull,0x14141414141400ull,
0x28282828282800ull,0x50505050505000ull,0xa0a0a0a0a0a000ull,0x40404040404000ull,
0x2020202020200ull,0x5050505050500ull,0xa0a0a0a0a0a00ull,0x14141414141400ull,
0x28282828282800ull,0x50505050505000ull,0xa0a0a0a0a0a000ull,0x40404040404000ull};

 uint64 HACIATRAS[2][64] = {{
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0x200ull,0x500ull,0xa00ull,0x1400ull,
0x2800ull,0x5000ull,0xa000ull,0x4000ull,
0x20200ull,0x50500ull,0xa0a00ull,0x141400ull,
0x282800ull,0x505000ull,0xa0a000ull,0x404000ull,
0x2020200ull,0x5050500ull,0xa0a0a00ull,0x14141400ull,
0x28282800ull,0x50505000ull,0xa0a0a000ull,0x40404000ull,
0x202020200ull,0x505050500ull,0xa0a0a0a00ull,0x1414141400ull,
0x2828282800ull,0x5050505000ull,0xa0a0a0a000ull,0x4040404000ull,
0x20202020200ull,0x50505050500ull,0xa0a0a0a0a00ull,0x141414141400ull,
0x282828282800ull,0x505050505000ull,0xa0a0a0a0a000ull,0x404040404000ull,
0x2020202020200ull,0x5050505050500ull,0xa0a0a0a0a0a00ull,0x14141414141400ull,
0x28282828282800ull,0x50505050505000ull,0xa0a0a0a0a0a000ull,0x40404040404000ull,
0x202020202020200ull,0x505050505050500ull,0xa0a0a0a0a0a0a00ull,0x1414141414141400ull,
0x2828282828282800ull,0x5050505050505000ull,0xa0a0a0a0a0a0a000ull,0x4040404040404000ull},{
0x2020202020202ull,0x5050505050505ull,0xa0a0a0a0a0a0aull,0x14141414141414ull,
0x28282828282828ull,0x50505050505050ull,0xa0a0a0a0a0a0a0ull,0x40404040404040ull,
0x2020202020200ull,0x5050505050500ull,0xa0a0a0a0a0a00ull,0x14141414141400ull,
0x28282828282800ull,0x50505050505000ull,0xa0a0a0a0a0a000ull,0x40404040404000ull,
0x2020202020000ull,0x5050505050000ull,0xa0a0a0a0a0000ull,0x14141414140000ull,
0x28282828280000ull,0x50505050500000ull,0xa0a0a0a0a00000ull,0x40404040400000ull,
0x2020202000000ull,0x5050505000000ull,0xa0a0a0a000000ull,0x14141414000000ull,
0x28282828000000ull,0x50505050000000ull,0xa0a0a0a0000000ull,0x40404040000000ull,
0x2020200000000ull,0x5050500000000ull,0xa0a0a00000000ull,0x14141400000000ull,
0x28282800000000ull,0x50505000000000ull,0xa0a0a000000000ull,0x40404000000000ull,
0x2020000000000ull,0x5050000000000ull,0xa0a0000000000ull,0x14140000000000ull,
0x28280000000000ull,0x50500000000000ull,0xa0a00000000000ull,0x40400000000000ull,
0x2000000000000ull,0x5000000000000ull,0xa000000000000ull,0x14000000000000ull,
0x28000000000000ull,0x50000000000000ull,0xa0000000000000ull,0x40000000000000ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull}};


 uint64 SEGURIDADREY_FUERTE[2][64] = {{
0x700ull,0x700ull,0xe00ull,0x1c00ull,
0x3800ull,0x7000ull,0xe000ull,0xe000ull,
0x70000ull,0x70000ull,0xe0000ull,0x1c0000ull,
0x380000ull,0x700000ull,0xe00000ull,0xe00000ull,
0x7000000ull,0x7000000ull,0xe000000ull,0x1c000000ull,
0x38000000ull,0x70000000ull,0xe0000000ull,0xe0000000ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull},{
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0x700000000ull,0x700000000ull,0xe00000000ull,0x1c00000000ull,
0x3800000000ull,0x7000000000ull,0xe000000000ull,0xe000000000ull,
0x70000000000ull,0x70000000000ull,0xe0000000000ull,0x1c0000000000ull,
0x380000000000ull,0x700000000000ull,0xe00000000000ull,0xe00000000000ull,
0x7000000000000ull,0x7000000000000ull,0xe000000000000ull,0x1c000000000000ull,
0x38000000000000ull,0x70000000000000ull,0xe0000000000000ull,0xe0000000000000ull}};


 uint64 SEGURIDADREY_DEBIL[2][64] = {{
0x70000ull,0x70000ull,0xe0000ull,0x1c0000ull,
0x380000ull,0x700000ull,0xe00000ull,0xe00000ull,
0x7000000ull,0x7000000ull,0xe000000ull,0x1c000000ull,
0x38000000ull,0x70000000ull,0xe0000000ull,0xe0000000ull,
0x700000000ull,0x700000000ull,0xe00000000ull,0x1c00000000ull,
0x3800000000ull,0x7000000000ull,0xe000000000ull,0xe000000000ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull},{
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0x7000000ull,0x7000000ull,0xe000000ull,0x1c000000ull,
0x38000000ull,0x70000000ull,0xe0000000ull,0xe0000000ull,
0x700000000ull,0x700000000ull,0xe00000000ull,0x1c00000000ull,
0x3800000000ull,0x7000000000ull,0xe000000000ull,0xe000000000ull,
0x70000000000ull,0x70000000000ull,0xe0000000000ull,0x1c0000000000ull,
0x380000000000ull,0x700000000000ull,0xe00000000000ull,0xe00000000000ull}};

  uint8 GEN_SLIDING_ATTACKS[8][64] = {
{
0xfe,0x2,0x6,0x2,0xe,0x2,0x6,0x2,
0x1e,0x2,0x6,0x2,0xe,0x2,0x6,0x2,
0x3e,0x2,0x6,0x2,0xe,0x2,0x6,0x2,
0x1e,0x2,0x6,0x2,0xe,0x2,0x6,0x2,
0x7e,0x2,0x6,0x2,0xe,0x2,0x6,0x2,
0x1e,0x2,0x6,0x2,0xe,0x2,0x6,0x2,
0x3e,0x2,0x6,0x2,0xe,0x2,0x6,0x2,
0x1e,0x2,0x6,0x2,0xe,0x2,0x6,0x2,
},{
0xfd,0xfd,0x5,0x5,0xd,0xd,0x5,0x5,
0x1d,0x1d,0x5,0x5,0xd,0xd,0x5,0x5,
0x3d,0x3d,0x5,0x5,0xd,0xd,0x5,0x5,
0x1d,0x1d,0x5,0x5,0xd,0xd,0x5,0x5,
0x7d,0x7d,0x5,0x5,0xd,0xd,0x5,0x5,
0x1d,0x1d,0x5,0x5,0xd,0xd,0x5,0x5,
0x3d,0x3d,0x5,0x5,0xd,0xd,0x5,0x5,
0x1d,0x1d,0x5,0x5,0xd,0xd,0x5,0x5,
},{
0xfb,0xfa,0xfb,0xfa,0xb,0xa,0xb,0xa,
0x1b,0x1a,0x1b,0x1a,0xb,0xa,0xb,0xa,
0x3b,0x3a,0x3b,0x3a,0xb,0xa,0xb,0xa,
0x1b,0x1a,0x1b,0x1a,0xb,0xa,0xb,0xa,
0x7b,0x7a,0x7b,0x7a,0xb,0xa,0xb,0xa,
0x1b,0x1a,0x1b,0x1a,0xb,0xa,0xb,0xa,
0x3b,0x3a,0x3b,0x3a,0xb,0xa,0xb,0xa,
0x1b,0x1a,0x1b,0x1a,0xb,0xa,0xb,0xa,
},{
0xf7,0xf6,0xf4,0xf4,0xf7,0xf6,0xf4,0xf4,
0x17,0x16,0x14,0x14,0x17,0x16,0x14,0x14,
0x37,0x36,0x34,0x34,0x37,0x36,0x34,0x34,
0x17,0x16,0x14,0x14,0x17,0x16,0x14,0x14,
0x77,0x76,0x74,0x74,0x77,0x76,0x74,0x74,
0x17,0x16,0x14,0x14,0x17,0x16,0x14,0x14,
0x37,0x36,0x34,0x34,0x37,0x36,0x34,0x34,
0x17,0x16,0x14,0x14,0x17,0x16,0x14,0x14,
},{
0xef,0xee,0xec,0xec,0xe8,0xe8,0xe8,0xe8,
0xef,0xee,0xec,0xec,0xe8,0xe8,0xe8,0xe8,
0x2f,0x2e,0x2c,0x2c,0x28,0x28,0x28,0x28,
0x2f,0x2e,0x2c,0x2c,0x28,0x28,0x28,0x28,
0x6f,0x6e,0x6c,0x6c,0x68,0x68,0x68,0x68,
0x6f,0x6e,0x6c,0x6c,0x68,0x68,0x68,0x68,
0x2f,0x2e,0x2c,0x2c,0x28,0x28,0x28,0x28,
0x2f,0x2e,0x2c,0x2c,0x28,0x28,0x28,0x28
},{
0xdf,0xde,0xdc,0xdc,0xd8,0xd8,0xd8,0xd8,
0xd0,0xd0,0xd0,0xd0,0xd0,0xd0,0xd0,0xd0,
0xdf,0xde,0xdc,0xdc,0xd8,0xd8,0xd8,0xd8,
0xd0,0xd0,0xd0,0xd0,0xd0,0xd0,0xd0,0xd0,
0x5f,0x5e,0x5c,0x5c,0x58,0x58,0x58,0x58,
0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,
0x5f,0x5e,0x5c,0x5c,0x58,0x58,0x58,0x58,
0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50
},{
0xbf,0xbe,0xbc,0xbc,0xb8,0xb8,0xb8,0xb8,
0xb0,0xb0,0xb0,0xb0,0xb0,0xb0,0xb0,0xb0,
0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,
0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,
0xbf,0xbe,0xbc,0xbc,0xb8,0xb8,0xb8,0xb8,
0xb0,0xb0,0xb0,0xb0,0xb0,0xb0,0xb0,0xb0,
0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,
0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0
},{
0x7f,0x7e,0x7c,0x7c,0x78,0x78,0x78,0x78,
0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,
0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,
0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40}
};


  uint32 FILERANK2POS[9][9] = {
{0xfffffff7, 0xffffffff, 0x7, 0xf, 0x17, 0x1f, 0x27, 0x2f, 0x37},
{0xfffffff8, 0, 0x8, 0x10, 0x18, 0x20, 0x28, 0x30, 0x38},
{0xfffffff9, 0x1, 0x9, 0x11, 0x19, 0x21, 0x29, 0x31, 0x39},
{0xfffffffa, 0x2, 0xa, 0x12, 0x1a, 0x22, 0x2a, 0x32, 0x3a},
{0xfffffffb, 0x3, 0xb, 0x13, 0x1b, 0x23, 0x2b, 0x33, 0x3b},
{0xfffffffc, 0x4, 0xc, 0x14, 0x1c, 0x24, 0x2c, 0x34, 0x3c},
{0xfffffffd, 0x5, 0xd, 0x15, 0x1d, 0x25, 0x2d, 0x35, 0x3d},
{0xfffffffe, 0x6, 0xe, 0x16, 0x1e, 0x26, 0x2e, 0x36, 0x3e},
{0xffffffff, 0x7, 0xf, 0x17, 0x1f, 0x27, 0x2f, 0x37, 0x3f}};

  int    TABLA_MSB1[256] = { 
0x0, 0x0, 0x1, 0x1, 0x2, 0x2, 0x2, 0x2, 0x3, 0x3,
0x3, 0x3, 0x3, 0x3, 0x3, 0x3, 0x4, 0x4, 0x4, 0x4,
0x4, 0x4, 0x4, 0x4, 0x4, 0x4, 0x4, 0x4, 0x4, 0x4,
0x4, 0x4, 0x5, 0x5, 0x5, 0x5, 0x5, 0x5, 0x5, 0x5,
0x5, 0x5, 0x5, 0x5, 0x5, 0x5, 0x5, 0x5, 0x5, 0x5,
0x5, 0x5, 0x5, 0x5, 0x5, 0x5, 0x5, 0x5, 0x5, 0x5,
0x5, 0x5, 0x5, 0x5, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6,
0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6,
0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6,
0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6,
0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6,
0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6,
0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x6, 0x7, 0x7,
0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7,
0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7,
0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7,
0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7,
0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7,
0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7,
0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7,
0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7,
0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7,
0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7,
0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7,
0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7,
0x7, 0x7, 0x7, 0x7, 0x7, 0x7};



  uint64 mascaraRey[64] = {
770ull,			1797ull,		3594ull,		7188ull,		14376ull,	
28752ull,		57504ull,		49216ull,		197123ull,	 	460039ull,	
920078ull,		1840156ull,		3680312ull, 		7360624ull, 		14721248ull, 	
12599488ull,		50463488ull, 		117769984ull, 		235539968ull, 		471079936ull,
942159872ull, 		1884319744ull, 		3768639488ull, 		3225468928ull,		12918652928ull, 
30149115904ull, 	60298231808ull, 	120596463616ull,	241192927232ull,	482385854464ull,
964771708928ull,	825720045568ull,	3307175149568ull, 	7718173671424ull, 	15436347342848ull, 	30872694685696ull, 	61745389371392ull, 	123490778742784ull, 	246981557485568ull, 	211384331665408ull,	846636838289408ull, 	1975852459884544ull,	3951704919769088ull, 	7903409839538176ull, 	15806819679076352ull, 	31613639358152704ull, 	63227278716305408ull, 	54114388906344448ull,	216739030602088448ull, 	505818229730443264ull, 	1011636459460886528ull,	2023272918921773056ull, 4046545837843546112ull,	8093091675687092224ull, 16186183351374184448ull,
13853283560024178688ull,144959613005987840ull,	362258295026614272ull,	724516590053228544ull,	1449033180106457088ull,	2898066360212914176ull,	5796132720425828352ull, 11592265440851656704ull,4665729213955833856ull};


  uint64 mascaraCaballo[64] = {
132096ull, 		329728ull, 		659712ull, 		1319424ull, 		2638848ull, 	
5277696ull, 		10489856ull,		4202496ull, 		33816580ull, 		84410376ull, 
168886289ull, 		337772578ull, 		675545156ull, 		1351090312ull,		2685403152ull, 
1075839008ull, 		8657044482ull, 		21609056261ull, 	43234889994ull, 	86469779988ull,
172939559976ull, 	345879119952ull, 	687463207072ull, 	275414786112ull, 	2216203387392ull,
5531918402816ull, 	11068131838464ull, 	22136263676928ull, 	44272527353856ull, 	88545054707712ull,
175990581010432ull, 	70506185244672ull, 	567348067172352ull, 	1416171111120896ull,	2833441750646784ull, 
5666883501293568ull,	11333767002587136ull, 	22667534005174272ull, 	45053588738670592ull, 	18049583422636032ull, 
145241105196122112ull, 	362539804446949376ull,	725361088165576704ull, 	1450722176331153408ull, 2901444352662306816ull, 
5802888705324613632ull, 11533718717099671552ull,4620693356194824192ull,	288234782788157440ull, 	576469569871282176ull, 
1224997833292120064ull, 2449995666584240128ull, 4899991333168480256ull, 9799982666336960512ull,	1152939783987658752ull, 2305878468463689728ull, 1128098930098176ull,	2257297371824128ull, 	4796069720358912ull, 	9592139440717824ull,
19184278881435648ull,	38368557762871296ull, 	4679521487814656ull,	9077567998918656ull};

  uint64 BITSET[64] = {
0x1ull, 0x2ull, 0x4ull, 0x8ull, 0x10ull, 0x20ull, 0x40ull, 0x80ull, 0x100ull, 0x200ull, 0x400ull, 0x800ull, 0x1000ull,
0x2000ull, 0x4000ull, 0x8000ull, 0x10000ull, 0x20000ull, 0x40000ull, 0x80000ull, 0x100000ull, 0x200000ull, 0x400000ull, 
0x800000ull, 0x1000000ull, 0x2000000ull, 0x4000000ull, 0x8000000ull, 0x10000000ull, 0x20000000ull, 0x40000000ull, 
0x80000000ull, 0x100000000ull, 0x200000000ull, 0x400000000ull, 0x800000000ull, 0x1000000000ull, 0x2000000000ull, 
0x4000000000ull, 0x8000000000ull, 0x10000000000ull, 0x20000000000ull, 0x40000000000ull, 0x80000000000ull, 0x100000000000ull,
0x200000000000ull, 0x400000000000ull, 0x800000000000ull, 0x1000000000000ull, 0x2000000000000ull, 0x4000000000000ull,
0x8000000000000ull, 0x10000000000000ull, 0x20000000000000ull, 0x40000000000000ull, 0x80000000000000ull, 0x100000000000000ull,
0x200000000000000ull, 0x400000000000000ull, 0x800000000000000ull, 0x1000000000000000ull, 0x2000000000000000ull, 0x4000000000000000ull,
0x8000000000000000ull};

  uint64 RANKMASK[64] = {
0x7eull, 0x7eull, 0x7eull, 0x7eull, 0x7eull, 0x7eull, 0x7eull, 0x7eull, 0x7e00ull, 0x7e00ull, 0x7e00ull, 0x7e00ull,
0x7e00ull, 0x7e00ull, 0x7e00ull, 0x7e00ull, 0x7e0000ull, 0x7e0000ull, 0x7e0000ull, 0x7e0000ull, 0x7e0000ull, 0x7e0000ull,
0x7e0000ull, 0x7e0000ull, 0x7e000000ull, 0x7e000000ull, 0x7e000000ull, 0x7e000000ull, 0x7e000000ull, 0x7e000000ull,
0x7e000000ull, 0x7e000000ull, 0x7e00000000ull, 0x7e00000000ull, 0x7e00000000ull, 0x7e00000000ull, 0x7e00000000ull,
0x7e00000000ull, 0x7e00000000ull, 0x7e00000000ull, 0x7e0000000000ull, 0x7e0000000000ull, 0x7e0000000000ull, 0x7e0000000000ull,
0x7e0000000000ull, 0x7e0000000000ull, 0x7e0000000000ull, 0x7e0000000000ull, 0x7e000000000000ull, 0x7e000000000000ull,
0x7e000000000000ull, 0x7e000000000000ull, 0x7e000000000000ull, 0x7e000000000000ull, 0x7e000000000000ull, 0x7e000000000000ull,
0x7e00000000000000ull, 0x7e00000000000000ull, 0x7e00000000000000ull, 0x7e00000000000000ull, 0x7e00000000000000ull,
0x7e00000000000000ull, 0x7e00000000000000ull, 0x7e00000000000000ull};

  uint64 FILEMASK[64] = {
0x1010101010100ull, 0x2020202020200ull, 0x4040404040400ull, 0x8080808080800ull, 0x10101010101000ull, 0x20202020202000ull,
0x40404040404000ull, 0x80808080808000ull, 0x1010101010100ull, 0x2020202020200ull, 0x4040404040400ull, 0x8080808080800ull,
0x10101010101000ull, 0x20202020202000ull, 0x40404040404000ull, 0x80808080808000ull, 0x1010101010100ull, 0x2020202020200ull,
0x4040404040400ull, 0x8080808080800ull, 0x10101010101000ull, 0x20202020202000ull, 0x40404040404000ull, 0x80808080808000ull,
0x1010101010100ull, 0x2020202020200ull, 0x4040404040400ull, 0x8080808080800ull, 0x10101010101000ull, 0x20202020202000ull,
0x40404040404000ull, 0x80808080808000ull, 0x1010101010100ull, 0x2020202020200ull, 0x4040404040400ull, 0x8080808080800ull,
0x10101010101000ull, 0x20202020202000ull, 0x40404040404000ull, 0x80808080808000ull, 0x1010101010100ull, 0x2020202020200ull,
0x4040404040400ull, 0x8080808080800ull, 0x10101010101000ull, 0x20202020202000ull, 0x40404040404000ull, 0x80808080808000ull,
0x1010101010100ull, 0x2020202020200ull, 0x4040404040400ull, 0x8080808080800ull, 0x10101010101000ull, 0x20202020202000ull,
0x40404040404000ull, 0x80808080808000ull, 0x1010101010100ull, 0x2020202020200ull, 0x4040404040400ull, 0x8080808080800ull,
0x10101010101000ull, 0x20202020202000ull, 0x40404040404000ull, 0x80808080808000ull};

  uint64 FILEMAGIC[64] =
{
0x8040201008040200ull, 0x4020100804020100ull, 0x2010080402010080ull, 0x1008040201008040ull, 0x804020100804020ull, 0x402010080402010ull,
0x201008040201008ull, 0x100804020100804ull, 0x8040201008040200ull, 0x4020100804020100ull, 0x2010080402010080ull, 0x1008040201008040ull,
0x804020100804020ull, 0x402010080402010ull, 0x201008040201008ull, 0x100804020100804ull, 0x8040201008040200ull, 0x4020100804020100ull,
0x2010080402010080ull, 0x1008040201008040ull, 0x804020100804020ull, 0x402010080402010ull, 0x201008040201008ull, 0x100804020100804ull,
0x8040201008040200ull, 0x4020100804020100ull, 0x2010080402010080ull, 0x1008040201008040ull, 0x804020100804020ull, 0x402010080402010ull,
0x201008040201008ull, 0x100804020100804ull, 0x8040201008040200ull, 0x4020100804020100ull, 0x2010080402010080ull, 0x1008040201008040ull,
0x804020100804020ull, 0x402010080402010ull, 0x201008040201008ull, 0x100804020100804ull, 0x8040201008040200ull, 0x4020100804020100ull,
0x2010080402010080ull, 0x1008040201008040ull, 0x804020100804020ull, 0x402010080402010ull, 0x201008040201008ull, 0x100804020100804ull,
0x8040201008040200ull, 0x4020100804020100ull, 0x2010080402010080ull, 0x1008040201008040ull, 0x804020100804020ull, 0x402010080402010ull,
0x201008040201008ull, 0x100804020100804ull, 0x8040201008040200ull, 0x4020100804020100ull, 0x2010080402010080ull, 0x1008040201008040ull,
0x804020100804020ull, 0x402010080402010ull, 0x201008040201008ull, 0x100804020100804ull};

  uint64 DIAGA8H1MASK[64] = {
0x0ull, 0x0ull, 0x200ull, 0x20400ull, 0x2040800ull, 0x204081000ull, 0x20408102000ull, 0x2040810204000ull, 
0x0ull, 0x200ull, 0x20400ull, 0x2040800ull, 0x204081000ull, 0x20408102000ull, 0x2040810204000ull, 0x4081020400000ull,
0x200ull, 0x20400ull, 0x2040800ull, 0x204081000ull, 0x20408102000ull, 0x2040810204000ull, 0x4081020400000ull, 0x8102040000000ull,
0x20400ull, 0x2040800ull, 0x204081000ull, 0x20408102000ull, 0x2040810204000ull, 0x4081020400000ull, 0x8102040000000ull,
0x10204000000000ull, 0x2040800ull, 0x204081000ull, 0x20408102000ull, 0x2040810204000ull, 0x4081020400000ull, 0x8102040000000ull,
0x10204000000000ull, 0x20400000000000ull, 0x204081000ull, 0x20408102000ull, 0x2040810204000ull, 0x4081020400000ull, 
0x8102040000000ull, 0x10204000000000ull, 0x20400000000000ull, 0x40000000000000ull, 0x20408102000ull, 0x2040810204000ull,
0x4081020400000ull, 0x8102040000000ull, 0x10204000000000ull, 0x20400000000000ull, 0x40000000000000ull, 0x0ull,
0x2040810204000ull, 0x4081020400000ull, 0x8102040000000ull, 0x10204000000000ull, 0x20400000000000ull, 0x40000000000000ull,
0x0ull, 0x0ull};

  uint64 DIAGA8H1MAGIC[64] = {
0x0ull, 0x0ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull,
0x101010101010100ull, 0x0ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull,
0x101010101010100ull, 0x101010101010100ull, 0x80808080808080ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull,
0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull, 0x80808080808080ull, 0x40404040404040ull, 0x101010101010100ull,
0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull, 0x80808080808080ull, 0x40404040404040ull,
0x20202020202020ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull, 0x80808080808080ull,
0x40404040404040ull, 0x20202020202020ull, 0x10101010101010ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull,
0x80808080808080ull, 0x40404040404040ull, 0x20202020202020ull, 0x10101010101010ull, 0x8080808080808ull, 0x101010101010100ull,
0x101010101010100ull, 0x80808080808080ull, 0x40404040404040ull, 0x20202020202020ull, 0x10101010101010ull, 0x8080808080808ull,
0x0ull, 0x101010101010100ull, 0x80808080808080ull, 0x40404040404040ull, 0x20202020202020ull, 0x10101010101010ull, 0x8080808080808ull,
0x0ull, 0x0ull };

  uint64 DIAGA1H8MASK[64] = 
{
0x40201008040200ull, 0x402010080400ull, 0x4020100800ull, 0x40201000ull, 0x402000ull, 0x4000ull, 0x0ull, 0x0ull,
0x20100804020000ull, 0x40201008040200ull, 0x402010080400ull, 0x4020100800ull, 0x40201000ull, 0x402000ull, 0x4000ull,
0x0ull, 0x10080402000000ull, 0x20100804020000ull, 0x40201008040200ull, 0x402010080400ull, 0x4020100800ull, 0x40201000ull,
0x402000ull, 0x4000ull, 0x8040200000000ull, 0x10080402000000ull, 0x20100804020000ull, 0x40201008040200ull, 0x402010080400ull,
0x4020100800ull, 0x40201000ull, 0x402000ull, 0x4020000000000ull, 0x8040200000000ull, 0x10080402000000ull, 0x20100804020000ull,
0x40201008040200ull, 0x402010080400ull, 0x4020100800ull, 0x40201000ull, 0x2000000000000ull, 0x4020000000000ull, 0x8040200000000ull,
0x10080402000000ull, 0x20100804020000ull, 0x40201008040200ull, 0x402010080400ull, 0x4020100800ull, 0x0ull, 0x2000000000000ull,
0x4020000000000ull, 0x8040200000000ull, 0x10080402000000ull, 0x20100804020000ull, 0x40201008040200ull, 0x402010080400ull,
0x0ull, 0x0ull, 0x2000000000000ull, 0x4020000000000ull, 0x8040200000000ull, 0x10080402000000ull, 0x20100804020000ull,
0x40201008040200ull};

  uint64 DIAGA1H8MAGIC[64] = {
0x101010101010100ull, 0x8080808080808000ull, 0x4040404040400000ull, 0x2020202020000000ull, 0x1010101000000000ull,
0x808080000000000ull, 0x0ull, 0x0ull, 0x101010101010100ull, 0x101010101010100ull, 0x8080808080808000ull, 0x4040404040400000ull,
0x2020202020000000ull, 0x1010101000000000ull, 0x808080000000000ull, 0x0ull, 0x101010101010100ull, 0x101010101010100ull,
0x101010101010100ull, 0x8080808080808000ull, 0x4040404040400000ull, 0x2020202020000000ull, 0x1010101000000000ull, 
0x808080000000000ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull,
0x8080808080808000ull, 0x4040404040400000ull, 0x2020202020000000ull, 0x1010101000000000ull, 0x101010101010100ull,
0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull, 0x8080808080808000ull,
0x4040404040400000ull, 0x2020202020000000ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull,
0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull, 0x8080808080808000ull, 0x4040404040400000ull, 0x0ull,
0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull,
0x8080808080808000ull, 0x0ull, 0x0ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull, 0x101010101010100ull,
0x101010101010100ull, 0x101010101010100ull };

  uint64 mascaraPeon[64][2] = {
{0x0ull, 0x0ull},
{0x0ull, 0x0ull},
{0x0ull, 0x0ull},
{0x0ull, 0x0ull},
{0x0ull, 0x0ull},
{0x0ull, 0x0ull},
{0x0ull, 0x0ull},
{0x0ull, 0x0ull},
{0x10000ull, 0x1ull},
{0x20000ull, 0x2ull},
{0x40000ull, 0x4ull},
{0x80000ull, 0x8ull},
{0x100000ull, 0x10ull},
{0x200000ull, 0x20ull},
{0x400000ull, 0x40ull},
{0x800000ull, 0x80ull},
{0x1000000ull, 0x100ull},
{0x2000000ull, 0x200ull},
{0x4000000ull, 0x400ull},
{0x8000000ull, 0x800ull},
{0x10000000ull, 0x1000ull},
{0x20000000ull, 0x2000ull},
{0x40000000ull, 0x4000ull},
{0x80000000ull, 0x8000ull},
{0x100000000ull, 0x10000ull},
{0x200000000ull, 0x20000ull},
{0x400000000ull, 0x40000ull},
{0x800000000ull, 0x80000ull},
{0x1000000000ull, 0x100000ull},
{0x2000000000ull, 0x200000ull},
{0x4000000000ull, 0x400000ull},
{0x8000000000ull, 0x800000ull},
{0x10000000000ull, 0x1000000ull},
{0x20000000000ull, 0x2000000ull},
{0x40000000000ull, 0x4000000ull},
{0x80000000000ull, 0x8000000ull},
{0x100000000000ull, 0x10000000ull},
{0x200000000000ull, 0x20000000ull},
{0x400000000000ull, 0x40000000ull},
{0x800000000000ull, 0x80000000ull},
{0x1000000000000ull, 0x100000000ull},
{0x2000000000000ull, 0x200000000ull},
{0x4000000000000ull, 0x400000000ull},
{0x8000000000000ull, 0x800000000ull},
{0x10000000000000ull, 0x1000000000ull},
{0x20000000000000ull, 0x2000000000ull},
{0x40000000000000ull, 0x4000000000ull},
{0x80000000000000ull, 0x8000000000ull},
{0x100000000000000ull, 0x10000000000ull},
{0x200000000000000ull, 0x20000000000ull},
{0x400000000000000ull, 0x40000000000ull},
{0x800000000000000ull, 0x80000000000ull},
{0x1000000000000000ull, 0x100000000000ull},
{0x2000000000000000ull, 0x200000000000ull},
{0x4000000000000000ull, 0x400000000000ull},
{0x8000000000000000ull, 0x800000000000ull},
{0x0ull, 0x0ull},
{0x0ull, 0x0ull},
{0x0ull, 0x0ull},
{0x0ull, 0x0ull},
{0x0ull, 0x0ull},
{0x0ull, 0x0ull},
{0x0ull, 0x0ull},
{0x0ull, 0x0ull}
};

  uint64 mascaraCapturarPeon[64][2] = {
{0x200ull, 0x0ull},
{0x500ull, 0x0ull},
{0xa00ull, 0x0ull},
{0x1400ull, 0x0ull},
{0x2800ull, 0x0ull},
{0x5000ull, 0x0ull},
{0xa000ull, 0x0ull},
{0x4000ull, 0x0ull},
{0x20000ull, 0x2ull},
{0x50000ull, 0x5ull},
{0xa0000ull, 0xaull},
{0x140000ull, 0x14ull},
{0x280000ull, 0x28ull},
{0x500000ull, 0x50ull},
{0xa00000ull, 0xa0ull},
{0x400000ull, 0x40ull},
{0x2000000ull, 0x200ull},
{0x5000000ull, 0x500ull},
{0xa000000ull, 0xa00ull},
{0x14000000ull, 0x1400ull},
{0x28000000ull, 0x2800ull},
{0x50000000ull, 0x5000ull},
{0xa0000000ull, 0xa000ull},
{0x40000000ull, 0x4000ull},
{0x200000000ull, 0x20000ull},
{0x500000000ull, 0x50000ull},
{0xa00000000ull, 0xa0000ull},
{0x1400000000ull, 0x140000ull},
{0x2800000000ull, 0x280000ull},
{0x5000000000ull, 0x500000ull},
{0xa000000000ull, 0xa00000ull},
{0x4000000000ull, 0x400000ull},
{0x20000000000ull, 0x2000000ull},
{0x50000000000ull, 0x5000000ull},
{0xa0000000000ull, 0xa000000ull},
{0x140000000000ull, 0x14000000ull},
{0x280000000000ull, 0x28000000ull},
{0x500000000000ull, 0x50000000ull},
{0xa00000000000ull, 0xa0000000ull},
{0x400000000000ull, 0x40000000ull},
{0x2000000000000ull, 0x200000000ull},
{0x5000000000000ull, 0x500000000ull},
{0xa000000000000ull, 0xa00000000ull},
{0x14000000000000ull, 0x1400000000ull},
{0x28000000000000ull, 0x2800000000ull},
{0x50000000000000ull, 0x5000000000ull},
{0xa0000000000000ull, 0xa000000000ull},
{0x40000000000000ull, 0x4000000000ull},
{0x200000000000000ull, 0x20000000000ull},
{0x500000000000000ull, 0x50000000000ull},
{0xa00000000000000ull, 0xa0000000000ull},
{0x1400000000000000ull, 0x140000000000ull},
{0x2800000000000000ull, 0x280000000000ull},
{0x5000000000000000ull, 0x500000000000ull},
{0xa000000000000000ull, 0xa00000000000ull},
{0x4000000000000000ull, 0x400000000000ull},
{0x0ull, 0x2000000000000ull},
{0x0ull, 0x5000000000000ull},
{0x0ull, 0xa000000000000ull},
{0x0ull, 0x14000000000000ull},
{0x0ull, 0x28000000000000ull},
{0x0ull, 0x50000000000000ull},
{0x0ull, 0xa0000000000000ull},
{0x0ull, 0x40000000000000ull}};

  uint32 RANKSHIFT[64] = {
        1,  1,  1,  1,  1,  1,  1,  1,
        9,  9,  9,  9,  9,  9,  9,  9,
       17, 17, 17, 17, 17, 17, 17, 17,  
       25, 25, 25, 25, 25, 25, 25, 25,
       33, 33, 33, 33, 33, 33, 33, 33,
       41, 41, 41, 41, 41, 41, 41, 41,
       49, 49, 49, 49, 49, 49, 49, 49,
       57, 57, 57, 57, 57, 57, 57, 57
};

  uint64 _FILEMAGICS[8] = {
       0x8040201008040200ull,
       0x4020100804020100ull,
       0x2010080402010080ull,
       0x1008040201008040ull,
       0x0804020100804020ull,
       0x0402010080402010ull,
       0x0201008040201008ull,
       0x0100804020100804ull
};

  uint64 _DIAGA8H1MAGICS[15] = {
       0x0ull,
       0x0ull,
       0x0101010101010100ull,
       0x0101010101010100ull,
       0x0101010101010100ull,
       0x0101010101010100ull,
       0x0101010101010100ull,
       0x0101010101010100ull,
       0x0080808080808080ull,
       0x0040404040404040ull,
       0x0020202020202020ull,
       0x0010101010101010ull,
       0x0008080808080808ull,
       0x0ull,
       0x0ull
};

  uint64  _DIAGA1H8MAGICS[15] = {
       0x0ull,
       0x0ull,
       0x0101010101010100ull,
       0x0101010101010100ull,
       0x0101010101010100ull,
       0x0101010101010100ull,
       0x0101010101010100ull,
       0x0101010101010100ull,
       0x8080808080808000ull,
       0x4040404040400000ull,
       0x2020202020000000ull,
       0x1010101000000000ull,
       0x0808080000000000ull,
       0x0ull,
       0x0ull
};

  uint64 DIAGA1H8_ATTACKS[64][64] = {
{
0x8040201008040200ull,0x200ull,0x40200ull,0x200ull,0x8040200ull,0x200ull,0x40200ull,0x200ull,
0x1008040200ull,0x200ull,0x40200ull,0x200ull,0x8040200ull,0x200ull,0x40200ull,0x200ull,
0x201008040200ull,0x200ull,0x40200ull,0x200ull,0x8040200ull,0x200ull,0x40200ull,0x200ull,
0x1008040200ull,0x200ull,0x40200ull,0x200ull,0x8040200ull,0x200ull,0x40200ull,0x200ull,
0x40201008040200ull,0x200ull,0x40200ull,0x200ull,0x8040200ull,0x200ull,0x40200ull,0x200ull,
0x1008040200ull,0x200ull,0x40200ull,0x200ull,0x8040200ull,0x200ull,0x40200ull,0x200ull,
0x201008040200ull,0x200ull,0x40200ull,0x200ull,0x8040200ull,0x200ull,0x40200ull,0x200ull,
0x1008040200ull,0x200ull,0x40200ull,0x200ull,0x8040200ull,0x200ull,0x40200ull,0x200ull
},{
0x80402010080400ull,0x400ull,0x80400ull,0x400ull,0x10080400ull,0x400ull,0x80400ull,0x400ull,
0x2010080400ull,0x400ull,0x80400ull,0x400ull,0x10080400ull,0x400ull,0x80400ull,0x400ull,
0x402010080400ull,0x400ull,0x80400ull,0x400ull,0x10080400ull,0x400ull,0x80400ull,0x400ull,
0x2010080400ull,0x400ull,0x80400ull,0x400ull,0x10080400ull,0x400ull,0x80400ull,0x400ull,
0x80402010080400ull,0x400ull,0x80400ull,0x400ull,0x10080400ull,0x400ull,0x80400ull,0x400ull,
0x2010080400ull,0x400ull,0x80400ull,0x400ull,0x10080400ull,0x400ull,0x80400ull,0x400ull,
0x402010080400ull,0x400ull,0x80400ull,0x400ull,0x10080400ull,0x400ull,0x80400ull,0x400ull,
0x2010080400ull,0x400ull,0x80400ull,0x400ull,0x10080400ull,0x400ull,0x80400ull,0x400ull
},{
0x804020100800ull,0x800ull,0x100800ull,0x800ull,0x20100800ull,0x800ull,0x100800ull,0x800ull,
0x4020100800ull,0x800ull,0x100800ull,0x800ull,0x20100800ull,0x800ull,0x100800ull,0x800ull,
0x804020100800ull,0x800ull,0x100800ull,0x800ull,0x20100800ull,0x800ull,0x100800ull,0x800ull,
0x4020100800ull,0x800ull,0x100800ull,0x800ull,0x20100800ull,0x800ull,0x100800ull,0x800ull,
0x804020100800ull,0x800ull,0x100800ull,0x800ull,0x20100800ull,0x800ull,0x100800ull,0x800ull,
0x4020100800ull,0x800ull,0x100800ull,0x800ull,0x20100800ull,0x800ull,0x100800ull,0x800ull,
0x804020100800ull,0x800ull,0x100800ull,0x800ull,0x20100800ull,0x800ull,0x100800ull,0x800ull,
0x4020100800ull,0x800ull,0x100800ull,0x800ull,0x20100800ull,0x800ull,0x100800ull,0x800ull
},{
0x8040201000ull,0x1000ull,0x201000ull,0x1000ull,0x40201000ull,0x1000ull,0x201000ull,0x1000ull,
0x8040201000ull,0x1000ull,0x201000ull,0x1000ull,0x40201000ull,0x1000ull,0x201000ull,0x1000ull,
0x8040201000ull,0x1000ull,0x201000ull,0x1000ull,0x40201000ull,0x1000ull,0x201000ull,0x1000ull,
0x8040201000ull,0x1000ull,0x201000ull,0x1000ull,0x40201000ull,0x1000ull,0x201000ull,0x1000ull,
0x8040201000ull,0x1000ull,0x201000ull,0x1000ull,0x40201000ull,0x1000ull,0x201000ull,0x1000ull,
0x8040201000ull,0x1000ull,0x201000ull,0x1000ull,0x40201000ull,0x1000ull,0x201000ull,0x1000ull,
0x8040201000ull,0x1000ull,0x201000ull,0x1000ull,0x40201000ull,0x1000ull,0x201000ull,0x1000ull,
0x8040201000ull,0x1000ull,0x201000ull,0x1000ull,0x40201000ull,0x1000ull,0x201000ull,0x1000ull
},{
0x80402000ull,0x2000ull,0x402000ull,0x2000ull,0x80402000ull,0x2000ull,0x402000ull,0x2000ull,
0x80402000ull,0x2000ull,0x402000ull,0x2000ull,0x80402000ull,0x2000ull,0x402000ull,0x2000ull,
0x80402000ull,0x2000ull,0x402000ull,0x2000ull,0x80402000ull,0x2000ull,0x402000ull,0x2000ull,
0x80402000ull,0x2000ull,0x402000ull,0x2000ull,0x80402000ull,0x2000ull,0x402000ull,0x2000ull,
0x80402000ull,0x2000ull,0x402000ull,0x2000ull,0x80402000ull,0x2000ull,0x402000ull,0x2000ull,
0x80402000ull,0x2000ull,0x402000ull,0x2000ull,0x80402000ull,0x2000ull,0x402000ull,0x2000ull,
0x80402000ull,0x2000ull,0x402000ull,0x2000ull,0x80402000ull,0x2000ull,0x402000ull,0x2000ull,
0x80402000ull,0x2000ull,0x402000ull,0x2000ull,0x80402000ull,0x2000ull,0x402000ull,0x2000ull
},{
0x804000ull,0x4000ull,0x804000ull,0x4000ull,0x804000ull,0x4000ull,0x804000ull,0x4000ull,
0x804000ull,0x4000ull,0x804000ull,0x4000ull,0x804000ull,0x4000ull,0x804000ull,0x4000ull,
0x804000ull,0x4000ull,0x804000ull,0x4000ull,0x804000ull,0x4000ull,0x804000ull,0x4000ull,
0x804000ull,0x4000ull,0x804000ull,0x4000ull,0x804000ull,0x4000ull,0x804000ull,0x4000ull,
0x804000ull,0x4000ull,0x804000ull,0x4000ull,0x804000ull,0x4000ull,0x804000ull,0x4000ull,
0x804000ull,0x4000ull,0x804000ull,0x4000ull,0x804000ull,0x4000ull,0x804000ull,0x4000ull,
0x804000ull,0x4000ull,0x804000ull,0x4000ull,0x804000ull,0x4000ull,0x804000ull,0x4000ull,
0x804000ull,0x4000ull,0x804000ull,0x4000ull,0x804000ull,0x4000ull,0x804000ull,0x4000ull
},{
0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,
0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,
0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,
0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,
0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,
0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,
0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,
0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull
},{
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull
},{
0x4020100804020000ull,0x20000ull,0x4020000ull,0x20000ull,0x804020000ull,0x20000ull,0x4020000ull,0x20000ull,
0x100804020000ull,0x20000ull,0x4020000ull,0x20000ull,0x804020000ull,0x20000ull,0x4020000ull,0x20000ull,
0x20100804020000ull,0x20000ull,0x4020000ull,0x20000ull,0x804020000ull,0x20000ull,0x4020000ull,0x20000ull,
0x100804020000ull,0x20000ull,0x4020000ull,0x20000ull,0x804020000ull,0x20000ull,0x4020000ull,0x20000ull,
0x4020100804020000ull,0x20000ull,0x4020000ull,0x20000ull,0x804020000ull,0x20000ull,0x4020000ull,0x20000ull,
0x100804020000ull,0x20000ull,0x4020000ull,0x20000ull,0x804020000ull,0x20000ull,0x4020000ull,0x20000ull,
0x20100804020000ull,0x20000ull,0x4020000ull,0x20000ull,0x804020000ull,0x20000ull,0x4020000ull,0x20000ull,
0x100804020000ull,0x20000ull,0x4020000ull,0x20000ull,0x804020000ull,0x20000ull,0x4020000ull,0x20000ull
},{
0x8040201008040001ull,0x8040201008040001ull,0x40001ull,0x40001ull,0x8040001ull,0x8040001ull,0x40001ull,0x40001ull,
0x1008040001ull,0x1008040001ull,0x40001ull,0x40001ull,0x8040001ull,0x8040001ull,0x40001ull,0x40001ull,
0x201008040001ull,0x201008040001ull,0x40001ull,0x40001ull,0x8040001ull,0x8040001ull,0x40001ull,0x40001ull,
0x1008040001ull,0x1008040001ull,0x40001ull,0x40001ull,0x8040001ull,0x8040001ull,0x40001ull,0x40001ull,
0x40201008040001ull,0x40201008040001ull,0x40001ull,0x40001ull,0x8040001ull,0x8040001ull,0x40001ull,0x40001ull,
0x1008040001ull,0x1008040001ull,0x40001ull,0x40001ull,0x8040001ull,0x8040001ull,0x40001ull,0x40001ull,
0x201008040001ull,0x201008040001ull,0x40001ull,0x40001ull,0x8040001ull,0x8040001ull,0x40001ull,0x40001ull,
0x1008040001ull,0x1008040001ull,0x40001ull,0x40001ull,0x8040001ull,0x8040001ull,0x40001ull,0x40001ull
},{
0x80402010080002ull,0x80402010080002ull,0x80002ull,0x80002ull,0x10080002ull,0x10080002ull,0x80002ull,0x80002ull,
0x2010080002ull,0x2010080002ull,0x80002ull,0x80002ull,0x10080002ull,0x10080002ull,0x80002ull,0x80002ull,
0x402010080002ull,0x402010080002ull,0x80002ull,0x80002ull,0x10080002ull,0x10080002ull,0x80002ull,0x80002ull,
0x2010080002ull,0x2010080002ull,0x80002ull,0x80002ull,0x10080002ull,0x10080002ull,0x80002ull,0x80002ull,
0x80402010080002ull,0x80402010080002ull,0x80002ull,0x80002ull,0x10080002ull,0x10080002ull,0x80002ull,0x80002ull,
0x2010080002ull,0x2010080002ull,0x80002ull,0x80002ull,0x10080002ull,0x10080002ull,0x80002ull,0x80002ull,
0x402010080002ull,0x402010080002ull,0x80002ull,0x80002ull,0x10080002ull,0x10080002ull,0x80002ull,0x80002ull,
0x2010080002ull,0x2010080002ull,0x80002ull,0x80002ull,0x10080002ull,0x10080002ull,0x80002ull,0x80002ull
},{
0x804020100004ull,0x804020100004ull,0x100004ull,0x100004ull,0x20100004ull,0x20100004ull,0x100004ull,0x100004ull,
0x4020100004ull,0x4020100004ull,0x100004ull,0x100004ull,0x20100004ull,0x20100004ull,0x100004ull,0x100004ull,
0x804020100004ull,0x804020100004ull,0x100004ull,0x100004ull,0x20100004ull,0x20100004ull,0x100004ull,0x100004ull,
0x4020100004ull,0x4020100004ull,0x100004ull,0x100004ull,0x20100004ull,0x20100004ull,0x100004ull,0x100004ull,
0x804020100004ull,0x804020100004ull,0x100004ull,0x100004ull,0x20100004ull,0x20100004ull,0x100004ull,0x100004ull,
0x4020100004ull,0x4020100004ull,0x100004ull,0x100004ull,0x20100004ull,0x20100004ull,0x100004ull,0x100004ull,
0x804020100004ull,0x804020100004ull,0x100004ull,0x100004ull,0x20100004ull,0x20100004ull,0x100004ull,0x100004ull,
0x4020100004ull,0x4020100004ull,0x100004ull,0x100004ull,0x20100004ull,0x20100004ull,0x100004ull,0x100004ull
},{
0x8040200008ull,0x8040200008ull,0x200008ull,0x200008ull,0x40200008ull,0x40200008ull,0x200008ull,0x200008ull,
0x8040200008ull,0x8040200008ull,0x200008ull,0x200008ull,0x40200008ull,0x40200008ull,0x200008ull,0x200008ull,
0x8040200008ull,0x8040200008ull,0x200008ull,0x200008ull,0x40200008ull,0x40200008ull,0x200008ull,0x200008ull,
0x8040200008ull,0x8040200008ull,0x200008ull,0x200008ull,0x40200008ull,0x40200008ull,0x200008ull,0x200008ull,
0x8040200008ull,0x8040200008ull,0x200008ull,0x200008ull,0x40200008ull,0x40200008ull,0x200008ull,0x200008ull,
0x8040200008ull,0x8040200008ull,0x200008ull,0x200008ull,0x40200008ull,0x40200008ull,0x200008ull,0x200008ull,
0x8040200008ull,0x8040200008ull,0x200008ull,0x200008ull,0x40200008ull,0x40200008ull,0x200008ull,0x200008ull,
0x8040200008ull,0x8040200008ull,0x200008ull,0x200008ull,0x40200008ull,0x40200008ull,0x200008ull,0x200008ull
},{
0x80400010ull,0x80400010ull,0x400010ull,0x400010ull,0x80400010ull,0x80400010ull,0x400010ull,0x400010ull,
0x80400010ull,0x80400010ull,0x400010ull,0x400010ull,0x80400010ull,0x80400010ull,0x400010ull,0x400010ull,
0x80400010ull,0x80400010ull,0x400010ull,0x400010ull,0x80400010ull,0x80400010ull,0x400010ull,0x400010ull,
0x80400010ull,0x80400010ull,0x400010ull,0x400010ull,0x80400010ull,0x80400010ull,0x400010ull,0x400010ull,
0x80400010ull,0x80400010ull,0x400010ull,0x400010ull,0x80400010ull,0x80400010ull,0x400010ull,0x400010ull,
0x80400010ull,0x80400010ull,0x400010ull,0x400010ull,0x80400010ull,0x80400010ull,0x400010ull,0x400010ull,
0x80400010ull,0x80400010ull,0x400010ull,0x400010ull,0x80400010ull,0x80400010ull,0x400010ull,0x400010ull,
0x80400010ull,0x80400010ull,0x400010ull,0x400010ull,0x80400010ull,0x80400010ull,0x400010ull,0x400010ull
},{
0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,
0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,
0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,
0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,
0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,
0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,
0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,
0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull,0x800020ull
},{
0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,
0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,
0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,
0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,
0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,
0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,
0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,
0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull
},{
0x2010080402000000ull,0x2000000ull,0x402000000ull,0x2000000ull,0x80402000000ull,0x2000000ull,0x402000000ull,0x2000000ull,
0x10080402000000ull,0x2000000ull,0x402000000ull,0x2000000ull,0x80402000000ull,0x2000000ull,0x402000000ull,0x2000000ull,
0x2010080402000000ull,0x2000000ull,0x402000000ull,0x2000000ull,0x80402000000ull,0x2000000ull,0x402000000ull,0x2000000ull,
0x10080402000000ull,0x2000000ull,0x402000000ull,0x2000000ull,0x80402000000ull,0x2000000ull,0x402000000ull,0x2000000ull,
0x2010080402000000ull,0x2000000ull,0x402000000ull,0x2000000ull,0x80402000000ull,0x2000000ull,0x402000000ull,0x2000000ull,
0x10080402000000ull,0x2000000ull,0x402000000ull,0x2000000ull,0x80402000000ull,0x2000000ull,0x402000000ull,0x2000000ull,
0x2010080402000000ull,0x2000000ull,0x402000000ull,0x2000000ull,0x80402000000ull,0x2000000ull,0x402000000ull,0x2000000ull,
0x10080402000000ull,0x2000000ull,0x402000000ull,0x2000000ull,0x80402000000ull,0x2000000ull,0x402000000ull,0x2000000ull
},{
0x4020100804000100ull,0x4020100804000100ull,0x4000100ull,0x4000100ull,0x804000100ull,0x804000100ull,0x4000100ull,0x4000100ull,
0x100804000100ull,0x100804000100ull,0x4000100ull,0x4000100ull,0x804000100ull,0x804000100ull,0x4000100ull,0x4000100ull,
0x20100804000100ull,0x20100804000100ull,0x4000100ull,0x4000100ull,0x804000100ull,0x804000100ull,0x4000100ull,0x4000100ull,
0x100804000100ull,0x100804000100ull,0x4000100ull,0x4000100ull,0x804000100ull,0x804000100ull,0x4000100ull,0x4000100ull,
0x4020100804000100ull,0x4020100804000100ull,0x4000100ull,0x4000100ull,0x804000100ull,0x804000100ull,0x4000100ull,0x4000100ull,
0x100804000100ull,0x100804000100ull,0x4000100ull,0x4000100ull,0x804000100ull,0x804000100ull,0x4000100ull,0x4000100ull,
0x20100804000100ull,0x20100804000100ull,0x4000100ull,0x4000100ull,0x804000100ull,0x804000100ull,0x4000100ull,0x4000100ull,
0x100804000100ull,0x100804000100ull,0x4000100ull,0x4000100ull,0x804000100ull,0x804000100ull,0x4000100ull,0x4000100ull
},{
0x8040201008000201ull,0x8040201008000200ull,0x8040201008000201ull,0x8040201008000200ull,0x8000201ull,0x8000200ull,0x8000201ull,0x8000200ull,
0x1008000201ull,0x1008000200ull,0x1008000201ull,0x1008000200ull,0x8000201ull,0x8000200ull,0x8000201ull,0x8000200ull,
0x201008000201ull,0x201008000200ull,0x201008000201ull,0x201008000200ull,0x8000201ull,0x8000200ull,0x8000201ull,0x8000200ull,
0x1008000201ull,0x1008000200ull,0x1008000201ull,0x1008000200ull,0x8000201ull,0x8000200ull,0x8000201ull,0x8000200ull,
0x40201008000201ull,0x40201008000200ull,0x40201008000201ull,0x40201008000200ull,0x8000201ull,0x8000200ull,0x8000201ull,0x8000200ull,
0x1008000201ull,0x1008000200ull,0x1008000201ull,0x1008000200ull,0x8000201ull,0x8000200ull,0x8000201ull,0x8000200ull,
0x201008000201ull,0x201008000200ull,0x201008000201ull,0x201008000200ull,0x8000201ull,0x8000200ull,0x8000201ull,0x8000200ull,
0x1008000201ull,0x1008000200ull,0x1008000201ull,0x1008000200ull,0x8000201ull,0x8000200ull,0x8000201ull,0x8000200ull
},{
0x80402010000402ull,0x80402010000400ull,0x80402010000402ull,0x80402010000400ull,0x10000402ull,0x10000400ull,0x10000402ull,0x10000400ull,
0x2010000402ull,0x2010000400ull,0x2010000402ull,0x2010000400ull,0x10000402ull,0x10000400ull,0x10000402ull,0x10000400ull,
0x402010000402ull,0x402010000400ull,0x402010000402ull,0x402010000400ull,0x10000402ull,0x10000400ull,0x10000402ull,0x10000400ull,
0x2010000402ull,0x2010000400ull,0x2010000402ull,0x2010000400ull,0x10000402ull,0x10000400ull,0x10000402ull,0x10000400ull,
0x80402010000402ull,0x80402010000400ull,0x80402010000402ull,0x80402010000400ull,0x10000402ull,0x10000400ull,0x10000402ull,0x10000400ull,
0x2010000402ull,0x2010000400ull,0x2010000402ull,0x2010000400ull,0x10000402ull,0x10000400ull,0x10000402ull,0x10000400ull,
0x402010000402ull,0x402010000400ull,0x402010000402ull,0x402010000400ull,0x10000402ull,0x10000400ull,0x10000402ull,0x10000400ull,
0x2010000402ull,0x2010000400ull,0x2010000402ull,0x2010000400ull,0x10000402ull,0x10000400ull,0x10000402ull,0x10000400ull
},{
0x804020000804ull,0x804020000800ull,0x804020000804ull,0x804020000800ull,0x20000804ull,0x20000800ull,0x20000804ull,0x20000800ull,
0x4020000804ull,0x4020000800ull,0x4020000804ull,0x4020000800ull,0x20000804ull,0x20000800ull,0x20000804ull,0x20000800ull,
0x804020000804ull,0x804020000800ull,0x804020000804ull,0x804020000800ull,0x20000804ull,0x20000800ull,0x20000804ull,0x20000800ull,
0x4020000804ull,0x4020000800ull,0x4020000804ull,0x4020000800ull,0x20000804ull,0x20000800ull,0x20000804ull,0x20000800ull,
0x804020000804ull,0x804020000800ull,0x804020000804ull,0x804020000800ull,0x20000804ull,0x20000800ull,0x20000804ull,0x20000800ull,
0x4020000804ull,0x4020000800ull,0x4020000804ull,0x4020000800ull,0x20000804ull,0x20000800ull,0x20000804ull,0x20000800ull,
0x804020000804ull,0x804020000800ull,0x804020000804ull,0x804020000800ull,0x20000804ull,0x20000800ull,0x20000804ull,0x20000800ull,
0x4020000804ull,0x4020000800ull,0x4020000804ull,0x4020000800ull,0x20000804ull,0x20000800ull,0x20000804ull,0x20000800ull
},{
0x8040001008ull,0x8040001000ull,0x8040001008ull,0x8040001000ull,0x40001008ull,0x40001000ull,0x40001008ull,0x40001000ull,
0x8040001008ull,0x8040001000ull,0x8040001008ull,0x8040001000ull,0x40001008ull,0x40001000ull,0x40001008ull,0x40001000ull,
0x8040001008ull,0x8040001000ull,0x8040001008ull,0x8040001000ull,0x40001008ull,0x40001000ull,0x40001008ull,0x40001000ull,
0x8040001008ull,0x8040001000ull,0x8040001008ull,0x8040001000ull,0x40001008ull,0x40001000ull,0x40001008ull,0x40001000ull,
0x8040001008ull,0x8040001000ull,0x8040001008ull,0x8040001000ull,0x40001008ull,0x40001000ull,0x40001008ull,0x40001000ull,
0x8040001008ull,0x8040001000ull,0x8040001008ull,0x8040001000ull,0x40001008ull,0x40001000ull,0x40001008ull,0x40001000ull,
0x8040001008ull,0x8040001000ull,0x8040001008ull,0x8040001000ull,0x40001008ull,0x40001000ull,0x40001008ull,0x40001000ull,
0x8040001008ull,0x8040001000ull,0x8040001008ull,0x8040001000ull,0x40001008ull,0x40001000ull,0x40001008ull,0x40001000ull
},{
0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,
0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,
0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,
0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,
0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,
0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,
0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,
0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull,0x80002010ull,0x80002000ull
},{
0x4020ull,0x4000ull,0x4020ull,0x4000ull,0x4020ull,0x4000ull,0x4020ull,0x4000ull,
0x4020ull,0x4000ull,0x4020ull,0x4000ull,0x4020ull,0x4000ull,0x4020ull,0x4000ull,
0x4020ull,0x4000ull,0x4020ull,0x4000ull,0x4020ull,0x4000ull,0x4020ull,0x4000ull,
0x4020ull,0x4000ull,0x4020ull,0x4000ull,0x4020ull,0x4000ull,0x4020ull,0x4000ull,
0x4020ull,0x4000ull,0x4020ull,0x4000ull,0x4020ull,0x4000ull,0x4020ull,0x4000ull,
0x4020ull,0x4000ull,0x4020ull,0x4000ull,0x4020ull,0x4000ull,0x4020ull,0x4000ull,
0x4020ull,0x4000ull,0x4020ull,0x4000ull,0x4020ull,0x4000ull,0x4020ull,0x4000ull,
0x4020ull,0x4000ull,0x4020ull,0x4000ull,0x4020ull,0x4000ull,0x4020ull,0x4000ull
},{
0x1008040200000000ull,0x200000000ull,0x40200000000ull,0x200000000ull,0x8040200000000ull,0x200000000ull,0x40200000000ull,0x200000000ull,
0x1008040200000000ull,0x200000000ull,0x40200000000ull,0x200000000ull,0x8040200000000ull,0x200000000ull,0x40200000000ull,0x200000000ull,
0x1008040200000000ull,0x200000000ull,0x40200000000ull,0x200000000ull,0x8040200000000ull,0x200000000ull,0x40200000000ull,0x200000000ull,
0x1008040200000000ull,0x200000000ull,0x40200000000ull,0x200000000ull,0x8040200000000ull,0x200000000ull,0x40200000000ull,0x200000000ull,
0x1008040200000000ull,0x200000000ull,0x40200000000ull,0x200000000ull,0x8040200000000ull,0x200000000ull,0x40200000000ull,0x200000000ull,
0x1008040200000000ull,0x200000000ull,0x40200000000ull,0x200000000ull,0x8040200000000ull,0x200000000ull,0x40200000000ull,0x200000000ull,
0x1008040200000000ull,0x200000000ull,0x40200000000ull,0x200000000ull,0x8040200000000ull,0x200000000ull,0x40200000000ull,0x200000000ull,
0x1008040200000000ull,0x200000000ull,0x40200000000ull,0x200000000ull,0x8040200000000ull,0x200000000ull,0x40200000000ull,0x200000000ull
},{
0x2010080400010000ull,0x2010080400010000ull,0x400010000ull,0x400010000ull,0x80400010000ull,0x80400010000ull,0x400010000ull,0x400010000ull,
0x10080400010000ull,0x10080400010000ull,0x400010000ull,0x400010000ull,0x80400010000ull,0x80400010000ull,0x400010000ull,0x400010000ull,
0x2010080400010000ull,0x2010080400010000ull,0x400010000ull,0x400010000ull,0x80400010000ull,0x80400010000ull,0x400010000ull,0x400010000ull,
0x10080400010000ull,0x10080400010000ull,0x400010000ull,0x400010000ull,0x80400010000ull,0x80400010000ull,0x400010000ull,0x400010000ull,
0x2010080400010000ull,0x2010080400010000ull,0x400010000ull,0x400010000ull,0x80400010000ull,0x80400010000ull,0x400010000ull,0x400010000ull,
0x10080400010000ull,0x10080400010000ull,0x400010000ull,0x400010000ull,0x80400010000ull,0x80400010000ull,0x400010000ull,0x400010000ull,
0x2010080400010000ull,0x2010080400010000ull,0x400010000ull,0x400010000ull,0x80400010000ull,0x80400010000ull,0x400010000ull,0x400010000ull,
0x10080400010000ull,0x10080400010000ull,0x400010000ull,0x400010000ull,0x80400010000ull,0x80400010000ull,0x400010000ull,0x400010000ull
},{
0x4020100800020100ull,0x4020100800020000ull,0x4020100800020100ull,0x4020100800020000ull,0x800020100ull,0x800020000ull,0x800020100ull,0x800020000ull,
0x100800020100ull,0x100800020000ull,0x100800020100ull,0x100800020000ull,0x800020100ull,0x800020000ull,0x800020100ull,0x800020000ull,
0x20100800020100ull,0x20100800020000ull,0x20100800020100ull,0x20100800020000ull,0x800020100ull,0x800020000ull,0x800020100ull,0x800020000ull,
0x100800020100ull,0x100800020000ull,0x100800020100ull,0x100800020000ull,0x800020100ull,0x800020000ull,0x800020100ull,0x800020000ull,
0x4020100800020100ull,0x4020100800020000ull,0x4020100800020100ull,0x4020100800020000ull,0x800020100ull,0x800020000ull,0x800020100ull,0x800020000ull,
0x100800020100ull,0x100800020000ull,0x100800020100ull,0x100800020000ull,0x800020100ull,0x800020000ull,0x800020100ull,0x800020000ull,
0x20100800020100ull,0x20100800020000ull,0x20100800020100ull,0x20100800020000ull,0x800020100ull,0x800020000ull,0x800020100ull,0x800020000ull,
0x100800020100ull,0x100800020000ull,0x100800020100ull,0x100800020000ull,0x800020100ull,0x800020000ull,0x800020100ull,0x800020000ull
},{
0x8040201000040201ull,0x8040201000040200ull,0x8040201000040000ull,0x8040201000040000ull,0x8040201000040201ull,0x8040201000040200ull,0x8040201000040000ull,0x8040201000040000ull,
0x1000040201ull,0x1000040200ull,0x1000040000ull,0x1000040000ull,0x1000040201ull,0x1000040200ull,0x1000040000ull,0x1000040000ull,
0x201000040201ull,0x201000040200ull,0x201000040000ull,0x201000040000ull,0x201000040201ull,0x201000040200ull,0x201000040000ull,0x201000040000ull,
0x1000040201ull,0x1000040200ull,0x1000040000ull,0x1000040000ull,0x1000040201ull,0x1000040200ull,0x1000040000ull,0x1000040000ull,
0x40201000040201ull,0x40201000040200ull,0x40201000040000ull,0x40201000040000ull,0x40201000040201ull,0x40201000040200ull,0x40201000040000ull,0x40201000040000ull,
0x1000040201ull,0x1000040200ull,0x1000040000ull,0x1000040000ull,0x1000040201ull,0x1000040200ull,0x1000040000ull,0x1000040000ull,
0x201000040201ull,0x201000040200ull,0x201000040000ull,0x201000040000ull,0x201000040201ull,0x201000040200ull,0x201000040000ull,0x201000040000ull,
0x1000040201ull,0x1000040200ull,0x1000040000ull,0x1000040000ull,0x1000040201ull,0x1000040200ull,0x1000040000ull,0x1000040000ull
},{
0x80402000080402ull,0x80402000080400ull,0x80402000080000ull,0x80402000080000ull,0x80402000080402ull,0x80402000080400ull,0x80402000080000ull,0x80402000080000ull,
0x2000080402ull,0x2000080400ull,0x2000080000ull,0x2000080000ull,0x2000080402ull,0x2000080400ull,0x2000080000ull,0x2000080000ull,
0x402000080402ull,0x402000080400ull,0x402000080000ull,0x402000080000ull,0x402000080402ull,0x402000080400ull,0x402000080000ull,0x402000080000ull,
0x2000080402ull,0x2000080400ull,0x2000080000ull,0x2000080000ull,0x2000080402ull,0x2000080400ull,0x2000080000ull,0x2000080000ull,
0x80402000080402ull,0x80402000080400ull,0x80402000080000ull,0x80402000080000ull,0x80402000080402ull,0x80402000080400ull,0x80402000080000ull,0x80402000080000ull,
0x2000080402ull,0x2000080400ull,0x2000080000ull,0x2000080000ull,0x2000080402ull,0x2000080400ull,0x2000080000ull,0x2000080000ull,
0x402000080402ull,0x402000080400ull,0x402000080000ull,0x402000080000ull,0x402000080402ull,0x402000080400ull,0x402000080000ull,0x402000080000ull,
0x2000080402ull,0x2000080400ull,0x2000080000ull,0x2000080000ull,0x2000080402ull,0x2000080400ull,0x2000080000ull,0x2000080000ull
},{
0x804000100804ull,0x804000100800ull,0x804000100000ull,0x804000100000ull,0x804000100804ull,0x804000100800ull,0x804000100000ull,0x804000100000ull,
0x4000100804ull,0x4000100800ull,0x4000100000ull,0x4000100000ull,0x4000100804ull,0x4000100800ull,0x4000100000ull,0x4000100000ull,
0x804000100804ull,0x804000100800ull,0x804000100000ull,0x804000100000ull,0x804000100804ull,0x804000100800ull,0x804000100000ull,0x804000100000ull,
0x4000100804ull,0x4000100800ull,0x4000100000ull,0x4000100000ull,0x4000100804ull,0x4000100800ull,0x4000100000ull,0x4000100000ull,
0x804000100804ull,0x804000100800ull,0x804000100000ull,0x804000100000ull,0x804000100804ull,0x804000100800ull,0x804000100000ull,0x804000100000ull,
0x4000100804ull,0x4000100800ull,0x4000100000ull,0x4000100000ull,0x4000100804ull,0x4000100800ull,0x4000100000ull,0x4000100000ull,
0x804000100804ull,0x804000100800ull,0x804000100000ull,0x804000100000ull,0x804000100804ull,0x804000100800ull,0x804000100000ull,0x804000100000ull,
0x4000100804ull,0x4000100800ull,0x4000100000ull,0x4000100000ull,0x4000100804ull,0x4000100800ull,0x4000100000ull,0x4000100000ull
},{
0x8000201008ull,0x8000201000ull,0x8000200000ull,0x8000200000ull,0x8000201008ull,0x8000201000ull,0x8000200000ull,0x8000200000ull,
0x8000201008ull,0x8000201000ull,0x8000200000ull,0x8000200000ull,0x8000201008ull,0x8000201000ull,0x8000200000ull,0x8000200000ull,
0x8000201008ull,0x8000201000ull,0x8000200000ull,0x8000200000ull,0x8000201008ull,0x8000201000ull,0x8000200000ull,0x8000200000ull,
0x8000201008ull,0x8000201000ull,0x8000200000ull,0x8000200000ull,0x8000201008ull,0x8000201000ull,0x8000200000ull,0x8000200000ull,
0x8000201008ull,0x8000201000ull,0x8000200000ull,0x8000200000ull,0x8000201008ull,0x8000201000ull,0x8000200000ull,0x8000200000ull,
0x8000201008ull,0x8000201000ull,0x8000200000ull,0x8000200000ull,0x8000201008ull,0x8000201000ull,0x8000200000ull,0x8000200000ull,
0x8000201008ull,0x8000201000ull,0x8000200000ull,0x8000200000ull,0x8000201008ull,0x8000201000ull,0x8000200000ull,0x8000200000ull,
0x8000201008ull,0x8000201000ull,0x8000200000ull,0x8000200000ull,0x8000201008ull,0x8000201000ull,0x8000200000ull,0x8000200000ull
},{
0x402010ull,0x402000ull,0x400000ull,0x400000ull,0x402010ull,0x402000ull,0x400000ull,0x400000ull,
0x402010ull,0x402000ull,0x400000ull,0x400000ull,0x402010ull,0x402000ull,0x400000ull,0x400000ull,
0x402010ull,0x402000ull,0x400000ull,0x400000ull,0x402010ull,0x402000ull,0x400000ull,0x400000ull,
0x402010ull,0x402000ull,0x400000ull,0x400000ull,0x402010ull,0x402000ull,0x400000ull,0x400000ull,
0x402010ull,0x402000ull,0x400000ull,0x400000ull,0x402010ull,0x402000ull,0x400000ull,0x400000ull,
0x402010ull,0x402000ull,0x400000ull,0x400000ull,0x402010ull,0x402000ull,0x400000ull,0x400000ull,
0x402010ull,0x402000ull,0x400000ull,0x400000ull,0x402010ull,0x402000ull,0x400000ull,0x400000ull,
0x402010ull,0x402000ull,0x400000ull,0x400000ull,0x402010ull,0x402000ull,0x400000ull,0x400000ull
},{
0x804020000000000ull,0x20000000000ull,0x4020000000000ull,0x20000000000ull,0x804020000000000ull,0x20000000000ull,0x4020000000000ull,0x20000000000ull,
0x804020000000000ull,0x20000000000ull,0x4020000000000ull,0x20000000000ull,0x804020000000000ull,0x20000000000ull,0x4020000000000ull,0x20000000000ull,
0x804020000000000ull,0x20000000000ull,0x4020000000000ull,0x20000000000ull,0x804020000000000ull,0x20000000000ull,0x4020000000000ull,0x20000000000ull,
0x804020000000000ull,0x20000000000ull,0x4020000000000ull,0x20000000000ull,0x804020000000000ull,0x20000000000ull,0x4020000000000ull,0x20000000000ull,
0x804020000000000ull,0x20000000000ull,0x4020000000000ull,0x20000000000ull,0x804020000000000ull,0x20000000000ull,0x4020000000000ull,0x20000000000ull,
0x804020000000000ull,0x20000000000ull,0x4020000000000ull,0x20000000000ull,0x804020000000000ull,0x20000000000ull,0x4020000000000ull,0x20000000000ull,
0x804020000000000ull,0x20000000000ull,0x4020000000000ull,0x20000000000ull,0x804020000000000ull,0x20000000000ull,0x4020000000000ull,0x20000000000ull,
0x804020000000000ull,0x20000000000ull,0x4020000000000ull,0x20000000000ull,0x804020000000000ull,0x20000000000ull,0x4020000000000ull,0x20000000000ull
},{
0x1008040001000000ull,0x1008040001000000ull,0x40001000000ull,0x40001000000ull,0x8040001000000ull,0x8040001000000ull,0x40001000000ull,0x40001000000ull,
0x1008040001000000ull,0x1008040001000000ull,0x40001000000ull,0x40001000000ull,0x8040001000000ull,0x8040001000000ull,0x40001000000ull,0x40001000000ull,
0x1008040001000000ull,0x1008040001000000ull,0x40001000000ull,0x40001000000ull,0x8040001000000ull,0x8040001000000ull,0x40001000000ull,0x40001000000ull,
0x1008040001000000ull,0x1008040001000000ull,0x40001000000ull,0x40001000000ull,0x8040001000000ull,0x8040001000000ull,0x40001000000ull,0x40001000000ull,
0x1008040001000000ull,0x1008040001000000ull,0x40001000000ull,0x40001000000ull,0x8040001000000ull,0x8040001000000ull,0x40001000000ull,0x40001000000ull,
0x1008040001000000ull,0x1008040001000000ull,0x40001000000ull,0x40001000000ull,0x8040001000000ull,0x8040001000000ull,0x40001000000ull,0x40001000000ull,
0x1008040001000000ull,0x1008040001000000ull,0x40001000000ull,0x40001000000ull,0x8040001000000ull,0x8040001000000ull,0x40001000000ull,0x40001000000ull,
0x1008040001000000ull,0x1008040001000000ull,0x40001000000ull,0x40001000000ull,0x8040001000000ull,0x8040001000000ull,0x40001000000ull,0x40001000000ull
},{
0x2010080002010000ull,0x2010080002000000ull,0x2010080002010000ull,0x2010080002000000ull,0x80002010000ull,0x80002000000ull,0x80002010000ull,0x80002000000ull,
0x10080002010000ull,0x10080002000000ull,0x10080002010000ull,0x10080002000000ull,0x80002010000ull,0x80002000000ull,0x80002010000ull,0x80002000000ull,
0x2010080002010000ull,0x2010080002000000ull,0x2010080002010000ull,0x2010080002000000ull,0x80002010000ull,0x80002000000ull,0x80002010000ull,0x80002000000ull,
0x10080002010000ull,0x10080002000000ull,0x10080002010000ull,0x10080002000000ull,0x80002010000ull,0x80002000000ull,0x80002010000ull,0x80002000000ull,
0x2010080002010000ull,0x2010080002000000ull,0x2010080002010000ull,0x2010080002000000ull,0x80002010000ull,0x80002000000ull,0x80002010000ull,0x80002000000ull,
0x10080002010000ull,0x10080002000000ull,0x10080002010000ull,0x10080002000000ull,0x80002010000ull,0x80002000000ull,0x80002010000ull,0x80002000000ull,
0x2010080002010000ull,0x2010080002000000ull,0x2010080002010000ull,0x2010080002000000ull,0x80002010000ull,0x80002000000ull,0x80002010000ull,0x80002000000ull,
0x10080002010000ull,0x10080002000000ull,0x10080002010000ull,0x10080002000000ull,0x80002010000ull,0x80002000000ull,0x80002010000ull,0x80002000000ull
},{
0x4020100004020100ull,0x4020100004020000ull,0x4020100004000000ull,0x4020100004000000ull,0x4020100004020100ull,0x4020100004020000ull,0x4020100004000000ull,0x4020100004000000ull,
0x100004020100ull,0x100004020000ull,0x100004000000ull,0x100004000000ull,0x100004020100ull,0x100004020000ull,0x100004000000ull,0x100004000000ull,
0x20100004020100ull,0x20100004020000ull,0x20100004000000ull,0x20100004000000ull,0x20100004020100ull,0x20100004020000ull,0x20100004000000ull,0x20100004000000ull,
0x100004020100ull,0x100004020000ull,0x100004000000ull,0x100004000000ull,0x100004020100ull,0x100004020000ull,0x100004000000ull,0x100004000000ull,
0x4020100004020100ull,0x4020100004020000ull,0x4020100004000000ull,0x4020100004000000ull,0x4020100004020100ull,0x4020100004020000ull,0x4020100004000000ull,0x4020100004000000ull,
0x100004020100ull,0x100004020000ull,0x100004000000ull,0x100004000000ull,0x100004020100ull,0x100004020000ull,0x100004000000ull,0x100004000000ull,
0x20100004020100ull,0x20100004020000ull,0x20100004000000ull,0x20100004000000ull,0x20100004020100ull,0x20100004020000ull,0x20100004000000ull,0x20100004000000ull,
0x100004020100ull,0x100004020000ull,0x100004000000ull,0x100004000000ull,0x100004020100ull,0x100004020000ull,0x100004000000ull,0x100004000000ull
},{
0x8040200008040201ull,0x8040200008040200ull,0x8040200008040000ull,0x8040200008040000ull,0x8040200008000000ull,0x8040200008000000ull,0x8040200008000000ull,0x8040200008000000ull,
0x8040200008040201ull,0x8040200008040200ull,0x8040200008040000ull,0x8040200008040000ull,0x8040200008000000ull,0x8040200008000000ull,0x8040200008000000ull,0x8040200008000000ull,
0x200008040201ull,0x200008040200ull,0x200008040000ull,0x200008040000ull,0x200008000000ull,0x200008000000ull,0x200008000000ull,0x200008000000ull,
0x200008040201ull,0x200008040200ull,0x200008040000ull,0x200008040000ull,0x200008000000ull,0x200008000000ull,0x200008000000ull,0x200008000000ull,
0x40200008040201ull,0x40200008040200ull,0x40200008040000ull,0x40200008040000ull,0x40200008000000ull,0x40200008000000ull,0x40200008000000ull,0x40200008000000ull,
0x40200008040201ull,0x40200008040200ull,0x40200008040000ull,0x40200008040000ull,0x40200008000000ull,0x40200008000000ull,0x40200008000000ull,0x40200008000000ull,
0x200008040201ull,0x200008040200ull,0x200008040000ull,0x200008040000ull,0x200008000000ull,0x200008000000ull,0x200008000000ull,0x200008000000ull,
0x200008040201ull,0x200008040200ull,0x200008040000ull,0x200008040000ull,0x200008000000ull,0x200008000000ull,0x200008000000ull,0x200008000000ull
},{
0x80400010080402ull,0x80400010080400ull,0x80400010080000ull,0x80400010080000ull,0x80400010000000ull,0x80400010000000ull,0x80400010000000ull,0x80400010000000ull,
0x80400010080402ull,0x80400010080400ull,0x80400010080000ull,0x80400010080000ull,0x80400010000000ull,0x80400010000000ull,0x80400010000000ull,0x80400010000000ull,
0x400010080402ull,0x400010080400ull,0x400010080000ull,0x400010080000ull,0x400010000000ull,0x400010000000ull,0x400010000000ull,0x400010000000ull,
0x400010080402ull,0x400010080400ull,0x400010080000ull,0x400010080000ull,0x400010000000ull,0x400010000000ull,0x400010000000ull,0x400010000000ull,
0x80400010080402ull,0x80400010080400ull,0x80400010080000ull,0x80400010080000ull,0x80400010000000ull,0x80400010000000ull,0x80400010000000ull,0x80400010000000ull,
0x80400010080402ull,0x80400010080400ull,0x80400010080000ull,0x80400010080000ull,0x80400010000000ull,0x80400010000000ull,0x80400010000000ull,0x80400010000000ull,
0x400010080402ull,0x400010080400ull,0x400010080000ull,0x400010080000ull,0x400010000000ull,0x400010000000ull,0x400010000000ull,0x400010000000ull,
0x400010080402ull,0x400010080400ull,0x400010080000ull,0x400010080000ull,0x400010000000ull,0x400010000000ull,0x400010000000ull,0x400010000000ull
},{
0x800020100804ull,0x800020100800ull,0x800020100000ull,0x800020100000ull,0x800020000000ull,0x800020000000ull,0x800020000000ull,0x800020000000ull,
0x800020100804ull,0x800020100800ull,0x800020100000ull,0x800020100000ull,0x800020000000ull,0x800020000000ull,0x800020000000ull,0x800020000000ull,
0x800020100804ull,0x800020100800ull,0x800020100000ull,0x800020100000ull,0x800020000000ull,0x800020000000ull,0x800020000000ull,0x800020000000ull,
0x800020100804ull,0x800020100800ull,0x800020100000ull,0x800020100000ull,0x800020000000ull,0x800020000000ull,0x800020000000ull,0x800020000000ull,
0x800020100804ull,0x800020100800ull,0x800020100000ull,0x800020100000ull,0x800020000000ull,0x800020000000ull,0x800020000000ull,0x800020000000ull,
0x800020100804ull,0x800020100800ull,0x800020100000ull,0x800020100000ull,0x800020000000ull,0x800020000000ull,0x800020000000ull,0x800020000000ull,
0x800020100804ull,0x800020100800ull,0x800020100000ull,0x800020100000ull,0x800020000000ull,0x800020000000ull,0x800020000000ull,0x800020000000ull,
0x800020100804ull,0x800020100800ull,0x800020100000ull,0x800020100000ull,0x800020000000ull,0x800020000000ull,0x800020000000ull,0x800020000000ull
},{
0x40201008ull,0x40201000ull,0x40200000ull,0x40200000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,
0x40201008ull,0x40201000ull,0x40200000ull,0x40200000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,
0x40201008ull,0x40201000ull,0x40200000ull,0x40200000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,
0x40201008ull,0x40201000ull,0x40200000ull,0x40200000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,
0x40201008ull,0x40201000ull,0x40200000ull,0x40200000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,
0x40201008ull,0x40201000ull,0x40200000ull,0x40200000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,
0x40201008ull,0x40201000ull,0x40200000ull,0x40200000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,
0x40201008ull,0x40201000ull,0x40200000ull,0x40200000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull
},{
0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,
0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,
0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,
0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,
0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,
0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,
0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,
0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull,0x402000000000000ull,0x2000000000000ull
},{
0x804000100000000ull,0x804000100000000ull,0x4000100000000ull,0x4000100000000ull,0x804000100000000ull,0x804000100000000ull,0x4000100000000ull,0x4000100000000ull,
0x804000100000000ull,0x804000100000000ull,0x4000100000000ull,0x4000100000000ull,0x804000100000000ull,0x804000100000000ull,0x4000100000000ull,0x4000100000000ull,
0x804000100000000ull,0x804000100000000ull,0x4000100000000ull,0x4000100000000ull,0x804000100000000ull,0x804000100000000ull,0x4000100000000ull,0x4000100000000ull,
0x804000100000000ull,0x804000100000000ull,0x4000100000000ull,0x4000100000000ull,0x804000100000000ull,0x804000100000000ull,0x4000100000000ull,0x4000100000000ull,
0x804000100000000ull,0x804000100000000ull,0x4000100000000ull,0x4000100000000ull,0x804000100000000ull,0x804000100000000ull,0x4000100000000ull,0x4000100000000ull,
0x804000100000000ull,0x804000100000000ull,0x4000100000000ull,0x4000100000000ull,0x804000100000000ull,0x804000100000000ull,0x4000100000000ull,0x4000100000000ull,
0x804000100000000ull,0x804000100000000ull,0x4000100000000ull,0x4000100000000ull,0x804000100000000ull,0x804000100000000ull,0x4000100000000ull,0x4000100000000ull,
0x804000100000000ull,0x804000100000000ull,0x4000100000000ull,0x4000100000000ull,0x804000100000000ull,0x804000100000000ull,0x4000100000000ull,0x4000100000000ull
},{
0x1008000201000000ull,0x1008000200000000ull,0x1008000201000000ull,0x1008000200000000ull,0x8000201000000ull,0x8000200000000ull,0x8000201000000ull,0x8000200000000ull,
0x1008000201000000ull,0x1008000200000000ull,0x1008000201000000ull,0x1008000200000000ull,0x8000201000000ull,0x8000200000000ull,0x8000201000000ull,0x8000200000000ull,
0x1008000201000000ull,0x1008000200000000ull,0x1008000201000000ull,0x1008000200000000ull,0x8000201000000ull,0x8000200000000ull,0x8000201000000ull,0x8000200000000ull,
0x1008000201000000ull,0x1008000200000000ull,0x1008000201000000ull,0x1008000200000000ull,0x8000201000000ull,0x8000200000000ull,0x8000201000000ull,0x8000200000000ull,
0x1008000201000000ull,0x1008000200000000ull,0x1008000201000000ull,0x1008000200000000ull,0x8000201000000ull,0x8000200000000ull,0x8000201000000ull,0x8000200000000ull,
0x1008000201000000ull,0x1008000200000000ull,0x1008000201000000ull,0x1008000200000000ull,0x8000201000000ull,0x8000200000000ull,0x8000201000000ull,0x8000200000000ull,
0x1008000201000000ull,0x1008000200000000ull,0x1008000201000000ull,0x1008000200000000ull,0x8000201000000ull,0x8000200000000ull,0x8000201000000ull,0x8000200000000ull,
0x1008000201000000ull,0x1008000200000000ull,0x1008000201000000ull,0x1008000200000000ull,0x8000201000000ull,0x8000200000000ull,0x8000201000000ull,0x8000200000000ull
},{
0x2010000402010000ull,0x2010000402000000ull,0x2010000400000000ull,0x2010000400000000ull,0x2010000402010000ull,0x2010000402000000ull,0x2010000400000000ull,0x2010000400000000ull,
0x10000402010000ull,0x10000402000000ull,0x10000400000000ull,0x10000400000000ull,0x10000402010000ull,0x10000402000000ull,0x10000400000000ull,0x10000400000000ull,
0x2010000402010000ull,0x2010000402000000ull,0x2010000400000000ull,0x2010000400000000ull,0x2010000402010000ull,0x2010000402000000ull,0x2010000400000000ull,0x2010000400000000ull,
0x10000402010000ull,0x10000402000000ull,0x10000400000000ull,0x10000400000000ull,0x10000402010000ull,0x10000402000000ull,0x10000400000000ull,0x10000400000000ull,
0x2010000402010000ull,0x2010000402000000ull,0x2010000400000000ull,0x2010000400000000ull,0x2010000402010000ull,0x2010000402000000ull,0x2010000400000000ull,0x2010000400000000ull,
0x10000402010000ull,0x10000402000000ull,0x10000400000000ull,0x10000400000000ull,0x10000402010000ull,0x10000402000000ull,0x10000400000000ull,0x10000400000000ull,
0x2010000402010000ull,0x2010000402000000ull,0x2010000400000000ull,0x2010000400000000ull,0x2010000402010000ull,0x2010000402000000ull,0x2010000400000000ull,0x2010000400000000ull,
0x10000402010000ull,0x10000402000000ull,0x10000400000000ull,0x10000400000000ull,0x10000402010000ull,0x10000402000000ull,0x10000400000000ull,0x10000400000000ull
},{
0x4020000804020100ull,0x4020000804020000ull,0x4020000804000000ull,0x4020000804000000ull,0x4020000800000000ull,0x4020000800000000ull,0x4020000800000000ull,0x4020000800000000ull,
0x4020000804020100ull,0x4020000804020000ull,0x4020000804000000ull,0x4020000804000000ull,0x4020000800000000ull,0x4020000800000000ull,0x4020000800000000ull,0x4020000800000000ull,
0x20000804020100ull,0x20000804020000ull,0x20000804000000ull,0x20000804000000ull,0x20000800000000ull,0x20000800000000ull,0x20000800000000ull,0x20000800000000ull,
0x20000804020100ull,0x20000804020000ull,0x20000804000000ull,0x20000804000000ull,0x20000800000000ull,0x20000800000000ull,0x20000800000000ull,0x20000800000000ull,
0x4020000804020100ull,0x4020000804020000ull,0x4020000804000000ull,0x4020000804000000ull,0x4020000800000000ull,0x4020000800000000ull,0x4020000800000000ull,0x4020000800000000ull,
0x4020000804020100ull,0x4020000804020000ull,0x4020000804000000ull,0x4020000804000000ull,0x4020000800000000ull,0x4020000800000000ull,0x4020000800000000ull,0x4020000800000000ull,
0x20000804020100ull,0x20000804020000ull,0x20000804000000ull,0x20000804000000ull,0x20000800000000ull,0x20000800000000ull,0x20000800000000ull,0x20000800000000ull,
0x20000804020100ull,0x20000804020000ull,0x20000804000000ull,0x20000804000000ull,0x20000800000000ull,0x20000800000000ull,0x20000800000000ull,0x20000800000000ull
},{
0x8040001008040201ull,0x8040001008040200ull,0x8040001008040000ull,0x8040001008040000ull,0x8040001008000000ull,0x8040001008000000ull,0x8040001008000000ull,0x8040001008000000ull,
0x8040001000000000ull,0x8040001000000000ull,0x8040001000000000ull,0x8040001000000000ull,0x8040001000000000ull,0x8040001000000000ull,0x8040001000000000ull,0x8040001000000000ull,
0x8040001008040201ull,0x8040001008040200ull,0x8040001008040000ull,0x8040001008040000ull,0x8040001008000000ull,0x8040001008000000ull,0x8040001008000000ull,0x8040001008000000ull,
0x8040001000000000ull,0x8040001000000000ull,0x8040001000000000ull,0x8040001000000000ull,0x8040001000000000ull,0x8040001000000000ull,0x8040001000000000ull,0x8040001000000000ull,
0x40001008040201ull,0x40001008040200ull,0x40001008040000ull,0x40001008040000ull,0x40001008000000ull,0x40001008000000ull,0x40001008000000ull,0x40001008000000ull,
0x40001000000000ull,0x40001000000000ull,0x40001000000000ull,0x40001000000000ull,0x40001000000000ull,0x40001000000000ull,0x40001000000000ull,0x40001000000000ull,
0x40001008040201ull,0x40001008040200ull,0x40001008040000ull,0x40001008040000ull,0x40001008000000ull,0x40001008000000ull,0x40001008000000ull,0x40001008000000ull,
0x40001000000000ull,0x40001000000000ull,0x40001000000000ull,0x40001000000000ull,0x40001000000000ull,0x40001000000000ull,0x40001000000000ull,0x40001000000000ull
},{
0x80002010080402ull,0x80002010080400ull,0x80002010080000ull,0x80002010080000ull,0x80002010000000ull,0x80002010000000ull,0x80002010000000ull,0x80002010000000ull,
0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,
0x80002010080402ull,0x80002010080400ull,0x80002010080000ull,0x80002010080000ull,0x80002010000000ull,0x80002010000000ull,0x80002010000000ull,0x80002010000000ull,
0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,
0x80002010080402ull,0x80002010080400ull,0x80002010080000ull,0x80002010080000ull,0x80002010000000ull,0x80002010000000ull,0x80002010000000ull,0x80002010000000ull,
0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,
0x80002010080402ull,0x80002010080400ull,0x80002010080000ull,0x80002010080000ull,0x80002010000000ull,0x80002010000000ull,0x80002010000000ull,0x80002010000000ull,
0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull,0x80002000000000ull
},{
0x4020100804ull,0x4020100800ull,0x4020100000ull,0x4020100000ull,0x4020000000ull,0x4020000000ull,0x4020000000ull,0x4020000000ull,
0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,
0x4020100804ull,0x4020100800ull,0x4020100000ull,0x4020100000ull,0x4020000000ull,0x4020000000ull,0x4020000000ull,0x4020000000ull,
0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,
0x4020100804ull,0x4020100800ull,0x4020100000ull,0x4020100000ull,0x4020000000ull,0x4020000000ull,0x4020000000ull,0x4020000000ull,
0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,
0x4020100804ull,0x4020100800ull,0x4020100000ull,0x4020100000ull,0x4020000000ull,0x4020000000ull,0x4020000000ull,0x4020000000ull,
0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull
},{
0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,
0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,
0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,
0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,
0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,
0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,
0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,
0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull,0x200000000000000ull
},{
0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,
0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,
0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,
0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,
0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,
0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,
0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,
0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull,0x400010000000000ull
},{
0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,
0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,
0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,
0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,
0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,
0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,
0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,
0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull,0x800020100000000ull,0x800020000000000ull
},{
0x1000040201000000ull,0x1000040200000000ull,0x1000040000000000ull,0x1000040000000000ull,0x1000040201000000ull,0x1000040200000000ull,0x1000040000000000ull,0x1000040000000000ull,
0x1000040201000000ull,0x1000040200000000ull,0x1000040000000000ull,0x1000040000000000ull,0x1000040201000000ull,0x1000040200000000ull,0x1000040000000000ull,0x1000040000000000ull,
0x1000040201000000ull,0x1000040200000000ull,0x1000040000000000ull,0x1000040000000000ull,0x1000040201000000ull,0x1000040200000000ull,0x1000040000000000ull,0x1000040000000000ull,
0x1000040201000000ull,0x1000040200000000ull,0x1000040000000000ull,0x1000040000000000ull,0x1000040201000000ull,0x1000040200000000ull,0x1000040000000000ull,0x1000040000000000ull,
0x1000040201000000ull,0x1000040200000000ull,0x1000040000000000ull,0x1000040000000000ull,0x1000040201000000ull,0x1000040200000000ull,0x1000040000000000ull,0x1000040000000000ull,
0x1000040201000000ull,0x1000040200000000ull,0x1000040000000000ull,0x1000040000000000ull,0x1000040201000000ull,0x1000040200000000ull,0x1000040000000000ull,0x1000040000000000ull,
0x1000040201000000ull,0x1000040200000000ull,0x1000040000000000ull,0x1000040000000000ull,0x1000040201000000ull,0x1000040200000000ull,0x1000040000000000ull,0x1000040000000000ull,
0x1000040201000000ull,0x1000040200000000ull,0x1000040000000000ull,0x1000040000000000ull,0x1000040201000000ull,0x1000040200000000ull,0x1000040000000000ull,0x1000040000000000ull
},{
0x2000080402010000ull,0x2000080402000000ull,0x2000080400000000ull,0x2000080400000000ull,0x2000080000000000ull,0x2000080000000000ull,0x2000080000000000ull,0x2000080000000000ull,
0x2000080402010000ull,0x2000080402000000ull,0x2000080400000000ull,0x2000080400000000ull,0x2000080000000000ull,0x2000080000000000ull,0x2000080000000000ull,0x2000080000000000ull,
0x2000080402010000ull,0x2000080402000000ull,0x2000080400000000ull,0x2000080400000000ull,0x2000080000000000ull,0x2000080000000000ull,0x2000080000000000ull,0x2000080000000000ull,
0x2000080402010000ull,0x2000080402000000ull,0x2000080400000000ull,0x2000080400000000ull,0x2000080000000000ull,0x2000080000000000ull,0x2000080000000000ull,0x2000080000000000ull,
0x2000080402010000ull,0x2000080402000000ull,0x2000080400000000ull,0x2000080400000000ull,0x2000080000000000ull,0x2000080000000000ull,0x2000080000000000ull,0x2000080000000000ull,
0x2000080402010000ull,0x2000080402000000ull,0x2000080400000000ull,0x2000080400000000ull,0x2000080000000000ull,0x2000080000000000ull,0x2000080000000000ull,0x2000080000000000ull,
0x2000080402010000ull,0x2000080402000000ull,0x2000080400000000ull,0x2000080400000000ull,0x2000080000000000ull,0x2000080000000000ull,0x2000080000000000ull,0x2000080000000000ull,
0x2000080402010000ull,0x2000080402000000ull,0x2000080400000000ull,0x2000080400000000ull,0x2000080000000000ull,0x2000080000000000ull,0x2000080000000000ull,0x2000080000000000ull
},{
0x4000100804020100ull,0x4000100804020000ull,0x4000100804000000ull,0x4000100804000000ull,0x4000100800000000ull,0x4000100800000000ull,0x4000100800000000ull,0x4000100800000000ull,
0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,
0x4000100804020100ull,0x4000100804020000ull,0x4000100804000000ull,0x4000100804000000ull,0x4000100800000000ull,0x4000100800000000ull,0x4000100800000000ull,0x4000100800000000ull,
0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,
0x4000100804020100ull,0x4000100804020000ull,0x4000100804000000ull,0x4000100804000000ull,0x4000100800000000ull,0x4000100800000000ull,0x4000100800000000ull,0x4000100800000000ull,
0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,
0x4000100804020100ull,0x4000100804020000ull,0x4000100804000000ull,0x4000100804000000ull,0x4000100800000000ull,0x4000100800000000ull,0x4000100800000000ull,0x4000100800000000ull,
0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull,0x4000100000000000ull
},{
0x8000201008040201ull,0x8000201008040200ull,0x8000201008040000ull,0x8000201008040000ull,0x8000201008000000ull,0x8000201008000000ull,0x8000201008000000ull,0x8000201008000000ull,
0x8000201000000000ull,0x8000201000000000ull,0x8000201000000000ull,0x8000201000000000ull,0x8000201000000000ull,0x8000201000000000ull,0x8000201000000000ull,0x8000201000000000ull,
0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,
0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,
0x8000201008040201ull,0x8000201008040200ull,0x8000201008040000ull,0x8000201008040000ull,0x8000201008000000ull,0x8000201008000000ull,0x8000201008000000ull,0x8000201008000000ull,
0x8000201000000000ull,0x8000201000000000ull,0x8000201000000000ull,0x8000201000000000ull,0x8000201000000000ull,0x8000201000000000ull,0x8000201000000000ull,0x8000201000000000ull,
0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,
0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull,0x8000200000000000ull
},{
0x402010080402ull,0x402010080400ull,0x402010080000ull,0x402010080000ull,0x402010000000ull,0x402010000000ull,0x402010000000ull,0x402010000000ull,
0x402000000000ull,0x402000000000ull,0x402000000000ull,0x402000000000ull,0x402000000000ull,0x402000000000ull,0x402000000000ull,0x402000000000ull,
0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,
0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,
0x402010080402ull,0x402010080400ull,0x402010080000ull,0x402010080000ull,0x402010000000ull,0x402010000000ull,0x402010000000ull,0x402010000000ull,
0x402000000000ull,0x402000000000ull,0x402000000000ull,0x402000000000ull,0x402000000000ull,0x402000000000ull,0x402000000000ull,0x402000000000ull,
0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,
0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull
},{
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull
},{
0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,
0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,
0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,
0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,
0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,
0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,
0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,
0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull,0x1000000000000ull
},{
0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,
0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,
0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,
0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,
0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,
0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,
0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,
0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull,0x2010000000000ull,0x2000000000000ull
},{
0x4020100000000ull,0x4020000000000ull,0x4000000000000ull,0x4000000000000ull,0x4020100000000ull,0x4020000000000ull,0x4000000000000ull,0x4000000000000ull,
0x4020100000000ull,0x4020000000000ull,0x4000000000000ull,0x4000000000000ull,0x4020100000000ull,0x4020000000000ull,0x4000000000000ull,0x4000000000000ull,
0x4020100000000ull,0x4020000000000ull,0x4000000000000ull,0x4000000000000ull,0x4020100000000ull,0x4020000000000ull,0x4000000000000ull,0x4000000000000ull,
0x4020100000000ull,0x4020000000000ull,0x4000000000000ull,0x4000000000000ull,0x4020100000000ull,0x4020000000000ull,0x4000000000000ull,0x4000000000000ull,
0x4020100000000ull,0x4020000000000ull,0x4000000000000ull,0x4000000000000ull,0x4020100000000ull,0x4020000000000ull,0x4000000000000ull,0x4000000000000ull,
0x4020100000000ull,0x4020000000000ull,0x4000000000000ull,0x4000000000000ull,0x4020100000000ull,0x4020000000000ull,0x4000000000000ull,0x4000000000000ull,
0x4020100000000ull,0x4020000000000ull,0x4000000000000ull,0x4000000000000ull,0x4020100000000ull,0x4020000000000ull,0x4000000000000ull,0x4000000000000ull,
0x4020100000000ull,0x4020000000000ull,0x4000000000000ull,0x4000000000000ull,0x4020100000000ull,0x4020000000000ull,0x4000000000000ull,0x4000000000000ull
},{
0x8040201000000ull,0x8040200000000ull,0x8040000000000ull,0x8040000000000ull,0x8000000000000ull,0x8000000000000ull,0x8000000000000ull,0x8000000000000ull,
0x8040201000000ull,0x8040200000000ull,0x8040000000000ull,0x8040000000000ull,0x8000000000000ull,0x8000000000000ull,0x8000000000000ull,0x8000000000000ull,
0x8040201000000ull,0x8040200000000ull,0x8040000000000ull,0x8040000000000ull,0x8000000000000ull,0x8000000000000ull,0x8000000000000ull,0x8000000000000ull,
0x8040201000000ull,0x8040200000000ull,0x8040000000000ull,0x8040000000000ull,0x8000000000000ull,0x8000000000000ull,0x8000000000000ull,0x8000000000000ull,
0x8040201000000ull,0x8040200000000ull,0x8040000000000ull,0x8040000000000ull,0x8000000000000ull,0x8000000000000ull,0x8000000000000ull,0x8000000000000ull,
0x8040201000000ull,0x8040200000000ull,0x8040000000000ull,0x8040000000000ull,0x8000000000000ull,0x8000000000000ull,0x8000000000000ull,0x8000000000000ull,
0x8040201000000ull,0x8040200000000ull,0x8040000000000ull,0x8040000000000ull,0x8000000000000ull,0x8000000000000ull,0x8000000000000ull,0x8000000000000ull,
0x8040201000000ull,0x8040200000000ull,0x8040000000000ull,0x8040000000000ull,0x8000000000000ull,0x8000000000000ull,0x8000000000000ull,0x8000000000000ull
},{
0x10080402010000ull,0x10080402000000ull,0x10080400000000ull,0x10080400000000ull,0x10080000000000ull,0x10080000000000ull,0x10080000000000ull,0x10080000000000ull,
0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,
0x10080402010000ull,0x10080402000000ull,0x10080400000000ull,0x10080400000000ull,0x10080000000000ull,0x10080000000000ull,0x10080000000000ull,0x10080000000000ull,
0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,
0x10080402010000ull,0x10080402000000ull,0x10080400000000ull,0x10080400000000ull,0x10080000000000ull,0x10080000000000ull,0x10080000000000ull,0x10080000000000ull,
0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,
0x10080402010000ull,0x10080402000000ull,0x10080400000000ull,0x10080400000000ull,0x10080000000000ull,0x10080000000000ull,0x10080000000000ull,0x10080000000000ull,
0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull,0x10000000000000ull
},{
0x20100804020100ull,0x20100804020000ull,0x20100804000000ull,0x20100804000000ull,0x20100800000000ull,0x20100800000000ull,0x20100800000000ull,0x20100800000000ull,
0x20100000000000ull,0x20100000000000ull,0x20100000000000ull,0x20100000000000ull,0x20100000000000ull,0x20100000000000ull,0x20100000000000ull,0x20100000000000ull,
0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,
0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,
0x20100804020100ull,0x20100804020000ull,0x20100804000000ull,0x20100804000000ull,0x20100800000000ull,0x20100800000000ull,0x20100800000000ull,0x20100800000000ull,
0x20100000000000ull,0x20100000000000ull,0x20100000000000ull,0x20100000000000ull,0x20100000000000ull,0x20100000000000ull,0x20100000000000ull,0x20100000000000ull,
0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,
0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull,0x20000000000000ull
},{
0x40201008040201ull,0x40201008040200ull,0x40201008040000ull,0x40201008040000ull,0x40201008000000ull,0x40201008000000ull,0x40201008000000ull,0x40201008000000ull,
0x40201000000000ull,0x40201000000000ull,0x40201000000000ull,0x40201000000000ull,0x40201000000000ull,0x40201000000000ull,0x40201000000000ull,0x40201000000000ull,
0x40200000000000ull,0x40200000000000ull,0x40200000000000ull,0x40200000000000ull,0x40200000000000ull,0x40200000000000ull,0x40200000000000ull,0x40200000000000ull,
0x40200000000000ull,0x40200000000000ull,0x40200000000000ull,0x40200000000000ull,0x40200000000000ull,0x40200000000000ull,0x40200000000000ull,0x40200000000000ull,
0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,
0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,
0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,
0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull
}};


  uint64 DIAGA8H1_ATTACKS[64][64] = {
{
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull
},{
0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,
0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,
0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,
0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,
0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,
0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,
0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,
0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull
},{
0x10200ull,0x200ull,0x10200ull,0x200ull,0x10200ull,0x200ull,0x10200ull,0x200ull,
0x10200ull,0x200ull,0x10200ull,0x200ull,0x10200ull,0x200ull,0x10200ull,0x200ull,
0x10200ull,0x200ull,0x10200ull,0x200ull,0x10200ull,0x200ull,0x10200ull,0x200ull,
0x10200ull,0x200ull,0x10200ull,0x200ull,0x10200ull,0x200ull,0x10200ull,0x200ull,
0x10200ull,0x200ull,0x10200ull,0x200ull,0x10200ull,0x200ull,0x10200ull,0x200ull,
0x10200ull,0x200ull,0x10200ull,0x200ull,0x10200ull,0x200ull,0x10200ull,0x200ull,
0x10200ull,0x200ull,0x10200ull,0x200ull,0x10200ull,0x200ull,0x10200ull,0x200ull,
0x10200ull,0x200ull,0x10200ull,0x200ull,0x10200ull,0x200ull,0x10200ull,0x200ull
},{
0x1020400ull,0x20400ull,0x400ull,0x400ull,0x1020400ull,0x20400ull,0x400ull,0x400ull,
0x1020400ull,0x20400ull,0x400ull,0x400ull,0x1020400ull,0x20400ull,0x400ull,0x400ull,
0x1020400ull,0x20400ull,0x400ull,0x400ull,0x1020400ull,0x20400ull,0x400ull,0x400ull,
0x1020400ull,0x20400ull,0x400ull,0x400ull,0x1020400ull,0x20400ull,0x400ull,0x400ull,
0x1020400ull,0x20400ull,0x400ull,0x400ull,0x1020400ull,0x20400ull,0x400ull,0x400ull,
0x1020400ull,0x20400ull,0x400ull,0x400ull,0x1020400ull,0x20400ull,0x400ull,0x400ull,
0x1020400ull,0x20400ull,0x400ull,0x400ull,0x1020400ull,0x20400ull,0x400ull,0x400ull,
0x1020400ull,0x20400ull,0x400ull,0x400ull,0x1020400ull,0x20400ull,0x400ull,0x400ull
},{
0x102040800ull,0x2040800ull,0x40800ull,0x40800ull,0x800ull,0x800ull,0x800ull,0x800ull,
0x102040800ull,0x2040800ull,0x40800ull,0x40800ull,0x800ull,0x800ull,0x800ull,0x800ull,
0x102040800ull,0x2040800ull,0x40800ull,0x40800ull,0x800ull,0x800ull,0x800ull,0x800ull,
0x102040800ull,0x2040800ull,0x40800ull,0x40800ull,0x800ull,0x800ull,0x800ull,0x800ull,
0x102040800ull,0x2040800ull,0x40800ull,0x40800ull,0x800ull,0x800ull,0x800ull,0x800ull,
0x102040800ull,0x2040800ull,0x40800ull,0x40800ull,0x800ull,0x800ull,0x800ull,0x800ull,
0x102040800ull,0x2040800ull,0x40800ull,0x40800ull,0x800ull,0x800ull,0x800ull,0x800ull,
0x102040800ull,0x2040800ull,0x40800ull,0x40800ull,0x800ull,0x800ull,0x800ull,0x800ull
},{
0x10204081000ull,0x204081000ull,0x4081000ull,0x4081000ull,0x81000ull,0x81000ull,0x81000ull,0x81000ull,
0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,
0x10204081000ull,0x204081000ull,0x4081000ull,0x4081000ull,0x81000ull,0x81000ull,0x81000ull,0x81000ull,
0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,
0x10204081000ull,0x204081000ull,0x4081000ull,0x4081000ull,0x81000ull,0x81000ull,0x81000ull,0x81000ull,
0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,
0x10204081000ull,0x204081000ull,0x4081000ull,0x4081000ull,0x81000ull,0x81000ull,0x81000ull,0x81000ull,
0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull
},{
0x1020408102000ull,0x20408102000ull,0x408102000ull,0x408102000ull,0x8102000ull,0x8102000ull,0x8102000ull,0x8102000ull,
0x102000ull,0x102000ull,0x102000ull,0x102000ull,0x102000ull,0x102000ull,0x102000ull,0x102000ull,
0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,
0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,
0x1020408102000ull,0x20408102000ull,0x408102000ull,0x408102000ull,0x8102000ull,0x8102000ull,0x8102000ull,0x8102000ull,
0x102000ull,0x102000ull,0x102000ull,0x102000ull,0x102000ull,0x102000ull,0x102000ull,0x102000ull,
0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,
0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull
},{
0x102040810204000ull,0x2040810204000ull,0x40810204000ull,0x40810204000ull,0x810204000ull,0x810204000ull,0x810204000ull,0x810204000ull,
0x10204000ull,0x10204000ull,0x10204000ull,0x10204000ull,0x10204000ull,0x10204000ull,0x10204000ull,0x10204000ull,
0x204000ull,0x204000ull,0x204000ull,0x204000ull,0x204000ull,0x204000ull,0x204000ull,0x204000ull,
0x204000ull,0x204000ull,0x204000ull,0x204000ull,0x204000ull,0x204000ull,0x204000ull,0x204000ull,
0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,
0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,
0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,
0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull
},{
0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,
0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,
0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,
0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,
0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,
0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,
0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,
0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull,0x2ull
},{
0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,
0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,
0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,
0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,
0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,
0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,
0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,
0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull,0x10004ull
},{
0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,
0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,
0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,
0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,
0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,
0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,
0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,
0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,0x1020008ull,0x20008ull,0x1020008ull,0x20008ull
},{
0x102040010ull,0x2040010ull,0x40010ull,0x40010ull,0x102040010ull,0x2040010ull,0x40010ull,0x40010ull,
0x102040010ull,0x2040010ull,0x40010ull,0x40010ull,0x102040010ull,0x2040010ull,0x40010ull,0x40010ull,
0x102040010ull,0x2040010ull,0x40010ull,0x40010ull,0x102040010ull,0x2040010ull,0x40010ull,0x40010ull,
0x102040010ull,0x2040010ull,0x40010ull,0x40010ull,0x102040010ull,0x2040010ull,0x40010ull,0x40010ull,
0x102040010ull,0x2040010ull,0x40010ull,0x40010ull,0x102040010ull,0x2040010ull,0x40010ull,0x40010ull,
0x102040010ull,0x2040010ull,0x40010ull,0x40010ull,0x102040010ull,0x2040010ull,0x40010ull,0x40010ull,
0x102040010ull,0x2040010ull,0x40010ull,0x40010ull,0x102040010ull,0x2040010ull,0x40010ull,0x40010ull,
0x102040010ull,0x2040010ull,0x40010ull,0x40010ull,0x102040010ull,0x2040010ull,0x40010ull,0x40010ull
},{
0x10204080020ull,0x204080020ull,0x4080020ull,0x4080020ull,0x80020ull,0x80020ull,0x80020ull,0x80020ull,
0x10204080020ull,0x204080020ull,0x4080020ull,0x4080020ull,0x80020ull,0x80020ull,0x80020ull,0x80020ull,
0x10204080020ull,0x204080020ull,0x4080020ull,0x4080020ull,0x80020ull,0x80020ull,0x80020ull,0x80020ull,
0x10204080020ull,0x204080020ull,0x4080020ull,0x4080020ull,0x80020ull,0x80020ull,0x80020ull,0x80020ull,
0x10204080020ull,0x204080020ull,0x4080020ull,0x4080020ull,0x80020ull,0x80020ull,0x80020ull,0x80020ull,
0x10204080020ull,0x204080020ull,0x4080020ull,0x4080020ull,0x80020ull,0x80020ull,0x80020ull,0x80020ull,
0x10204080020ull,0x204080020ull,0x4080020ull,0x4080020ull,0x80020ull,0x80020ull,0x80020ull,0x80020ull,
0x10204080020ull,0x204080020ull,0x4080020ull,0x4080020ull,0x80020ull,0x80020ull,0x80020ull,0x80020ull
},{
0x1020408100040ull,0x20408100040ull,0x408100040ull,0x408100040ull,0x8100040ull,0x8100040ull,0x8100040ull,0x8100040ull,
0x100040ull,0x100040ull,0x100040ull,0x100040ull,0x100040ull,0x100040ull,0x100040ull,0x100040ull,
0x1020408100040ull,0x20408100040ull,0x408100040ull,0x408100040ull,0x8100040ull,0x8100040ull,0x8100040ull,0x8100040ull,
0x100040ull,0x100040ull,0x100040ull,0x100040ull,0x100040ull,0x100040ull,0x100040ull,0x100040ull,
0x1020408100040ull,0x20408100040ull,0x408100040ull,0x408100040ull,0x8100040ull,0x8100040ull,0x8100040ull,0x8100040ull,
0x100040ull,0x100040ull,0x100040ull,0x100040ull,0x100040ull,0x100040ull,0x100040ull,0x100040ull,
0x1020408100040ull,0x20408100040ull,0x408100040ull,0x408100040ull,0x8100040ull,0x8100040ull,0x8100040ull,0x8100040ull,
0x100040ull,0x100040ull,0x100040ull,0x100040ull,0x100040ull,0x100040ull,0x100040ull,0x100040ull
},{
0x102040810200080ull,0x2040810200080ull,0x40810200080ull,0x40810200080ull,0x810200080ull,0x810200080ull,0x810200080ull,0x810200080ull,
0x10200080ull,0x10200080ull,0x10200080ull,0x10200080ull,0x10200080ull,0x10200080ull,0x10200080ull,0x10200080ull,
0x200080ull,0x200080ull,0x200080ull,0x200080ull,0x200080ull,0x200080ull,0x200080ull,0x200080ull,
0x200080ull,0x200080ull,0x200080ull,0x200080ull,0x200080ull,0x200080ull,0x200080ull,0x200080ull,
0x102040810200080ull,0x2040810200080ull,0x40810200080ull,0x40810200080ull,0x810200080ull,0x810200080ull,0x810200080ull,0x810200080ull,
0x10200080ull,0x10200080ull,0x10200080ull,0x10200080ull,0x10200080ull,0x10200080ull,0x10200080ull,0x10200080ull,
0x200080ull,0x200080ull,0x200080ull,0x200080ull,0x200080ull,0x200080ull,0x200080ull,0x200080ull,
0x200080ull,0x200080ull,0x200080ull,0x200080ull,0x200080ull,0x200080ull,0x200080ull,0x200080ull
},{
0x204081020400000ull,0x4081020400000ull,0x81020400000ull,0x81020400000ull,0x1020400000ull,0x1020400000ull,0x1020400000ull,0x1020400000ull,
0x20400000ull,0x20400000ull,0x20400000ull,0x20400000ull,0x20400000ull,0x20400000ull,0x20400000ull,0x20400000ull,
0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,
0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,
0x204081020400000ull,0x4081020400000ull,0x81020400000ull,0x81020400000ull,0x1020400000ull,0x1020400000ull,0x1020400000ull,0x1020400000ull,
0x20400000ull,0x20400000ull,0x20400000ull,0x20400000ull,0x20400000ull,0x20400000ull,0x20400000ull,0x20400000ull,
0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,
0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull
},{
0x204ull,0x200ull,0x204ull,0x200ull,0x204ull,0x200ull,0x204ull,0x200ull,
0x204ull,0x200ull,0x204ull,0x200ull,0x204ull,0x200ull,0x204ull,0x200ull,
0x204ull,0x200ull,0x204ull,0x200ull,0x204ull,0x200ull,0x204ull,0x200ull,
0x204ull,0x200ull,0x204ull,0x200ull,0x204ull,0x200ull,0x204ull,0x200ull,
0x204ull,0x200ull,0x204ull,0x200ull,0x204ull,0x200ull,0x204ull,0x200ull,
0x204ull,0x200ull,0x204ull,0x200ull,0x204ull,0x200ull,0x204ull,0x200ull,
0x204ull,0x200ull,0x204ull,0x200ull,0x204ull,0x200ull,0x204ull,0x200ull,
0x204ull,0x200ull,0x204ull,0x200ull,0x204ull,0x200ull,0x204ull,0x200ull
},{
0x1000408ull,0x1000408ull,0x1000400ull,0x1000400ull,0x1000408ull,0x1000408ull,0x1000400ull,0x1000400ull,
0x1000408ull,0x1000408ull,0x1000400ull,0x1000400ull,0x1000408ull,0x1000408ull,0x1000400ull,0x1000400ull,
0x1000408ull,0x1000408ull,0x1000400ull,0x1000400ull,0x1000408ull,0x1000408ull,0x1000400ull,0x1000400ull,
0x1000408ull,0x1000408ull,0x1000400ull,0x1000400ull,0x1000408ull,0x1000408ull,0x1000400ull,0x1000400ull,
0x1000408ull,0x1000408ull,0x1000400ull,0x1000400ull,0x1000408ull,0x1000408ull,0x1000400ull,0x1000400ull,
0x1000408ull,0x1000408ull,0x1000400ull,0x1000400ull,0x1000408ull,0x1000408ull,0x1000400ull,0x1000400ull,
0x1000408ull,0x1000408ull,0x1000400ull,0x1000400ull,0x1000408ull,0x1000408ull,0x1000400ull,0x1000400ull,
0x1000408ull,0x1000408ull,0x1000400ull,0x1000400ull,0x1000408ull,0x1000408ull,0x1000400ull,0x1000400ull
},{
0x102000810ull,0x2000810ull,0x102000810ull,0x2000810ull,0x102000800ull,0x2000800ull,0x102000800ull,0x2000800ull,
0x102000810ull,0x2000810ull,0x102000810ull,0x2000810ull,0x102000800ull,0x2000800ull,0x102000800ull,0x2000800ull,
0x102000810ull,0x2000810ull,0x102000810ull,0x2000810ull,0x102000800ull,0x2000800ull,0x102000800ull,0x2000800ull,
0x102000810ull,0x2000810ull,0x102000810ull,0x2000810ull,0x102000800ull,0x2000800ull,0x102000800ull,0x2000800ull,
0x102000810ull,0x2000810ull,0x102000810ull,0x2000810ull,0x102000800ull,0x2000800ull,0x102000800ull,0x2000800ull,
0x102000810ull,0x2000810ull,0x102000810ull,0x2000810ull,0x102000800ull,0x2000800ull,0x102000800ull,0x2000800ull,
0x102000810ull,0x2000810ull,0x102000810ull,0x2000810ull,0x102000800ull,0x2000800ull,0x102000800ull,0x2000800ull,
0x102000810ull,0x2000810ull,0x102000810ull,0x2000810ull,0x102000800ull,0x2000800ull,0x102000800ull,0x2000800ull
},{
0x10204001020ull,0x204001020ull,0x4001020ull,0x4001020ull,0x10204001020ull,0x204001020ull,0x4001020ull,0x4001020ull,
0x10204001000ull,0x204001000ull,0x4001000ull,0x4001000ull,0x10204001000ull,0x204001000ull,0x4001000ull,0x4001000ull,
0x10204001020ull,0x204001020ull,0x4001020ull,0x4001020ull,0x10204001020ull,0x204001020ull,0x4001020ull,0x4001020ull,
0x10204001000ull,0x204001000ull,0x4001000ull,0x4001000ull,0x10204001000ull,0x204001000ull,0x4001000ull,0x4001000ull,
0x10204001020ull,0x204001020ull,0x4001020ull,0x4001020ull,0x10204001020ull,0x204001020ull,0x4001020ull,0x4001020ull,
0x10204001000ull,0x204001000ull,0x4001000ull,0x4001000ull,0x10204001000ull,0x204001000ull,0x4001000ull,0x4001000ull,
0x10204001020ull,0x204001020ull,0x4001020ull,0x4001020ull,0x10204001020ull,0x204001020ull,0x4001020ull,0x4001020ull,
0x10204001000ull,0x204001000ull,0x4001000ull,0x4001000ull,0x10204001000ull,0x204001000ull,0x4001000ull,0x4001000ull
},{
0x1020408002040ull,0x20408002040ull,0x408002040ull,0x408002040ull,0x8002040ull,0x8002040ull,0x8002040ull,0x8002040ull,
0x1020408002040ull,0x20408002040ull,0x408002040ull,0x408002040ull,0x8002040ull,0x8002040ull,0x8002040ull,0x8002040ull,
0x1020408002000ull,0x20408002000ull,0x408002000ull,0x408002000ull,0x8002000ull,0x8002000ull,0x8002000ull,0x8002000ull,
0x1020408002000ull,0x20408002000ull,0x408002000ull,0x408002000ull,0x8002000ull,0x8002000ull,0x8002000ull,0x8002000ull,
0x1020408002040ull,0x20408002040ull,0x408002040ull,0x408002040ull,0x8002040ull,0x8002040ull,0x8002040ull,0x8002040ull,
0x1020408002040ull,0x20408002040ull,0x408002040ull,0x408002040ull,0x8002040ull,0x8002040ull,0x8002040ull,0x8002040ull,
0x1020408002000ull,0x20408002000ull,0x408002000ull,0x408002000ull,0x8002000ull,0x8002000ull,0x8002000ull,0x8002000ull,
0x1020408002000ull,0x20408002000ull,0x408002000ull,0x408002000ull,0x8002000ull,0x8002000ull,0x8002000ull,0x8002000ull
},{
0x102040810004080ull,0x2040810004080ull,0x40810004080ull,0x40810004080ull,0x810004080ull,0x810004080ull,0x810004080ull,0x810004080ull,
0x10004080ull,0x10004080ull,0x10004080ull,0x10004080ull,0x10004080ull,0x10004080ull,0x10004080ull,0x10004080ull,
0x102040810004080ull,0x2040810004080ull,0x40810004080ull,0x40810004080ull,0x810004080ull,0x810004080ull,0x810004080ull,0x810004080ull,
0x10004080ull,0x10004080ull,0x10004080ull,0x10004080ull,0x10004080ull,0x10004080ull,0x10004080ull,0x10004080ull,
0x102040810004000ull,0x2040810004000ull,0x40810004000ull,0x40810004000ull,0x810004000ull,0x810004000ull,0x810004000ull,0x810004000ull,
0x10004000ull,0x10004000ull,0x10004000ull,0x10004000ull,0x10004000ull,0x10004000ull,0x10004000ull,0x10004000ull,
0x102040810004000ull,0x2040810004000ull,0x40810004000ull,0x40810004000ull,0x810004000ull,0x810004000ull,0x810004000ull,0x810004000ull,
0x10004000ull,0x10004000ull,0x10004000ull,0x10004000ull,0x10004000ull,0x10004000ull,0x10004000ull,0x10004000ull
},{
0x204081020008000ull,0x4081020008000ull,0x81020008000ull,0x81020008000ull,0x1020008000ull,0x1020008000ull,0x1020008000ull,0x1020008000ull,
0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,
0x204081020008000ull,0x4081020008000ull,0x81020008000ull,0x81020008000ull,0x1020008000ull,0x1020008000ull,0x1020008000ull,0x1020008000ull,
0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,
0x204081020008000ull,0x4081020008000ull,0x81020008000ull,0x81020008000ull,0x1020008000ull,0x1020008000ull,0x1020008000ull,0x1020008000ull,
0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,
0x204081020008000ull,0x4081020008000ull,0x81020008000ull,0x81020008000ull,0x1020008000ull,0x1020008000ull,0x1020008000ull,0x1020008000ull,
0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull,0x20008000ull
},{
0x408102040000000ull,0x8102040000000ull,0x102040000000ull,0x102040000000ull,0x2040000000ull,0x2040000000ull,0x2040000000ull,0x2040000000ull,
0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,
0x408102040000000ull,0x8102040000000ull,0x102040000000ull,0x102040000000ull,0x2040000000ull,0x2040000000ull,0x2040000000ull,0x2040000000ull,
0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,
0x408102040000000ull,0x8102040000000ull,0x102040000000ull,0x102040000000ull,0x2040000000ull,0x2040000000ull,0x2040000000ull,0x2040000000ull,
0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,
0x408102040000000ull,0x8102040000000ull,0x102040000000ull,0x102040000000ull,0x2040000000ull,0x2040000000ull,0x2040000000ull,0x2040000000ull,
0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull
},{
0x20408ull,0x20000ull,0x20400ull,0x20000ull,0x20408ull,0x20000ull,0x20400ull,0x20000ull,
0x20408ull,0x20000ull,0x20400ull,0x20000ull,0x20408ull,0x20000ull,0x20400ull,0x20000ull,
0x20408ull,0x20000ull,0x20400ull,0x20000ull,0x20408ull,0x20000ull,0x20400ull,0x20000ull,
0x20408ull,0x20000ull,0x20400ull,0x20000ull,0x20408ull,0x20000ull,0x20400ull,0x20000ull,
0x20408ull,0x20000ull,0x20400ull,0x20000ull,0x20408ull,0x20000ull,0x20400ull,0x20000ull,
0x20408ull,0x20000ull,0x20400ull,0x20000ull,0x20408ull,0x20000ull,0x20400ull,0x20000ull,
0x20408ull,0x20000ull,0x20400ull,0x20000ull,0x20408ull,0x20000ull,0x20400ull,0x20000ull,
0x20408ull,0x20000ull,0x20400ull,0x20000ull,0x20408ull,0x20000ull,0x20400ull,0x20000ull
},{
0x100040810ull,0x100040810ull,0x100040000ull,0x100040000ull,0x100040800ull,0x100040800ull,0x100040000ull,0x100040000ull,
0x100040810ull,0x100040810ull,0x100040000ull,0x100040000ull,0x100040800ull,0x100040800ull,0x100040000ull,0x100040000ull,
0x100040810ull,0x100040810ull,0x100040000ull,0x100040000ull,0x100040800ull,0x100040800ull,0x100040000ull,0x100040000ull,
0x100040810ull,0x100040810ull,0x100040000ull,0x100040000ull,0x100040800ull,0x100040800ull,0x100040000ull,0x100040000ull,
0x100040810ull,0x100040810ull,0x100040000ull,0x100040000ull,0x100040800ull,0x100040800ull,0x100040000ull,0x100040000ull,
0x100040810ull,0x100040810ull,0x100040000ull,0x100040000ull,0x100040800ull,0x100040800ull,0x100040000ull,0x100040000ull,
0x100040810ull,0x100040810ull,0x100040000ull,0x100040000ull,0x100040800ull,0x100040800ull,0x100040000ull,0x100040000ull,
0x100040810ull,0x100040810ull,0x100040000ull,0x100040000ull,0x100040800ull,0x100040800ull,0x100040000ull,0x100040000ull
},{
0x10200081020ull,0x200081020ull,0x10200081020ull,0x200081020ull,0x10200080000ull,0x200080000ull,0x10200080000ull,0x200080000ull,
0x10200081000ull,0x200081000ull,0x10200081000ull,0x200081000ull,0x10200080000ull,0x200080000ull,0x10200080000ull,0x200080000ull,
0x10200081020ull,0x200081020ull,0x10200081020ull,0x200081020ull,0x10200080000ull,0x200080000ull,0x10200080000ull,0x200080000ull,
0x10200081000ull,0x200081000ull,0x10200081000ull,0x200081000ull,0x10200080000ull,0x200080000ull,0x10200080000ull,0x200080000ull,
0x10200081020ull,0x200081020ull,0x10200081020ull,0x200081020ull,0x10200080000ull,0x200080000ull,0x10200080000ull,0x200080000ull,
0x10200081000ull,0x200081000ull,0x10200081000ull,0x200081000ull,0x10200080000ull,0x200080000ull,0x10200080000ull,0x200080000ull,
0x10200081020ull,0x200081020ull,0x10200081020ull,0x200081020ull,0x10200080000ull,0x200080000ull,0x10200080000ull,0x200080000ull,
0x10200081000ull,0x200081000ull,0x10200081000ull,0x200081000ull,0x10200080000ull,0x200080000ull,0x10200080000ull,0x200080000ull
},{
0x1020400102040ull,0x20400102040ull,0x400102040ull,0x400102040ull,0x1020400102040ull,0x20400102040ull,0x400102040ull,0x400102040ull,
0x1020400100000ull,0x20400100000ull,0x400100000ull,0x400100000ull,0x1020400100000ull,0x20400100000ull,0x400100000ull,0x400100000ull,
0x1020400102000ull,0x20400102000ull,0x400102000ull,0x400102000ull,0x1020400102000ull,0x20400102000ull,0x400102000ull,0x400102000ull,
0x1020400100000ull,0x20400100000ull,0x400100000ull,0x400100000ull,0x1020400100000ull,0x20400100000ull,0x400100000ull,0x400100000ull,
0x1020400102040ull,0x20400102040ull,0x400102040ull,0x400102040ull,0x1020400102040ull,0x20400102040ull,0x400102040ull,0x400102040ull,
0x1020400100000ull,0x20400100000ull,0x400100000ull,0x400100000ull,0x1020400100000ull,0x20400100000ull,0x400100000ull,0x400100000ull,
0x1020400102000ull,0x20400102000ull,0x400102000ull,0x400102000ull,0x1020400102000ull,0x20400102000ull,0x400102000ull,0x400102000ull,
0x1020400100000ull,0x20400100000ull,0x400100000ull,0x400100000ull,0x1020400100000ull,0x20400100000ull,0x400100000ull,0x400100000ull
},{
0x102040800204080ull,0x2040800204080ull,0x40800204080ull,0x40800204080ull,0x800204080ull,0x800204080ull,0x800204080ull,0x800204080ull,
0x102040800204080ull,0x2040800204080ull,0x40800204080ull,0x40800204080ull,0x800204080ull,0x800204080ull,0x800204080ull,0x800204080ull,
0x102040800200000ull,0x2040800200000ull,0x40800200000ull,0x40800200000ull,0x800200000ull,0x800200000ull,0x800200000ull,0x800200000ull,
0x102040800200000ull,0x2040800200000ull,0x40800200000ull,0x40800200000ull,0x800200000ull,0x800200000ull,0x800200000ull,0x800200000ull,
0x102040800204000ull,0x2040800204000ull,0x40800204000ull,0x40800204000ull,0x800204000ull,0x800204000ull,0x800204000ull,0x800204000ull,
0x102040800204000ull,0x2040800204000ull,0x40800204000ull,0x40800204000ull,0x800204000ull,0x800204000ull,0x800204000ull,0x800204000ull,
0x102040800200000ull,0x2040800200000ull,0x40800200000ull,0x40800200000ull,0x800200000ull,0x800200000ull,0x800200000ull,0x800200000ull,
0x102040800200000ull,0x2040800200000ull,0x40800200000ull,0x40800200000ull,0x800200000ull,0x800200000ull,0x800200000ull,0x800200000ull
},{
0x204081000408000ull,0x4081000408000ull,0x81000408000ull,0x81000408000ull,0x1000408000ull,0x1000408000ull,0x1000408000ull,0x1000408000ull,
0x204081000408000ull,0x4081000408000ull,0x81000408000ull,0x81000408000ull,0x1000408000ull,0x1000408000ull,0x1000408000ull,0x1000408000ull,
0x204081000400000ull,0x4081000400000ull,0x81000400000ull,0x81000400000ull,0x1000400000ull,0x1000400000ull,0x1000400000ull,0x1000400000ull,
0x204081000400000ull,0x4081000400000ull,0x81000400000ull,0x81000400000ull,0x1000400000ull,0x1000400000ull,0x1000400000ull,0x1000400000ull,
0x204081000408000ull,0x4081000408000ull,0x81000408000ull,0x81000408000ull,0x1000408000ull,0x1000408000ull,0x1000408000ull,0x1000408000ull,
0x204081000408000ull,0x4081000408000ull,0x81000408000ull,0x81000408000ull,0x1000408000ull,0x1000408000ull,0x1000408000ull,0x1000408000ull,
0x204081000400000ull,0x4081000400000ull,0x81000400000ull,0x81000400000ull,0x1000400000ull,0x1000400000ull,0x1000400000ull,0x1000400000ull,
0x204081000400000ull,0x4081000400000ull,0x81000400000ull,0x81000400000ull,0x1000400000ull,0x1000400000ull,0x1000400000ull,0x1000400000ull
},{
0x408102000800000ull,0x8102000800000ull,0x102000800000ull,0x102000800000ull,0x2000800000ull,0x2000800000ull,0x2000800000ull,0x2000800000ull,
0x408102000800000ull,0x8102000800000ull,0x102000800000ull,0x102000800000ull,0x2000800000ull,0x2000800000ull,0x2000800000ull,0x2000800000ull,
0x408102000800000ull,0x8102000800000ull,0x102000800000ull,0x102000800000ull,0x2000800000ull,0x2000800000ull,0x2000800000ull,0x2000800000ull,
0x408102000800000ull,0x8102000800000ull,0x102000800000ull,0x102000800000ull,0x2000800000ull,0x2000800000ull,0x2000800000ull,0x2000800000ull,
0x408102000800000ull,0x8102000800000ull,0x102000800000ull,0x102000800000ull,0x2000800000ull,0x2000800000ull,0x2000800000ull,0x2000800000ull,
0x408102000800000ull,0x8102000800000ull,0x102000800000ull,0x102000800000ull,0x2000800000ull,0x2000800000ull,0x2000800000ull,0x2000800000ull,
0x408102000800000ull,0x8102000800000ull,0x102000800000ull,0x102000800000ull,0x2000800000ull,0x2000800000ull,0x2000800000ull,0x2000800000ull,
0x408102000800000ull,0x8102000800000ull,0x102000800000ull,0x102000800000ull,0x2000800000ull,0x2000800000ull,0x2000800000ull,0x2000800000ull
},{
0x810204000000000ull,0x10204000000000ull,0x204000000000ull,0x204000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,
0x810204000000000ull,0x10204000000000ull,0x204000000000ull,0x204000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,
0x810204000000000ull,0x10204000000000ull,0x204000000000ull,0x204000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,
0x810204000000000ull,0x10204000000000ull,0x204000000000ull,0x204000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,
0x810204000000000ull,0x10204000000000ull,0x204000000000ull,0x204000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,
0x810204000000000ull,0x10204000000000ull,0x204000000000ull,0x204000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,
0x810204000000000ull,0x10204000000000ull,0x204000000000ull,0x204000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,
0x810204000000000ull,0x10204000000000ull,0x204000000000ull,0x204000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull
},{
0x2040810ull,0x2000000ull,0x2040000ull,0x2000000ull,0x2040800ull,0x2000000ull,0x2040000ull,0x2000000ull,
0x2040810ull,0x2000000ull,0x2040000ull,0x2000000ull,0x2040800ull,0x2000000ull,0x2040000ull,0x2000000ull,
0x2040810ull,0x2000000ull,0x2040000ull,0x2000000ull,0x2040800ull,0x2000000ull,0x2040000ull,0x2000000ull,
0x2040810ull,0x2000000ull,0x2040000ull,0x2000000ull,0x2040800ull,0x2000000ull,0x2040000ull,0x2000000ull,
0x2040810ull,0x2000000ull,0x2040000ull,0x2000000ull,0x2040800ull,0x2000000ull,0x2040000ull,0x2000000ull,
0x2040810ull,0x2000000ull,0x2040000ull,0x2000000ull,0x2040800ull,0x2000000ull,0x2040000ull,0x2000000ull,
0x2040810ull,0x2000000ull,0x2040000ull,0x2000000ull,0x2040800ull,0x2000000ull,0x2040000ull,0x2000000ull,
0x2040810ull,0x2000000ull,0x2040000ull,0x2000000ull,0x2040800ull,0x2000000ull,0x2040000ull,0x2000000ull
},{
0x10004081020ull,0x10004081020ull,0x10004000000ull,0x10004000000ull,0x10004080000ull,0x10004080000ull,0x10004000000ull,0x10004000000ull,
0x10004081000ull,0x10004081000ull,0x10004000000ull,0x10004000000ull,0x10004080000ull,0x10004080000ull,0x10004000000ull,0x10004000000ull,
0x10004081020ull,0x10004081020ull,0x10004000000ull,0x10004000000ull,0x10004080000ull,0x10004080000ull,0x10004000000ull,0x10004000000ull,
0x10004081000ull,0x10004081000ull,0x10004000000ull,0x10004000000ull,0x10004080000ull,0x10004080000ull,0x10004000000ull,0x10004000000ull,
0x10004081020ull,0x10004081020ull,0x10004000000ull,0x10004000000ull,0x10004080000ull,0x10004080000ull,0x10004000000ull,0x10004000000ull,
0x10004081000ull,0x10004081000ull,0x10004000000ull,0x10004000000ull,0x10004080000ull,0x10004080000ull,0x10004000000ull,0x10004000000ull,
0x10004081020ull,0x10004081020ull,0x10004000000ull,0x10004000000ull,0x10004080000ull,0x10004080000ull,0x10004000000ull,0x10004000000ull,
0x10004081000ull,0x10004081000ull,0x10004000000ull,0x10004000000ull,0x10004080000ull,0x10004080000ull,0x10004000000ull,0x10004000000ull
},{
0x1020008102040ull,0x20008102040ull,0x1020008102040ull,0x20008102040ull,0x1020008000000ull,0x20008000000ull,0x1020008000000ull,0x20008000000ull,
0x1020008100000ull,0x20008100000ull,0x1020008100000ull,0x20008100000ull,0x1020008000000ull,0x20008000000ull,0x1020008000000ull,0x20008000000ull,
0x1020008102000ull,0x20008102000ull,0x1020008102000ull,0x20008102000ull,0x1020008000000ull,0x20008000000ull,0x1020008000000ull,0x20008000000ull,
0x1020008100000ull,0x20008100000ull,0x1020008100000ull,0x20008100000ull,0x1020008000000ull,0x20008000000ull,0x1020008000000ull,0x20008000000ull,
0x1020008102040ull,0x20008102040ull,0x1020008102040ull,0x20008102040ull,0x1020008000000ull,0x20008000000ull,0x1020008000000ull,0x20008000000ull,
0x1020008100000ull,0x20008100000ull,0x1020008100000ull,0x20008100000ull,0x1020008000000ull,0x20008000000ull,0x1020008000000ull,0x20008000000ull,
0x1020008102000ull,0x20008102000ull,0x1020008102000ull,0x20008102000ull,0x1020008000000ull,0x20008000000ull,0x1020008000000ull,0x20008000000ull,
0x1020008100000ull,0x20008100000ull,0x1020008100000ull,0x20008100000ull,0x1020008000000ull,0x20008000000ull,0x1020008000000ull,0x20008000000ull
},{
0x102040010204080ull,0x2040010204080ull,0x40010204080ull,0x40010204080ull,0x102040010204080ull,0x2040010204080ull,0x40010204080ull,0x40010204080ull,
0x102040010000000ull,0x2040010000000ull,0x40010000000ull,0x40010000000ull,0x102040010000000ull,0x2040010000000ull,0x40010000000ull,0x40010000000ull,
0x102040010200000ull,0x2040010200000ull,0x40010200000ull,0x40010200000ull,0x102040010200000ull,0x2040010200000ull,0x40010200000ull,0x40010200000ull,
0x102040010000000ull,0x2040010000000ull,0x40010000000ull,0x40010000000ull,0x102040010000000ull,0x2040010000000ull,0x40010000000ull,0x40010000000ull,
0x102040010204000ull,0x2040010204000ull,0x40010204000ull,0x40010204000ull,0x102040010204000ull,0x2040010204000ull,0x40010204000ull,0x40010204000ull,
0x102040010000000ull,0x2040010000000ull,0x40010000000ull,0x40010000000ull,0x102040010000000ull,0x2040010000000ull,0x40010000000ull,0x40010000000ull,
0x102040010200000ull,0x2040010200000ull,0x40010200000ull,0x40010200000ull,0x102040010200000ull,0x2040010200000ull,0x40010200000ull,0x40010200000ull,
0x102040010000000ull,0x2040010000000ull,0x40010000000ull,0x40010000000ull,0x102040010000000ull,0x2040010000000ull,0x40010000000ull,0x40010000000ull
},{
0x204080020408000ull,0x4080020408000ull,0x80020408000ull,0x80020408000ull,0x204080020408000ull,0x4080020408000ull,0x80020408000ull,0x80020408000ull,
0x204080020000000ull,0x4080020000000ull,0x80020000000ull,0x80020000000ull,0x204080020000000ull,0x4080020000000ull,0x80020000000ull,0x80020000000ull,
0x204080020400000ull,0x4080020400000ull,0x80020400000ull,0x80020400000ull,0x204080020400000ull,0x4080020400000ull,0x80020400000ull,0x80020400000ull,
0x204080020000000ull,0x4080020000000ull,0x80020000000ull,0x80020000000ull,0x204080020000000ull,0x4080020000000ull,0x80020000000ull,0x80020000000ull,
0x204080020408000ull,0x4080020408000ull,0x80020408000ull,0x80020408000ull,0x204080020408000ull,0x4080020408000ull,0x80020408000ull,0x80020408000ull,
0x204080020000000ull,0x4080020000000ull,0x80020000000ull,0x80020000000ull,0x204080020000000ull,0x4080020000000ull,0x80020000000ull,0x80020000000ull,
0x204080020400000ull,0x4080020400000ull,0x80020400000ull,0x80020400000ull,0x204080020400000ull,0x4080020400000ull,0x80020400000ull,0x80020400000ull,
0x204080020000000ull,0x4080020000000ull,0x80020000000ull,0x80020000000ull,0x204080020000000ull,0x4080020000000ull,0x80020000000ull,0x80020000000ull
},{
0x408100040800000ull,0x8100040800000ull,0x100040800000ull,0x100040800000ull,0x408100040800000ull,0x8100040800000ull,0x100040800000ull,0x100040800000ull,
0x408100040000000ull,0x8100040000000ull,0x100040000000ull,0x100040000000ull,0x408100040000000ull,0x8100040000000ull,0x100040000000ull,0x100040000000ull,
0x408100040800000ull,0x8100040800000ull,0x100040800000ull,0x100040800000ull,0x408100040800000ull,0x8100040800000ull,0x100040800000ull,0x100040800000ull,
0x408100040000000ull,0x8100040000000ull,0x100040000000ull,0x100040000000ull,0x408100040000000ull,0x8100040000000ull,0x100040000000ull,0x100040000000ull,
0x408100040800000ull,0x8100040800000ull,0x100040800000ull,0x100040800000ull,0x408100040800000ull,0x8100040800000ull,0x100040800000ull,0x100040800000ull,
0x408100040000000ull,0x8100040000000ull,0x100040000000ull,0x100040000000ull,0x408100040000000ull,0x8100040000000ull,0x100040000000ull,0x100040000000ull,
0x408100040800000ull,0x8100040800000ull,0x100040800000ull,0x100040800000ull,0x408100040800000ull,0x8100040800000ull,0x100040800000ull,0x100040800000ull,
0x408100040000000ull,0x8100040000000ull,0x100040000000ull,0x100040000000ull,0x408100040000000ull,0x8100040000000ull,0x100040000000ull,0x100040000000ull
},{
0x810200080000000ull,0x10200080000000ull,0x200080000000ull,0x200080000000ull,0x810200080000000ull,0x10200080000000ull,0x200080000000ull,0x200080000000ull,
0x810200080000000ull,0x10200080000000ull,0x200080000000ull,0x200080000000ull,0x810200080000000ull,0x10200080000000ull,0x200080000000ull,0x200080000000ull,
0x810200080000000ull,0x10200080000000ull,0x200080000000ull,0x200080000000ull,0x810200080000000ull,0x10200080000000ull,0x200080000000ull,0x200080000000ull,
0x810200080000000ull,0x10200080000000ull,0x200080000000ull,0x200080000000ull,0x810200080000000ull,0x10200080000000ull,0x200080000000ull,0x200080000000ull,
0x810200080000000ull,0x10200080000000ull,0x200080000000ull,0x200080000000ull,0x810200080000000ull,0x10200080000000ull,0x200080000000ull,0x200080000000ull,
0x810200080000000ull,0x10200080000000ull,0x200080000000ull,0x200080000000ull,0x810200080000000ull,0x10200080000000ull,0x200080000000ull,0x200080000000ull,
0x810200080000000ull,0x10200080000000ull,0x200080000000ull,0x200080000000ull,0x810200080000000ull,0x10200080000000ull,0x200080000000ull,0x200080000000ull,
0x810200080000000ull,0x10200080000000ull,0x200080000000ull,0x200080000000ull,0x810200080000000ull,0x10200080000000ull,0x200080000000ull,0x200080000000ull
},{
0x1020400000000000ull,0x20400000000000ull,0x400000000000ull,0x400000000000ull,0x1020400000000000ull,0x20400000000000ull,0x400000000000ull,0x400000000000ull,
0x1020400000000000ull,0x20400000000000ull,0x400000000000ull,0x400000000000ull,0x1020400000000000ull,0x20400000000000ull,0x400000000000ull,0x400000000000ull,
0x1020400000000000ull,0x20400000000000ull,0x400000000000ull,0x400000000000ull,0x1020400000000000ull,0x20400000000000ull,0x400000000000ull,0x400000000000ull,
0x1020400000000000ull,0x20400000000000ull,0x400000000000ull,0x400000000000ull,0x1020400000000000ull,0x20400000000000ull,0x400000000000ull,0x400000000000ull,
0x1020400000000000ull,0x20400000000000ull,0x400000000000ull,0x400000000000ull,0x1020400000000000ull,0x20400000000000ull,0x400000000000ull,0x400000000000ull,
0x1020400000000000ull,0x20400000000000ull,0x400000000000ull,0x400000000000ull,0x1020400000000000ull,0x20400000000000ull,0x400000000000ull,0x400000000000ull,
0x1020400000000000ull,0x20400000000000ull,0x400000000000ull,0x400000000000ull,0x1020400000000000ull,0x20400000000000ull,0x400000000000ull,0x400000000000ull,
0x1020400000000000ull,0x20400000000000ull,0x400000000000ull,0x400000000000ull,0x1020400000000000ull,0x20400000000000ull,0x400000000000ull,0x400000000000ull
},{
0x204081020ull,0x200000000ull,0x204000000ull,0x200000000ull,0x204080000ull,0x200000000ull,0x204000000ull,0x200000000ull,
0x204081000ull,0x200000000ull,0x204000000ull,0x200000000ull,0x204080000ull,0x200000000ull,0x204000000ull,0x200000000ull,
0x204081020ull,0x200000000ull,0x204000000ull,0x200000000ull,0x204080000ull,0x200000000ull,0x204000000ull,0x200000000ull,
0x204081000ull,0x200000000ull,0x204000000ull,0x200000000ull,0x204080000ull,0x200000000ull,0x204000000ull,0x200000000ull,
0x204081020ull,0x200000000ull,0x204000000ull,0x200000000ull,0x204080000ull,0x200000000ull,0x204000000ull,0x200000000ull,
0x204081000ull,0x200000000ull,0x204000000ull,0x200000000ull,0x204080000ull,0x200000000ull,0x204000000ull,0x200000000ull,
0x204081020ull,0x200000000ull,0x204000000ull,0x200000000ull,0x204080000ull,0x200000000ull,0x204000000ull,0x200000000ull,
0x204081000ull,0x200000000ull,0x204000000ull,0x200000000ull,0x204080000ull,0x200000000ull,0x204000000ull,0x200000000ull
},{
0x1000408102040ull,0x1000408102040ull,0x1000400000000ull,0x1000400000000ull,0x1000408000000ull,0x1000408000000ull,0x1000400000000ull,0x1000400000000ull,
0x1000408100000ull,0x1000408100000ull,0x1000400000000ull,0x1000400000000ull,0x1000408000000ull,0x1000408000000ull,0x1000400000000ull,0x1000400000000ull,
0x1000408102000ull,0x1000408102000ull,0x1000400000000ull,0x1000400000000ull,0x1000408000000ull,0x1000408000000ull,0x1000400000000ull,0x1000400000000ull,
0x1000408100000ull,0x1000408100000ull,0x1000400000000ull,0x1000400000000ull,0x1000408000000ull,0x1000408000000ull,0x1000400000000ull,0x1000400000000ull,
0x1000408102040ull,0x1000408102040ull,0x1000400000000ull,0x1000400000000ull,0x1000408000000ull,0x1000408000000ull,0x1000400000000ull,0x1000400000000ull,
0x1000408100000ull,0x1000408100000ull,0x1000400000000ull,0x1000400000000ull,0x1000408000000ull,0x1000408000000ull,0x1000400000000ull,0x1000400000000ull,
0x1000408102000ull,0x1000408102000ull,0x1000400000000ull,0x1000400000000ull,0x1000408000000ull,0x1000408000000ull,0x1000400000000ull,0x1000400000000ull,
0x1000408100000ull,0x1000408100000ull,0x1000400000000ull,0x1000400000000ull,0x1000408000000ull,0x1000408000000ull,0x1000400000000ull,0x1000400000000ull
},{
0x102000810204080ull,0x2000810204080ull,0x102000810204080ull,0x2000810204080ull,0x102000800000000ull,0x2000800000000ull,0x102000800000000ull,0x2000800000000ull,
0x102000810000000ull,0x2000810000000ull,0x102000810000000ull,0x2000810000000ull,0x102000800000000ull,0x2000800000000ull,0x102000800000000ull,0x2000800000000ull,
0x102000810200000ull,0x2000810200000ull,0x102000810200000ull,0x2000810200000ull,0x102000800000000ull,0x2000800000000ull,0x102000800000000ull,0x2000800000000ull,
0x102000810000000ull,0x2000810000000ull,0x102000810000000ull,0x2000810000000ull,0x102000800000000ull,0x2000800000000ull,0x102000800000000ull,0x2000800000000ull,
0x102000810204000ull,0x2000810204000ull,0x102000810204000ull,0x2000810204000ull,0x102000800000000ull,0x2000800000000ull,0x102000800000000ull,0x2000800000000ull,
0x102000810000000ull,0x2000810000000ull,0x102000810000000ull,0x2000810000000ull,0x102000800000000ull,0x2000800000000ull,0x102000800000000ull,0x2000800000000ull,
0x102000810200000ull,0x2000810200000ull,0x102000810200000ull,0x2000810200000ull,0x102000800000000ull,0x2000800000000ull,0x102000800000000ull,0x2000800000000ull,
0x102000810000000ull,0x2000810000000ull,0x102000810000000ull,0x2000810000000ull,0x102000800000000ull,0x2000800000000ull,0x102000800000000ull,0x2000800000000ull
},{
0x204001020408000ull,0x4001020408000ull,0x204001020408000ull,0x4001020408000ull,0x204001000000000ull,0x4001000000000ull,0x204001000000000ull,0x4001000000000ull,
0x204001020000000ull,0x4001020000000ull,0x204001020000000ull,0x4001020000000ull,0x204001000000000ull,0x4001000000000ull,0x204001000000000ull,0x4001000000000ull,
0x204001020400000ull,0x4001020400000ull,0x204001020400000ull,0x4001020400000ull,0x204001000000000ull,0x4001000000000ull,0x204001000000000ull,0x4001000000000ull,
0x204001020000000ull,0x4001020000000ull,0x204001020000000ull,0x4001020000000ull,0x204001000000000ull,0x4001000000000ull,0x204001000000000ull,0x4001000000000ull,
0x204001020408000ull,0x4001020408000ull,0x204001020408000ull,0x4001020408000ull,0x204001000000000ull,0x4001000000000ull,0x204001000000000ull,0x4001000000000ull,
0x204001020000000ull,0x4001020000000ull,0x204001020000000ull,0x4001020000000ull,0x204001000000000ull,0x4001000000000ull,0x204001000000000ull,0x4001000000000ull,
0x204001020400000ull,0x4001020400000ull,0x204001020400000ull,0x4001020400000ull,0x204001000000000ull,0x4001000000000ull,0x204001000000000ull,0x4001000000000ull,
0x204001020000000ull,0x4001020000000ull,0x204001020000000ull,0x4001020000000ull,0x204001000000000ull,0x4001000000000ull,0x204001000000000ull,0x4001000000000ull
},{
0x408002040800000ull,0x8002040800000ull,0x408002040800000ull,0x8002040800000ull,0x408002000000000ull,0x8002000000000ull,0x408002000000000ull,0x8002000000000ull,
0x408002040000000ull,0x8002040000000ull,0x408002040000000ull,0x8002040000000ull,0x408002000000000ull,0x8002000000000ull,0x408002000000000ull,0x8002000000000ull,
0x408002040800000ull,0x8002040800000ull,0x408002040800000ull,0x8002040800000ull,0x408002000000000ull,0x8002000000000ull,0x408002000000000ull,0x8002000000000ull,
0x408002040000000ull,0x8002040000000ull,0x408002040000000ull,0x8002040000000ull,0x408002000000000ull,0x8002000000000ull,0x408002000000000ull,0x8002000000000ull,
0x408002040800000ull,0x8002040800000ull,0x408002040800000ull,0x8002040800000ull,0x408002000000000ull,0x8002000000000ull,0x408002000000000ull,0x8002000000000ull,
0x408002040000000ull,0x8002040000000ull,0x408002040000000ull,0x8002040000000ull,0x408002000000000ull,0x8002000000000ull,0x408002000000000ull,0x8002000000000ull,
0x408002040800000ull,0x8002040800000ull,0x408002040800000ull,0x8002040800000ull,0x408002000000000ull,0x8002000000000ull,0x408002000000000ull,0x8002000000000ull,
0x408002040000000ull,0x8002040000000ull,0x408002040000000ull,0x8002040000000ull,0x408002000000000ull,0x8002000000000ull,0x408002000000000ull,0x8002000000000ull
},{
0x810004080000000ull,0x10004080000000ull,0x810004080000000ull,0x10004080000000ull,0x810004000000000ull,0x10004000000000ull,0x810004000000000ull,0x10004000000000ull,
0x810004080000000ull,0x10004080000000ull,0x810004080000000ull,0x10004080000000ull,0x810004000000000ull,0x10004000000000ull,0x810004000000000ull,0x10004000000000ull,
0x810004080000000ull,0x10004080000000ull,0x810004080000000ull,0x10004080000000ull,0x810004000000000ull,0x10004000000000ull,0x810004000000000ull,0x10004000000000ull,
0x810004080000000ull,0x10004080000000ull,0x810004080000000ull,0x10004080000000ull,0x810004000000000ull,0x10004000000000ull,0x810004000000000ull,0x10004000000000ull,
0x810004080000000ull,0x10004080000000ull,0x810004080000000ull,0x10004080000000ull,0x810004000000000ull,0x10004000000000ull,0x810004000000000ull,0x10004000000000ull,
0x810004080000000ull,0x10004080000000ull,0x810004080000000ull,0x10004080000000ull,0x810004000000000ull,0x10004000000000ull,0x810004000000000ull,0x10004000000000ull,
0x810004080000000ull,0x10004080000000ull,0x810004080000000ull,0x10004080000000ull,0x810004000000000ull,0x10004000000000ull,0x810004000000000ull,0x10004000000000ull,
0x810004080000000ull,0x10004080000000ull,0x810004080000000ull,0x10004080000000ull,0x810004000000000ull,0x10004000000000ull,0x810004000000000ull,0x10004000000000ull
},{
0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,
0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,
0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,
0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,
0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,
0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,
0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,
0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull,0x1020008000000000ull,0x20008000000000ull
},{
0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,
0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,
0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,
0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,
0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,
0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,
0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,
0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull,0x2040000000000000ull,0x40000000000000ull
},{
0x20408102040ull,0x20000000000ull,0x20400000000ull,0x20000000000ull,0x20408000000ull,0x20000000000ull,0x20400000000ull,0x20000000000ull,
0x20408100000ull,0x20000000000ull,0x20400000000ull,0x20000000000ull,0x20408000000ull,0x20000000000ull,0x20400000000ull,0x20000000000ull,
0x20408102000ull,0x20000000000ull,0x20400000000ull,0x20000000000ull,0x20408000000ull,0x20000000000ull,0x20400000000ull,0x20000000000ull,
0x20408100000ull,0x20000000000ull,0x20400000000ull,0x20000000000ull,0x20408000000ull,0x20000000000ull,0x20400000000ull,0x20000000000ull,
0x20408102040ull,0x20000000000ull,0x20400000000ull,0x20000000000ull,0x20408000000ull,0x20000000000ull,0x20400000000ull,0x20000000000ull,
0x20408100000ull,0x20000000000ull,0x20400000000ull,0x20000000000ull,0x20408000000ull,0x20000000000ull,0x20400000000ull,0x20000000000ull,
0x20408102000ull,0x20000000000ull,0x20400000000ull,0x20000000000ull,0x20408000000ull,0x20000000000ull,0x20400000000ull,0x20000000000ull,
0x20408100000ull,0x20000000000ull,0x20400000000ull,0x20000000000ull,0x20408000000ull,0x20000000000ull,0x20400000000ull,0x20000000000ull
},{
0x100040810204080ull,0x100040810204080ull,0x100040000000000ull,0x100040000000000ull,0x100040800000000ull,0x100040800000000ull,0x100040000000000ull,0x100040000000000ull,
0x100040810000000ull,0x100040810000000ull,0x100040000000000ull,0x100040000000000ull,0x100040800000000ull,0x100040800000000ull,0x100040000000000ull,0x100040000000000ull,
0x100040810200000ull,0x100040810200000ull,0x100040000000000ull,0x100040000000000ull,0x100040800000000ull,0x100040800000000ull,0x100040000000000ull,0x100040000000000ull,
0x100040810000000ull,0x100040810000000ull,0x100040000000000ull,0x100040000000000ull,0x100040800000000ull,0x100040800000000ull,0x100040000000000ull,0x100040000000000ull,
0x100040810204000ull,0x100040810204000ull,0x100040000000000ull,0x100040000000000ull,0x100040800000000ull,0x100040800000000ull,0x100040000000000ull,0x100040000000000ull,
0x100040810000000ull,0x100040810000000ull,0x100040000000000ull,0x100040000000000ull,0x100040800000000ull,0x100040800000000ull,0x100040000000000ull,0x100040000000000ull,
0x100040810200000ull,0x100040810200000ull,0x100040000000000ull,0x100040000000000ull,0x100040800000000ull,0x100040800000000ull,0x100040000000000ull,0x100040000000000ull,
0x100040810000000ull,0x100040810000000ull,0x100040000000000ull,0x100040000000000ull,0x100040800000000ull,0x100040800000000ull,0x100040000000000ull,0x100040000000000ull
},{
0x200081020408000ull,0x200081020408000ull,0x200080000000000ull,0x200080000000000ull,0x200081000000000ull,0x200081000000000ull,0x200080000000000ull,0x200080000000000ull,
0x200081020000000ull,0x200081020000000ull,0x200080000000000ull,0x200080000000000ull,0x200081000000000ull,0x200081000000000ull,0x200080000000000ull,0x200080000000000ull,
0x200081020400000ull,0x200081020400000ull,0x200080000000000ull,0x200080000000000ull,0x200081000000000ull,0x200081000000000ull,0x200080000000000ull,0x200080000000000ull,
0x200081020000000ull,0x200081020000000ull,0x200080000000000ull,0x200080000000000ull,0x200081000000000ull,0x200081000000000ull,0x200080000000000ull,0x200080000000000ull,
0x200081020408000ull,0x200081020408000ull,0x200080000000000ull,0x200080000000000ull,0x200081000000000ull,0x200081000000000ull,0x200080000000000ull,0x200080000000000ull,
0x200081020000000ull,0x200081020000000ull,0x200080000000000ull,0x200080000000000ull,0x200081000000000ull,0x200081000000000ull,0x200080000000000ull,0x200080000000000ull,
0x200081020400000ull,0x200081020400000ull,0x200080000000000ull,0x200080000000000ull,0x200081000000000ull,0x200081000000000ull,0x200080000000000ull,0x200080000000000ull,
0x200081020000000ull,0x200081020000000ull,0x200080000000000ull,0x200080000000000ull,0x200081000000000ull,0x200081000000000ull,0x200080000000000ull,0x200080000000000ull
},{
0x400102040800000ull,0x400102040800000ull,0x400100000000000ull,0x400100000000000ull,0x400102000000000ull,0x400102000000000ull,0x400100000000000ull,0x400100000000000ull,
0x400102040000000ull,0x400102040000000ull,0x400100000000000ull,0x400100000000000ull,0x400102000000000ull,0x400102000000000ull,0x400100000000000ull,0x400100000000000ull,
0x400102040800000ull,0x400102040800000ull,0x400100000000000ull,0x400100000000000ull,0x400102000000000ull,0x400102000000000ull,0x400100000000000ull,0x400100000000000ull,
0x400102040000000ull,0x400102040000000ull,0x400100000000000ull,0x400100000000000ull,0x400102000000000ull,0x400102000000000ull,0x400100000000000ull,0x400100000000000ull,
0x400102040800000ull,0x400102040800000ull,0x400100000000000ull,0x400100000000000ull,0x400102000000000ull,0x400102000000000ull,0x400100000000000ull,0x400100000000000ull,
0x400102040000000ull,0x400102040000000ull,0x400100000000000ull,0x400100000000000ull,0x400102000000000ull,0x400102000000000ull,0x400100000000000ull,0x400100000000000ull,
0x400102040800000ull,0x400102040800000ull,0x400100000000000ull,0x400100000000000ull,0x400102000000000ull,0x400102000000000ull,0x400100000000000ull,0x400100000000000ull,
0x400102040000000ull,0x400102040000000ull,0x400100000000000ull,0x400100000000000ull,0x400102000000000ull,0x400102000000000ull,0x400100000000000ull,0x400100000000000ull
},{
0x800204080000000ull,0x800204080000000ull,0x800200000000000ull,0x800200000000000ull,0x800204000000000ull,0x800204000000000ull,0x800200000000000ull,0x800200000000000ull,
0x800204080000000ull,0x800204080000000ull,0x800200000000000ull,0x800200000000000ull,0x800204000000000ull,0x800204000000000ull,0x800200000000000ull,0x800200000000000ull,
0x800204080000000ull,0x800204080000000ull,0x800200000000000ull,0x800200000000000ull,0x800204000000000ull,0x800204000000000ull,0x800200000000000ull,0x800200000000000ull,
0x800204080000000ull,0x800204080000000ull,0x800200000000000ull,0x800200000000000ull,0x800204000000000ull,0x800204000000000ull,0x800200000000000ull,0x800200000000000ull,
0x800204080000000ull,0x800204080000000ull,0x800200000000000ull,0x800200000000000ull,0x800204000000000ull,0x800204000000000ull,0x800200000000000ull,0x800200000000000ull,
0x800204080000000ull,0x800204080000000ull,0x800200000000000ull,0x800200000000000ull,0x800204000000000ull,0x800204000000000ull,0x800200000000000ull,0x800200000000000ull,
0x800204080000000ull,0x800204080000000ull,0x800200000000000ull,0x800200000000000ull,0x800204000000000ull,0x800204000000000ull,0x800200000000000ull,0x800200000000000ull,
0x800204080000000ull,0x800204080000000ull,0x800200000000000ull,0x800200000000000ull,0x800204000000000ull,0x800204000000000ull,0x800200000000000ull,0x800200000000000ull
},{
0x1000408000000000ull,0x1000408000000000ull,0x1000400000000000ull,0x1000400000000000ull,0x1000408000000000ull,0x1000408000000000ull,0x1000400000000000ull,0x1000400000000000ull,
0x1000408000000000ull,0x1000408000000000ull,0x1000400000000000ull,0x1000400000000000ull,0x1000408000000000ull,0x1000408000000000ull,0x1000400000000000ull,0x1000400000000000ull,
0x1000408000000000ull,0x1000408000000000ull,0x1000400000000000ull,0x1000400000000000ull,0x1000408000000000ull,0x1000408000000000ull,0x1000400000000000ull,0x1000400000000000ull,
0x1000408000000000ull,0x1000408000000000ull,0x1000400000000000ull,0x1000400000000000ull,0x1000408000000000ull,0x1000408000000000ull,0x1000400000000000ull,0x1000400000000000ull,
0x1000408000000000ull,0x1000408000000000ull,0x1000400000000000ull,0x1000400000000000ull,0x1000408000000000ull,0x1000408000000000ull,0x1000400000000000ull,0x1000400000000000ull,
0x1000408000000000ull,0x1000408000000000ull,0x1000400000000000ull,0x1000400000000000ull,0x1000408000000000ull,0x1000408000000000ull,0x1000400000000000ull,0x1000400000000000ull,
0x1000408000000000ull,0x1000408000000000ull,0x1000400000000000ull,0x1000400000000000ull,0x1000408000000000ull,0x1000408000000000ull,0x1000400000000000ull,0x1000400000000000ull,
0x1000408000000000ull,0x1000408000000000ull,0x1000400000000000ull,0x1000400000000000ull,0x1000408000000000ull,0x1000408000000000ull,0x1000400000000000ull,0x1000400000000000ull
},{
0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,
0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,
0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,
0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,
0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,
0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,
0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,
0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull,0x2000800000000000ull
},{
0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,
0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,
0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,
0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,
0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,
0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,
0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,
0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull
},{
0x2040810204080ull,0x2000000000000ull,0x2040000000000ull,0x2000000000000ull,0x2040800000000ull,0x2000000000000ull,0x2040000000000ull,0x2000000000000ull,
0x2040810000000ull,0x2000000000000ull,0x2040000000000ull,0x2000000000000ull,0x2040800000000ull,0x2000000000000ull,0x2040000000000ull,0x2000000000000ull,
0x2040810200000ull,0x2000000000000ull,0x2040000000000ull,0x2000000000000ull,0x2040800000000ull,0x2000000000000ull,0x2040000000000ull,0x2000000000000ull,
0x2040810000000ull,0x2000000000000ull,0x2040000000000ull,0x2000000000000ull,0x2040800000000ull,0x2000000000000ull,0x2040000000000ull,0x2000000000000ull,
0x2040810204000ull,0x2000000000000ull,0x2040000000000ull,0x2000000000000ull,0x2040800000000ull,0x2000000000000ull,0x2040000000000ull,0x2000000000000ull,
0x2040810000000ull,0x2000000000000ull,0x2040000000000ull,0x2000000000000ull,0x2040800000000ull,0x2000000000000ull,0x2040000000000ull,0x2000000000000ull,
0x2040810200000ull,0x2000000000000ull,0x2040000000000ull,0x2000000000000ull,0x2040800000000ull,0x2000000000000ull,0x2040000000000ull,0x2000000000000ull,
0x2040810000000ull,0x2000000000000ull,0x2040000000000ull,0x2000000000000ull,0x2040800000000ull,0x2000000000000ull,0x2040000000000ull,0x2000000000000ull
},{
0x4081020408000ull,0x4000000000000ull,0x4080000000000ull,0x4000000000000ull,0x4081000000000ull,0x4000000000000ull,0x4080000000000ull,0x4000000000000ull,
0x4081020000000ull,0x4000000000000ull,0x4080000000000ull,0x4000000000000ull,0x4081000000000ull,0x4000000000000ull,0x4080000000000ull,0x4000000000000ull,
0x4081020400000ull,0x4000000000000ull,0x4080000000000ull,0x4000000000000ull,0x4081000000000ull,0x4000000000000ull,0x4080000000000ull,0x4000000000000ull,
0x4081020000000ull,0x4000000000000ull,0x4080000000000ull,0x4000000000000ull,0x4081000000000ull,0x4000000000000ull,0x4080000000000ull,0x4000000000000ull,
0x4081020408000ull,0x4000000000000ull,0x4080000000000ull,0x4000000000000ull,0x4081000000000ull,0x4000000000000ull,0x4080000000000ull,0x4000000000000ull,
0x4081020000000ull,0x4000000000000ull,0x4080000000000ull,0x4000000000000ull,0x4081000000000ull,0x4000000000000ull,0x4080000000000ull,0x4000000000000ull,
0x4081020400000ull,0x4000000000000ull,0x4080000000000ull,0x4000000000000ull,0x4081000000000ull,0x4000000000000ull,0x4080000000000ull,0x4000000000000ull,
0x4081020000000ull,0x4000000000000ull,0x4080000000000ull,0x4000000000000ull,0x4081000000000ull,0x4000000000000ull,0x4080000000000ull,0x4000000000000ull
},{
0x8102040800000ull,0x8000000000000ull,0x8100000000000ull,0x8000000000000ull,0x8102000000000ull,0x8000000000000ull,0x8100000000000ull,0x8000000000000ull,
0x8102040000000ull,0x8000000000000ull,0x8100000000000ull,0x8000000000000ull,0x8102000000000ull,0x8000000000000ull,0x8100000000000ull,0x8000000000000ull,
0x8102040800000ull,0x8000000000000ull,0x8100000000000ull,0x8000000000000ull,0x8102000000000ull,0x8000000000000ull,0x8100000000000ull,0x8000000000000ull,
0x8102040000000ull,0x8000000000000ull,0x8100000000000ull,0x8000000000000ull,0x8102000000000ull,0x8000000000000ull,0x8100000000000ull,0x8000000000000ull,
0x8102040800000ull,0x8000000000000ull,0x8100000000000ull,0x8000000000000ull,0x8102000000000ull,0x8000000000000ull,0x8100000000000ull,0x8000000000000ull,
0x8102040000000ull,0x8000000000000ull,0x8100000000000ull,0x8000000000000ull,0x8102000000000ull,0x8000000000000ull,0x8100000000000ull,0x8000000000000ull,
0x8102040800000ull,0x8000000000000ull,0x8100000000000ull,0x8000000000000ull,0x8102000000000ull,0x8000000000000ull,0x8100000000000ull,0x8000000000000ull,
0x8102040000000ull,0x8000000000000ull,0x8100000000000ull,0x8000000000000ull,0x8102000000000ull,0x8000000000000ull,0x8100000000000ull,0x8000000000000ull
},{
0x10204080000000ull,0x10000000000000ull,0x10200000000000ull,0x10000000000000ull,0x10204000000000ull,0x10000000000000ull,0x10200000000000ull,0x10000000000000ull,
0x10204080000000ull,0x10000000000000ull,0x10200000000000ull,0x10000000000000ull,0x10204000000000ull,0x10000000000000ull,0x10200000000000ull,0x10000000000000ull,
0x10204080000000ull,0x10000000000000ull,0x10200000000000ull,0x10000000000000ull,0x10204000000000ull,0x10000000000000ull,0x10200000000000ull,0x10000000000000ull,
0x10204080000000ull,0x10000000000000ull,0x10200000000000ull,0x10000000000000ull,0x10204000000000ull,0x10000000000000ull,0x10200000000000ull,0x10000000000000ull,
0x10204080000000ull,0x10000000000000ull,0x10200000000000ull,0x10000000000000ull,0x10204000000000ull,0x10000000000000ull,0x10200000000000ull,0x10000000000000ull,
0x10204080000000ull,0x10000000000000ull,0x10200000000000ull,0x10000000000000ull,0x10204000000000ull,0x10000000000000ull,0x10200000000000ull,0x10000000000000ull,
0x10204080000000ull,0x10000000000000ull,0x10200000000000ull,0x10000000000000ull,0x10204000000000ull,0x10000000000000ull,0x10200000000000ull,0x10000000000000ull,
0x10204080000000ull,0x10000000000000ull,0x10200000000000ull,0x10000000000000ull,0x10204000000000ull,0x10000000000000ull,0x10200000000000ull,0x10000000000000ull
},{
0x20408000000000ull,0x20000000000000ull,0x20400000000000ull,0x20000000000000ull,0x20408000000000ull,0x20000000000000ull,0x20400000000000ull,0x20000000000000ull,
0x20408000000000ull,0x20000000000000ull,0x20400000000000ull,0x20000000000000ull,0x20408000000000ull,0x20000000000000ull,0x20400000000000ull,0x20000000000000ull,
0x20408000000000ull,0x20000000000000ull,0x20400000000000ull,0x20000000000000ull,0x20408000000000ull,0x20000000000000ull,0x20400000000000ull,0x20000000000000ull,
0x20408000000000ull,0x20000000000000ull,0x20400000000000ull,0x20000000000000ull,0x20408000000000ull,0x20000000000000ull,0x20400000000000ull,0x20000000000000ull,
0x20408000000000ull,0x20000000000000ull,0x20400000000000ull,0x20000000000000ull,0x20408000000000ull,0x20000000000000ull,0x20400000000000ull,0x20000000000000ull,
0x20408000000000ull,0x20000000000000ull,0x20400000000000ull,0x20000000000000ull,0x20408000000000ull,0x20000000000000ull,0x20400000000000ull,0x20000000000000ull,
0x20408000000000ull,0x20000000000000ull,0x20400000000000ull,0x20000000000000ull,0x20408000000000ull,0x20000000000000ull,0x20400000000000ull,0x20000000000000ull,
0x20408000000000ull,0x20000000000000ull,0x20400000000000ull,0x20000000000000ull,0x20408000000000ull,0x20000000000000ull,0x20400000000000ull,0x20000000000000ull
},{
0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,
0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,
0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,
0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,
0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,
0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,
0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,
0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull,0x40800000000000ull,0x40000000000000ull
},{
0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,
0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,
0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,
0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,
0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,
0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,
0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,
0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull,0x80000000000000ull
},{
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull
}};



  uint64 FILE_ATTACKS[64][64] = {
{
0x101010101010100ull,0x1010101010100ull,0x10101010100ull,0x10101010100ull,0x101010100ull,0x101010100ull,0x101010100ull,0x101010100ull,
0x1010100ull,0x1010100ull,0x1010100ull,0x1010100ull,0x1010100ull,0x1010100ull,0x1010100ull,0x1010100ull,
0x10100ull,0x10100ull,0x10100ull,0x10100ull,0x10100ull,0x10100ull,0x10100ull,0x10100ull,
0x10100ull,0x10100ull,0x10100ull,0x10100ull,0x10100ull,0x10100ull,0x10100ull,0x10100ull,
0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,
0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,
0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,
0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull,0x100ull
},{
0x202020202020200ull,0x2020202020200ull,0x20202020200ull,0x20202020200ull,0x202020200ull,0x202020200ull,0x202020200ull,0x202020200ull,
0x2020200ull,0x2020200ull,0x2020200ull,0x2020200ull,0x2020200ull,0x2020200ull,0x2020200ull,0x2020200ull,
0x20200ull,0x20200ull,0x20200ull,0x20200ull,0x20200ull,0x20200ull,0x20200ull,0x20200ull,
0x20200ull,0x20200ull,0x20200ull,0x20200ull,0x20200ull,0x20200ull,0x20200ull,0x20200ull,
0x200ull,0x200ull,0x200ull,0x200ull,0x200ull,0x200ull,0x200ull,0x200ull,
0x200ull,0x200ull,0x200ull,0x200ull,0x200ull,0x200ull,0x200ull,0x200ull,
0x200ull,0x200ull,0x200ull,0x200ull,0x200ull,0x200ull,0x200ull,0x200ull,
0x200ull,0x200ull,0x200ull,0x200ull,0x200ull,0x200ull,0x200ull,0x200ull
},{
0x404040404040400ull,0x4040404040400ull,0x40404040400ull,0x40404040400ull,0x404040400ull,0x404040400ull,0x404040400ull,0x404040400ull,
0x4040400ull,0x4040400ull,0x4040400ull,0x4040400ull,0x4040400ull,0x4040400ull,0x4040400ull,0x4040400ull,
0x40400ull,0x40400ull,0x40400ull,0x40400ull,0x40400ull,0x40400ull,0x40400ull,0x40400ull,
0x40400ull,0x40400ull,0x40400ull,0x40400ull,0x40400ull,0x40400ull,0x40400ull,0x40400ull,
0x400ull,0x400ull,0x400ull,0x400ull,0x400ull,0x400ull,0x400ull,0x400ull,
0x400ull,0x400ull,0x400ull,0x400ull,0x400ull,0x400ull,0x400ull,0x400ull,
0x400ull,0x400ull,0x400ull,0x400ull,0x400ull,0x400ull,0x400ull,0x400ull,
0x400ull,0x400ull,0x400ull,0x400ull,0x400ull,0x400ull,0x400ull,0x400ull
},{
0x808080808080800ull,0x8080808080800ull,0x80808080800ull,0x80808080800ull,0x808080800ull,0x808080800ull,0x808080800ull,0x808080800ull,
0x8080800ull,0x8080800ull,0x8080800ull,0x8080800ull,0x8080800ull,0x8080800ull,0x8080800ull,0x8080800ull,
0x80800ull,0x80800ull,0x80800ull,0x80800ull,0x80800ull,0x80800ull,0x80800ull,0x80800ull,
0x80800ull,0x80800ull,0x80800ull,0x80800ull,0x80800ull,0x80800ull,0x80800ull,0x80800ull,
0x800ull,0x800ull,0x800ull,0x800ull,0x800ull,0x800ull,0x800ull,0x800ull,
0x800ull,0x800ull,0x800ull,0x800ull,0x800ull,0x800ull,0x800ull,0x800ull,
0x800ull,0x800ull,0x800ull,0x800ull,0x800ull,0x800ull,0x800ull,0x800ull,
0x800ull,0x800ull,0x800ull,0x800ull,0x800ull,0x800ull,0x800ull,0x800ull
},{
0x1010101010101000ull,0x10101010101000ull,0x101010101000ull,0x101010101000ull,0x1010101000ull,0x1010101000ull,0x1010101000ull,0x1010101000ull,
0x10101000ull,0x10101000ull,0x10101000ull,0x10101000ull,0x10101000ull,0x10101000ull,0x10101000ull,0x10101000ull,
0x101000ull,0x101000ull,0x101000ull,0x101000ull,0x101000ull,0x101000ull,0x101000ull,0x101000ull,
0x101000ull,0x101000ull,0x101000ull,0x101000ull,0x101000ull,0x101000ull,0x101000ull,0x101000ull,
0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,
0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,
0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,
0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull,0x1000ull
},{
0x2020202020202000ull,0x20202020202000ull,0x202020202000ull,0x202020202000ull,0x2020202000ull,0x2020202000ull,0x2020202000ull,0x2020202000ull,
0x20202000ull,0x20202000ull,0x20202000ull,0x20202000ull,0x20202000ull,0x20202000ull,0x20202000ull,0x20202000ull,
0x202000ull,0x202000ull,0x202000ull,0x202000ull,0x202000ull,0x202000ull,0x202000ull,0x202000ull,
0x202000ull,0x202000ull,0x202000ull,0x202000ull,0x202000ull,0x202000ull,0x202000ull,0x202000ull,
0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,
0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,
0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,
0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull,0x2000ull
},{
0x4040404040404000ull,0x40404040404000ull,0x404040404000ull,0x404040404000ull,0x4040404000ull,0x4040404000ull,0x4040404000ull,0x4040404000ull,
0x40404000ull,0x40404000ull,0x40404000ull,0x40404000ull,0x40404000ull,0x40404000ull,0x40404000ull,0x40404000ull,
0x404000ull,0x404000ull,0x404000ull,0x404000ull,0x404000ull,0x404000ull,0x404000ull,0x404000ull,
0x404000ull,0x404000ull,0x404000ull,0x404000ull,0x404000ull,0x404000ull,0x404000ull,0x404000ull,
0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,
0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,
0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,
0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull
},{
0x8080808080808000ull,0x80808080808000ull,0x808080808000ull,0x808080808000ull,0x8080808000ull,0x8080808000ull,0x8080808000ull,0x8080808000ull,
0x80808000ull,0x80808000ull,0x80808000ull,0x80808000ull,0x80808000ull,0x80808000ull,0x80808000ull,0x80808000ull,
0x808000ull,0x808000ull,0x808000ull,0x808000ull,0x808000ull,0x808000ull,0x808000ull,0x808000ull,
0x808000ull,0x808000ull,0x808000ull,0x808000ull,0x808000ull,0x808000ull,0x808000ull,0x808000ull,
0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,
0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,
0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,
0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull,0x8000ull
},{
0x101010101010001ull,0x1010101010001ull,0x10101010001ull,0x10101010001ull,0x101010001ull,0x101010001ull,0x101010001ull,0x101010001ull,
0x1010001ull,0x1010001ull,0x1010001ull,0x1010001ull,0x1010001ull,0x1010001ull,0x1010001ull,0x1010001ull,
0x10001ull,0x10001ull,0x10001ull,0x10001ull,0x10001ull,0x10001ull,0x10001ull,0x10001ull,
0x10001ull,0x10001ull,0x10001ull,0x10001ull,0x10001ull,0x10001ull,0x10001ull,0x10001ull,
0x101010101010001ull,0x1010101010001ull,0x10101010001ull,0x10101010001ull,0x101010001ull,0x101010001ull,0x101010001ull,0x101010001ull,
0x1010001ull,0x1010001ull,0x1010001ull,0x1010001ull,0x1010001ull,0x1010001ull,0x1010001ull,0x1010001ull,
0x10001ull,0x10001ull,0x10001ull,0x10001ull,0x10001ull,0x10001ull,0x10001ull,0x10001ull,
0x10001ull,0x10001ull,0x10001ull,0x10001ull,0x10001ull,0x10001ull,0x10001ull,0x10001ull
},{
0x202020202020002ull,0x2020202020002ull,0x20202020002ull,0x20202020002ull,0x202020002ull,0x202020002ull,0x202020002ull,0x202020002ull,
0x2020002ull,0x2020002ull,0x2020002ull,0x2020002ull,0x2020002ull,0x2020002ull,0x2020002ull,0x2020002ull,
0x20002ull,0x20002ull,0x20002ull,0x20002ull,0x20002ull,0x20002ull,0x20002ull,0x20002ull,
0x20002ull,0x20002ull,0x20002ull,0x20002ull,0x20002ull,0x20002ull,0x20002ull,0x20002ull,
0x202020202020002ull,0x2020202020002ull,0x20202020002ull,0x20202020002ull,0x202020002ull,0x202020002ull,0x202020002ull,0x202020002ull,
0x2020002ull,0x2020002ull,0x2020002ull,0x2020002ull,0x2020002ull,0x2020002ull,0x2020002ull,0x2020002ull,
0x20002ull,0x20002ull,0x20002ull,0x20002ull,0x20002ull,0x20002ull,0x20002ull,0x20002ull,
0x20002ull,0x20002ull,0x20002ull,0x20002ull,0x20002ull,0x20002ull,0x20002ull,0x20002ull
},{
0x404040404040004ull,0x4040404040004ull,0x40404040004ull,0x40404040004ull,0x404040004ull,0x404040004ull,0x404040004ull,0x404040004ull,
0x4040004ull,0x4040004ull,0x4040004ull,0x4040004ull,0x4040004ull,0x4040004ull,0x4040004ull,0x4040004ull,
0x40004ull,0x40004ull,0x40004ull,0x40004ull,0x40004ull,0x40004ull,0x40004ull,0x40004ull,
0x40004ull,0x40004ull,0x40004ull,0x40004ull,0x40004ull,0x40004ull,0x40004ull,0x40004ull,
0x404040404040004ull,0x4040404040004ull,0x40404040004ull,0x40404040004ull,0x404040004ull,0x404040004ull,0x404040004ull,0x404040004ull,
0x4040004ull,0x4040004ull,0x4040004ull,0x4040004ull,0x4040004ull,0x4040004ull,0x4040004ull,0x4040004ull,
0x40004ull,0x40004ull,0x40004ull,0x40004ull,0x40004ull,0x40004ull,0x40004ull,0x40004ull,
0x40004ull,0x40004ull,0x40004ull,0x40004ull,0x40004ull,0x40004ull,0x40004ull,0x40004ull
},{
0x808080808080008ull,0x8080808080008ull,0x80808080008ull,0x80808080008ull,0x808080008ull,0x808080008ull,0x808080008ull,0x808080008ull,
0x8080008ull,0x8080008ull,0x8080008ull,0x8080008ull,0x8080008ull,0x8080008ull,0x8080008ull,0x8080008ull,
0x80008ull,0x80008ull,0x80008ull,0x80008ull,0x80008ull,0x80008ull,0x80008ull,0x80008ull,
0x80008ull,0x80008ull,0x80008ull,0x80008ull,0x80008ull,0x80008ull,0x80008ull,0x80008ull,
0x808080808080008ull,0x8080808080008ull,0x80808080008ull,0x80808080008ull,0x808080008ull,0x808080008ull,0x808080008ull,0x808080008ull,
0x8080008ull,0x8080008ull,0x8080008ull,0x8080008ull,0x8080008ull,0x8080008ull,0x8080008ull,0x8080008ull,
0x80008ull,0x80008ull,0x80008ull,0x80008ull,0x80008ull,0x80008ull,0x80008ull,0x80008ull,
0x80008ull,0x80008ull,0x80008ull,0x80008ull,0x80008ull,0x80008ull,0x80008ull,0x80008ull
},{
0x1010101010100010ull,0x10101010100010ull,0x101010100010ull,0x101010100010ull,0x1010100010ull,0x1010100010ull,0x1010100010ull,0x1010100010ull,
0x10100010ull,0x10100010ull,0x10100010ull,0x10100010ull,0x10100010ull,0x10100010ull,0x10100010ull,0x10100010ull,
0x100010ull,0x100010ull,0x100010ull,0x100010ull,0x100010ull,0x100010ull,0x100010ull,0x100010ull,
0x100010ull,0x100010ull,0x100010ull,0x100010ull,0x100010ull,0x100010ull,0x100010ull,0x100010ull,
0x1010101010100010ull,0x10101010100010ull,0x101010100010ull,0x101010100010ull,0x1010100010ull,0x1010100010ull,0x1010100010ull,0x1010100010ull,
0x10100010ull,0x10100010ull,0x10100010ull,0x10100010ull,0x10100010ull,0x10100010ull,0x10100010ull,0x10100010ull,
0x100010ull,0x100010ull,0x100010ull,0x100010ull,0x100010ull,0x100010ull,0x100010ull,0x100010ull,
0x100010ull,0x100010ull,0x100010ull,0x100010ull,0x100010ull,0x100010ull,0x100010ull,0x100010ull
},{
0x2020202020200020ull,0x20202020200020ull,0x202020200020ull,0x202020200020ull,0x2020200020ull,0x2020200020ull,0x2020200020ull,0x2020200020ull,
0x20200020ull,0x20200020ull,0x20200020ull,0x20200020ull,0x20200020ull,0x20200020ull,0x20200020ull,0x20200020ull,
0x200020ull,0x200020ull,0x200020ull,0x200020ull,0x200020ull,0x200020ull,0x200020ull,0x200020ull,
0x200020ull,0x200020ull,0x200020ull,0x200020ull,0x200020ull,0x200020ull,0x200020ull,0x200020ull,
0x2020202020200020ull,0x20202020200020ull,0x202020200020ull,0x202020200020ull,0x2020200020ull,0x2020200020ull,0x2020200020ull,0x2020200020ull,
0x20200020ull,0x20200020ull,0x20200020ull,0x20200020ull,0x20200020ull,0x20200020ull,0x20200020ull,0x20200020ull,
0x200020ull,0x200020ull,0x200020ull,0x200020ull,0x200020ull,0x200020ull,0x200020ull,0x200020ull,
0x200020ull,0x200020ull,0x200020ull,0x200020ull,0x200020ull,0x200020ull,0x200020ull,0x200020ull
},{
0x4040404040400040ull,0x40404040400040ull,0x404040400040ull,0x404040400040ull,0x4040400040ull,0x4040400040ull,0x4040400040ull,0x4040400040ull,
0x40400040ull,0x40400040ull,0x40400040ull,0x40400040ull,0x40400040ull,0x40400040ull,0x40400040ull,0x40400040ull,
0x400040ull,0x400040ull,0x400040ull,0x400040ull,0x400040ull,0x400040ull,0x400040ull,0x400040ull,
0x400040ull,0x400040ull,0x400040ull,0x400040ull,0x400040ull,0x400040ull,0x400040ull,0x400040ull,
0x4040404040400040ull,0x40404040400040ull,0x404040400040ull,0x404040400040ull,0x4040400040ull,0x4040400040ull,0x4040400040ull,0x4040400040ull,
0x40400040ull,0x40400040ull,0x40400040ull,0x40400040ull,0x40400040ull,0x40400040ull,0x40400040ull,0x40400040ull,
0x400040ull,0x400040ull,0x400040ull,0x400040ull,0x400040ull,0x400040ull,0x400040ull,0x400040ull,
0x400040ull,0x400040ull,0x400040ull,0x400040ull,0x400040ull,0x400040ull,0x400040ull,0x400040ull
},{
0x8080808080800080ull,0x80808080800080ull,0x808080800080ull,0x808080800080ull,0x8080800080ull,0x8080800080ull,0x8080800080ull,0x8080800080ull,
0x80800080ull,0x80800080ull,0x80800080ull,0x80800080ull,0x80800080ull,0x80800080ull,0x80800080ull,0x80800080ull,
0x800080ull,0x800080ull,0x800080ull,0x800080ull,0x800080ull,0x800080ull,0x800080ull,0x800080ull,
0x800080ull,0x800080ull,0x800080ull,0x800080ull,0x800080ull,0x800080ull,0x800080ull,0x800080ull,
0x8080808080800080ull,0x80808080800080ull,0x808080800080ull,0x808080800080ull,0x8080800080ull,0x8080800080ull,0x8080800080ull,0x8080800080ull,
0x80800080ull,0x80800080ull,0x80800080ull,0x80800080ull,0x80800080ull,0x80800080ull,0x80800080ull,0x80800080ull,
0x800080ull,0x800080ull,0x800080ull,0x800080ull,0x800080ull,0x800080ull,0x800080ull,0x800080ull,
0x800080ull,0x800080ull,0x800080ull,0x800080ull,0x800080ull,0x800080ull,0x800080ull,0x800080ull
},{
0x101010101000101ull,0x1010101000101ull,0x10101000101ull,0x10101000101ull,0x101000101ull,0x101000101ull,0x101000101ull,0x101000101ull,
0x1000101ull,0x1000101ull,0x1000101ull,0x1000101ull,0x1000101ull,0x1000101ull,0x1000101ull,0x1000101ull,
0x101010101000101ull,0x1010101000101ull,0x10101000101ull,0x10101000101ull,0x101000101ull,0x101000101ull,0x101000101ull,0x101000101ull,
0x1000101ull,0x1000101ull,0x1000101ull,0x1000101ull,0x1000101ull,0x1000101ull,0x1000101ull,0x1000101ull,
0x101010101000100ull,0x1010101000100ull,0x10101000100ull,0x10101000100ull,0x101000100ull,0x101000100ull,0x101000100ull,0x101000100ull,
0x1000100ull,0x1000100ull,0x1000100ull,0x1000100ull,0x1000100ull,0x1000100ull,0x1000100ull,0x1000100ull,
0x101010101000100ull,0x1010101000100ull,0x10101000100ull,0x10101000100ull,0x101000100ull,0x101000100ull,0x101000100ull,0x101000100ull,
0x1000100ull,0x1000100ull,0x1000100ull,0x1000100ull,0x1000100ull,0x1000100ull,0x1000100ull,0x1000100ull
},{
0x202020202000202ull,0x2020202000202ull,0x20202000202ull,0x20202000202ull,0x202000202ull,0x202000202ull,0x202000202ull,0x202000202ull,
0x2000202ull,0x2000202ull,0x2000202ull,0x2000202ull,0x2000202ull,0x2000202ull,0x2000202ull,0x2000202ull,
0x202020202000202ull,0x2020202000202ull,0x20202000202ull,0x20202000202ull,0x202000202ull,0x202000202ull,0x202000202ull,0x202000202ull,
0x2000202ull,0x2000202ull,0x2000202ull,0x2000202ull,0x2000202ull,0x2000202ull,0x2000202ull,0x2000202ull,
0x202020202000200ull,0x2020202000200ull,0x20202000200ull,0x20202000200ull,0x202000200ull,0x202000200ull,0x202000200ull,0x202000200ull,
0x2000200ull,0x2000200ull,0x2000200ull,0x2000200ull,0x2000200ull,0x2000200ull,0x2000200ull,0x2000200ull,
0x202020202000200ull,0x2020202000200ull,0x20202000200ull,0x20202000200ull,0x202000200ull,0x202000200ull,0x202000200ull,0x202000200ull,
0x2000200ull,0x2000200ull,0x2000200ull,0x2000200ull,0x2000200ull,0x2000200ull,0x2000200ull,0x2000200ull
},{
0x404040404000404ull,0x4040404000404ull,0x40404000404ull,0x40404000404ull,0x404000404ull,0x404000404ull,0x404000404ull,0x404000404ull,
0x4000404ull,0x4000404ull,0x4000404ull,0x4000404ull,0x4000404ull,0x4000404ull,0x4000404ull,0x4000404ull,
0x404040404000404ull,0x4040404000404ull,0x40404000404ull,0x40404000404ull,0x404000404ull,0x404000404ull,0x404000404ull,0x404000404ull,
0x4000404ull,0x4000404ull,0x4000404ull,0x4000404ull,0x4000404ull,0x4000404ull,0x4000404ull,0x4000404ull,
0x404040404000400ull,0x4040404000400ull,0x40404000400ull,0x40404000400ull,0x404000400ull,0x404000400ull,0x404000400ull,0x404000400ull,
0x4000400ull,0x4000400ull,0x4000400ull,0x4000400ull,0x4000400ull,0x4000400ull,0x4000400ull,0x4000400ull,
0x404040404000400ull,0x4040404000400ull,0x40404000400ull,0x40404000400ull,0x404000400ull,0x404000400ull,0x404000400ull,0x404000400ull,
0x4000400ull,0x4000400ull,0x4000400ull,0x4000400ull,0x4000400ull,0x4000400ull,0x4000400ull,0x4000400ull
},{
0x808080808000808ull,0x8080808000808ull,0x80808000808ull,0x80808000808ull,0x808000808ull,0x808000808ull,0x808000808ull,0x808000808ull,
0x8000808ull,0x8000808ull,0x8000808ull,0x8000808ull,0x8000808ull,0x8000808ull,0x8000808ull,0x8000808ull,
0x808080808000808ull,0x8080808000808ull,0x80808000808ull,0x80808000808ull,0x808000808ull,0x808000808ull,0x808000808ull,0x808000808ull,
0x8000808ull,0x8000808ull,0x8000808ull,0x8000808ull,0x8000808ull,0x8000808ull,0x8000808ull,0x8000808ull,
0x808080808000800ull,0x8080808000800ull,0x80808000800ull,0x80808000800ull,0x808000800ull,0x808000800ull,0x808000800ull,0x808000800ull,
0x8000800ull,0x8000800ull,0x8000800ull,0x8000800ull,0x8000800ull,0x8000800ull,0x8000800ull,0x8000800ull,
0x808080808000800ull,0x8080808000800ull,0x80808000800ull,0x80808000800ull,0x808000800ull,0x808000800ull,0x808000800ull,0x808000800ull,
0x8000800ull,0x8000800ull,0x8000800ull,0x8000800ull,0x8000800ull,0x8000800ull,0x8000800ull,0x8000800ull
},{
0x1010101010001010ull,0x10101010001010ull,0x101010001010ull,0x101010001010ull,0x1010001010ull,0x1010001010ull,0x1010001010ull,0x1010001010ull,
0x10001010ull,0x10001010ull,0x10001010ull,0x10001010ull,0x10001010ull,0x10001010ull,0x10001010ull,0x10001010ull,
0x1010101010001010ull,0x10101010001010ull,0x101010001010ull,0x101010001010ull,0x1010001010ull,0x1010001010ull,0x1010001010ull,0x1010001010ull,
0x10001010ull,0x10001010ull,0x10001010ull,0x10001010ull,0x10001010ull,0x10001010ull,0x10001010ull,0x10001010ull,
0x1010101010001000ull,0x10101010001000ull,0x101010001000ull,0x101010001000ull,0x1010001000ull,0x1010001000ull,0x1010001000ull,0x1010001000ull,
0x10001000ull,0x10001000ull,0x10001000ull,0x10001000ull,0x10001000ull,0x10001000ull,0x10001000ull,0x10001000ull,
0x1010101010001000ull,0x10101010001000ull,0x101010001000ull,0x101010001000ull,0x1010001000ull,0x1010001000ull,0x1010001000ull,0x1010001000ull,
0x10001000ull,0x10001000ull,0x10001000ull,0x10001000ull,0x10001000ull,0x10001000ull,0x10001000ull,0x10001000ull
},{
0x2020202020002020ull,0x20202020002020ull,0x202020002020ull,0x202020002020ull,0x2020002020ull,0x2020002020ull,0x2020002020ull,0x2020002020ull,
0x20002020ull,0x20002020ull,0x20002020ull,0x20002020ull,0x20002020ull,0x20002020ull,0x20002020ull,0x20002020ull,
0x2020202020002020ull,0x20202020002020ull,0x202020002020ull,0x202020002020ull,0x2020002020ull,0x2020002020ull,0x2020002020ull,0x2020002020ull,
0x20002020ull,0x20002020ull,0x20002020ull,0x20002020ull,0x20002020ull,0x20002020ull,0x20002020ull,0x20002020ull,
0x2020202020002000ull,0x20202020002000ull,0x202020002000ull,0x202020002000ull,0x2020002000ull,0x2020002000ull,0x2020002000ull,0x2020002000ull,
0x20002000ull,0x20002000ull,0x20002000ull,0x20002000ull,0x20002000ull,0x20002000ull,0x20002000ull,0x20002000ull,
0x2020202020002000ull,0x20202020002000ull,0x202020002000ull,0x202020002000ull,0x2020002000ull,0x2020002000ull,0x2020002000ull,0x2020002000ull,
0x20002000ull,0x20002000ull,0x20002000ull,0x20002000ull,0x20002000ull,0x20002000ull,0x20002000ull,0x20002000ull
},{
0x4040404040004040ull,0x40404040004040ull,0x404040004040ull,0x404040004040ull,0x4040004040ull,0x4040004040ull,0x4040004040ull,0x4040004040ull,
0x40004040ull,0x40004040ull,0x40004040ull,0x40004040ull,0x40004040ull,0x40004040ull,0x40004040ull,0x40004040ull,
0x4040404040004040ull,0x40404040004040ull,0x404040004040ull,0x404040004040ull,0x4040004040ull,0x4040004040ull,0x4040004040ull,0x4040004040ull,
0x40004040ull,0x40004040ull,0x40004040ull,0x40004040ull,0x40004040ull,0x40004040ull,0x40004040ull,0x40004040ull,
0x4040404040004000ull,0x40404040004000ull,0x404040004000ull,0x404040004000ull,0x4040004000ull,0x4040004000ull,0x4040004000ull,0x4040004000ull,
0x40004000ull,0x40004000ull,0x40004000ull,0x40004000ull,0x40004000ull,0x40004000ull,0x40004000ull,0x40004000ull,
0x4040404040004000ull,0x40404040004000ull,0x404040004000ull,0x404040004000ull,0x4040004000ull,0x4040004000ull,0x4040004000ull,0x4040004000ull,
0x40004000ull,0x40004000ull,0x40004000ull,0x40004000ull,0x40004000ull,0x40004000ull,0x40004000ull,0x40004000ull
},{
0x8080808080008080ull,0x80808080008080ull,0x808080008080ull,0x808080008080ull,0x8080008080ull,0x8080008080ull,0x8080008080ull,0x8080008080ull,
0x80008080ull,0x80008080ull,0x80008080ull,0x80008080ull,0x80008080ull,0x80008080ull,0x80008080ull,0x80008080ull,
0x8080808080008080ull,0x80808080008080ull,0x808080008080ull,0x808080008080ull,0x8080008080ull,0x8080008080ull,0x8080008080ull,0x8080008080ull,
0x80008080ull,0x80008080ull,0x80008080ull,0x80008080ull,0x80008080ull,0x80008080ull,0x80008080ull,0x80008080ull,
0x8080808080008000ull,0x80808080008000ull,0x808080008000ull,0x808080008000ull,0x8080008000ull,0x8080008000ull,0x8080008000ull,0x8080008000ull,
0x80008000ull,0x80008000ull,0x80008000ull,0x80008000ull,0x80008000ull,0x80008000ull,0x80008000ull,0x80008000ull,
0x8080808080008000ull,0x80808080008000ull,0x808080008000ull,0x808080008000ull,0x8080008000ull,0x8080008000ull,0x8080008000ull,0x8080008000ull,
0x80008000ull,0x80008000ull,0x80008000ull,0x80008000ull,0x80008000ull,0x80008000ull,0x80008000ull,0x80008000ull
},{
0x101010100010101ull,0x1010100010101ull,0x10100010101ull,0x10100010101ull,0x100010101ull,0x100010101ull,0x100010101ull,0x100010101ull,
0x101010100010101ull,0x1010100010101ull,0x10100010101ull,0x10100010101ull,0x100010101ull,0x100010101ull,0x100010101ull,0x100010101ull,
0x101010100010000ull,0x1010100010000ull,0x10100010000ull,0x10100010000ull,0x100010000ull,0x100010000ull,0x100010000ull,0x100010000ull,
0x101010100010000ull,0x1010100010000ull,0x10100010000ull,0x10100010000ull,0x100010000ull,0x100010000ull,0x100010000ull,0x100010000ull,
0x101010100010100ull,0x1010100010100ull,0x10100010100ull,0x10100010100ull,0x100010100ull,0x100010100ull,0x100010100ull,0x100010100ull,
0x101010100010100ull,0x1010100010100ull,0x10100010100ull,0x10100010100ull,0x100010100ull,0x100010100ull,0x100010100ull,0x100010100ull,
0x101010100010000ull,0x1010100010000ull,0x10100010000ull,0x10100010000ull,0x100010000ull,0x100010000ull,0x100010000ull,0x100010000ull,
0x101010100010000ull,0x1010100010000ull,0x10100010000ull,0x10100010000ull,0x100010000ull,0x100010000ull,0x100010000ull,0x100010000ull
},{
0x202020200020202ull,0x2020200020202ull,0x20200020202ull,0x20200020202ull,0x200020202ull,0x200020202ull,0x200020202ull,0x200020202ull,
0x202020200020202ull,0x2020200020202ull,0x20200020202ull,0x20200020202ull,0x200020202ull,0x200020202ull,0x200020202ull,0x200020202ull,
0x202020200020000ull,0x2020200020000ull,0x20200020000ull,0x20200020000ull,0x200020000ull,0x200020000ull,0x200020000ull,0x200020000ull,
0x202020200020000ull,0x2020200020000ull,0x20200020000ull,0x20200020000ull,0x200020000ull,0x200020000ull,0x200020000ull,0x200020000ull,
0x202020200020200ull,0x2020200020200ull,0x20200020200ull,0x20200020200ull,0x200020200ull,0x200020200ull,0x200020200ull,0x200020200ull,
0x202020200020200ull,0x2020200020200ull,0x20200020200ull,0x20200020200ull,0x200020200ull,0x200020200ull,0x200020200ull,0x200020200ull,
0x202020200020000ull,0x2020200020000ull,0x20200020000ull,0x20200020000ull,0x200020000ull,0x200020000ull,0x200020000ull,0x200020000ull,
0x202020200020000ull,0x2020200020000ull,0x20200020000ull,0x20200020000ull,0x200020000ull,0x200020000ull,0x200020000ull,0x200020000ull
},{
0x404040400040404ull,0x4040400040404ull,0x40400040404ull,0x40400040404ull,0x400040404ull,0x400040404ull,0x400040404ull,0x400040404ull,
0x404040400040404ull,0x4040400040404ull,0x40400040404ull,0x40400040404ull,0x400040404ull,0x400040404ull,0x400040404ull,0x400040404ull,
0x404040400040000ull,0x4040400040000ull,0x40400040000ull,0x40400040000ull,0x400040000ull,0x400040000ull,0x400040000ull,0x400040000ull,
0x404040400040000ull,0x4040400040000ull,0x40400040000ull,0x40400040000ull,0x400040000ull,0x400040000ull,0x400040000ull,0x400040000ull,
0x404040400040400ull,0x4040400040400ull,0x40400040400ull,0x40400040400ull,0x400040400ull,0x400040400ull,0x400040400ull,0x400040400ull,
0x404040400040400ull,0x4040400040400ull,0x40400040400ull,0x40400040400ull,0x400040400ull,0x400040400ull,0x400040400ull,0x400040400ull,
0x404040400040000ull,0x4040400040000ull,0x40400040000ull,0x40400040000ull,0x400040000ull,0x400040000ull,0x400040000ull,0x400040000ull,
0x404040400040000ull,0x4040400040000ull,0x40400040000ull,0x40400040000ull,0x400040000ull,0x400040000ull,0x400040000ull,0x400040000ull
},{
0x808080800080808ull,0x8080800080808ull,0x80800080808ull,0x80800080808ull,0x800080808ull,0x800080808ull,0x800080808ull,0x800080808ull,
0x808080800080808ull,0x8080800080808ull,0x80800080808ull,0x80800080808ull,0x800080808ull,0x800080808ull,0x800080808ull,0x800080808ull,
0x808080800080000ull,0x8080800080000ull,0x80800080000ull,0x80800080000ull,0x800080000ull,0x800080000ull,0x800080000ull,0x800080000ull,
0x808080800080000ull,0x8080800080000ull,0x80800080000ull,0x80800080000ull,0x800080000ull,0x800080000ull,0x800080000ull,0x800080000ull,
0x808080800080800ull,0x8080800080800ull,0x80800080800ull,0x80800080800ull,0x800080800ull,0x800080800ull,0x800080800ull,0x800080800ull,
0x808080800080800ull,0x8080800080800ull,0x80800080800ull,0x80800080800ull,0x800080800ull,0x800080800ull,0x800080800ull,0x800080800ull,
0x808080800080000ull,0x8080800080000ull,0x80800080000ull,0x80800080000ull,0x800080000ull,0x800080000ull,0x800080000ull,0x800080000ull,
0x808080800080000ull,0x8080800080000ull,0x80800080000ull,0x80800080000ull,0x800080000ull,0x800080000ull,0x800080000ull,0x800080000ull
},{
0x1010101000101010ull,0x10101000101010ull,0x101000101010ull,0x101000101010ull,0x1000101010ull,0x1000101010ull,0x1000101010ull,0x1000101010ull,
0x1010101000101010ull,0x10101000101010ull,0x101000101010ull,0x101000101010ull,0x1000101010ull,0x1000101010ull,0x1000101010ull,0x1000101010ull,
0x1010101000100000ull,0x10101000100000ull,0x101000100000ull,0x101000100000ull,0x1000100000ull,0x1000100000ull,0x1000100000ull,0x1000100000ull,
0x1010101000100000ull,0x10101000100000ull,0x101000100000ull,0x101000100000ull,0x1000100000ull,0x1000100000ull,0x1000100000ull,0x1000100000ull,
0x1010101000101000ull,0x10101000101000ull,0x101000101000ull,0x101000101000ull,0x1000101000ull,0x1000101000ull,0x1000101000ull,0x1000101000ull,
0x1010101000101000ull,0x10101000101000ull,0x101000101000ull,0x101000101000ull,0x1000101000ull,0x1000101000ull,0x1000101000ull,0x1000101000ull,
0x1010101000100000ull,0x10101000100000ull,0x101000100000ull,0x101000100000ull,0x1000100000ull,0x1000100000ull,0x1000100000ull,0x1000100000ull,
0x1010101000100000ull,0x10101000100000ull,0x101000100000ull,0x101000100000ull,0x1000100000ull,0x1000100000ull,0x1000100000ull,0x1000100000ull
},{
0x2020202000202020ull,0x20202000202020ull,0x202000202020ull,0x202000202020ull,0x2000202020ull,0x2000202020ull,0x2000202020ull,0x2000202020ull,
0x2020202000202020ull,0x20202000202020ull,0x202000202020ull,0x202000202020ull,0x2000202020ull,0x2000202020ull,0x2000202020ull,0x2000202020ull,
0x2020202000200000ull,0x20202000200000ull,0x202000200000ull,0x202000200000ull,0x2000200000ull,0x2000200000ull,0x2000200000ull,0x2000200000ull,
0x2020202000200000ull,0x20202000200000ull,0x202000200000ull,0x202000200000ull,0x2000200000ull,0x2000200000ull,0x2000200000ull,0x2000200000ull,
0x2020202000202000ull,0x20202000202000ull,0x202000202000ull,0x202000202000ull,0x2000202000ull,0x2000202000ull,0x2000202000ull,0x2000202000ull,
0x2020202000202000ull,0x20202000202000ull,0x202000202000ull,0x202000202000ull,0x2000202000ull,0x2000202000ull,0x2000202000ull,0x2000202000ull,
0x2020202000200000ull,0x20202000200000ull,0x202000200000ull,0x202000200000ull,0x2000200000ull,0x2000200000ull,0x2000200000ull,0x2000200000ull,
0x2020202000200000ull,0x20202000200000ull,0x202000200000ull,0x202000200000ull,0x2000200000ull,0x2000200000ull,0x2000200000ull,0x2000200000ull
},{
0x4040404000404040ull,0x40404000404040ull,0x404000404040ull,0x404000404040ull,0x4000404040ull,0x4000404040ull,0x4000404040ull,0x4000404040ull,
0x4040404000404040ull,0x40404000404040ull,0x404000404040ull,0x404000404040ull,0x4000404040ull,0x4000404040ull,0x4000404040ull,0x4000404040ull,
0x4040404000400000ull,0x40404000400000ull,0x404000400000ull,0x404000400000ull,0x4000400000ull,0x4000400000ull,0x4000400000ull,0x4000400000ull,
0x4040404000400000ull,0x40404000400000ull,0x404000400000ull,0x404000400000ull,0x4000400000ull,0x4000400000ull,0x4000400000ull,0x4000400000ull,
0x4040404000404000ull,0x40404000404000ull,0x404000404000ull,0x404000404000ull,0x4000404000ull,0x4000404000ull,0x4000404000ull,0x4000404000ull,
0x4040404000404000ull,0x40404000404000ull,0x404000404000ull,0x404000404000ull,0x4000404000ull,0x4000404000ull,0x4000404000ull,0x4000404000ull,
0x4040404000400000ull,0x40404000400000ull,0x404000400000ull,0x404000400000ull,0x4000400000ull,0x4000400000ull,0x4000400000ull,0x4000400000ull,
0x4040404000400000ull,0x40404000400000ull,0x404000400000ull,0x404000400000ull,0x4000400000ull,0x4000400000ull,0x4000400000ull,0x4000400000ull
},{
0x8080808000808080ull,0x80808000808080ull,0x808000808080ull,0x808000808080ull,0x8000808080ull,0x8000808080ull,0x8000808080ull,0x8000808080ull,
0x8080808000808080ull,0x80808000808080ull,0x808000808080ull,0x808000808080ull,0x8000808080ull,0x8000808080ull,0x8000808080ull,0x8000808080ull,
0x8080808000800000ull,0x80808000800000ull,0x808000800000ull,0x808000800000ull,0x8000800000ull,0x8000800000ull,0x8000800000ull,0x8000800000ull,
0x8080808000800000ull,0x80808000800000ull,0x808000800000ull,0x808000800000ull,0x8000800000ull,0x8000800000ull,0x8000800000ull,0x8000800000ull,
0x8080808000808000ull,0x80808000808000ull,0x808000808000ull,0x808000808000ull,0x8000808000ull,0x8000808000ull,0x8000808000ull,0x8000808000ull,
0x8080808000808000ull,0x80808000808000ull,0x808000808000ull,0x808000808000ull,0x8000808000ull,0x8000808000ull,0x8000808000ull,0x8000808000ull,
0x8080808000800000ull,0x80808000800000ull,0x808000800000ull,0x808000800000ull,0x8000800000ull,0x8000800000ull,0x8000800000ull,0x8000800000ull,
0x8080808000800000ull,0x80808000800000ull,0x808000800000ull,0x808000800000ull,0x8000800000ull,0x8000800000ull,0x8000800000ull,0x8000800000ull
},{
0x101010001010101ull,0x1010001010101ull,0x10001010101ull,0x10001010101ull,0x101010001010101ull,0x1010001010101ull,0x10001010101ull,0x10001010101ull,
0x101010001000000ull,0x1010001000000ull,0x10001000000ull,0x10001000000ull,0x101010001000000ull,0x1010001000000ull,0x10001000000ull,0x10001000000ull,
0x101010001010000ull,0x1010001010000ull,0x10001010000ull,0x10001010000ull,0x101010001010000ull,0x1010001010000ull,0x10001010000ull,0x10001010000ull,
0x101010001000000ull,0x1010001000000ull,0x10001000000ull,0x10001000000ull,0x101010001000000ull,0x1010001000000ull,0x10001000000ull,0x10001000000ull,
0x101010001010100ull,0x1010001010100ull,0x10001010100ull,0x10001010100ull,0x101010001010100ull,0x1010001010100ull,0x10001010100ull,0x10001010100ull,
0x101010001000000ull,0x1010001000000ull,0x10001000000ull,0x10001000000ull,0x101010001000000ull,0x1010001000000ull,0x10001000000ull,0x10001000000ull,
0x101010001010000ull,0x1010001010000ull,0x10001010000ull,0x10001010000ull,0x101010001010000ull,0x1010001010000ull,0x10001010000ull,0x10001010000ull,
0x101010001000000ull,0x1010001000000ull,0x10001000000ull,0x10001000000ull,0x101010001000000ull,0x1010001000000ull,0x10001000000ull,0x10001000000ull
},{
0x202020002020202ull,0x2020002020202ull,0x20002020202ull,0x20002020202ull,0x202020002020202ull,0x2020002020202ull,0x20002020202ull,0x20002020202ull,
0x202020002000000ull,0x2020002000000ull,0x20002000000ull,0x20002000000ull,0x202020002000000ull,0x2020002000000ull,0x20002000000ull,0x20002000000ull,
0x202020002020000ull,0x2020002020000ull,0x20002020000ull,0x20002020000ull,0x202020002020000ull,0x2020002020000ull,0x20002020000ull,0x20002020000ull,
0x202020002000000ull,0x2020002000000ull,0x20002000000ull,0x20002000000ull,0x202020002000000ull,0x2020002000000ull,0x20002000000ull,0x20002000000ull,
0x202020002020200ull,0x2020002020200ull,0x20002020200ull,0x20002020200ull,0x202020002020200ull,0x2020002020200ull,0x20002020200ull,0x20002020200ull,
0x202020002000000ull,0x2020002000000ull,0x20002000000ull,0x20002000000ull,0x202020002000000ull,0x2020002000000ull,0x20002000000ull,0x20002000000ull,
0x202020002020000ull,0x2020002020000ull,0x20002020000ull,0x20002020000ull,0x202020002020000ull,0x2020002020000ull,0x20002020000ull,0x20002020000ull,
0x202020002000000ull,0x2020002000000ull,0x20002000000ull,0x20002000000ull,0x202020002000000ull,0x2020002000000ull,0x20002000000ull,0x20002000000ull
},{
0x404040004040404ull,0x4040004040404ull,0x40004040404ull,0x40004040404ull,0x404040004040404ull,0x4040004040404ull,0x40004040404ull,0x40004040404ull,
0x404040004000000ull,0x4040004000000ull,0x40004000000ull,0x40004000000ull,0x404040004000000ull,0x4040004000000ull,0x40004000000ull,0x40004000000ull,
0x404040004040000ull,0x4040004040000ull,0x40004040000ull,0x40004040000ull,0x404040004040000ull,0x4040004040000ull,0x40004040000ull,0x40004040000ull,
0x404040004000000ull,0x4040004000000ull,0x40004000000ull,0x40004000000ull,0x404040004000000ull,0x4040004000000ull,0x40004000000ull,0x40004000000ull,
0x404040004040400ull,0x4040004040400ull,0x40004040400ull,0x40004040400ull,0x404040004040400ull,0x4040004040400ull,0x40004040400ull,0x40004040400ull,
0x404040004000000ull,0x4040004000000ull,0x40004000000ull,0x40004000000ull,0x404040004000000ull,0x4040004000000ull,0x40004000000ull,0x40004000000ull,
0x404040004040000ull,0x4040004040000ull,0x40004040000ull,0x40004040000ull,0x404040004040000ull,0x4040004040000ull,0x40004040000ull,0x40004040000ull,
0x404040004000000ull,0x4040004000000ull,0x40004000000ull,0x40004000000ull,0x404040004000000ull,0x4040004000000ull,0x40004000000ull,0x40004000000ull
},{
0x808080008080808ull,0x8080008080808ull,0x80008080808ull,0x80008080808ull,0x808080008080808ull,0x8080008080808ull,0x80008080808ull,0x80008080808ull,
0x808080008000000ull,0x8080008000000ull,0x80008000000ull,0x80008000000ull,0x808080008000000ull,0x8080008000000ull,0x80008000000ull,0x80008000000ull,
0x808080008080000ull,0x8080008080000ull,0x80008080000ull,0x80008080000ull,0x808080008080000ull,0x8080008080000ull,0x80008080000ull,0x80008080000ull,
0x808080008000000ull,0x8080008000000ull,0x80008000000ull,0x80008000000ull,0x808080008000000ull,0x8080008000000ull,0x80008000000ull,0x80008000000ull,
0x808080008080800ull,0x8080008080800ull,0x80008080800ull,0x80008080800ull,0x808080008080800ull,0x8080008080800ull,0x80008080800ull,0x80008080800ull,
0x808080008000000ull,0x8080008000000ull,0x80008000000ull,0x80008000000ull,0x808080008000000ull,0x8080008000000ull,0x80008000000ull,0x80008000000ull,
0x808080008080000ull,0x8080008080000ull,0x80008080000ull,0x80008080000ull,0x808080008080000ull,0x8080008080000ull,0x80008080000ull,0x80008080000ull,
0x808080008000000ull,0x8080008000000ull,0x80008000000ull,0x80008000000ull,0x808080008000000ull,0x8080008000000ull,0x80008000000ull,0x80008000000ull
},{
0x1010100010101010ull,0x10100010101010ull,0x100010101010ull,0x100010101010ull,0x1010100010101010ull,0x10100010101010ull,0x100010101010ull,0x100010101010ull,
0x1010100010000000ull,0x10100010000000ull,0x100010000000ull,0x100010000000ull,0x1010100010000000ull,0x10100010000000ull,0x100010000000ull,0x100010000000ull,
0x1010100010100000ull,0x10100010100000ull,0x100010100000ull,0x100010100000ull,0x1010100010100000ull,0x10100010100000ull,0x100010100000ull,0x100010100000ull,
0x1010100010000000ull,0x10100010000000ull,0x100010000000ull,0x100010000000ull,0x1010100010000000ull,0x10100010000000ull,0x100010000000ull,0x100010000000ull,
0x1010100010101000ull,0x10100010101000ull,0x100010101000ull,0x100010101000ull,0x1010100010101000ull,0x10100010101000ull,0x100010101000ull,0x100010101000ull,
0x1010100010000000ull,0x10100010000000ull,0x100010000000ull,0x100010000000ull,0x1010100010000000ull,0x10100010000000ull,0x100010000000ull,0x100010000000ull,
0x1010100010100000ull,0x10100010100000ull,0x100010100000ull,0x100010100000ull,0x1010100010100000ull,0x10100010100000ull,0x100010100000ull,0x100010100000ull,
0x1010100010000000ull,0x10100010000000ull,0x100010000000ull,0x100010000000ull,0x1010100010000000ull,0x10100010000000ull,0x100010000000ull,0x100010000000ull
},{
0x2020200020202020ull,0x20200020202020ull,0x200020202020ull,0x200020202020ull,0x2020200020202020ull,0x20200020202020ull,0x200020202020ull,0x200020202020ull,
0x2020200020000000ull,0x20200020000000ull,0x200020000000ull,0x200020000000ull,0x2020200020000000ull,0x20200020000000ull,0x200020000000ull,0x200020000000ull,
0x2020200020200000ull,0x20200020200000ull,0x200020200000ull,0x200020200000ull,0x2020200020200000ull,0x20200020200000ull,0x200020200000ull,0x200020200000ull,
0x2020200020000000ull,0x20200020000000ull,0x200020000000ull,0x200020000000ull,0x2020200020000000ull,0x20200020000000ull,0x200020000000ull,0x200020000000ull,
0x2020200020202000ull,0x20200020202000ull,0x200020202000ull,0x200020202000ull,0x2020200020202000ull,0x20200020202000ull,0x200020202000ull,0x200020202000ull,
0x2020200020000000ull,0x20200020000000ull,0x200020000000ull,0x200020000000ull,0x2020200020000000ull,0x20200020000000ull,0x200020000000ull,0x200020000000ull,
0x2020200020200000ull,0x20200020200000ull,0x200020200000ull,0x200020200000ull,0x2020200020200000ull,0x20200020200000ull,0x200020200000ull,0x200020200000ull,
0x2020200020000000ull,0x20200020000000ull,0x200020000000ull,0x200020000000ull,0x2020200020000000ull,0x20200020000000ull,0x200020000000ull,0x200020000000ull
},{
0x4040400040404040ull,0x40400040404040ull,0x400040404040ull,0x400040404040ull,0x4040400040404040ull,0x40400040404040ull,0x400040404040ull,0x400040404040ull,
0x4040400040000000ull,0x40400040000000ull,0x400040000000ull,0x400040000000ull,0x4040400040000000ull,0x40400040000000ull,0x400040000000ull,0x400040000000ull,
0x4040400040400000ull,0x40400040400000ull,0x400040400000ull,0x400040400000ull,0x4040400040400000ull,0x40400040400000ull,0x400040400000ull,0x400040400000ull,
0x4040400040000000ull,0x40400040000000ull,0x400040000000ull,0x400040000000ull,0x4040400040000000ull,0x40400040000000ull,0x400040000000ull,0x400040000000ull,
0x4040400040404000ull,0x40400040404000ull,0x400040404000ull,0x400040404000ull,0x4040400040404000ull,0x40400040404000ull,0x400040404000ull,0x400040404000ull,
0x4040400040000000ull,0x40400040000000ull,0x400040000000ull,0x400040000000ull,0x4040400040000000ull,0x40400040000000ull,0x400040000000ull,0x400040000000ull,
0x4040400040400000ull,0x40400040400000ull,0x400040400000ull,0x400040400000ull,0x4040400040400000ull,0x40400040400000ull,0x400040400000ull,0x400040400000ull,
0x4040400040000000ull,0x40400040000000ull,0x400040000000ull,0x400040000000ull,0x4040400040000000ull,0x40400040000000ull,0x400040000000ull,0x400040000000ull
},{
0x8080800080808080ull,0x80800080808080ull,0x800080808080ull,0x800080808080ull,0x8080800080808080ull,0x80800080808080ull,0x800080808080ull,0x800080808080ull,
0x8080800080000000ull,0x80800080000000ull,0x800080000000ull,0x800080000000ull,0x8080800080000000ull,0x80800080000000ull,0x800080000000ull,0x800080000000ull,
0x8080800080800000ull,0x80800080800000ull,0x800080800000ull,0x800080800000ull,0x8080800080800000ull,0x80800080800000ull,0x800080800000ull,0x800080800000ull,
0x8080800080000000ull,0x80800080000000ull,0x800080000000ull,0x800080000000ull,0x8080800080000000ull,0x80800080000000ull,0x800080000000ull,0x800080000000ull,
0x8080800080808000ull,0x80800080808000ull,0x800080808000ull,0x800080808000ull,0x8080800080808000ull,0x80800080808000ull,0x800080808000ull,0x800080808000ull,
0x8080800080000000ull,0x80800080000000ull,0x800080000000ull,0x800080000000ull,0x8080800080000000ull,0x80800080000000ull,0x800080000000ull,0x800080000000ull,
0x8080800080800000ull,0x80800080800000ull,0x800080800000ull,0x800080800000ull,0x8080800080800000ull,0x80800080800000ull,0x800080800000ull,0x800080800000ull,
0x8080800080000000ull,0x80800080000000ull,0x800080000000ull,0x800080000000ull,0x8080800080000000ull,0x80800080000000ull,0x800080000000ull,0x800080000000ull
},{
0x101000101010101ull,0x1000101010101ull,0x101000101010101ull,0x1000101010101ull,0x101000100000000ull,0x1000100000000ull,0x101000100000000ull,0x1000100000000ull,
0x101000101000000ull,0x1000101000000ull,0x101000101000000ull,0x1000101000000ull,0x101000100000000ull,0x1000100000000ull,0x101000100000000ull,0x1000100000000ull,
0x101000101010000ull,0x1000101010000ull,0x101000101010000ull,0x1000101010000ull,0x101000100000000ull,0x1000100000000ull,0x101000100000000ull,0x1000100000000ull,
0x101000101000000ull,0x1000101000000ull,0x101000101000000ull,0x1000101000000ull,0x101000100000000ull,0x1000100000000ull,0x101000100000000ull,0x1000100000000ull,
0x101000101010100ull,0x1000101010100ull,0x101000101010100ull,0x1000101010100ull,0x101000100000000ull,0x1000100000000ull,0x101000100000000ull,0x1000100000000ull,
0x101000101000000ull,0x1000101000000ull,0x101000101000000ull,0x1000101000000ull,0x101000100000000ull,0x1000100000000ull,0x101000100000000ull,0x1000100000000ull,
0x101000101010000ull,0x1000101010000ull,0x101000101010000ull,0x1000101010000ull,0x101000100000000ull,0x1000100000000ull,0x101000100000000ull,0x1000100000000ull,
0x101000101000000ull,0x1000101000000ull,0x101000101000000ull,0x1000101000000ull,0x101000100000000ull,0x1000100000000ull,0x101000100000000ull,0x1000100000000ull
},{
0x202000202020202ull,0x2000202020202ull,0x202000202020202ull,0x2000202020202ull,0x202000200000000ull,0x2000200000000ull,0x202000200000000ull,0x2000200000000ull,
0x202000202000000ull,0x2000202000000ull,0x202000202000000ull,0x2000202000000ull,0x202000200000000ull,0x2000200000000ull,0x202000200000000ull,0x2000200000000ull,
0x202000202020000ull,0x2000202020000ull,0x202000202020000ull,0x2000202020000ull,0x202000200000000ull,0x2000200000000ull,0x202000200000000ull,0x2000200000000ull,
0x202000202000000ull,0x2000202000000ull,0x202000202000000ull,0x2000202000000ull,0x202000200000000ull,0x2000200000000ull,0x202000200000000ull,0x2000200000000ull,
0x202000202020200ull,0x2000202020200ull,0x202000202020200ull,0x2000202020200ull,0x202000200000000ull,0x2000200000000ull,0x202000200000000ull,0x2000200000000ull,
0x202000202000000ull,0x2000202000000ull,0x202000202000000ull,0x2000202000000ull,0x202000200000000ull,0x2000200000000ull,0x202000200000000ull,0x2000200000000ull,
0x202000202020000ull,0x2000202020000ull,0x202000202020000ull,0x2000202020000ull,0x202000200000000ull,0x2000200000000ull,0x202000200000000ull,0x2000200000000ull,
0x202000202000000ull,0x2000202000000ull,0x202000202000000ull,0x2000202000000ull,0x202000200000000ull,0x2000200000000ull,0x202000200000000ull,0x2000200000000ull
},{
0x404000404040404ull,0x4000404040404ull,0x404000404040404ull,0x4000404040404ull,0x404000400000000ull,0x4000400000000ull,0x404000400000000ull,0x4000400000000ull,
0x404000404000000ull,0x4000404000000ull,0x404000404000000ull,0x4000404000000ull,0x404000400000000ull,0x4000400000000ull,0x404000400000000ull,0x4000400000000ull,
0x404000404040000ull,0x4000404040000ull,0x404000404040000ull,0x4000404040000ull,0x404000400000000ull,0x4000400000000ull,0x404000400000000ull,0x4000400000000ull,
0x404000404000000ull,0x4000404000000ull,0x404000404000000ull,0x4000404000000ull,0x404000400000000ull,0x4000400000000ull,0x404000400000000ull,0x4000400000000ull,
0x404000404040400ull,0x4000404040400ull,0x404000404040400ull,0x4000404040400ull,0x404000400000000ull,0x4000400000000ull,0x404000400000000ull,0x4000400000000ull,
0x404000404000000ull,0x4000404000000ull,0x404000404000000ull,0x4000404000000ull,0x404000400000000ull,0x4000400000000ull,0x404000400000000ull,0x4000400000000ull,
0x404000404040000ull,0x4000404040000ull,0x404000404040000ull,0x4000404040000ull,0x404000400000000ull,0x4000400000000ull,0x404000400000000ull,0x4000400000000ull,
0x404000404000000ull,0x4000404000000ull,0x404000404000000ull,0x4000404000000ull,0x404000400000000ull,0x4000400000000ull,0x404000400000000ull,0x4000400000000ull
},{
0x808000808080808ull,0x8000808080808ull,0x808000808080808ull,0x8000808080808ull,0x808000800000000ull,0x8000800000000ull,0x808000800000000ull,0x8000800000000ull,
0x808000808000000ull,0x8000808000000ull,0x808000808000000ull,0x8000808000000ull,0x808000800000000ull,0x8000800000000ull,0x808000800000000ull,0x8000800000000ull,
0x808000808080000ull,0x8000808080000ull,0x808000808080000ull,0x8000808080000ull,0x808000800000000ull,0x8000800000000ull,0x808000800000000ull,0x8000800000000ull,
0x808000808000000ull,0x8000808000000ull,0x808000808000000ull,0x8000808000000ull,0x808000800000000ull,0x8000800000000ull,0x808000800000000ull,0x8000800000000ull,
0x808000808080800ull,0x8000808080800ull,0x808000808080800ull,0x8000808080800ull,0x808000800000000ull,0x8000800000000ull,0x808000800000000ull,0x8000800000000ull,
0x808000808000000ull,0x8000808000000ull,0x808000808000000ull,0x8000808000000ull,0x808000800000000ull,0x8000800000000ull,0x808000800000000ull,0x8000800000000ull,
0x808000808080000ull,0x8000808080000ull,0x808000808080000ull,0x8000808080000ull,0x808000800000000ull,0x8000800000000ull,0x808000800000000ull,0x8000800000000ull,
0x808000808000000ull,0x8000808000000ull,0x808000808000000ull,0x8000808000000ull,0x808000800000000ull,0x8000800000000ull,0x808000800000000ull,0x8000800000000ull
},{
0x1010001010101010ull,0x10001010101010ull,0x1010001010101010ull,0x10001010101010ull,0x1010001000000000ull,0x10001000000000ull,0x1010001000000000ull,0x10001000000000ull,
0x1010001010000000ull,0x10001010000000ull,0x1010001010000000ull,0x10001010000000ull,0x1010001000000000ull,0x10001000000000ull,0x1010001000000000ull,0x10001000000000ull,
0x1010001010100000ull,0x10001010100000ull,0x1010001010100000ull,0x10001010100000ull,0x1010001000000000ull,0x10001000000000ull,0x1010001000000000ull,0x10001000000000ull,
0x1010001010000000ull,0x10001010000000ull,0x1010001010000000ull,0x10001010000000ull,0x1010001000000000ull,0x10001000000000ull,0x1010001000000000ull,0x10001000000000ull,
0x1010001010101000ull,0x10001010101000ull,0x1010001010101000ull,0x10001010101000ull,0x1010001000000000ull,0x10001000000000ull,0x1010001000000000ull,0x10001000000000ull,
0x1010001010000000ull,0x10001010000000ull,0x1010001010000000ull,0x10001010000000ull,0x1010001000000000ull,0x10001000000000ull,0x1010001000000000ull,0x10001000000000ull,
0x1010001010100000ull,0x10001010100000ull,0x1010001010100000ull,0x10001010100000ull,0x1010001000000000ull,0x10001000000000ull,0x1010001000000000ull,0x10001000000000ull,
0x1010001010000000ull,0x10001010000000ull,0x1010001010000000ull,0x10001010000000ull,0x1010001000000000ull,0x10001000000000ull,0x1010001000000000ull,0x10001000000000ull
},{
0x2020002020202020ull,0x20002020202020ull,0x2020002020202020ull,0x20002020202020ull,0x2020002000000000ull,0x20002000000000ull,0x2020002000000000ull,0x20002000000000ull,
0x2020002020000000ull,0x20002020000000ull,0x2020002020000000ull,0x20002020000000ull,0x2020002000000000ull,0x20002000000000ull,0x2020002000000000ull,0x20002000000000ull,
0x2020002020200000ull,0x20002020200000ull,0x2020002020200000ull,0x20002020200000ull,0x2020002000000000ull,0x20002000000000ull,0x2020002000000000ull,0x20002000000000ull,
0x2020002020000000ull,0x20002020000000ull,0x2020002020000000ull,0x20002020000000ull,0x2020002000000000ull,0x20002000000000ull,0x2020002000000000ull,0x20002000000000ull,
0x2020002020202000ull,0x20002020202000ull,0x2020002020202000ull,0x20002020202000ull,0x2020002000000000ull,0x20002000000000ull,0x2020002000000000ull,0x20002000000000ull,
0x2020002020000000ull,0x20002020000000ull,0x2020002020000000ull,0x20002020000000ull,0x2020002000000000ull,0x20002000000000ull,0x2020002000000000ull,0x20002000000000ull,
0x2020002020200000ull,0x20002020200000ull,0x2020002020200000ull,0x20002020200000ull,0x2020002000000000ull,0x20002000000000ull,0x2020002000000000ull,0x20002000000000ull,
0x2020002020000000ull,0x20002020000000ull,0x2020002020000000ull,0x20002020000000ull,0x2020002000000000ull,0x20002000000000ull,0x2020002000000000ull,0x20002000000000ull
},{
0x4040004040404040ull,0x40004040404040ull,0x4040004040404040ull,0x40004040404040ull,0x4040004000000000ull,0x40004000000000ull,0x4040004000000000ull,0x40004000000000ull,
0x4040004040000000ull,0x40004040000000ull,0x4040004040000000ull,0x40004040000000ull,0x4040004000000000ull,0x40004000000000ull,0x4040004000000000ull,0x40004000000000ull,
0x4040004040400000ull,0x40004040400000ull,0x4040004040400000ull,0x40004040400000ull,0x4040004000000000ull,0x40004000000000ull,0x4040004000000000ull,0x40004000000000ull,
0x4040004040000000ull,0x40004040000000ull,0x4040004040000000ull,0x40004040000000ull,0x4040004000000000ull,0x40004000000000ull,0x4040004000000000ull,0x40004000000000ull,
0x4040004040404000ull,0x40004040404000ull,0x4040004040404000ull,0x40004040404000ull,0x4040004000000000ull,0x40004000000000ull,0x4040004000000000ull,0x40004000000000ull,
0x4040004040000000ull,0x40004040000000ull,0x4040004040000000ull,0x40004040000000ull,0x4040004000000000ull,0x40004000000000ull,0x4040004000000000ull,0x40004000000000ull,
0x4040004040400000ull,0x40004040400000ull,0x4040004040400000ull,0x40004040400000ull,0x4040004000000000ull,0x40004000000000ull,0x4040004000000000ull,0x40004000000000ull,
0x4040004040000000ull,0x40004040000000ull,0x4040004040000000ull,0x40004040000000ull,0x4040004000000000ull,0x40004000000000ull,0x4040004000000000ull,0x40004000000000ull
},{
0x8080008080808080ull,0x80008080808080ull,0x8080008080808080ull,0x80008080808080ull,0x8080008000000000ull,0x80008000000000ull,0x8080008000000000ull,0x80008000000000ull,
0x8080008080000000ull,0x80008080000000ull,0x8080008080000000ull,0x80008080000000ull,0x8080008000000000ull,0x80008000000000ull,0x8080008000000000ull,0x80008000000000ull,
0x8080008080800000ull,0x80008080800000ull,0x8080008080800000ull,0x80008080800000ull,0x8080008000000000ull,0x80008000000000ull,0x8080008000000000ull,0x80008000000000ull,
0x8080008080000000ull,0x80008080000000ull,0x8080008080000000ull,0x80008080000000ull,0x8080008000000000ull,0x80008000000000ull,0x8080008000000000ull,0x80008000000000ull,
0x8080008080808000ull,0x80008080808000ull,0x8080008080808000ull,0x80008080808000ull,0x8080008000000000ull,0x80008000000000ull,0x8080008000000000ull,0x80008000000000ull,
0x8080008080000000ull,0x80008080000000ull,0x8080008080000000ull,0x80008080000000ull,0x8080008000000000ull,0x80008000000000ull,0x8080008000000000ull,0x80008000000000ull,
0x8080008080800000ull,0x80008080800000ull,0x8080008080800000ull,0x80008080800000ull,0x8080008000000000ull,0x80008000000000ull,0x8080008000000000ull,0x80008000000000ull,
0x8080008080000000ull,0x80008080000000ull,0x8080008080000000ull,0x80008080000000ull,0x8080008000000000ull,0x80008000000000ull,0x8080008000000000ull,0x80008000000000ull
},{
0x100010101010101ull,0x100010101010101ull,0x100010000000000ull,0x100010000000000ull,0x100010100000000ull,0x100010100000000ull,0x100010000000000ull,0x100010000000000ull,
0x100010101000000ull,0x100010101000000ull,0x100010000000000ull,0x100010000000000ull,0x100010100000000ull,0x100010100000000ull,0x100010000000000ull,0x100010000000000ull,
0x100010101010000ull,0x100010101010000ull,0x100010000000000ull,0x100010000000000ull,0x100010100000000ull,0x100010100000000ull,0x100010000000000ull,0x100010000000000ull,
0x100010101000000ull,0x100010101000000ull,0x100010000000000ull,0x100010000000000ull,0x100010100000000ull,0x100010100000000ull,0x100010000000000ull,0x100010000000000ull,
0x100010101010100ull,0x100010101010100ull,0x100010000000000ull,0x100010000000000ull,0x100010100000000ull,0x100010100000000ull,0x100010000000000ull,0x100010000000000ull,
0x100010101000000ull,0x100010101000000ull,0x100010000000000ull,0x100010000000000ull,0x100010100000000ull,0x100010100000000ull,0x100010000000000ull,0x100010000000000ull,
0x100010101010000ull,0x100010101010000ull,0x100010000000000ull,0x100010000000000ull,0x100010100000000ull,0x100010100000000ull,0x100010000000000ull,0x100010000000000ull,
0x100010101000000ull,0x100010101000000ull,0x100010000000000ull,0x100010000000000ull,0x100010100000000ull,0x100010100000000ull,0x100010000000000ull,0x100010000000000ull
},{
0x200020202020202ull,0x200020202020202ull,0x200020000000000ull,0x200020000000000ull,0x200020200000000ull,0x200020200000000ull,0x200020000000000ull,0x200020000000000ull,
0x200020202000000ull,0x200020202000000ull,0x200020000000000ull,0x200020000000000ull,0x200020200000000ull,0x200020200000000ull,0x200020000000000ull,0x200020000000000ull,
0x200020202020000ull,0x200020202020000ull,0x200020000000000ull,0x200020000000000ull,0x200020200000000ull,0x200020200000000ull,0x200020000000000ull,0x200020000000000ull,
0x200020202000000ull,0x200020202000000ull,0x200020000000000ull,0x200020000000000ull,0x200020200000000ull,0x200020200000000ull,0x200020000000000ull,0x200020000000000ull,
0x200020202020200ull,0x200020202020200ull,0x200020000000000ull,0x200020000000000ull,0x200020200000000ull,0x200020200000000ull,0x200020000000000ull,0x200020000000000ull,
0x200020202000000ull,0x200020202000000ull,0x200020000000000ull,0x200020000000000ull,0x200020200000000ull,0x200020200000000ull,0x200020000000000ull,0x200020000000000ull,
0x200020202020000ull,0x200020202020000ull,0x200020000000000ull,0x200020000000000ull,0x200020200000000ull,0x200020200000000ull,0x200020000000000ull,0x200020000000000ull,
0x200020202000000ull,0x200020202000000ull,0x200020000000000ull,0x200020000000000ull,0x200020200000000ull,0x200020200000000ull,0x200020000000000ull,0x200020000000000ull
},{
0x400040404040404ull,0x400040404040404ull,0x400040000000000ull,0x400040000000000ull,0x400040400000000ull,0x400040400000000ull,0x400040000000000ull,0x400040000000000ull,
0x400040404000000ull,0x400040404000000ull,0x400040000000000ull,0x400040000000000ull,0x400040400000000ull,0x400040400000000ull,0x400040000000000ull,0x400040000000000ull,
0x400040404040000ull,0x400040404040000ull,0x400040000000000ull,0x400040000000000ull,0x400040400000000ull,0x400040400000000ull,0x400040000000000ull,0x400040000000000ull,
0x400040404000000ull,0x400040404000000ull,0x400040000000000ull,0x400040000000000ull,0x400040400000000ull,0x400040400000000ull,0x400040000000000ull,0x400040000000000ull,
0x400040404040400ull,0x400040404040400ull,0x400040000000000ull,0x400040000000000ull,0x400040400000000ull,0x400040400000000ull,0x400040000000000ull,0x400040000000000ull,
0x400040404000000ull,0x400040404000000ull,0x400040000000000ull,0x400040000000000ull,0x400040400000000ull,0x400040400000000ull,0x400040000000000ull,0x400040000000000ull,
0x400040404040000ull,0x400040404040000ull,0x400040000000000ull,0x400040000000000ull,0x400040400000000ull,0x400040400000000ull,0x400040000000000ull,0x400040000000000ull,
0x400040404000000ull,0x400040404000000ull,0x400040000000000ull,0x400040000000000ull,0x400040400000000ull,0x400040400000000ull,0x400040000000000ull,0x400040000000000ull
},{
0x800080808080808ull,0x800080808080808ull,0x800080000000000ull,0x800080000000000ull,0x800080800000000ull,0x800080800000000ull,0x800080000000000ull,0x800080000000000ull,
0x800080808000000ull,0x800080808000000ull,0x800080000000000ull,0x800080000000000ull,0x800080800000000ull,0x800080800000000ull,0x800080000000000ull,0x800080000000000ull,
0x800080808080000ull,0x800080808080000ull,0x800080000000000ull,0x800080000000000ull,0x800080800000000ull,0x800080800000000ull,0x800080000000000ull,0x800080000000000ull,
0x800080808000000ull,0x800080808000000ull,0x800080000000000ull,0x800080000000000ull,0x800080800000000ull,0x800080800000000ull,0x800080000000000ull,0x800080000000000ull,
0x800080808080800ull,0x800080808080800ull,0x800080000000000ull,0x800080000000000ull,0x800080800000000ull,0x800080800000000ull,0x800080000000000ull,0x800080000000000ull,
0x800080808000000ull,0x800080808000000ull,0x800080000000000ull,0x800080000000000ull,0x800080800000000ull,0x800080800000000ull,0x800080000000000ull,0x800080000000000ull,
0x800080808080000ull,0x800080808080000ull,0x800080000000000ull,0x800080000000000ull,0x800080800000000ull,0x800080800000000ull,0x800080000000000ull,0x800080000000000ull,
0x800080808000000ull,0x800080808000000ull,0x800080000000000ull,0x800080000000000ull,0x800080800000000ull,0x800080800000000ull,0x800080000000000ull,0x800080000000000ull
},{
0x1000101010101010ull,0x1000101010101010ull,0x1000100000000000ull,0x1000100000000000ull,0x1000101000000000ull,0x1000101000000000ull,0x1000100000000000ull,0x1000100000000000ull,
0x1000101010000000ull,0x1000101010000000ull,0x1000100000000000ull,0x1000100000000000ull,0x1000101000000000ull,0x1000101000000000ull,0x1000100000000000ull,0x1000100000000000ull,
0x1000101010100000ull,0x1000101010100000ull,0x1000100000000000ull,0x1000100000000000ull,0x1000101000000000ull,0x1000101000000000ull,0x1000100000000000ull,0x1000100000000000ull,
0x1000101010000000ull,0x1000101010000000ull,0x1000100000000000ull,0x1000100000000000ull,0x1000101000000000ull,0x1000101000000000ull,0x1000100000000000ull,0x1000100000000000ull,
0x1000101010101000ull,0x1000101010101000ull,0x1000100000000000ull,0x1000100000000000ull,0x1000101000000000ull,0x1000101000000000ull,0x1000100000000000ull,0x1000100000000000ull,
0x1000101010000000ull,0x1000101010000000ull,0x1000100000000000ull,0x1000100000000000ull,0x1000101000000000ull,0x1000101000000000ull,0x1000100000000000ull,0x1000100000000000ull,
0x1000101010100000ull,0x1000101010100000ull,0x1000100000000000ull,0x1000100000000000ull,0x1000101000000000ull,0x1000101000000000ull,0x1000100000000000ull,0x1000100000000000ull,
0x1000101010000000ull,0x1000101010000000ull,0x1000100000000000ull,0x1000100000000000ull,0x1000101000000000ull,0x1000101000000000ull,0x1000100000000000ull,0x1000100000000000ull
},{
0x2000202020202020ull,0x2000202020202020ull,0x2000200000000000ull,0x2000200000000000ull,0x2000202000000000ull,0x2000202000000000ull,0x2000200000000000ull,0x2000200000000000ull,
0x2000202020000000ull,0x2000202020000000ull,0x2000200000000000ull,0x2000200000000000ull,0x2000202000000000ull,0x2000202000000000ull,0x2000200000000000ull,0x2000200000000000ull,
0x2000202020200000ull,0x2000202020200000ull,0x2000200000000000ull,0x2000200000000000ull,0x2000202000000000ull,0x2000202000000000ull,0x2000200000000000ull,0x2000200000000000ull,
0x2000202020000000ull,0x2000202020000000ull,0x2000200000000000ull,0x2000200000000000ull,0x2000202000000000ull,0x2000202000000000ull,0x2000200000000000ull,0x2000200000000000ull,
0x2000202020202000ull,0x2000202020202000ull,0x2000200000000000ull,0x2000200000000000ull,0x2000202000000000ull,0x2000202000000000ull,0x2000200000000000ull,0x2000200000000000ull,
0x2000202020000000ull,0x2000202020000000ull,0x2000200000000000ull,0x2000200000000000ull,0x2000202000000000ull,0x2000202000000000ull,0x2000200000000000ull,0x2000200000000000ull,
0x2000202020200000ull,0x2000202020200000ull,0x2000200000000000ull,0x2000200000000000ull,0x2000202000000000ull,0x2000202000000000ull,0x2000200000000000ull,0x2000200000000000ull,
0x2000202020000000ull,0x2000202020000000ull,0x2000200000000000ull,0x2000200000000000ull,0x2000202000000000ull,0x2000202000000000ull,0x2000200000000000ull,0x2000200000000000ull
},{
0x4000404040404040ull,0x4000404040404040ull,0x4000400000000000ull,0x4000400000000000ull,0x4000404000000000ull,0x4000404000000000ull,0x4000400000000000ull,0x4000400000000000ull,
0x4000404040000000ull,0x4000404040000000ull,0x4000400000000000ull,0x4000400000000000ull,0x4000404000000000ull,0x4000404000000000ull,0x4000400000000000ull,0x4000400000000000ull,
0x4000404040400000ull,0x4000404040400000ull,0x4000400000000000ull,0x4000400000000000ull,0x4000404000000000ull,0x4000404000000000ull,0x4000400000000000ull,0x4000400000000000ull,
0x4000404040000000ull,0x4000404040000000ull,0x4000400000000000ull,0x4000400000000000ull,0x4000404000000000ull,0x4000404000000000ull,0x4000400000000000ull,0x4000400000000000ull,
0x4000404040404000ull,0x4000404040404000ull,0x4000400000000000ull,0x4000400000000000ull,0x4000404000000000ull,0x4000404000000000ull,0x4000400000000000ull,0x4000400000000000ull,
0x4000404040000000ull,0x4000404040000000ull,0x4000400000000000ull,0x4000400000000000ull,0x4000404000000000ull,0x4000404000000000ull,0x4000400000000000ull,0x4000400000000000ull,
0x4000404040400000ull,0x4000404040400000ull,0x4000400000000000ull,0x4000400000000000ull,0x4000404000000000ull,0x4000404000000000ull,0x4000400000000000ull,0x4000400000000000ull,
0x4000404040000000ull,0x4000404040000000ull,0x4000400000000000ull,0x4000400000000000ull,0x4000404000000000ull,0x4000404000000000ull,0x4000400000000000ull,0x4000400000000000ull
},{
0x8000808080808080ull,0x8000808080808080ull,0x8000800000000000ull,0x8000800000000000ull,0x8000808000000000ull,0x8000808000000000ull,0x8000800000000000ull,0x8000800000000000ull,
0x8000808080000000ull,0x8000808080000000ull,0x8000800000000000ull,0x8000800000000000ull,0x8000808000000000ull,0x8000808000000000ull,0x8000800000000000ull,0x8000800000000000ull,
0x8000808080800000ull,0x8000808080800000ull,0x8000800000000000ull,0x8000800000000000ull,0x8000808000000000ull,0x8000808000000000ull,0x8000800000000000ull,0x8000800000000000ull,
0x8000808080000000ull,0x8000808080000000ull,0x8000800000000000ull,0x8000800000000000ull,0x8000808000000000ull,0x8000808000000000ull,0x8000800000000000ull,0x8000800000000000ull,
0x8000808080808000ull,0x8000808080808000ull,0x8000800000000000ull,0x8000800000000000ull,0x8000808000000000ull,0x8000808000000000ull,0x8000800000000000ull,0x8000800000000000ull,
0x8000808080000000ull,0x8000808080000000ull,0x8000800000000000ull,0x8000800000000000ull,0x8000808000000000ull,0x8000808000000000ull,0x8000800000000000ull,0x8000800000000000ull,
0x8000808080800000ull,0x8000808080800000ull,0x8000800000000000ull,0x8000800000000000ull,0x8000808000000000ull,0x8000808000000000ull,0x8000800000000000ull,0x8000800000000000ull,
0x8000808080000000ull,0x8000808080000000ull,0x8000800000000000ull,0x8000800000000000ull,0x8000808000000000ull,0x8000808000000000ull,0x8000800000000000ull,0x8000800000000000ull
},{
0x1010101010101ull,0x1000000000000ull,0x1010000000000ull,0x1000000000000ull,0x1010100000000ull,0x1000000000000ull,0x1010000000000ull,0x1000000000000ull,
0x1010101000000ull,0x1000000000000ull,0x1010000000000ull,0x1000000000000ull,0x1010100000000ull,0x1000000000000ull,0x1010000000000ull,0x1000000000000ull,
0x1010101010000ull,0x1000000000000ull,0x1010000000000ull,0x1000000000000ull,0x1010100000000ull,0x1000000000000ull,0x1010000000000ull,0x1000000000000ull,
0x1010101000000ull,0x1000000000000ull,0x1010000000000ull,0x1000000000000ull,0x1010100000000ull,0x1000000000000ull,0x1010000000000ull,0x1000000000000ull,
0x1010101010100ull,0x1000000000000ull,0x1010000000000ull,0x1000000000000ull,0x1010100000000ull,0x1000000000000ull,0x1010000000000ull,0x1000000000000ull,
0x1010101000000ull,0x1000000000000ull,0x1010000000000ull,0x1000000000000ull,0x1010100000000ull,0x1000000000000ull,0x1010000000000ull,0x1000000000000ull,
0x1010101010000ull,0x1000000000000ull,0x1010000000000ull,0x1000000000000ull,0x1010100000000ull,0x1000000000000ull,0x1010000000000ull,0x1000000000000ull,
0x1010101000000ull,0x1000000000000ull,0x1010000000000ull,0x1000000000000ull,0x1010100000000ull,0x1000000000000ull,0x1010000000000ull,0x1000000000000ull
},{
0x2020202020202ull,0x2000000000000ull,0x2020000000000ull,0x2000000000000ull,0x2020200000000ull,0x2000000000000ull,0x2020000000000ull,0x2000000000000ull,
0x2020202000000ull,0x2000000000000ull,0x2020000000000ull,0x2000000000000ull,0x2020200000000ull,0x2000000000000ull,0x2020000000000ull,0x2000000000000ull,
0x2020202020000ull,0x2000000000000ull,0x2020000000000ull,0x2000000000000ull,0x2020200000000ull,0x2000000000000ull,0x2020000000000ull,0x2000000000000ull,
0x2020202000000ull,0x2000000000000ull,0x2020000000000ull,0x2000000000000ull,0x2020200000000ull,0x2000000000000ull,0x2020000000000ull,0x2000000000000ull,
0x2020202020200ull,0x2000000000000ull,0x2020000000000ull,0x2000000000000ull,0x2020200000000ull,0x2000000000000ull,0x2020000000000ull,0x2000000000000ull,
0x2020202000000ull,0x2000000000000ull,0x2020000000000ull,0x2000000000000ull,0x2020200000000ull,0x2000000000000ull,0x2020000000000ull,0x2000000000000ull,
0x2020202020000ull,0x2000000000000ull,0x2020000000000ull,0x2000000000000ull,0x2020200000000ull,0x2000000000000ull,0x2020000000000ull,0x2000000000000ull,
0x2020202000000ull,0x2000000000000ull,0x2020000000000ull,0x2000000000000ull,0x2020200000000ull,0x2000000000000ull,0x2020000000000ull,0x2000000000000ull
},{
0x4040404040404ull,0x4000000000000ull,0x4040000000000ull,0x4000000000000ull,0x4040400000000ull,0x4000000000000ull,0x4040000000000ull,0x4000000000000ull,
0x4040404000000ull,0x4000000000000ull,0x4040000000000ull,0x4000000000000ull,0x4040400000000ull,0x4000000000000ull,0x4040000000000ull,0x4000000000000ull,
0x4040404040000ull,0x4000000000000ull,0x4040000000000ull,0x4000000000000ull,0x4040400000000ull,0x4000000000000ull,0x4040000000000ull,0x4000000000000ull,
0x4040404000000ull,0x4000000000000ull,0x4040000000000ull,0x4000000000000ull,0x4040400000000ull,0x4000000000000ull,0x4040000000000ull,0x4000000000000ull,
0x4040404040400ull,0x4000000000000ull,0x4040000000000ull,0x4000000000000ull,0x4040400000000ull,0x4000000000000ull,0x4040000000000ull,0x4000000000000ull,
0x4040404000000ull,0x4000000000000ull,0x4040000000000ull,0x4000000000000ull,0x4040400000000ull,0x4000000000000ull,0x4040000000000ull,0x4000000000000ull,
0x4040404040000ull,0x4000000000000ull,0x4040000000000ull,0x4000000000000ull,0x4040400000000ull,0x4000000000000ull,0x4040000000000ull,0x4000000000000ull,
0x4040404000000ull,0x4000000000000ull,0x4040000000000ull,0x4000000000000ull,0x4040400000000ull,0x4000000000000ull,0x4040000000000ull,0x4000000000000ull
},{
0x8080808080808ull,0x8000000000000ull,0x8080000000000ull,0x8000000000000ull,0x8080800000000ull,0x8000000000000ull,0x8080000000000ull,0x8000000000000ull,
0x8080808000000ull,0x8000000000000ull,0x8080000000000ull,0x8000000000000ull,0x8080800000000ull,0x8000000000000ull,0x8080000000000ull,0x8000000000000ull,
0x8080808080000ull,0x8000000000000ull,0x8080000000000ull,0x8000000000000ull,0x8080800000000ull,0x8000000000000ull,0x8080000000000ull,0x8000000000000ull,
0x8080808000000ull,0x8000000000000ull,0x8080000000000ull,0x8000000000000ull,0x8080800000000ull,0x8000000000000ull,0x8080000000000ull,0x8000000000000ull,
0x8080808080800ull,0x8000000000000ull,0x8080000000000ull,0x8000000000000ull,0x8080800000000ull,0x8000000000000ull,0x8080000000000ull,0x8000000000000ull,
0x8080808000000ull,0x8000000000000ull,0x8080000000000ull,0x8000000000000ull,0x8080800000000ull,0x8000000000000ull,0x8080000000000ull,0x8000000000000ull,
0x8080808080000ull,0x8000000000000ull,0x8080000000000ull,0x8000000000000ull,0x8080800000000ull,0x8000000000000ull,0x8080000000000ull,0x8000000000000ull,
0x8080808000000ull,0x8000000000000ull,0x8080000000000ull,0x8000000000000ull,0x8080800000000ull,0x8000000000000ull,0x8080000000000ull,0x8000000000000ull
},{
0x10101010101010ull,0x10000000000000ull,0x10100000000000ull,0x10000000000000ull,0x10101000000000ull,0x10000000000000ull,0x10100000000000ull,0x10000000000000ull,
0x10101010000000ull,0x10000000000000ull,0x10100000000000ull,0x10000000000000ull,0x10101000000000ull,0x10000000000000ull,0x10100000000000ull,0x10000000000000ull,
0x10101010100000ull,0x10000000000000ull,0x10100000000000ull,0x10000000000000ull,0x10101000000000ull,0x10000000000000ull,0x10100000000000ull,0x10000000000000ull,
0x10101010000000ull,0x10000000000000ull,0x10100000000000ull,0x10000000000000ull,0x10101000000000ull,0x10000000000000ull,0x10100000000000ull,0x10000000000000ull,
0x10101010101000ull,0x10000000000000ull,0x10100000000000ull,0x10000000000000ull,0x10101000000000ull,0x10000000000000ull,0x10100000000000ull,0x10000000000000ull,
0x10101010000000ull,0x10000000000000ull,0x10100000000000ull,0x10000000000000ull,0x10101000000000ull,0x10000000000000ull,0x10100000000000ull,0x10000000000000ull,
0x10101010100000ull,0x10000000000000ull,0x10100000000000ull,0x10000000000000ull,0x10101000000000ull,0x10000000000000ull,0x10100000000000ull,0x10000000000000ull,
0x10101010000000ull,0x10000000000000ull,0x10100000000000ull,0x10000000000000ull,0x10101000000000ull,0x10000000000000ull,0x10100000000000ull,0x10000000000000ull
},{
0x20202020202020ull,0x20000000000000ull,0x20200000000000ull,0x20000000000000ull,0x20202000000000ull,0x20000000000000ull,0x20200000000000ull,0x20000000000000ull,
0x20202020000000ull,0x20000000000000ull,0x20200000000000ull,0x20000000000000ull,0x20202000000000ull,0x20000000000000ull,0x20200000000000ull,0x20000000000000ull,
0x20202020200000ull,0x20000000000000ull,0x20200000000000ull,0x20000000000000ull,0x20202000000000ull,0x20000000000000ull,0x20200000000000ull,0x20000000000000ull,
0x20202020000000ull,0x20000000000000ull,0x20200000000000ull,0x20000000000000ull,0x20202000000000ull,0x20000000000000ull,0x20200000000000ull,0x20000000000000ull,
0x20202020202000ull,0x20000000000000ull,0x20200000000000ull,0x20000000000000ull,0x20202000000000ull,0x20000000000000ull,0x20200000000000ull,0x20000000000000ull,
0x20202020000000ull,0x20000000000000ull,0x20200000000000ull,0x20000000000000ull,0x20202000000000ull,0x20000000000000ull,0x20200000000000ull,0x20000000000000ull,
0x20202020200000ull,0x20000000000000ull,0x20200000000000ull,0x20000000000000ull,0x20202000000000ull,0x20000000000000ull,0x20200000000000ull,0x20000000000000ull,
0x20202020000000ull,0x20000000000000ull,0x20200000000000ull,0x20000000000000ull,0x20202000000000ull,0x20000000000000ull,0x20200000000000ull,0x20000000000000ull
},{
0x40404040404040ull,0x40000000000000ull,0x40400000000000ull,0x40000000000000ull,0x40404000000000ull,0x40000000000000ull,0x40400000000000ull,0x40000000000000ull,
0x40404040000000ull,0x40000000000000ull,0x40400000000000ull,0x40000000000000ull,0x40404000000000ull,0x40000000000000ull,0x40400000000000ull,0x40000000000000ull,
0x40404040400000ull,0x40000000000000ull,0x40400000000000ull,0x40000000000000ull,0x40404000000000ull,0x40000000000000ull,0x40400000000000ull,0x40000000000000ull,
0x40404040000000ull,0x40000000000000ull,0x40400000000000ull,0x40000000000000ull,0x40404000000000ull,0x40000000000000ull,0x40400000000000ull,0x40000000000000ull,
0x40404040404000ull,0x40000000000000ull,0x40400000000000ull,0x40000000000000ull,0x40404000000000ull,0x40000000000000ull,0x40400000000000ull,0x40000000000000ull,
0x40404040000000ull,0x40000000000000ull,0x40400000000000ull,0x40000000000000ull,0x40404000000000ull,0x40000000000000ull,0x40400000000000ull,0x40000000000000ull,
0x40404040400000ull,0x40000000000000ull,0x40400000000000ull,0x40000000000000ull,0x40404000000000ull,0x40000000000000ull,0x40400000000000ull,0x40000000000000ull,
0x40404040000000ull,0x40000000000000ull,0x40400000000000ull,0x40000000000000ull,0x40404000000000ull,0x40000000000000ull,0x40400000000000ull,0x40000000000000ull
},{
0x80808080808080ull,0x80000000000000ull,0x80800000000000ull,0x80000000000000ull,0x80808000000000ull,0x80000000000000ull,0x80800000000000ull,0x80000000000000ull,
0x80808080000000ull,0x80000000000000ull,0x80800000000000ull,0x80000000000000ull,0x80808000000000ull,0x80000000000000ull,0x80800000000000ull,0x80000000000000ull,
0x80808080800000ull,0x80000000000000ull,0x80800000000000ull,0x80000000000000ull,0x80808000000000ull,0x80000000000000ull,0x80800000000000ull,0x80000000000000ull,
0x80808080000000ull,0x80000000000000ull,0x80800000000000ull,0x80000000000000ull,0x80808000000000ull,0x80000000000000ull,0x80800000000000ull,0x80000000000000ull,
0x80808080808000ull,0x80000000000000ull,0x80800000000000ull,0x80000000000000ull,0x80808000000000ull,0x80000000000000ull,0x80800000000000ull,0x80000000000000ull,
0x80808080000000ull,0x80000000000000ull,0x80800000000000ull,0x80000000000000ull,0x80808000000000ull,0x80000000000000ull,0x80800000000000ull,0x80000000000000ull,
0x80808080800000ull,0x80000000000000ull,0x80800000000000ull,0x80000000000000ull,0x80808000000000ull,0x80000000000000ull,0x80800000000000ull,0x80000000000000ull,
0x80808080000000ull,0x80000000000000ull,0x80800000000000ull,0x80000000000000ull,0x80808000000000ull,0x80000000000000ull,0x80800000000000ull,0x80000000000000ull
}};


  uint64 RANK_ATTACKS[64][64] = {
{
0xfeull,0x2ull,0x6ull,0x2ull,0xeull,0x2ull,0x6ull,0x2ull,
0x1eull,0x2ull,0x6ull,0x2ull,0xeull,0x2ull,0x6ull,0x2ull,
0x3eull,0x2ull,0x6ull,0x2ull,0xeull,0x2ull,0x6ull,0x2ull,
0x1eull,0x2ull,0x6ull,0x2ull,0xeull,0x2ull,0x6ull,0x2ull,
0x7eull,0x2ull,0x6ull,0x2ull,0xeull,0x2ull,0x6ull,0x2ull,
0x1eull,0x2ull,0x6ull,0x2ull,0xeull,0x2ull,0x6ull,0x2ull,
0x3eull,0x2ull,0x6ull,0x2ull,0xeull,0x2ull,0x6ull,0x2ull,
0x1eull,0x2ull,0x6ull,0x2ull,0xeull,0x2ull,0x6ull,0x2ull
},{
0xfdull,0xfdull,0x5ull,0x5ull,0xdull,0xdull,0x5ull,0x5ull,
0x1dull,0x1dull,0x5ull,0x5ull,0xdull,0xdull,0x5ull,0x5ull,
0x3dull,0x3dull,0x5ull,0x5ull,0xdull,0xdull,0x5ull,0x5ull,
0x1dull,0x1dull,0x5ull,0x5ull,0xdull,0xdull,0x5ull,0x5ull,
0x7dull,0x7dull,0x5ull,0x5ull,0xdull,0xdull,0x5ull,0x5ull,
0x1dull,0x1dull,0x5ull,0x5ull,0xdull,0xdull,0x5ull,0x5ull,
0x3dull,0x3dull,0x5ull,0x5ull,0xdull,0xdull,0x5ull,0x5ull,
0x1dull,0x1dull,0x5ull,0x5ull,0xdull,0xdull,0x5ull,0x5ull
},{
0xfbull,0xfaull,0xfbull,0xfaull,0xbull,0xaull,0xbull,0xaull,
0x1bull,0x1aull,0x1bull,0x1aull,0xbull,0xaull,0xbull,0xaull,
0x3bull,0x3aull,0x3bull,0x3aull,0xbull,0xaull,0xbull,0xaull,
0x1bull,0x1aull,0x1bull,0x1aull,0xbull,0xaull,0xbull,0xaull,
0x7bull,0x7aull,0x7bull,0x7aull,0xbull,0xaull,0xbull,0xaull,
0x1bull,0x1aull,0x1bull,0x1aull,0xbull,0xaull,0xbull,0xaull,
0x3bull,0x3aull,0x3bull,0x3aull,0xbull,0xaull,0xbull,0xaull,
0x1bull,0x1aull,0x1bull,0x1aull,0xbull,0xaull,0xbull,0xaull
},{
0xf7ull,0xf6ull,0xf4ull,0xf4ull,0xf7ull,0xf6ull,0xf4ull,0xf4ull,
0x17ull,0x16ull,0x14ull,0x14ull,0x17ull,0x16ull,0x14ull,0x14ull,
0x37ull,0x36ull,0x34ull,0x34ull,0x37ull,0x36ull,0x34ull,0x34ull,
0x17ull,0x16ull,0x14ull,0x14ull,0x17ull,0x16ull,0x14ull,0x14ull,
0x77ull,0x76ull,0x74ull,0x74ull,0x77ull,0x76ull,0x74ull,0x74ull,
0x17ull,0x16ull,0x14ull,0x14ull,0x17ull,0x16ull,0x14ull,0x14ull,
0x37ull,0x36ull,0x34ull,0x34ull,0x37ull,0x36ull,0x34ull,0x34ull,
0x17ull,0x16ull,0x14ull,0x14ull,0x17ull,0x16ull,0x14ull,0x14ull
},{
0xefull,0xeeull,0xecull,0xecull,0xe8ull,0xe8ull,0xe8ull,0xe8ull,
0xefull,0xeeull,0xecull,0xecull,0xe8ull,0xe8ull,0xe8ull,0xe8ull,
0x2full,0x2eull,0x2cull,0x2cull,0x28ull,0x28ull,0x28ull,0x28ull,
0x2full,0x2eull,0x2cull,0x2cull,0x28ull,0x28ull,0x28ull,0x28ull,
0x6full,0x6eull,0x6cull,0x6cull,0x68ull,0x68ull,0x68ull,0x68ull,
0x6full,0x6eull,0x6cull,0x6cull,0x68ull,0x68ull,0x68ull,0x68ull,
0x2full,0x2eull,0x2cull,0x2cull,0x28ull,0x28ull,0x28ull,0x28ull,
0x2full,0x2eull,0x2cull,0x2cull,0x28ull,0x28ull,0x28ull,0x28ull
},{
0xdfull,0xdeull,0xdcull,0xdcull,0xd8ull,0xd8ull,0xd8ull,0xd8ull,
0xd0ull,0xd0ull,0xd0ull,0xd0ull,0xd0ull,0xd0ull,0xd0ull,0xd0ull,
0xdfull,0xdeull,0xdcull,0xdcull,0xd8ull,0xd8ull,0xd8ull,0xd8ull,
0xd0ull,0xd0ull,0xd0ull,0xd0ull,0xd0ull,0xd0ull,0xd0ull,0xd0ull,
0x5full,0x5eull,0x5cull,0x5cull,0x58ull,0x58ull,0x58ull,0x58ull,
0x50ull,0x50ull,0x50ull,0x50ull,0x50ull,0x50ull,0x50ull,0x50ull,
0x5full,0x5eull,0x5cull,0x5cull,0x58ull,0x58ull,0x58ull,0x58ull,
0x50ull,0x50ull,0x50ull,0x50ull,0x50ull,0x50ull,0x50ull,0x50ull
},{
0xbfull,0xbeull,0xbcull,0xbcull,0xb8ull,0xb8ull,0xb8ull,0xb8ull,
0xb0ull,0xb0ull,0xb0ull,0xb0ull,0xb0ull,0xb0ull,0xb0ull,0xb0ull,
0xa0ull,0xa0ull,0xa0ull,0xa0ull,0xa0ull,0xa0ull,0xa0ull,0xa0ull,
0xa0ull,0xa0ull,0xa0ull,0xa0ull,0xa0ull,0xa0ull,0xa0ull,0xa0ull,
0xbfull,0xbeull,0xbcull,0xbcull,0xb8ull,0xb8ull,0xb8ull,0xb8ull,
0xb0ull,0xb0ull,0xb0ull,0xb0ull,0xb0ull,0xb0ull,0xb0ull,0xb0ull,
0xa0ull,0xa0ull,0xa0ull,0xa0ull,0xa0ull,0xa0ull,0xa0ull,0xa0ull,
0xa0ull,0xa0ull,0xa0ull,0xa0ull,0xa0ull,0xa0ull,0xa0ull,0xa0ull
},{
0x7full,0x7eull,0x7cull,0x7cull,0x78ull,0x78ull,0x78ull,0x78ull,
0x70ull,0x70ull,0x70ull,0x70ull,0x70ull,0x70ull,0x70ull,0x70ull,
0x60ull,0x60ull,0x60ull,0x60ull,0x60ull,0x60ull,0x60ull,0x60ull,
0x60ull,0x60ull,0x60ull,0x60ull,0x60ull,0x60ull,0x60ull,0x60ull,
0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,
0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,
0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,
0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull,0x40ull
},{
0xfe00ull,0x200ull,0x600ull,0x200ull,0xe00ull,0x200ull,0x600ull,0x200ull,
0x1e00ull,0x200ull,0x600ull,0x200ull,0xe00ull,0x200ull,0x600ull,0x200ull,
0x3e00ull,0x200ull,0x600ull,0x200ull,0xe00ull,0x200ull,0x600ull,0x200ull,
0x1e00ull,0x200ull,0x600ull,0x200ull,0xe00ull,0x200ull,0x600ull,0x200ull,
0x7e00ull,0x200ull,0x600ull,0x200ull,0xe00ull,0x200ull,0x600ull,0x200ull,
0x1e00ull,0x200ull,0x600ull,0x200ull,0xe00ull,0x200ull,0x600ull,0x200ull,
0x3e00ull,0x200ull,0x600ull,0x200ull,0xe00ull,0x200ull,0x600ull,0x200ull,
0x1e00ull,0x200ull,0x600ull,0x200ull,0xe00ull,0x200ull,0x600ull,0x200ull
},{
0xfd00ull,0xfd00ull,0x500ull,0x500ull,0xd00ull,0xd00ull,0x500ull,0x500ull,
0x1d00ull,0x1d00ull,0x500ull,0x500ull,0xd00ull,0xd00ull,0x500ull,0x500ull,
0x3d00ull,0x3d00ull,0x500ull,0x500ull,0xd00ull,0xd00ull,0x500ull,0x500ull,
0x1d00ull,0x1d00ull,0x500ull,0x500ull,0xd00ull,0xd00ull,0x500ull,0x500ull,
0x7d00ull,0x7d00ull,0x500ull,0x500ull,0xd00ull,0xd00ull,0x500ull,0x500ull,
0x1d00ull,0x1d00ull,0x500ull,0x500ull,0xd00ull,0xd00ull,0x500ull,0x500ull,
0x3d00ull,0x3d00ull,0x500ull,0x500ull,0xd00ull,0xd00ull,0x500ull,0x500ull,
0x1d00ull,0x1d00ull,0x500ull,0x500ull,0xd00ull,0xd00ull,0x500ull,0x500ull
},{
0xfb00ull,0xfa00ull,0xfb00ull,0xfa00ull,0xb00ull,0xa00ull,0xb00ull,0xa00ull,
0x1b00ull,0x1a00ull,0x1b00ull,0x1a00ull,0xb00ull,0xa00ull,0xb00ull,0xa00ull,
0x3b00ull,0x3a00ull,0x3b00ull,0x3a00ull,0xb00ull,0xa00ull,0xb00ull,0xa00ull,
0x1b00ull,0x1a00ull,0x1b00ull,0x1a00ull,0xb00ull,0xa00ull,0xb00ull,0xa00ull,
0x7b00ull,0x7a00ull,0x7b00ull,0x7a00ull,0xb00ull,0xa00ull,0xb00ull,0xa00ull,
0x1b00ull,0x1a00ull,0x1b00ull,0x1a00ull,0xb00ull,0xa00ull,0xb00ull,0xa00ull,
0x3b00ull,0x3a00ull,0x3b00ull,0x3a00ull,0xb00ull,0xa00ull,0xb00ull,0xa00ull,
0x1b00ull,0x1a00ull,0x1b00ull,0x1a00ull,0xb00ull,0xa00ull,0xb00ull,0xa00ull
},{
0xf700ull,0xf600ull,0xf400ull,0xf400ull,0xf700ull,0xf600ull,0xf400ull,0xf400ull,
0x1700ull,0x1600ull,0x1400ull,0x1400ull,0x1700ull,0x1600ull,0x1400ull,0x1400ull,
0x3700ull,0x3600ull,0x3400ull,0x3400ull,0x3700ull,0x3600ull,0x3400ull,0x3400ull,
0x1700ull,0x1600ull,0x1400ull,0x1400ull,0x1700ull,0x1600ull,0x1400ull,0x1400ull,
0x7700ull,0x7600ull,0x7400ull,0x7400ull,0x7700ull,0x7600ull,0x7400ull,0x7400ull,
0x1700ull,0x1600ull,0x1400ull,0x1400ull,0x1700ull,0x1600ull,0x1400ull,0x1400ull,
0x3700ull,0x3600ull,0x3400ull,0x3400ull,0x3700ull,0x3600ull,0x3400ull,0x3400ull,
0x1700ull,0x1600ull,0x1400ull,0x1400ull,0x1700ull,0x1600ull,0x1400ull,0x1400ull
},{
0xef00ull,0xee00ull,0xec00ull,0xec00ull,0xe800ull,0xe800ull,0xe800ull,0xe800ull,
0xef00ull,0xee00ull,0xec00ull,0xec00ull,0xe800ull,0xe800ull,0xe800ull,0xe800ull,
0x2f00ull,0x2e00ull,0x2c00ull,0x2c00ull,0x2800ull,0x2800ull,0x2800ull,0x2800ull,
0x2f00ull,0x2e00ull,0x2c00ull,0x2c00ull,0x2800ull,0x2800ull,0x2800ull,0x2800ull,
0x6f00ull,0x6e00ull,0x6c00ull,0x6c00ull,0x6800ull,0x6800ull,0x6800ull,0x6800ull,
0x6f00ull,0x6e00ull,0x6c00ull,0x6c00ull,0x6800ull,0x6800ull,0x6800ull,0x6800ull,
0x2f00ull,0x2e00ull,0x2c00ull,0x2c00ull,0x2800ull,0x2800ull,0x2800ull,0x2800ull,
0x2f00ull,0x2e00ull,0x2c00ull,0x2c00ull,0x2800ull,0x2800ull,0x2800ull,0x2800ull
},{
0xdf00ull,0xde00ull,0xdc00ull,0xdc00ull,0xd800ull,0xd800ull,0xd800ull,0xd800ull,
0xd000ull,0xd000ull,0xd000ull,0xd000ull,0xd000ull,0xd000ull,0xd000ull,0xd000ull,
0xdf00ull,0xde00ull,0xdc00ull,0xdc00ull,0xd800ull,0xd800ull,0xd800ull,0xd800ull,
0xd000ull,0xd000ull,0xd000ull,0xd000ull,0xd000ull,0xd000ull,0xd000ull,0xd000ull,
0x5f00ull,0x5e00ull,0x5c00ull,0x5c00ull,0x5800ull,0x5800ull,0x5800ull,0x5800ull,
0x5000ull,0x5000ull,0x5000ull,0x5000ull,0x5000ull,0x5000ull,0x5000ull,0x5000ull,
0x5f00ull,0x5e00ull,0x5c00ull,0x5c00ull,0x5800ull,0x5800ull,0x5800ull,0x5800ull,
0x5000ull,0x5000ull,0x5000ull,0x5000ull,0x5000ull,0x5000ull,0x5000ull,0x5000ull
},{
0xbf00ull,0xbe00ull,0xbc00ull,0xbc00ull,0xb800ull,0xb800ull,0xb800ull,0xb800ull,
0xb000ull,0xb000ull,0xb000ull,0xb000ull,0xb000ull,0xb000ull,0xb000ull,0xb000ull,
0xa000ull,0xa000ull,0xa000ull,0xa000ull,0xa000ull,0xa000ull,0xa000ull,0xa000ull,
0xa000ull,0xa000ull,0xa000ull,0xa000ull,0xa000ull,0xa000ull,0xa000ull,0xa000ull,
0xbf00ull,0xbe00ull,0xbc00ull,0xbc00ull,0xb800ull,0xb800ull,0xb800ull,0xb800ull,
0xb000ull,0xb000ull,0xb000ull,0xb000ull,0xb000ull,0xb000ull,0xb000ull,0xb000ull,
0xa000ull,0xa000ull,0xa000ull,0xa000ull,0xa000ull,0xa000ull,0xa000ull,0xa000ull,
0xa000ull,0xa000ull,0xa000ull,0xa000ull,0xa000ull,0xa000ull,0xa000ull,0xa000ull
},{
0x7f00ull,0x7e00ull,0x7c00ull,0x7c00ull,0x7800ull,0x7800ull,0x7800ull,0x7800ull,
0x7000ull,0x7000ull,0x7000ull,0x7000ull,0x7000ull,0x7000ull,0x7000ull,0x7000ull,
0x6000ull,0x6000ull,0x6000ull,0x6000ull,0x6000ull,0x6000ull,0x6000ull,0x6000ull,
0x6000ull,0x6000ull,0x6000ull,0x6000ull,0x6000ull,0x6000ull,0x6000ull,0x6000ull,
0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,
0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,
0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,
0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull,0x4000ull
},{
0xfe0000ull,0x20000ull,0x60000ull,0x20000ull,0xe0000ull,0x20000ull,0x60000ull,0x20000ull,
0x1e0000ull,0x20000ull,0x60000ull,0x20000ull,0xe0000ull,0x20000ull,0x60000ull,0x20000ull,
0x3e0000ull,0x20000ull,0x60000ull,0x20000ull,0xe0000ull,0x20000ull,0x60000ull,0x20000ull,
0x1e0000ull,0x20000ull,0x60000ull,0x20000ull,0xe0000ull,0x20000ull,0x60000ull,0x20000ull,
0x7e0000ull,0x20000ull,0x60000ull,0x20000ull,0xe0000ull,0x20000ull,0x60000ull,0x20000ull,
0x1e0000ull,0x20000ull,0x60000ull,0x20000ull,0xe0000ull,0x20000ull,0x60000ull,0x20000ull,
0x3e0000ull,0x20000ull,0x60000ull,0x20000ull,0xe0000ull,0x20000ull,0x60000ull,0x20000ull,
0x1e0000ull,0x20000ull,0x60000ull,0x20000ull,0xe0000ull,0x20000ull,0x60000ull,0x20000ull
},{
0xfd0000ull,0xfd0000ull,0x50000ull,0x50000ull,0xd0000ull,0xd0000ull,0x50000ull,0x50000ull,
0x1d0000ull,0x1d0000ull,0x50000ull,0x50000ull,0xd0000ull,0xd0000ull,0x50000ull,0x50000ull,
0x3d0000ull,0x3d0000ull,0x50000ull,0x50000ull,0xd0000ull,0xd0000ull,0x50000ull,0x50000ull,
0x1d0000ull,0x1d0000ull,0x50000ull,0x50000ull,0xd0000ull,0xd0000ull,0x50000ull,0x50000ull,
0x7d0000ull,0x7d0000ull,0x50000ull,0x50000ull,0xd0000ull,0xd0000ull,0x50000ull,0x50000ull,
0x1d0000ull,0x1d0000ull,0x50000ull,0x50000ull,0xd0000ull,0xd0000ull,0x50000ull,0x50000ull,
0x3d0000ull,0x3d0000ull,0x50000ull,0x50000ull,0xd0000ull,0xd0000ull,0x50000ull,0x50000ull,
0x1d0000ull,0x1d0000ull,0x50000ull,0x50000ull,0xd0000ull,0xd0000ull,0x50000ull,0x50000ull
},{
0xfb0000ull,0xfa0000ull,0xfb0000ull,0xfa0000ull,0xb0000ull,0xa0000ull,0xb0000ull,0xa0000ull,
0x1b0000ull,0x1a0000ull,0x1b0000ull,0x1a0000ull,0xb0000ull,0xa0000ull,0xb0000ull,0xa0000ull,
0x3b0000ull,0x3a0000ull,0x3b0000ull,0x3a0000ull,0xb0000ull,0xa0000ull,0xb0000ull,0xa0000ull,
0x1b0000ull,0x1a0000ull,0x1b0000ull,0x1a0000ull,0xb0000ull,0xa0000ull,0xb0000ull,0xa0000ull,
0x7b0000ull,0x7a0000ull,0x7b0000ull,0x7a0000ull,0xb0000ull,0xa0000ull,0xb0000ull,0xa0000ull,
0x1b0000ull,0x1a0000ull,0x1b0000ull,0x1a0000ull,0xb0000ull,0xa0000ull,0xb0000ull,0xa0000ull,
0x3b0000ull,0x3a0000ull,0x3b0000ull,0x3a0000ull,0xb0000ull,0xa0000ull,0xb0000ull,0xa0000ull,
0x1b0000ull,0x1a0000ull,0x1b0000ull,0x1a0000ull,0xb0000ull,0xa0000ull,0xb0000ull,0xa0000ull
},{
0xf70000ull,0xf60000ull,0xf40000ull,0xf40000ull,0xf70000ull,0xf60000ull,0xf40000ull,0xf40000ull,
0x170000ull,0x160000ull,0x140000ull,0x140000ull,0x170000ull,0x160000ull,0x140000ull,0x140000ull,
0x370000ull,0x360000ull,0x340000ull,0x340000ull,0x370000ull,0x360000ull,0x340000ull,0x340000ull,
0x170000ull,0x160000ull,0x140000ull,0x140000ull,0x170000ull,0x160000ull,0x140000ull,0x140000ull,
0x770000ull,0x760000ull,0x740000ull,0x740000ull,0x770000ull,0x760000ull,0x740000ull,0x740000ull,
0x170000ull,0x160000ull,0x140000ull,0x140000ull,0x170000ull,0x160000ull,0x140000ull,0x140000ull,
0x370000ull,0x360000ull,0x340000ull,0x340000ull,0x370000ull,0x360000ull,0x340000ull,0x340000ull,
0x170000ull,0x160000ull,0x140000ull,0x140000ull,0x170000ull,0x160000ull,0x140000ull,0x140000ull
},{
0xef0000ull,0xee0000ull,0xec0000ull,0xec0000ull,0xe80000ull,0xe80000ull,0xe80000ull,0xe80000ull,
0xef0000ull,0xee0000ull,0xec0000ull,0xec0000ull,0xe80000ull,0xe80000ull,0xe80000ull,0xe80000ull,
0x2f0000ull,0x2e0000ull,0x2c0000ull,0x2c0000ull,0x280000ull,0x280000ull,0x280000ull,0x280000ull,
0x2f0000ull,0x2e0000ull,0x2c0000ull,0x2c0000ull,0x280000ull,0x280000ull,0x280000ull,0x280000ull,
0x6f0000ull,0x6e0000ull,0x6c0000ull,0x6c0000ull,0x680000ull,0x680000ull,0x680000ull,0x680000ull,
0x6f0000ull,0x6e0000ull,0x6c0000ull,0x6c0000ull,0x680000ull,0x680000ull,0x680000ull,0x680000ull,
0x2f0000ull,0x2e0000ull,0x2c0000ull,0x2c0000ull,0x280000ull,0x280000ull,0x280000ull,0x280000ull,
0x2f0000ull,0x2e0000ull,0x2c0000ull,0x2c0000ull,0x280000ull,0x280000ull,0x280000ull,0x280000ull
},{
0xdf0000ull,0xde0000ull,0xdc0000ull,0xdc0000ull,0xd80000ull,0xd80000ull,0xd80000ull,0xd80000ull,
0xd00000ull,0xd00000ull,0xd00000ull,0xd00000ull,0xd00000ull,0xd00000ull,0xd00000ull,0xd00000ull,
0xdf0000ull,0xde0000ull,0xdc0000ull,0xdc0000ull,0xd80000ull,0xd80000ull,0xd80000ull,0xd80000ull,
0xd00000ull,0xd00000ull,0xd00000ull,0xd00000ull,0xd00000ull,0xd00000ull,0xd00000ull,0xd00000ull,
0x5f0000ull,0x5e0000ull,0x5c0000ull,0x5c0000ull,0x580000ull,0x580000ull,0x580000ull,0x580000ull,
0x500000ull,0x500000ull,0x500000ull,0x500000ull,0x500000ull,0x500000ull,0x500000ull,0x500000ull,
0x5f0000ull,0x5e0000ull,0x5c0000ull,0x5c0000ull,0x580000ull,0x580000ull,0x580000ull,0x580000ull,
0x500000ull,0x500000ull,0x500000ull,0x500000ull,0x500000ull,0x500000ull,0x500000ull,0x500000ull
},{
0xbf0000ull,0xbe0000ull,0xbc0000ull,0xbc0000ull,0xb80000ull,0xb80000ull,0xb80000ull,0xb80000ull,
0xb00000ull,0xb00000ull,0xb00000ull,0xb00000ull,0xb00000ull,0xb00000ull,0xb00000ull,0xb00000ull,
0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,
0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,
0xbf0000ull,0xbe0000ull,0xbc0000ull,0xbc0000ull,0xb80000ull,0xb80000ull,0xb80000ull,0xb80000ull,
0xb00000ull,0xb00000ull,0xb00000ull,0xb00000ull,0xb00000ull,0xb00000ull,0xb00000ull,0xb00000ull,
0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,
0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull,0xa00000ull
},{
0x7f0000ull,0x7e0000ull,0x7c0000ull,0x7c0000ull,0x780000ull,0x780000ull,0x780000ull,0x780000ull,
0x700000ull,0x700000ull,0x700000ull,0x700000ull,0x700000ull,0x700000ull,0x700000ull,0x700000ull,
0x600000ull,0x600000ull,0x600000ull,0x600000ull,0x600000ull,0x600000ull,0x600000ull,0x600000ull,
0x600000ull,0x600000ull,0x600000ull,0x600000ull,0x600000ull,0x600000ull,0x600000ull,0x600000ull,
0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,
0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,
0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,
0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull,0x400000ull
},{
0xfe000000ull,0x2000000ull,0x6000000ull,0x2000000ull,0xe000000ull,0x2000000ull,0x6000000ull,0x2000000ull,
0x1e000000ull,0x2000000ull,0x6000000ull,0x2000000ull,0xe000000ull,0x2000000ull,0x6000000ull,0x2000000ull,
0x3e000000ull,0x2000000ull,0x6000000ull,0x2000000ull,0xe000000ull,0x2000000ull,0x6000000ull,0x2000000ull,
0x1e000000ull,0x2000000ull,0x6000000ull,0x2000000ull,0xe000000ull,0x2000000ull,0x6000000ull,0x2000000ull,
0x7e000000ull,0x2000000ull,0x6000000ull,0x2000000ull,0xe000000ull,0x2000000ull,0x6000000ull,0x2000000ull,
0x1e000000ull,0x2000000ull,0x6000000ull,0x2000000ull,0xe000000ull,0x2000000ull,0x6000000ull,0x2000000ull,
0x3e000000ull,0x2000000ull,0x6000000ull,0x2000000ull,0xe000000ull,0x2000000ull,0x6000000ull,0x2000000ull,
0x1e000000ull,0x2000000ull,0x6000000ull,0x2000000ull,0xe000000ull,0x2000000ull,0x6000000ull,0x2000000ull
},{
0xfd000000ull,0xfd000000ull,0x5000000ull,0x5000000ull,0xd000000ull,0xd000000ull,0x5000000ull,0x5000000ull,
0x1d000000ull,0x1d000000ull,0x5000000ull,0x5000000ull,0xd000000ull,0xd000000ull,0x5000000ull,0x5000000ull,
0x3d000000ull,0x3d000000ull,0x5000000ull,0x5000000ull,0xd000000ull,0xd000000ull,0x5000000ull,0x5000000ull,
0x1d000000ull,0x1d000000ull,0x5000000ull,0x5000000ull,0xd000000ull,0xd000000ull,0x5000000ull,0x5000000ull,
0x7d000000ull,0x7d000000ull,0x5000000ull,0x5000000ull,0xd000000ull,0xd000000ull,0x5000000ull,0x5000000ull,
0x1d000000ull,0x1d000000ull,0x5000000ull,0x5000000ull,0xd000000ull,0xd000000ull,0x5000000ull,0x5000000ull,
0x3d000000ull,0x3d000000ull,0x5000000ull,0x5000000ull,0xd000000ull,0xd000000ull,0x5000000ull,0x5000000ull,
0x1d000000ull,0x1d000000ull,0x5000000ull,0x5000000ull,0xd000000ull,0xd000000ull,0x5000000ull,0x5000000ull
},{
0xfb000000ull,0xfa000000ull,0xfb000000ull,0xfa000000ull,0xb000000ull,0xa000000ull,0xb000000ull,0xa000000ull,
0x1b000000ull,0x1a000000ull,0x1b000000ull,0x1a000000ull,0xb000000ull,0xa000000ull,0xb000000ull,0xa000000ull,
0x3b000000ull,0x3a000000ull,0x3b000000ull,0x3a000000ull,0xb000000ull,0xa000000ull,0xb000000ull,0xa000000ull,
0x1b000000ull,0x1a000000ull,0x1b000000ull,0x1a000000ull,0xb000000ull,0xa000000ull,0xb000000ull,0xa000000ull,
0x7b000000ull,0x7a000000ull,0x7b000000ull,0x7a000000ull,0xb000000ull,0xa000000ull,0xb000000ull,0xa000000ull,
0x1b000000ull,0x1a000000ull,0x1b000000ull,0x1a000000ull,0xb000000ull,0xa000000ull,0xb000000ull,0xa000000ull,
0x3b000000ull,0x3a000000ull,0x3b000000ull,0x3a000000ull,0xb000000ull,0xa000000ull,0xb000000ull,0xa000000ull,
0x1b000000ull,0x1a000000ull,0x1b000000ull,0x1a000000ull,0xb000000ull,0xa000000ull,0xb000000ull,0xa000000ull
},{
0xf7000000ull,0xf6000000ull,0xf4000000ull,0xf4000000ull,0xf7000000ull,0xf6000000ull,0xf4000000ull,0xf4000000ull,
0x17000000ull,0x16000000ull,0x14000000ull,0x14000000ull,0x17000000ull,0x16000000ull,0x14000000ull,0x14000000ull,
0x37000000ull,0x36000000ull,0x34000000ull,0x34000000ull,0x37000000ull,0x36000000ull,0x34000000ull,0x34000000ull,
0x17000000ull,0x16000000ull,0x14000000ull,0x14000000ull,0x17000000ull,0x16000000ull,0x14000000ull,0x14000000ull,
0x77000000ull,0x76000000ull,0x74000000ull,0x74000000ull,0x77000000ull,0x76000000ull,0x74000000ull,0x74000000ull,
0x17000000ull,0x16000000ull,0x14000000ull,0x14000000ull,0x17000000ull,0x16000000ull,0x14000000ull,0x14000000ull,
0x37000000ull,0x36000000ull,0x34000000ull,0x34000000ull,0x37000000ull,0x36000000ull,0x34000000ull,0x34000000ull,
0x17000000ull,0x16000000ull,0x14000000ull,0x14000000ull,0x17000000ull,0x16000000ull,0x14000000ull,0x14000000ull
},{
0xef000000ull,0xee000000ull,0xec000000ull,0xec000000ull,0xe8000000ull,0xe8000000ull,0xe8000000ull,0xe8000000ull,
0xef000000ull,0xee000000ull,0xec000000ull,0xec000000ull,0xe8000000ull,0xe8000000ull,0xe8000000ull,0xe8000000ull,
0x2f000000ull,0x2e000000ull,0x2c000000ull,0x2c000000ull,0x28000000ull,0x28000000ull,0x28000000ull,0x28000000ull,
0x2f000000ull,0x2e000000ull,0x2c000000ull,0x2c000000ull,0x28000000ull,0x28000000ull,0x28000000ull,0x28000000ull,
0x6f000000ull,0x6e000000ull,0x6c000000ull,0x6c000000ull,0x68000000ull,0x68000000ull,0x68000000ull,0x68000000ull,
0x6f000000ull,0x6e000000ull,0x6c000000ull,0x6c000000ull,0x68000000ull,0x68000000ull,0x68000000ull,0x68000000ull,
0x2f000000ull,0x2e000000ull,0x2c000000ull,0x2c000000ull,0x28000000ull,0x28000000ull,0x28000000ull,0x28000000ull,
0x2f000000ull,0x2e000000ull,0x2c000000ull,0x2c000000ull,0x28000000ull,0x28000000ull,0x28000000ull,0x28000000ull
},{
0xdf000000ull,0xde000000ull,0xdc000000ull,0xdc000000ull,0xd8000000ull,0xd8000000ull,0xd8000000ull,0xd8000000ull,
0xd0000000ull,0xd0000000ull,0xd0000000ull,0xd0000000ull,0xd0000000ull,0xd0000000ull,0xd0000000ull,0xd0000000ull,
0xdf000000ull,0xde000000ull,0xdc000000ull,0xdc000000ull,0xd8000000ull,0xd8000000ull,0xd8000000ull,0xd8000000ull,
0xd0000000ull,0xd0000000ull,0xd0000000ull,0xd0000000ull,0xd0000000ull,0xd0000000ull,0xd0000000ull,0xd0000000ull,
0x5f000000ull,0x5e000000ull,0x5c000000ull,0x5c000000ull,0x58000000ull,0x58000000ull,0x58000000ull,0x58000000ull,
0x50000000ull,0x50000000ull,0x50000000ull,0x50000000ull,0x50000000ull,0x50000000ull,0x50000000ull,0x50000000ull,
0x5f000000ull,0x5e000000ull,0x5c000000ull,0x5c000000ull,0x58000000ull,0x58000000ull,0x58000000ull,0x58000000ull,
0x50000000ull,0x50000000ull,0x50000000ull,0x50000000ull,0x50000000ull,0x50000000ull,0x50000000ull,0x50000000ull
},{
0xbf000000ull,0xbe000000ull,0xbc000000ull,0xbc000000ull,0xb8000000ull,0xb8000000ull,0xb8000000ull,0xb8000000ull,
0xb0000000ull,0xb0000000ull,0xb0000000ull,0xb0000000ull,0xb0000000ull,0xb0000000ull,0xb0000000ull,0xb0000000ull,
0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,
0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,
0xbf000000ull,0xbe000000ull,0xbc000000ull,0xbc000000ull,0xb8000000ull,0xb8000000ull,0xb8000000ull,0xb8000000ull,
0xb0000000ull,0xb0000000ull,0xb0000000ull,0xb0000000ull,0xb0000000ull,0xb0000000ull,0xb0000000ull,0xb0000000ull,
0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,
0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull,0xa0000000ull
},{
0x7f000000ull,0x7e000000ull,0x7c000000ull,0x7c000000ull,0x78000000ull,0x78000000ull,0x78000000ull,0x78000000ull,
0x70000000ull,0x70000000ull,0x70000000ull,0x70000000ull,0x70000000ull,0x70000000ull,0x70000000ull,0x70000000ull,
0x60000000ull,0x60000000ull,0x60000000ull,0x60000000ull,0x60000000ull,0x60000000ull,0x60000000ull,0x60000000ull,
0x60000000ull,0x60000000ull,0x60000000ull,0x60000000ull,0x60000000ull,0x60000000ull,0x60000000ull,0x60000000ull,
0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,
0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,
0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,
0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull,0x40000000ull
},{
0xfe00000000ull,0x200000000ull,0x600000000ull,0x200000000ull,0xe00000000ull,0x200000000ull,0x600000000ull,0x200000000ull,
0x1e00000000ull,0x200000000ull,0x600000000ull,0x200000000ull,0xe00000000ull,0x200000000ull,0x600000000ull,0x200000000ull,
0x3e00000000ull,0x200000000ull,0x600000000ull,0x200000000ull,0xe00000000ull,0x200000000ull,0x600000000ull,0x200000000ull,
0x1e00000000ull,0x200000000ull,0x600000000ull,0x200000000ull,0xe00000000ull,0x200000000ull,0x600000000ull,0x200000000ull,
0x7e00000000ull,0x200000000ull,0x600000000ull,0x200000000ull,0xe00000000ull,0x200000000ull,0x600000000ull,0x200000000ull,
0x1e00000000ull,0x200000000ull,0x600000000ull,0x200000000ull,0xe00000000ull,0x200000000ull,0x600000000ull,0x200000000ull,
0x3e00000000ull,0x200000000ull,0x600000000ull,0x200000000ull,0xe00000000ull,0x200000000ull,0x600000000ull,0x200000000ull,
0x1e00000000ull,0x200000000ull,0x600000000ull,0x200000000ull,0xe00000000ull,0x200000000ull,0x600000000ull,0x200000000ull
},{
0xfd00000000ull,0xfd00000000ull,0x500000000ull,0x500000000ull,0xd00000000ull,0xd00000000ull,0x500000000ull,0x500000000ull,
0x1d00000000ull,0x1d00000000ull,0x500000000ull,0x500000000ull,0xd00000000ull,0xd00000000ull,0x500000000ull,0x500000000ull,
0x3d00000000ull,0x3d00000000ull,0x500000000ull,0x500000000ull,0xd00000000ull,0xd00000000ull,0x500000000ull,0x500000000ull,
0x1d00000000ull,0x1d00000000ull,0x500000000ull,0x500000000ull,0xd00000000ull,0xd00000000ull,0x500000000ull,0x500000000ull,
0x7d00000000ull,0x7d00000000ull,0x500000000ull,0x500000000ull,0xd00000000ull,0xd00000000ull,0x500000000ull,0x500000000ull,
0x1d00000000ull,0x1d00000000ull,0x500000000ull,0x500000000ull,0xd00000000ull,0xd00000000ull,0x500000000ull,0x500000000ull,
0x3d00000000ull,0x3d00000000ull,0x500000000ull,0x500000000ull,0xd00000000ull,0xd00000000ull,0x500000000ull,0x500000000ull,
0x1d00000000ull,0x1d00000000ull,0x500000000ull,0x500000000ull,0xd00000000ull,0xd00000000ull,0x500000000ull,0x500000000ull
},{
0xfb00000000ull,0xfa00000000ull,0xfb00000000ull,0xfa00000000ull,0xb00000000ull,0xa00000000ull,0xb00000000ull,0xa00000000ull,
0x1b00000000ull,0x1a00000000ull,0x1b00000000ull,0x1a00000000ull,0xb00000000ull,0xa00000000ull,0xb00000000ull,0xa00000000ull,
0x3b00000000ull,0x3a00000000ull,0x3b00000000ull,0x3a00000000ull,0xb00000000ull,0xa00000000ull,0xb00000000ull,0xa00000000ull,
0x1b00000000ull,0x1a00000000ull,0x1b00000000ull,0x1a00000000ull,0xb00000000ull,0xa00000000ull,0xb00000000ull,0xa00000000ull,
0x7b00000000ull,0x7a00000000ull,0x7b00000000ull,0x7a00000000ull,0xb00000000ull,0xa00000000ull,0xb00000000ull,0xa00000000ull,
0x1b00000000ull,0x1a00000000ull,0x1b00000000ull,0x1a00000000ull,0xb00000000ull,0xa00000000ull,0xb00000000ull,0xa00000000ull,
0x3b00000000ull,0x3a00000000ull,0x3b00000000ull,0x3a00000000ull,0xb00000000ull,0xa00000000ull,0xb00000000ull,0xa00000000ull,
0x1b00000000ull,0x1a00000000ull,0x1b00000000ull,0x1a00000000ull,0xb00000000ull,0xa00000000ull,0xb00000000ull,0xa00000000ull
},{
0xf700000000ull,0xf600000000ull,0xf400000000ull,0xf400000000ull,0xf700000000ull,0xf600000000ull,0xf400000000ull,0xf400000000ull,
0x1700000000ull,0x1600000000ull,0x1400000000ull,0x1400000000ull,0x1700000000ull,0x1600000000ull,0x1400000000ull,0x1400000000ull,
0x3700000000ull,0x3600000000ull,0x3400000000ull,0x3400000000ull,0x3700000000ull,0x3600000000ull,0x3400000000ull,0x3400000000ull,
0x1700000000ull,0x1600000000ull,0x1400000000ull,0x1400000000ull,0x1700000000ull,0x1600000000ull,0x1400000000ull,0x1400000000ull,
0x7700000000ull,0x7600000000ull,0x7400000000ull,0x7400000000ull,0x7700000000ull,0x7600000000ull,0x7400000000ull,0x7400000000ull,
0x1700000000ull,0x1600000000ull,0x1400000000ull,0x1400000000ull,0x1700000000ull,0x1600000000ull,0x1400000000ull,0x1400000000ull,
0x3700000000ull,0x3600000000ull,0x3400000000ull,0x3400000000ull,0x3700000000ull,0x3600000000ull,0x3400000000ull,0x3400000000ull,
0x1700000000ull,0x1600000000ull,0x1400000000ull,0x1400000000ull,0x1700000000ull,0x1600000000ull,0x1400000000ull,0x1400000000ull
},{
0xef00000000ull,0xee00000000ull,0xec00000000ull,0xec00000000ull,0xe800000000ull,0xe800000000ull,0xe800000000ull,0xe800000000ull,
0xef00000000ull,0xee00000000ull,0xec00000000ull,0xec00000000ull,0xe800000000ull,0xe800000000ull,0xe800000000ull,0xe800000000ull,
0x2f00000000ull,0x2e00000000ull,0x2c00000000ull,0x2c00000000ull,0x2800000000ull,0x2800000000ull,0x2800000000ull,0x2800000000ull,
0x2f00000000ull,0x2e00000000ull,0x2c00000000ull,0x2c00000000ull,0x2800000000ull,0x2800000000ull,0x2800000000ull,0x2800000000ull,
0x6f00000000ull,0x6e00000000ull,0x6c00000000ull,0x6c00000000ull,0x6800000000ull,0x6800000000ull,0x6800000000ull,0x6800000000ull,
0x6f00000000ull,0x6e00000000ull,0x6c00000000ull,0x6c00000000ull,0x6800000000ull,0x6800000000ull,0x6800000000ull,0x6800000000ull,
0x2f00000000ull,0x2e00000000ull,0x2c00000000ull,0x2c00000000ull,0x2800000000ull,0x2800000000ull,0x2800000000ull,0x2800000000ull,
0x2f00000000ull,0x2e00000000ull,0x2c00000000ull,0x2c00000000ull,0x2800000000ull,0x2800000000ull,0x2800000000ull,0x2800000000ull
},{
0xdf00000000ull,0xde00000000ull,0xdc00000000ull,0xdc00000000ull,0xd800000000ull,0xd800000000ull,0xd800000000ull,0xd800000000ull,
0xd000000000ull,0xd000000000ull,0xd000000000ull,0xd000000000ull,0xd000000000ull,0xd000000000ull,0xd000000000ull,0xd000000000ull,
0xdf00000000ull,0xde00000000ull,0xdc00000000ull,0xdc00000000ull,0xd800000000ull,0xd800000000ull,0xd800000000ull,0xd800000000ull,
0xd000000000ull,0xd000000000ull,0xd000000000ull,0xd000000000ull,0xd000000000ull,0xd000000000ull,0xd000000000ull,0xd000000000ull,
0x5f00000000ull,0x5e00000000ull,0x5c00000000ull,0x5c00000000ull,0x5800000000ull,0x5800000000ull,0x5800000000ull,0x5800000000ull,
0x5000000000ull,0x5000000000ull,0x5000000000ull,0x5000000000ull,0x5000000000ull,0x5000000000ull,0x5000000000ull,0x5000000000ull,
0x5f00000000ull,0x5e00000000ull,0x5c00000000ull,0x5c00000000ull,0x5800000000ull,0x5800000000ull,0x5800000000ull,0x5800000000ull,
0x5000000000ull,0x5000000000ull,0x5000000000ull,0x5000000000ull,0x5000000000ull,0x5000000000ull,0x5000000000ull,0x5000000000ull
},{
0xbf00000000ull,0xbe00000000ull,0xbc00000000ull,0xbc00000000ull,0xb800000000ull,0xb800000000ull,0xb800000000ull,0xb800000000ull,
0xb000000000ull,0xb000000000ull,0xb000000000ull,0xb000000000ull,0xb000000000ull,0xb000000000ull,0xb000000000ull,0xb000000000ull,
0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,
0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,
0xbf00000000ull,0xbe00000000ull,0xbc00000000ull,0xbc00000000ull,0xb800000000ull,0xb800000000ull,0xb800000000ull,0xb800000000ull,
0xb000000000ull,0xb000000000ull,0xb000000000ull,0xb000000000ull,0xb000000000ull,0xb000000000ull,0xb000000000ull,0xb000000000ull,
0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,
0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull,0xa000000000ull
},{
0x7f00000000ull,0x7e00000000ull,0x7c00000000ull,0x7c00000000ull,0x7800000000ull,0x7800000000ull,0x7800000000ull,0x7800000000ull,
0x7000000000ull,0x7000000000ull,0x7000000000ull,0x7000000000ull,0x7000000000ull,0x7000000000ull,0x7000000000ull,0x7000000000ull,
0x6000000000ull,0x6000000000ull,0x6000000000ull,0x6000000000ull,0x6000000000ull,0x6000000000ull,0x6000000000ull,0x6000000000ull,
0x6000000000ull,0x6000000000ull,0x6000000000ull,0x6000000000ull,0x6000000000ull,0x6000000000ull,0x6000000000ull,0x6000000000ull,
0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,
0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,
0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,
0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull,0x4000000000ull
},{
0xfe0000000000ull,0x20000000000ull,0x60000000000ull,0x20000000000ull,0xe0000000000ull,0x20000000000ull,0x60000000000ull,0x20000000000ull,
0x1e0000000000ull,0x20000000000ull,0x60000000000ull,0x20000000000ull,0xe0000000000ull,0x20000000000ull,0x60000000000ull,0x20000000000ull,
0x3e0000000000ull,0x20000000000ull,0x60000000000ull,0x20000000000ull,0xe0000000000ull,0x20000000000ull,0x60000000000ull,0x20000000000ull,
0x1e0000000000ull,0x20000000000ull,0x60000000000ull,0x20000000000ull,0xe0000000000ull,0x20000000000ull,0x60000000000ull,0x20000000000ull,
0x7e0000000000ull,0x20000000000ull,0x60000000000ull,0x20000000000ull,0xe0000000000ull,0x20000000000ull,0x60000000000ull,0x20000000000ull,
0x1e0000000000ull,0x20000000000ull,0x60000000000ull,0x20000000000ull,0xe0000000000ull,0x20000000000ull,0x60000000000ull,0x20000000000ull,
0x3e0000000000ull,0x20000000000ull,0x60000000000ull,0x20000000000ull,0xe0000000000ull,0x20000000000ull,0x60000000000ull,0x20000000000ull,
0x1e0000000000ull,0x20000000000ull,0x60000000000ull,0x20000000000ull,0xe0000000000ull,0x20000000000ull,0x60000000000ull,0x20000000000ull
},{
0xfd0000000000ull,0xfd0000000000ull,0x50000000000ull,0x50000000000ull,0xd0000000000ull,0xd0000000000ull,0x50000000000ull,0x50000000000ull,
0x1d0000000000ull,0x1d0000000000ull,0x50000000000ull,0x50000000000ull,0xd0000000000ull,0xd0000000000ull,0x50000000000ull,0x50000000000ull,
0x3d0000000000ull,0x3d0000000000ull,0x50000000000ull,0x50000000000ull,0xd0000000000ull,0xd0000000000ull,0x50000000000ull,0x50000000000ull,
0x1d0000000000ull,0x1d0000000000ull,0x50000000000ull,0x50000000000ull,0xd0000000000ull,0xd0000000000ull,0x50000000000ull,0x50000000000ull,
0x7d0000000000ull,0x7d0000000000ull,0x50000000000ull,0x50000000000ull,0xd0000000000ull,0xd0000000000ull,0x50000000000ull,0x50000000000ull,
0x1d0000000000ull,0x1d0000000000ull,0x50000000000ull,0x50000000000ull,0xd0000000000ull,0xd0000000000ull,0x50000000000ull,0x50000000000ull,
0x3d0000000000ull,0x3d0000000000ull,0x50000000000ull,0x50000000000ull,0xd0000000000ull,0xd0000000000ull,0x50000000000ull,0x50000000000ull,
0x1d0000000000ull,0x1d0000000000ull,0x50000000000ull,0x50000000000ull,0xd0000000000ull,0xd0000000000ull,0x50000000000ull,0x50000000000ull
},{
0xfb0000000000ull,0xfa0000000000ull,0xfb0000000000ull,0xfa0000000000ull,0xb0000000000ull,0xa0000000000ull,0xb0000000000ull,0xa0000000000ull,
0x1b0000000000ull,0x1a0000000000ull,0x1b0000000000ull,0x1a0000000000ull,0xb0000000000ull,0xa0000000000ull,0xb0000000000ull,0xa0000000000ull,
0x3b0000000000ull,0x3a0000000000ull,0x3b0000000000ull,0x3a0000000000ull,0xb0000000000ull,0xa0000000000ull,0xb0000000000ull,0xa0000000000ull,
0x1b0000000000ull,0x1a0000000000ull,0x1b0000000000ull,0x1a0000000000ull,0xb0000000000ull,0xa0000000000ull,0xb0000000000ull,0xa0000000000ull,
0x7b0000000000ull,0x7a0000000000ull,0x7b0000000000ull,0x7a0000000000ull,0xb0000000000ull,0xa0000000000ull,0xb0000000000ull,0xa0000000000ull,
0x1b0000000000ull,0x1a0000000000ull,0x1b0000000000ull,0x1a0000000000ull,0xb0000000000ull,0xa0000000000ull,0xb0000000000ull,0xa0000000000ull,
0x3b0000000000ull,0x3a0000000000ull,0x3b0000000000ull,0x3a0000000000ull,0xb0000000000ull,0xa0000000000ull,0xb0000000000ull,0xa0000000000ull,
0x1b0000000000ull,0x1a0000000000ull,0x1b0000000000ull,0x1a0000000000ull,0xb0000000000ull,0xa0000000000ull,0xb0000000000ull,0xa0000000000ull
},{
0xf70000000000ull,0xf60000000000ull,0xf40000000000ull,0xf40000000000ull,0xf70000000000ull,0xf60000000000ull,0xf40000000000ull,0xf40000000000ull,
0x170000000000ull,0x160000000000ull,0x140000000000ull,0x140000000000ull,0x170000000000ull,0x160000000000ull,0x140000000000ull,0x140000000000ull,
0x370000000000ull,0x360000000000ull,0x340000000000ull,0x340000000000ull,0x370000000000ull,0x360000000000ull,0x340000000000ull,0x340000000000ull,
0x170000000000ull,0x160000000000ull,0x140000000000ull,0x140000000000ull,0x170000000000ull,0x160000000000ull,0x140000000000ull,0x140000000000ull,
0x770000000000ull,0x760000000000ull,0x740000000000ull,0x740000000000ull,0x770000000000ull,0x760000000000ull,0x740000000000ull,0x740000000000ull,
0x170000000000ull,0x160000000000ull,0x140000000000ull,0x140000000000ull,0x170000000000ull,0x160000000000ull,0x140000000000ull,0x140000000000ull,
0x370000000000ull,0x360000000000ull,0x340000000000ull,0x340000000000ull,0x370000000000ull,0x360000000000ull,0x340000000000ull,0x340000000000ull,
0x170000000000ull,0x160000000000ull,0x140000000000ull,0x140000000000ull,0x170000000000ull,0x160000000000ull,0x140000000000ull,0x140000000000ull
},{
0xef0000000000ull,0xee0000000000ull,0xec0000000000ull,0xec0000000000ull,0xe80000000000ull,0xe80000000000ull,0xe80000000000ull,0xe80000000000ull,
0xef0000000000ull,0xee0000000000ull,0xec0000000000ull,0xec0000000000ull,0xe80000000000ull,0xe80000000000ull,0xe80000000000ull,0xe80000000000ull,
0x2f0000000000ull,0x2e0000000000ull,0x2c0000000000ull,0x2c0000000000ull,0x280000000000ull,0x280000000000ull,0x280000000000ull,0x280000000000ull,
0x2f0000000000ull,0x2e0000000000ull,0x2c0000000000ull,0x2c0000000000ull,0x280000000000ull,0x280000000000ull,0x280000000000ull,0x280000000000ull,
0x6f0000000000ull,0x6e0000000000ull,0x6c0000000000ull,0x6c0000000000ull,0x680000000000ull,0x680000000000ull,0x680000000000ull,0x680000000000ull,
0x6f0000000000ull,0x6e0000000000ull,0x6c0000000000ull,0x6c0000000000ull,0x680000000000ull,0x680000000000ull,0x680000000000ull,0x680000000000ull,
0x2f0000000000ull,0x2e0000000000ull,0x2c0000000000ull,0x2c0000000000ull,0x280000000000ull,0x280000000000ull,0x280000000000ull,0x280000000000ull,
0x2f0000000000ull,0x2e0000000000ull,0x2c0000000000ull,0x2c0000000000ull,0x280000000000ull,0x280000000000ull,0x280000000000ull,0x280000000000ull
},{
0xdf0000000000ull,0xde0000000000ull,0xdc0000000000ull,0xdc0000000000ull,0xd80000000000ull,0xd80000000000ull,0xd80000000000ull,0xd80000000000ull,
0xd00000000000ull,0xd00000000000ull,0xd00000000000ull,0xd00000000000ull,0xd00000000000ull,0xd00000000000ull,0xd00000000000ull,0xd00000000000ull,
0xdf0000000000ull,0xde0000000000ull,0xdc0000000000ull,0xdc0000000000ull,0xd80000000000ull,0xd80000000000ull,0xd80000000000ull,0xd80000000000ull,
0xd00000000000ull,0xd00000000000ull,0xd00000000000ull,0xd00000000000ull,0xd00000000000ull,0xd00000000000ull,0xd00000000000ull,0xd00000000000ull,
0x5f0000000000ull,0x5e0000000000ull,0x5c0000000000ull,0x5c0000000000ull,0x580000000000ull,0x580000000000ull,0x580000000000ull,0x580000000000ull,
0x500000000000ull,0x500000000000ull,0x500000000000ull,0x500000000000ull,0x500000000000ull,0x500000000000ull,0x500000000000ull,0x500000000000ull,
0x5f0000000000ull,0x5e0000000000ull,0x5c0000000000ull,0x5c0000000000ull,0x580000000000ull,0x580000000000ull,0x580000000000ull,0x580000000000ull,
0x500000000000ull,0x500000000000ull,0x500000000000ull,0x500000000000ull,0x500000000000ull,0x500000000000ull,0x500000000000ull,0x500000000000ull
},{
0xbf0000000000ull,0xbe0000000000ull,0xbc0000000000ull,0xbc0000000000ull,0xb80000000000ull,0xb80000000000ull,0xb80000000000ull,0xb80000000000ull,
0xb00000000000ull,0xb00000000000ull,0xb00000000000ull,0xb00000000000ull,0xb00000000000ull,0xb00000000000ull,0xb00000000000ull,0xb00000000000ull,
0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,
0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,
0xbf0000000000ull,0xbe0000000000ull,0xbc0000000000ull,0xbc0000000000ull,0xb80000000000ull,0xb80000000000ull,0xb80000000000ull,0xb80000000000ull,
0xb00000000000ull,0xb00000000000ull,0xb00000000000ull,0xb00000000000ull,0xb00000000000ull,0xb00000000000ull,0xb00000000000ull,0xb00000000000ull,
0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,
0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull,0xa00000000000ull
},{
0x7f0000000000ull,0x7e0000000000ull,0x7c0000000000ull,0x7c0000000000ull,0x780000000000ull,0x780000000000ull,0x780000000000ull,0x780000000000ull,
0x700000000000ull,0x700000000000ull,0x700000000000ull,0x700000000000ull,0x700000000000ull,0x700000000000ull,0x700000000000ull,0x700000000000ull,
0x600000000000ull,0x600000000000ull,0x600000000000ull,0x600000000000ull,0x600000000000ull,0x600000000000ull,0x600000000000ull,0x600000000000ull,
0x600000000000ull,0x600000000000ull,0x600000000000ull,0x600000000000ull,0x600000000000ull,0x600000000000ull,0x600000000000ull,0x600000000000ull,
0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,
0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,
0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,
0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull,0x400000000000ull
},{
0xfe000000000000ull,0x2000000000000ull,0x6000000000000ull,0x2000000000000ull,0xe000000000000ull,0x2000000000000ull,0x6000000000000ull,0x2000000000000ull,
0x1e000000000000ull,0x2000000000000ull,0x6000000000000ull,0x2000000000000ull,0xe000000000000ull,0x2000000000000ull,0x6000000000000ull,0x2000000000000ull,
0x3e000000000000ull,0x2000000000000ull,0x6000000000000ull,0x2000000000000ull,0xe000000000000ull,0x2000000000000ull,0x6000000000000ull,0x2000000000000ull,
0x1e000000000000ull,0x2000000000000ull,0x6000000000000ull,0x2000000000000ull,0xe000000000000ull,0x2000000000000ull,0x6000000000000ull,0x2000000000000ull,
0x7e000000000000ull,0x2000000000000ull,0x6000000000000ull,0x2000000000000ull,0xe000000000000ull,0x2000000000000ull,0x6000000000000ull,0x2000000000000ull,
0x1e000000000000ull,0x2000000000000ull,0x6000000000000ull,0x2000000000000ull,0xe000000000000ull,0x2000000000000ull,0x6000000000000ull,0x2000000000000ull,
0x3e000000000000ull,0x2000000000000ull,0x6000000000000ull,0x2000000000000ull,0xe000000000000ull,0x2000000000000ull,0x6000000000000ull,0x2000000000000ull,
0x1e000000000000ull,0x2000000000000ull,0x6000000000000ull,0x2000000000000ull,0xe000000000000ull,0x2000000000000ull,0x6000000000000ull,0x2000000000000ull
},{
0xfd000000000000ull,0xfd000000000000ull,0x5000000000000ull,0x5000000000000ull,0xd000000000000ull,0xd000000000000ull,0x5000000000000ull,0x5000000000000ull,
0x1d000000000000ull,0x1d000000000000ull,0x5000000000000ull,0x5000000000000ull,0xd000000000000ull,0xd000000000000ull,0x5000000000000ull,0x5000000000000ull,
0x3d000000000000ull,0x3d000000000000ull,0x5000000000000ull,0x5000000000000ull,0xd000000000000ull,0xd000000000000ull,0x5000000000000ull,0x5000000000000ull,
0x1d000000000000ull,0x1d000000000000ull,0x5000000000000ull,0x5000000000000ull,0xd000000000000ull,0xd000000000000ull,0x5000000000000ull,0x5000000000000ull,
0x7d000000000000ull,0x7d000000000000ull,0x5000000000000ull,0x5000000000000ull,0xd000000000000ull,0xd000000000000ull,0x5000000000000ull,0x5000000000000ull,
0x1d000000000000ull,0x1d000000000000ull,0x5000000000000ull,0x5000000000000ull,0xd000000000000ull,0xd000000000000ull,0x5000000000000ull,0x5000000000000ull,
0x3d000000000000ull,0x3d000000000000ull,0x5000000000000ull,0x5000000000000ull,0xd000000000000ull,0xd000000000000ull,0x5000000000000ull,0x5000000000000ull,
0x1d000000000000ull,0x1d000000000000ull,0x5000000000000ull,0x5000000000000ull,0xd000000000000ull,0xd000000000000ull,0x5000000000000ull,0x5000000000000ull
},{
0xfb000000000000ull,0xfa000000000000ull,0xfb000000000000ull,0xfa000000000000ull,0xb000000000000ull,0xa000000000000ull,0xb000000000000ull,0xa000000000000ull,
0x1b000000000000ull,0x1a000000000000ull,0x1b000000000000ull,0x1a000000000000ull,0xb000000000000ull,0xa000000000000ull,0xb000000000000ull,0xa000000000000ull,
0x3b000000000000ull,0x3a000000000000ull,0x3b000000000000ull,0x3a000000000000ull,0xb000000000000ull,0xa000000000000ull,0xb000000000000ull,0xa000000000000ull,
0x1b000000000000ull,0x1a000000000000ull,0x1b000000000000ull,0x1a000000000000ull,0xb000000000000ull,0xa000000000000ull,0xb000000000000ull,0xa000000000000ull,
0x7b000000000000ull,0x7a000000000000ull,0x7b000000000000ull,0x7a000000000000ull,0xb000000000000ull,0xa000000000000ull,0xb000000000000ull,0xa000000000000ull,
0x1b000000000000ull,0x1a000000000000ull,0x1b000000000000ull,0x1a000000000000ull,0xb000000000000ull,0xa000000000000ull,0xb000000000000ull,0xa000000000000ull,
0x3b000000000000ull,0x3a000000000000ull,0x3b000000000000ull,0x3a000000000000ull,0xb000000000000ull,0xa000000000000ull,0xb000000000000ull,0xa000000000000ull,
0x1b000000000000ull,0x1a000000000000ull,0x1b000000000000ull,0x1a000000000000ull,0xb000000000000ull,0xa000000000000ull,0xb000000000000ull,0xa000000000000ull
},{
0xf7000000000000ull,0xf6000000000000ull,0xf4000000000000ull,0xf4000000000000ull,0xf7000000000000ull,0xf6000000000000ull,0xf4000000000000ull,0xf4000000000000ull,
0x17000000000000ull,0x16000000000000ull,0x14000000000000ull,0x14000000000000ull,0x17000000000000ull,0x16000000000000ull,0x14000000000000ull,0x14000000000000ull,
0x37000000000000ull,0x36000000000000ull,0x34000000000000ull,0x34000000000000ull,0x37000000000000ull,0x36000000000000ull,0x34000000000000ull,0x34000000000000ull,
0x17000000000000ull,0x16000000000000ull,0x14000000000000ull,0x14000000000000ull,0x17000000000000ull,0x16000000000000ull,0x14000000000000ull,0x14000000000000ull,
0x77000000000000ull,0x76000000000000ull,0x74000000000000ull,0x74000000000000ull,0x77000000000000ull,0x76000000000000ull,0x74000000000000ull,0x74000000000000ull,
0x17000000000000ull,0x16000000000000ull,0x14000000000000ull,0x14000000000000ull,0x17000000000000ull,0x16000000000000ull,0x14000000000000ull,0x14000000000000ull,
0x37000000000000ull,0x36000000000000ull,0x34000000000000ull,0x34000000000000ull,0x37000000000000ull,0x36000000000000ull,0x34000000000000ull,0x34000000000000ull,
0x17000000000000ull,0x16000000000000ull,0x14000000000000ull,0x14000000000000ull,0x17000000000000ull,0x16000000000000ull,0x14000000000000ull,0x14000000000000ull
},{
0xef000000000000ull,0xee000000000000ull,0xec000000000000ull,0xec000000000000ull,0xe8000000000000ull,0xe8000000000000ull,0xe8000000000000ull,0xe8000000000000ull,
0xef000000000000ull,0xee000000000000ull,0xec000000000000ull,0xec000000000000ull,0xe8000000000000ull,0xe8000000000000ull,0xe8000000000000ull,0xe8000000000000ull,
0x2f000000000000ull,0x2e000000000000ull,0x2c000000000000ull,0x2c000000000000ull,0x28000000000000ull,0x28000000000000ull,0x28000000000000ull,0x28000000000000ull,
0x2f000000000000ull,0x2e000000000000ull,0x2c000000000000ull,0x2c000000000000ull,0x28000000000000ull,0x28000000000000ull,0x28000000000000ull,0x28000000000000ull,
0x6f000000000000ull,0x6e000000000000ull,0x6c000000000000ull,0x6c000000000000ull,0x68000000000000ull,0x68000000000000ull,0x68000000000000ull,0x68000000000000ull,
0x6f000000000000ull,0x6e000000000000ull,0x6c000000000000ull,0x6c000000000000ull,0x68000000000000ull,0x68000000000000ull,0x68000000000000ull,0x68000000000000ull,
0x2f000000000000ull,0x2e000000000000ull,0x2c000000000000ull,0x2c000000000000ull,0x28000000000000ull,0x28000000000000ull,0x28000000000000ull,0x28000000000000ull,
0x2f000000000000ull,0x2e000000000000ull,0x2c000000000000ull,0x2c000000000000ull,0x28000000000000ull,0x28000000000000ull,0x28000000000000ull,0x28000000000000ull
},{
0xdf000000000000ull,0xde000000000000ull,0xdc000000000000ull,0xdc000000000000ull,0xd8000000000000ull,0xd8000000000000ull,0xd8000000000000ull,0xd8000000000000ull,
0xd0000000000000ull,0xd0000000000000ull,0xd0000000000000ull,0xd0000000000000ull,0xd0000000000000ull,0xd0000000000000ull,0xd0000000000000ull,0xd0000000000000ull,
0xdf000000000000ull,0xde000000000000ull,0xdc000000000000ull,0xdc000000000000ull,0xd8000000000000ull,0xd8000000000000ull,0xd8000000000000ull,0xd8000000000000ull,
0xd0000000000000ull,0xd0000000000000ull,0xd0000000000000ull,0xd0000000000000ull,0xd0000000000000ull,0xd0000000000000ull,0xd0000000000000ull,0xd0000000000000ull,
0x5f000000000000ull,0x5e000000000000ull,0x5c000000000000ull,0x5c000000000000ull,0x58000000000000ull,0x58000000000000ull,0x58000000000000ull,0x58000000000000ull,
0x50000000000000ull,0x50000000000000ull,0x50000000000000ull,0x50000000000000ull,0x50000000000000ull,0x50000000000000ull,0x50000000000000ull,0x50000000000000ull,
0x5f000000000000ull,0x5e000000000000ull,0x5c000000000000ull,0x5c000000000000ull,0x58000000000000ull,0x58000000000000ull,0x58000000000000ull,0x58000000000000ull,
0x50000000000000ull,0x50000000000000ull,0x50000000000000ull,0x50000000000000ull,0x50000000000000ull,0x50000000000000ull,0x50000000000000ull,0x50000000000000ull
},{
0xbf000000000000ull,0xbe000000000000ull,0xbc000000000000ull,0xbc000000000000ull,0xb8000000000000ull,0xb8000000000000ull,0xb8000000000000ull,0xb8000000000000ull,
0xb0000000000000ull,0xb0000000000000ull,0xb0000000000000ull,0xb0000000000000ull,0xb0000000000000ull,0xb0000000000000ull,0xb0000000000000ull,0xb0000000000000ull,
0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,
0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,
0xbf000000000000ull,0xbe000000000000ull,0xbc000000000000ull,0xbc000000000000ull,0xb8000000000000ull,0xb8000000000000ull,0xb8000000000000ull,0xb8000000000000ull,
0xb0000000000000ull,0xb0000000000000ull,0xb0000000000000ull,0xb0000000000000ull,0xb0000000000000ull,0xb0000000000000ull,0xb0000000000000ull,0xb0000000000000ull,
0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,
0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull,0xa0000000000000ull
},{
0x7f000000000000ull,0x7e000000000000ull,0x7c000000000000ull,0x7c000000000000ull,0x78000000000000ull,0x78000000000000ull,0x78000000000000ull,0x78000000000000ull,
0x70000000000000ull,0x70000000000000ull,0x70000000000000ull,0x70000000000000ull,0x70000000000000ull,0x70000000000000ull,0x70000000000000ull,0x70000000000000ull,
0x60000000000000ull,0x60000000000000ull,0x60000000000000ull,0x60000000000000ull,0x60000000000000ull,0x60000000000000ull,0x60000000000000ull,0x60000000000000ull,
0x60000000000000ull,0x60000000000000ull,0x60000000000000ull,0x60000000000000ull,0x60000000000000ull,0x60000000000000ull,0x60000000000000ull,0x60000000000000ull,
0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,
0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,
0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,
0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull,0x40000000000000ull
},{
0xfe00000000000000ull,0x200000000000000ull,0x600000000000000ull,0x200000000000000ull,0xe00000000000000ull,0x200000000000000ull,0x600000000000000ull,0x200000000000000ull,
0x1e00000000000000ull,0x200000000000000ull,0x600000000000000ull,0x200000000000000ull,0xe00000000000000ull,0x200000000000000ull,0x600000000000000ull,0x200000000000000ull,
0x3e00000000000000ull,0x200000000000000ull,0x600000000000000ull,0x200000000000000ull,0xe00000000000000ull,0x200000000000000ull,0x600000000000000ull,0x200000000000000ull,
0x1e00000000000000ull,0x200000000000000ull,0x600000000000000ull,0x200000000000000ull,0xe00000000000000ull,0x200000000000000ull,0x600000000000000ull,0x200000000000000ull,
0x7e00000000000000ull,0x200000000000000ull,0x600000000000000ull,0x200000000000000ull,0xe00000000000000ull,0x200000000000000ull,0x600000000000000ull,0x200000000000000ull,
0x1e00000000000000ull,0x200000000000000ull,0x600000000000000ull,0x200000000000000ull,0xe00000000000000ull,0x200000000000000ull,0x600000000000000ull,0x200000000000000ull,
0x3e00000000000000ull,0x200000000000000ull,0x600000000000000ull,0x200000000000000ull,0xe00000000000000ull,0x200000000000000ull,0x600000000000000ull,0x200000000000000ull,
0x1e00000000000000ull,0x200000000000000ull,0x600000000000000ull,0x200000000000000ull,0xe00000000000000ull,0x200000000000000ull,0x600000000000000ull,0x200000000000000ull
},{
0xfd00000000000000ull,0xfd00000000000000ull,0x500000000000000ull,0x500000000000000ull,0xd00000000000000ull,0xd00000000000000ull,0x500000000000000ull,0x500000000000000ull,
0x1d00000000000000ull,0x1d00000000000000ull,0x500000000000000ull,0x500000000000000ull,0xd00000000000000ull,0xd00000000000000ull,0x500000000000000ull,0x500000000000000ull,
0x3d00000000000000ull,0x3d00000000000000ull,0x500000000000000ull,0x500000000000000ull,0xd00000000000000ull,0xd00000000000000ull,0x500000000000000ull,0x500000000000000ull,
0x1d00000000000000ull,0x1d00000000000000ull,0x500000000000000ull,0x500000000000000ull,0xd00000000000000ull,0xd00000000000000ull,0x500000000000000ull,0x500000000000000ull,
0x7d00000000000000ull,0x7d00000000000000ull,0x500000000000000ull,0x500000000000000ull,0xd00000000000000ull,0xd00000000000000ull,0x500000000000000ull,0x500000000000000ull,
0x1d00000000000000ull,0x1d00000000000000ull,0x500000000000000ull,0x500000000000000ull,0xd00000000000000ull,0xd00000000000000ull,0x500000000000000ull,0x500000000000000ull,
0x3d00000000000000ull,0x3d00000000000000ull,0x500000000000000ull,0x500000000000000ull,0xd00000000000000ull,0xd00000000000000ull,0x500000000000000ull,0x500000000000000ull,
0x1d00000000000000ull,0x1d00000000000000ull,0x500000000000000ull,0x500000000000000ull,0xd00000000000000ull,0xd00000000000000ull,0x500000000000000ull,0x500000000000000ull
},{
0xfb00000000000000ull,0xfa00000000000000ull,0xfb00000000000000ull,0xfa00000000000000ull,0xb00000000000000ull,0xa00000000000000ull,0xb00000000000000ull,0xa00000000000000ull,
0x1b00000000000000ull,0x1a00000000000000ull,0x1b00000000000000ull,0x1a00000000000000ull,0xb00000000000000ull,0xa00000000000000ull,0xb00000000000000ull,0xa00000000000000ull,
0x3b00000000000000ull,0x3a00000000000000ull,0x3b00000000000000ull,0x3a00000000000000ull,0xb00000000000000ull,0xa00000000000000ull,0xb00000000000000ull,0xa00000000000000ull,
0x1b00000000000000ull,0x1a00000000000000ull,0x1b00000000000000ull,0x1a00000000000000ull,0xb00000000000000ull,0xa00000000000000ull,0xb00000000000000ull,0xa00000000000000ull,
0x7b00000000000000ull,0x7a00000000000000ull,0x7b00000000000000ull,0x7a00000000000000ull,0xb00000000000000ull,0xa00000000000000ull,0xb00000000000000ull,0xa00000000000000ull,
0x1b00000000000000ull,0x1a00000000000000ull,0x1b00000000000000ull,0x1a00000000000000ull,0xb00000000000000ull,0xa00000000000000ull,0xb00000000000000ull,0xa00000000000000ull,
0x3b00000000000000ull,0x3a00000000000000ull,0x3b00000000000000ull,0x3a00000000000000ull,0xb00000000000000ull,0xa00000000000000ull,0xb00000000000000ull,0xa00000000000000ull,
0x1b00000000000000ull,0x1a00000000000000ull,0x1b00000000000000ull,0x1a00000000000000ull,0xb00000000000000ull,0xa00000000000000ull,0xb00000000000000ull,0xa00000000000000ull
},{
0xf700000000000000ull,0xf600000000000000ull,0xf400000000000000ull,0xf400000000000000ull,0xf700000000000000ull,0xf600000000000000ull,0xf400000000000000ull,0xf400000000000000ull,
0x1700000000000000ull,0x1600000000000000ull,0x1400000000000000ull,0x1400000000000000ull,0x1700000000000000ull,0x1600000000000000ull,0x1400000000000000ull,0x1400000000000000ull,
0x3700000000000000ull,0x3600000000000000ull,0x3400000000000000ull,0x3400000000000000ull,0x3700000000000000ull,0x3600000000000000ull,0x3400000000000000ull,0x3400000000000000ull,
0x1700000000000000ull,0x1600000000000000ull,0x1400000000000000ull,0x1400000000000000ull,0x1700000000000000ull,0x1600000000000000ull,0x1400000000000000ull,0x1400000000000000ull,
0x7700000000000000ull,0x7600000000000000ull,0x7400000000000000ull,0x7400000000000000ull,0x7700000000000000ull,0x7600000000000000ull,0x7400000000000000ull,0x7400000000000000ull,
0x1700000000000000ull,0x1600000000000000ull,0x1400000000000000ull,0x1400000000000000ull,0x1700000000000000ull,0x1600000000000000ull,0x1400000000000000ull,0x1400000000000000ull,
0x3700000000000000ull,0x3600000000000000ull,0x3400000000000000ull,0x3400000000000000ull,0x3700000000000000ull,0x3600000000000000ull,0x3400000000000000ull,0x3400000000000000ull,
0x1700000000000000ull,0x1600000000000000ull,0x1400000000000000ull,0x1400000000000000ull,0x1700000000000000ull,0x1600000000000000ull,0x1400000000000000ull,0x1400000000000000ull
},{
0xef00000000000000ull,0xee00000000000000ull,0xec00000000000000ull,0xec00000000000000ull,0xe800000000000000ull,0xe800000000000000ull,0xe800000000000000ull,0xe800000000000000ull,
0xef00000000000000ull,0xee00000000000000ull,0xec00000000000000ull,0xec00000000000000ull,0xe800000000000000ull,0xe800000000000000ull,0xe800000000000000ull,0xe800000000000000ull,
0x2f00000000000000ull,0x2e00000000000000ull,0x2c00000000000000ull,0x2c00000000000000ull,0x2800000000000000ull,0x2800000000000000ull,0x2800000000000000ull,0x2800000000000000ull,
0x2f00000000000000ull,0x2e00000000000000ull,0x2c00000000000000ull,0x2c00000000000000ull,0x2800000000000000ull,0x2800000000000000ull,0x2800000000000000ull,0x2800000000000000ull,
0x6f00000000000000ull,0x6e00000000000000ull,0x6c00000000000000ull,0x6c00000000000000ull,0x6800000000000000ull,0x6800000000000000ull,0x6800000000000000ull,0x6800000000000000ull,
0x6f00000000000000ull,0x6e00000000000000ull,0x6c00000000000000ull,0x6c00000000000000ull,0x6800000000000000ull,0x6800000000000000ull,0x6800000000000000ull,0x6800000000000000ull,
0x2f00000000000000ull,0x2e00000000000000ull,0x2c00000000000000ull,0x2c00000000000000ull,0x2800000000000000ull,0x2800000000000000ull,0x2800000000000000ull,0x2800000000000000ull,
0x2f00000000000000ull,0x2e00000000000000ull,0x2c00000000000000ull,0x2c00000000000000ull,0x2800000000000000ull,0x2800000000000000ull,0x2800000000000000ull,0x2800000000000000ull
},{
0xdf00000000000000ull,0xde00000000000000ull,0xdc00000000000000ull,0xdc00000000000000ull,0xd800000000000000ull,0xd800000000000000ull,0xd800000000000000ull,0xd800000000000000ull,
0xd000000000000000ull,0xd000000000000000ull,0xd000000000000000ull,0xd000000000000000ull,0xd000000000000000ull,0xd000000000000000ull,0xd000000000000000ull,0xd000000000000000ull,
0xdf00000000000000ull,0xde00000000000000ull,0xdc00000000000000ull,0xdc00000000000000ull,0xd800000000000000ull,0xd800000000000000ull,0xd800000000000000ull,0xd800000000000000ull,
0xd000000000000000ull,0xd000000000000000ull,0xd000000000000000ull,0xd000000000000000ull,0xd000000000000000ull,0xd000000000000000ull,0xd000000000000000ull,0xd000000000000000ull,
0x5f00000000000000ull,0x5e00000000000000ull,0x5c00000000000000ull,0x5c00000000000000ull,0x5800000000000000ull,0x5800000000000000ull,0x5800000000000000ull,0x5800000000000000ull,
0x5000000000000000ull,0x5000000000000000ull,0x5000000000000000ull,0x5000000000000000ull,0x5000000000000000ull,0x5000000000000000ull,0x5000000000000000ull,0x5000000000000000ull,
0x5f00000000000000ull,0x5e00000000000000ull,0x5c00000000000000ull,0x5c00000000000000ull,0x5800000000000000ull,0x5800000000000000ull,0x5800000000000000ull,0x5800000000000000ull,
0x5000000000000000ull,0x5000000000000000ull,0x5000000000000000ull,0x5000000000000000ull,0x5000000000000000ull,0x5000000000000000ull,0x5000000000000000ull,0x5000000000000000ull
},{
0xbf00000000000000ull,0xbe00000000000000ull,0xbc00000000000000ull,0xbc00000000000000ull,0xb800000000000000ull,0xb800000000000000ull,0xb800000000000000ull,0xb800000000000000ull,
0xb000000000000000ull,0xb000000000000000ull,0xb000000000000000ull,0xb000000000000000ull,0xb000000000000000ull,0xb000000000000000ull,0xb000000000000000ull,0xb000000000000000ull,
0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,
0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,
0xbf00000000000000ull,0xbe00000000000000ull,0xbc00000000000000ull,0xbc00000000000000ull,0xb800000000000000ull,0xb800000000000000ull,0xb800000000000000ull,0xb800000000000000ull,
0xb000000000000000ull,0xb000000000000000ull,0xb000000000000000ull,0xb000000000000000ull,0xb000000000000000ull,0xb000000000000000ull,0xb000000000000000ull,0xb000000000000000ull,
0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,
0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull,0xa000000000000000ull
},{
0x7f00000000000000ull,0x7e00000000000000ull,0x7c00000000000000ull,0x7c00000000000000ull,0x7800000000000000ull,0x7800000000000000ull,0x7800000000000000ull,0x7800000000000000ull,
0x7000000000000000ull,0x7000000000000000ull,0x7000000000000000ull,0x7000000000000000ull,0x7000000000000000ull,0x7000000000000000ull,0x7000000000000000ull,0x7000000000000000ull,
0x6000000000000000ull,0x6000000000000000ull,0x6000000000000000ull,0x6000000000000000ull,0x6000000000000000ull,0x6000000000000000ull,0x6000000000000000ull,0x6000000000000000ull,
0x6000000000000000ull,0x6000000000000000ull,0x6000000000000000ull,0x6000000000000000ull,0x6000000000000000ull,0x6000000000000000ull,0x6000000000000000ull,0x6000000000000000ull,
0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,
0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,
0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,
0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull,0x4000000000000000ull
}};

 uint32 DISTANCIA[64][64] = {
{
0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0x1,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0x2,0x2,0x2,0x3,0x4,0x5,0x6,0x7,
0x3,0x3,0x3,0x3,0x4,0x5,0x6,0x7,
0x4,0x4,0x4,0x4,0x4,0x5,0x6,0x7,
0x5,0x5,0x5,0x5,0x5,0x5,0x6,0x7,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x7,
0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7
},{
0x1,0,0x1,0x2,0x3,0x4,0x5,0x6,
0x1,0x1,0x1,0x2,0x3,0x4,0x5,0x6,
0x2,0x2,0x2,0x2,0x3,0x4,0x5,0x6,
0x3,0x3,0x3,0x3,0x3,0x4,0x5,0x6,
0x4,0x4,0x4,0x4,0x4,0x4,0x5,0x6,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x6,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7
},{
0x2,0x1,0,0x1,0x2,0x3,0x4,0x5,
0x2,0x1,0x1,0x1,0x2,0x3,0x4,0x5,
0x2,0x2,0x2,0x2,0x2,0x3,0x4,0x5,
0x3,0x3,0x3,0x3,0x3,0x3,0x4,0x5,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x5,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7
},{
0x3,0x2,0x1,0,0x1,0x2,0x3,0x4,
0x3,0x2,0x1,0x1,0x1,0x2,0x3,0x4,
0x3,0x2,0x2,0x2,0x2,0x2,0x3,0x4,
0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x4,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7
},{
0x4,0x3,0x2,0x1,0,0x1,0x2,0x3,
0x4,0x3,0x2,0x1,0x1,0x1,0x2,0x3,
0x4,0x3,0x2,0x2,0x2,0x2,0x2,0x3,
0x4,0x3,0x3,0x3,0x3,0x3,0x3,0x3,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7
},{
0x5,0x4,0x3,0x2,0x1,0,0x1,0x2,
0x5,0x4,0x3,0x2,0x1,0x1,0x1,0x2,
0x5,0x4,0x3,0x2,0x2,0x2,0x2,0x2,
0x5,0x4,0x3,0x3,0x3,0x3,0x3,0x3,
0x5,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7
},{
0x6,0x5,0x4,0x3,0x2,0x1,0,0x1,
0x6,0x5,0x4,0x3,0x2,0x1,0x1,0x1,
0x6,0x5,0x4,0x3,0x2,0x2,0x2,0x2,
0x6,0x5,0x4,0x3,0x3,0x3,0x3,0x3,
0x6,0x5,0x4,0x4,0x4,0x4,0x4,0x4,
0x6,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7
},{
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x1,
0x7,0x6,0x5,0x4,0x3,0x2,0x2,0x2,
0x7,0x6,0x5,0x4,0x3,0x3,0x3,0x3,
0x7,0x6,0x5,0x4,0x4,0x4,0x4,0x4,
0x7,0x6,0x5,0x5,0x5,0x5,0x5,0x5,
0x7,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7
},{
0x1,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0x1,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0x2,0x2,0x2,0x3,0x4,0x5,0x6,0x7,
0x3,0x3,0x3,0x3,0x4,0x5,0x6,0x7,
0x4,0x4,0x4,0x4,0x4,0x5,0x6,0x7,
0x5,0x5,0x5,0x5,0x5,0x5,0x6,0x7,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x7
},{
0x1,0x1,0x1,0x2,0x3,0x4,0x5,0x6,
0x1,0,0x1,0x2,0x3,0x4,0x5,0x6,
0x1,0x1,0x1,0x2,0x3,0x4,0x5,0x6,
0x2,0x2,0x2,0x2,0x3,0x4,0x5,0x6,
0x3,0x3,0x3,0x3,0x3,0x4,0x5,0x6,
0x4,0x4,0x4,0x4,0x4,0x4,0x5,0x6,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x6,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6
},{
0x2,0x1,0x1,0x1,0x2,0x3,0x4,0x5,
0x2,0x1,0,0x1,0x2,0x3,0x4,0x5,
0x2,0x1,0x1,0x1,0x2,0x3,0x4,0x5,
0x2,0x2,0x2,0x2,0x2,0x3,0x4,0x5,
0x3,0x3,0x3,0x3,0x3,0x3,0x4,0x5,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x5,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6
},{
0x3,0x2,0x1,0x1,0x1,0x2,0x3,0x4,
0x3,0x2,0x1,0,0x1,0x2,0x3,0x4,
0x3,0x2,0x1,0x1,0x1,0x2,0x3,0x4,
0x3,0x2,0x2,0x2,0x2,0x2,0x3,0x4,
0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x4,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6
},{
0x4,0x3,0x2,0x1,0x1,0x1,0x2,0x3,
0x4,0x3,0x2,0x1,0,0x1,0x2,0x3,
0x4,0x3,0x2,0x1,0x1,0x1,0x2,0x3,
0x4,0x3,0x2,0x2,0x2,0x2,0x2,0x3,
0x4,0x3,0x3,0x3,0x3,0x3,0x3,0x3,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6
},{
0x5,0x4,0x3,0x2,0x1,0x1,0x1,0x2,
0x5,0x4,0x3,0x2,0x1,0,0x1,0x2,
0x5,0x4,0x3,0x2,0x1,0x1,0x1,0x2,
0x5,0x4,0x3,0x2,0x2,0x2,0x2,0x2,
0x5,0x4,0x3,0x3,0x3,0x3,0x3,0x3,
0x5,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6
},{
0x6,0x5,0x4,0x3,0x2,0x1,0x1,0x1,
0x6,0x5,0x4,0x3,0x2,0x1,0,0x1,
0x6,0x5,0x4,0x3,0x2,0x1,0x1,0x1,
0x6,0x5,0x4,0x3,0x2,0x2,0x2,0x2,
0x6,0x5,0x4,0x3,0x3,0x3,0x3,0x3,
0x6,0x5,0x4,0x4,0x4,0x4,0x4,0x4,
0x6,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6
},{
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x1,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x1,
0x7,0x6,0x5,0x4,0x3,0x2,0x2,0x2,
0x7,0x6,0x5,0x4,0x3,0x3,0x3,0x3,
0x7,0x6,0x5,0x4,0x4,0x4,0x4,0x4,
0x7,0x6,0x5,0x5,0x5,0x5,0x5,0x5,
0x7,0x6,0x6,0x6,0x6,0x6,0x6,0x6
},{
0x2,0x2,0x2,0x3,0x4,0x5,0x6,0x7,
0x1,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0x1,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0x2,0x2,0x2,0x3,0x4,0x5,0x6,0x7,
0x3,0x3,0x3,0x3,0x4,0x5,0x6,0x7,
0x4,0x4,0x4,0x4,0x4,0x5,0x6,0x7,
0x5,0x5,0x5,0x5,0x5,0x5,0x6,0x7
},{
0x2,0x2,0x2,0x2,0x3,0x4,0x5,0x6,
0x1,0x1,0x1,0x2,0x3,0x4,0x5,0x6,
0x1,0,0x1,0x2,0x3,0x4,0x5,0x6,
0x1,0x1,0x1,0x2,0x3,0x4,0x5,0x6,
0x2,0x2,0x2,0x2,0x3,0x4,0x5,0x6,
0x3,0x3,0x3,0x3,0x3,0x4,0x5,0x6,
0x4,0x4,0x4,0x4,0x4,0x4,0x5,0x6,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x6
},{
0x2,0x2,0x2,0x2,0x2,0x3,0x4,0x5,
0x2,0x1,0x1,0x1,0x2,0x3,0x4,0x5,
0x2,0x1,0,0x1,0x2,0x3,0x4,0x5,
0x2,0x1,0x1,0x1,0x2,0x3,0x4,0x5,
0x2,0x2,0x2,0x2,0x2,0x3,0x4,0x5,
0x3,0x3,0x3,0x3,0x3,0x3,0x4,0x5,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x5,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5
},{
0x3,0x2,0x2,0x2,0x2,0x2,0x3,0x4,
0x3,0x2,0x1,0x1,0x1,0x2,0x3,0x4,
0x3,0x2,0x1,0,0x1,0x2,0x3,0x4,
0x3,0x2,0x1,0x1,0x1,0x2,0x3,0x4,
0x3,0x2,0x2,0x2,0x2,0x2,0x3,0x4,
0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x4,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5
},{
0x4,0x3,0x2,0x2,0x2,0x2,0x2,0x3,
0x4,0x3,0x2,0x1,0x1,0x1,0x2,0x3,
0x4,0x3,0x2,0x1,0,0x1,0x2,0x3,
0x4,0x3,0x2,0x1,0x1,0x1,0x2,0x3,
0x4,0x3,0x2,0x2,0x2,0x2,0x2,0x3,
0x4,0x3,0x3,0x3,0x3,0x3,0x3,0x3,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5
},{
0x5,0x4,0x3,0x2,0x2,0x2,0x2,0x2,
0x5,0x4,0x3,0x2,0x1,0x1,0x1,0x2,
0x5,0x4,0x3,0x2,0x1,0,0x1,0x2,
0x5,0x4,0x3,0x2,0x1,0x1,0x1,0x2,
0x5,0x4,0x3,0x2,0x2,0x2,0x2,0x2,
0x5,0x4,0x3,0x3,0x3,0x3,0x3,0x3,
0x5,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5
},{
0x6,0x5,0x4,0x3,0x2,0x2,0x2,0x2,
0x6,0x5,0x4,0x3,0x2,0x1,0x1,0x1,
0x6,0x5,0x4,0x3,0x2,0x1,0,0x1,
0x6,0x5,0x4,0x3,0x2,0x1,0x1,0x1,
0x6,0x5,0x4,0x3,0x2,0x2,0x2,0x2,
0x6,0x5,0x4,0x3,0x3,0x3,0x3,0x3,
0x6,0x5,0x4,0x4,0x4,0x4,0x4,0x4,
0x6,0x5,0x5,0x5,0x5,0x5,0x5,0x5
},{
0x7,0x6,0x5,0x4,0x3,0x2,0x2,0x2,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x1,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x1,
0x7,0x6,0x5,0x4,0x3,0x2,0x2,0x2,
0x7,0x6,0x5,0x4,0x3,0x3,0x3,0x3,
0x7,0x6,0x5,0x4,0x4,0x4,0x4,0x4,
0x7,0x6,0x5,0x5,0x5,0x5,0x5,0x5
},{
0x3,0x3,0x3,0x3,0x4,0x5,0x6,0x7,
0x2,0x2,0x2,0x3,0x4,0x5,0x6,0x7,
0x1,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0x1,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0x2,0x2,0x2,0x3,0x4,0x5,0x6,0x7,
0x3,0x3,0x3,0x3,0x4,0x5,0x6,0x7,
0x4,0x4,0x4,0x4,0x4,0x5,0x6,0x7
},{
0x3,0x3,0x3,0x3,0x3,0x4,0x5,0x6,
0x2,0x2,0x2,0x2,0x3,0x4,0x5,0x6,
0x1,0x1,0x1,0x2,0x3,0x4,0x5,0x6,
0x1,0,0x1,0x2,0x3,0x4,0x5,0x6,
0x1,0x1,0x1,0x2,0x3,0x4,0x5,0x6,
0x2,0x2,0x2,0x2,0x3,0x4,0x5,0x6,
0x3,0x3,0x3,0x3,0x3,0x4,0x5,0x6,
0x4,0x4,0x4,0x4,0x4,0x4,0x5,0x6
},{
0x3,0x3,0x3,0x3,0x3,0x3,0x4,0x5,
0x2,0x2,0x2,0x2,0x2,0x3,0x4,0x5,
0x2,0x1,0x1,0x1,0x2,0x3,0x4,0x5,
0x2,0x1,0,0x1,0x2,0x3,0x4,0x5,
0x2,0x1,0x1,0x1,0x2,0x3,0x4,0x5,
0x2,0x2,0x2,0x2,0x2,0x3,0x4,0x5,
0x3,0x3,0x3,0x3,0x3,0x3,0x4,0x5,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x5
},{
0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x4,
0x3,0x2,0x2,0x2,0x2,0x2,0x3,0x4,
0x3,0x2,0x1,0x1,0x1,0x2,0x3,0x4,
0x3,0x2,0x1,0,0x1,0x2,0x3,0x4,
0x3,0x2,0x1,0x1,0x1,0x2,0x3,0x4,
0x3,0x2,0x2,0x2,0x2,0x2,0x3,0x4,
0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x4,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x4
},{
0x4,0x3,0x3,0x3,0x3,0x3,0x3,0x3,
0x4,0x3,0x2,0x2,0x2,0x2,0x2,0x3,
0x4,0x3,0x2,0x1,0x1,0x1,0x2,0x3,
0x4,0x3,0x2,0x1,0,0x1,0x2,0x3,
0x4,0x3,0x2,0x1,0x1,0x1,0x2,0x3,
0x4,0x3,0x2,0x2,0x2,0x2,0x2,0x3,
0x4,0x3,0x3,0x3,0x3,0x3,0x3,0x3,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x4
},{
0x5,0x4,0x3,0x3,0x3,0x3,0x3,0x3,
0x5,0x4,0x3,0x2,0x2,0x2,0x2,0x2,
0x5,0x4,0x3,0x2,0x1,0x1,0x1,0x2,
0x5,0x4,0x3,0x2,0x1,0,0x1,0x2,
0x5,0x4,0x3,0x2,0x1,0x1,0x1,0x2,
0x5,0x4,0x3,0x2,0x2,0x2,0x2,0x2,
0x5,0x4,0x3,0x3,0x3,0x3,0x3,0x3,
0x5,0x4,0x4,0x4,0x4,0x4,0x4,0x4
},{
0x6,0x5,0x4,0x3,0x3,0x3,0x3,0x3,
0x6,0x5,0x4,0x3,0x2,0x2,0x2,0x2,
0x6,0x5,0x4,0x3,0x2,0x1,0x1,0x1,
0x6,0x5,0x4,0x3,0x2,0x1,0,0x1,
0x6,0x5,0x4,0x3,0x2,0x1,0x1,0x1,
0x6,0x5,0x4,0x3,0x2,0x2,0x2,0x2,
0x6,0x5,0x4,0x3,0x3,0x3,0x3,0x3,
0x6,0x5,0x4,0x4,0x4,0x4,0x4,0x4
},{
0x7,0x6,0x5,0x4,0x3,0x3,0x3,0x3,
0x7,0x6,0x5,0x4,0x3,0x2,0x2,0x2,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x1,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x1,
0x7,0x6,0x5,0x4,0x3,0x2,0x2,0x2,
0x7,0x6,0x5,0x4,0x3,0x3,0x3,0x3,
0x7,0x6,0x5,0x4,0x4,0x4,0x4,0x4
},{
0x4,0x4,0x4,0x4,0x4,0x5,0x6,0x7,
0x3,0x3,0x3,0x3,0x4,0x5,0x6,0x7,
0x2,0x2,0x2,0x3,0x4,0x5,0x6,0x7,
0x1,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0x1,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0x2,0x2,0x2,0x3,0x4,0x5,0x6,0x7,
0x3,0x3,0x3,0x3,0x4,0x5,0x6,0x7
},{
0x4,0x4,0x4,0x4,0x4,0x4,0x5,0x6,
0x3,0x3,0x3,0x3,0x3,0x4,0x5,0x6,
0x2,0x2,0x2,0x2,0x3,0x4,0x5,0x6,
0x1,0x1,0x1,0x2,0x3,0x4,0x5,0x6,
0x1,0,0x1,0x2,0x3,0x4,0x5,0x6,
0x1,0x1,0x1,0x2,0x3,0x4,0x5,0x6,
0x2,0x2,0x2,0x2,0x3,0x4,0x5,0x6,
0x3,0x3,0x3,0x3,0x3,0x4,0x5,0x6
},{
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x5,
0x3,0x3,0x3,0x3,0x3,0x3,0x4,0x5,
0x2,0x2,0x2,0x2,0x2,0x3,0x4,0x5,
0x2,0x1,0x1,0x1,0x2,0x3,0x4,0x5,
0x2,0x1,0,0x1,0x2,0x3,0x4,0x5,
0x2,0x1,0x1,0x1,0x2,0x3,0x4,0x5,
0x2,0x2,0x2,0x2,0x2,0x3,0x4,0x5,
0x3,0x3,0x3,0x3,0x3,0x3,0x4,0x5
},{
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x4,
0x3,0x2,0x2,0x2,0x2,0x2,0x3,0x4,
0x3,0x2,0x1,0x1,0x1,0x2,0x3,0x4,
0x3,0x2,0x1,0,0x1,0x2,0x3,0x4,
0x3,0x2,0x1,0x1,0x1,0x2,0x3,0x4,
0x3,0x2,0x2,0x2,0x2,0x2,0x3,0x4,
0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x4
},{
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x4,0x3,0x3,0x3,0x3,0x3,0x3,0x3,
0x4,0x3,0x2,0x2,0x2,0x2,0x2,0x3,
0x4,0x3,0x2,0x1,0x1,0x1,0x2,0x3,
0x4,0x3,0x2,0x1,0,0x1,0x2,0x3,
0x4,0x3,0x2,0x1,0x1,0x1,0x2,0x3,
0x4,0x3,0x2,0x2,0x2,0x2,0x2,0x3,
0x4,0x3,0x3,0x3,0x3,0x3,0x3,0x3
},{
0x5,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x5,0x4,0x3,0x3,0x3,0x3,0x3,0x3,
0x5,0x4,0x3,0x2,0x2,0x2,0x2,0x2,
0x5,0x4,0x3,0x2,0x1,0x1,0x1,0x2,
0x5,0x4,0x3,0x2,0x1,0,0x1,0x2,
0x5,0x4,0x3,0x2,0x1,0x1,0x1,0x2,
0x5,0x4,0x3,0x2,0x2,0x2,0x2,0x2,
0x5,0x4,0x3,0x3,0x3,0x3,0x3,0x3
},{
0x6,0x5,0x4,0x4,0x4,0x4,0x4,0x4,
0x6,0x5,0x4,0x3,0x3,0x3,0x3,0x3,
0x6,0x5,0x4,0x3,0x2,0x2,0x2,0x2,
0x6,0x5,0x4,0x3,0x2,0x1,0x1,0x1,
0x6,0x5,0x4,0x3,0x2,0x1,0,0x1,
0x6,0x5,0x4,0x3,0x2,0x1,0x1,0x1,
0x6,0x5,0x4,0x3,0x2,0x2,0x2,0x2,
0x6,0x5,0x4,0x3,0x3,0x3,0x3,0x3
},{
0x7,0x6,0x5,0x4,0x4,0x4,0x4,0x4,
0x7,0x6,0x5,0x4,0x3,0x3,0x3,0x3,
0x7,0x6,0x5,0x4,0x3,0x2,0x2,0x2,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x1,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x1,
0x7,0x6,0x5,0x4,0x3,0x2,0x2,0x2,
0x7,0x6,0x5,0x4,0x3,0x3,0x3,0x3
},{
0x5,0x5,0x5,0x5,0x5,0x5,0x6,0x7,
0x4,0x4,0x4,0x4,0x4,0x5,0x6,0x7,
0x3,0x3,0x3,0x3,0x4,0x5,0x6,0x7,
0x2,0x2,0x2,0x3,0x4,0x5,0x6,0x7,
0x1,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0x1,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0x2,0x2,0x2,0x3,0x4,0x5,0x6,0x7
},{
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x6,
0x4,0x4,0x4,0x4,0x4,0x4,0x5,0x6,
0x3,0x3,0x3,0x3,0x3,0x4,0x5,0x6,
0x2,0x2,0x2,0x2,0x3,0x4,0x5,0x6,
0x1,0x1,0x1,0x2,0x3,0x4,0x5,0x6,
0x1,0,0x1,0x2,0x3,0x4,0x5,0x6,
0x1,0x1,0x1,0x2,0x3,0x4,0x5,0x6,
0x2,0x2,0x2,0x2,0x3,0x4,0x5,0x6
},{
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x5,
0x3,0x3,0x3,0x3,0x3,0x3,0x4,0x5,
0x2,0x2,0x2,0x2,0x2,0x3,0x4,0x5,
0x2,0x1,0x1,0x1,0x2,0x3,0x4,0x5,
0x2,0x1,0,0x1,0x2,0x3,0x4,0x5,
0x2,0x1,0x1,0x1,0x2,0x3,0x4,0x5,
0x2,0x2,0x2,0x2,0x2,0x3,0x4,0x5
},{
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x4,
0x3,0x2,0x2,0x2,0x2,0x2,0x3,0x4,
0x3,0x2,0x1,0x1,0x1,0x2,0x3,0x4,
0x3,0x2,0x1,0,0x1,0x2,0x3,0x4,
0x3,0x2,0x1,0x1,0x1,0x2,0x3,0x4,
0x3,0x2,0x2,0x2,0x2,0x2,0x3,0x4
},{
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x4,0x3,0x3,0x3,0x3,0x3,0x3,0x3,
0x4,0x3,0x2,0x2,0x2,0x2,0x2,0x3,
0x4,0x3,0x2,0x1,0x1,0x1,0x2,0x3,
0x4,0x3,0x2,0x1,0,0x1,0x2,0x3,
0x4,0x3,0x2,0x1,0x1,0x1,0x2,0x3,
0x4,0x3,0x2,0x2,0x2,0x2,0x2,0x3
},{
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x5,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x5,0x4,0x3,0x3,0x3,0x3,0x3,0x3,
0x5,0x4,0x3,0x2,0x2,0x2,0x2,0x2,
0x5,0x4,0x3,0x2,0x1,0x1,0x1,0x2,
0x5,0x4,0x3,0x2,0x1,0,0x1,0x2,
0x5,0x4,0x3,0x2,0x1,0x1,0x1,0x2,
0x5,0x4,0x3,0x2,0x2,0x2,0x2,0x2
},{
0x6,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x6,0x5,0x4,0x4,0x4,0x4,0x4,0x4,
0x6,0x5,0x4,0x3,0x3,0x3,0x3,0x3,
0x6,0x5,0x4,0x3,0x2,0x2,0x2,0x2,
0x6,0x5,0x4,0x3,0x2,0x1,0x1,0x1,
0x6,0x5,0x4,0x3,0x2,0x1,0,0x1,
0x6,0x5,0x4,0x3,0x2,0x1,0x1,0x1,
0x6,0x5,0x4,0x3,0x2,0x2,0x2,0x2
},{
0x7,0x6,0x5,0x5,0x5,0x5,0x5,0x5,
0x7,0x6,0x5,0x4,0x4,0x4,0x4,0x4,
0x7,0x6,0x5,0x4,0x3,0x3,0x3,0x3,
0x7,0x6,0x5,0x4,0x3,0x2,0x2,0x2,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x1,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x1,
0x7,0x6,0x5,0x4,0x3,0x2,0x2,0x2
},{
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x7,
0x5,0x5,0x5,0x5,0x5,0x5,0x6,0x7,
0x4,0x4,0x4,0x4,0x4,0x5,0x6,0x7,
0x3,0x3,0x3,0x3,0x4,0x5,0x6,0x7,
0x2,0x2,0x2,0x3,0x4,0x5,0x6,0x7,
0x1,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0x1,0x1,0x2,0x3,0x4,0x5,0x6,0x7
},{
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x6,
0x4,0x4,0x4,0x4,0x4,0x4,0x5,0x6,
0x3,0x3,0x3,0x3,0x3,0x4,0x5,0x6,
0x2,0x2,0x2,0x2,0x3,0x4,0x5,0x6,
0x1,0x1,0x1,0x2,0x3,0x4,0x5,0x6,
0x1,0,0x1,0x2,0x3,0x4,0x5,0x6,
0x1,0x1,0x1,0x2,0x3,0x4,0x5,0x6
},{
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x5,
0x3,0x3,0x3,0x3,0x3,0x3,0x4,0x5,
0x2,0x2,0x2,0x2,0x2,0x3,0x4,0x5,
0x2,0x1,0x1,0x1,0x2,0x3,0x4,0x5,
0x2,0x1,0,0x1,0x2,0x3,0x4,0x5,
0x2,0x1,0x1,0x1,0x2,0x3,0x4,0x5
},{
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x4,
0x3,0x2,0x2,0x2,0x2,0x2,0x3,0x4,
0x3,0x2,0x1,0x1,0x1,0x2,0x3,0x4,
0x3,0x2,0x1,0,0x1,0x2,0x3,0x4,
0x3,0x2,0x1,0x1,0x1,0x2,0x3,0x4
},{
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x4,0x3,0x3,0x3,0x3,0x3,0x3,0x3,
0x4,0x3,0x2,0x2,0x2,0x2,0x2,0x3,
0x4,0x3,0x2,0x1,0x1,0x1,0x2,0x3,
0x4,0x3,0x2,0x1,0,0x1,0x2,0x3,
0x4,0x3,0x2,0x1,0x1,0x1,0x2,0x3
},{
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x5,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x5,0x4,0x3,0x3,0x3,0x3,0x3,0x3,
0x5,0x4,0x3,0x2,0x2,0x2,0x2,0x2,
0x5,0x4,0x3,0x2,0x1,0x1,0x1,0x2,
0x5,0x4,0x3,0x2,0x1,0,0x1,0x2,
0x5,0x4,0x3,0x2,0x1,0x1,0x1,0x2
},{
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x6,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x6,0x5,0x4,0x4,0x4,0x4,0x4,0x4,
0x6,0x5,0x4,0x3,0x3,0x3,0x3,0x3,
0x6,0x5,0x4,0x3,0x2,0x2,0x2,0x2,
0x6,0x5,0x4,0x3,0x2,0x1,0x1,0x1,
0x6,0x5,0x4,0x3,0x2,0x1,0,0x1,
0x6,0x5,0x4,0x3,0x2,0x1,0x1,0x1
},{
0x7,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x7,0x6,0x5,0x5,0x5,0x5,0x5,0x5,
0x7,0x6,0x5,0x4,0x4,0x4,0x4,0x4,
0x7,0x6,0x5,0x4,0x3,0x3,0x3,0x3,
0x7,0x6,0x5,0x4,0x3,0x2,0x2,0x2,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x1,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x1
},{
0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x7,
0x5,0x5,0x5,0x5,0x5,0x5,0x6,0x7,
0x4,0x4,0x4,0x4,0x4,0x5,0x6,0x7,
0x3,0x3,0x3,0x3,0x4,0x5,0x6,0x7,
0x2,0x2,0x2,0x3,0x4,0x5,0x6,0x7,
0x1,0x1,0x2,0x3,0x4,0x5,0x6,0x7,
0,0x1,0x2,0x3,0x4,0x5,0x6,0x7
},{
0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x6,
0x4,0x4,0x4,0x4,0x4,0x4,0x5,0x6,
0x3,0x3,0x3,0x3,0x3,0x4,0x5,0x6,
0x2,0x2,0x2,0x2,0x3,0x4,0x5,0x6,
0x1,0x1,0x1,0x2,0x3,0x4,0x5,0x6,
0x1,0,0x1,0x2,0x3,0x4,0x5,0x6
},{
0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x5,
0x3,0x3,0x3,0x3,0x3,0x3,0x4,0x5,
0x2,0x2,0x2,0x2,0x2,0x3,0x4,0x5,
0x2,0x1,0x1,0x1,0x2,0x3,0x4,0x5,
0x2,0x1,0,0x1,0x2,0x3,0x4,0x5
},{
0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x4,
0x3,0x2,0x2,0x2,0x2,0x2,0x3,0x4,
0x3,0x2,0x1,0x1,0x1,0x2,0x3,0x4,
0x3,0x2,0x1,0,0x1,0x2,0x3,0x4
},{
0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x4,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x4,0x3,0x3,0x3,0x3,0x3,0x3,0x3,
0x4,0x3,0x2,0x2,0x2,0x2,0x2,0x3,
0x4,0x3,0x2,0x1,0x1,0x1,0x2,0x3,
0x4,0x3,0x2,0x1,0,0x1,0x2,0x3
},{
0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x5,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x5,0x4,0x4,0x4,0x4,0x4,0x4,0x4,
0x5,0x4,0x3,0x3,0x3,0x3,0x3,0x3,
0x5,0x4,0x3,0x2,0x2,0x2,0x2,0x2,
0x5,0x4,0x3,0x2,0x1,0x1,0x1,0x2,
0x5,0x4,0x3,0x2,0x1,0,0x1,0x2
},{
0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7,
0x6,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x6,0x5,0x5,0x5,0x5,0x5,0x5,0x5,
0x6,0x5,0x4,0x4,0x4,0x4,0x4,0x4,
0x6,0x5,0x4,0x3,0x3,0x3,0x3,0x3,
0x6,0x5,0x4,0x3,0x2,0x2,0x2,0x2,
0x6,0x5,0x4,0x3,0x2,0x1,0x1,0x1,
0x6,0x5,0x4,0x3,0x2,0x1,0,0x1
},{
0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7,
0x7,0x6,0x6,0x6,0x6,0x6,0x6,0x6,
0x7,0x6,0x5,0x5,0x5,0x5,0x5,0x5,
0x7,0x6,0x5,0x4,0x4,0x4,0x4,0x4,
0x7,0x6,0x5,0x4,0x3,0x3,0x3,0x3,
0x7,0x6,0x5,0x4,0x3,0x2,0x2,0x2,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x1,
0x7,0x6,0x5,0x4,0x3,0x2,0x1,0
}};

 int DIRATAQUEVIENE[64][64] = {
{
0,0x1,0x1,0x1,0x1,0x1,0x1,0x1,
0x8,0x9,0,0,0,0,0,0,
0x8,0,0x9,0,0,0,0,0,
0x8,0,0,0x9,0,0,0,0,
0x8,0,0,0,0x9,0,0,0,
0x8,0,0,0,0,0x9,0,0,
0x8,0,0,0,0,0,0x9,0,
0x8,0,0,0,0,0,0,0x9
},{
0xffffffff,0,0x1,0x1,0x1,0x1,0x1,0x1,
0x7,0x8,0x9,0,0,0,0,0,
0,0x8,0,0x9,0,0,0,0,
0,0x8,0,0,0x9,0,0,0,
0,0x8,0,0,0,0x9,0,0,
0,0x8,0,0,0,0,0x9,0,
0,0x8,0,0,0,0,0,0x9,
0,0x8,0,0,0,0,0,0
},{
0xffffffff,0xffffffff,0,0x1,0x1,0x1,0x1,0x1,
0,0x7,0x8,0x9,0,0,0,0,
0x7,0,0x8,0,0x9,0,0,0,
0,0,0x8,0,0,0x9,0,0,
0,0,0x8,0,0,0,0x9,0,
0,0,0x8,0,0,0,0,0x9,
0,0,0x8,0,0,0,0,0,
0,0,0x8,0,0,0,0,0
},{
0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,0x1,0x1,
0,0,0x7,0x8,0x9,0,0,0,
0,0x7,0,0x8,0,0x9,0,0,
0x7,0,0,0x8,0,0,0x9,0,
0,0,0,0x8,0,0,0,0x9,
0,0,0,0x8,0,0,0,0,
0,0,0,0x8,0,0,0,0,
0,0,0,0x8,0,0,0,0
},{
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,0x1,
0,0,0,0x7,0x8,0x9,0,0,
0,0,0x7,0,0x8,0,0x9,0,
0,0x7,0,0,0x8,0,0,0x9,
0x7,0,0,0,0x8,0,0,0,
0,0,0,0,0x8,0,0,0,
0,0,0,0,0x8,0,0,0,
0,0,0,0,0x8,0,0,0
},{
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,
0,0,0,0,0x7,0x8,0x9,0,
0,0,0,0x7,0,0x8,0,0x9,
0,0,0x7,0,0,0x8,0,0,
0,0x7,0,0,0,0x8,0,0,
0x7,0,0,0,0,0x8,0,0,
0,0,0,0,0,0x8,0,0,
0,0,0,0,0,0x8,0,0
},{
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,
0,0,0,0,0,0x7,0x8,0x9,
0,0,0,0,0x7,0,0x8,0,
0,0,0,0x7,0,0,0x8,0,
0,0,0x7,0,0,0,0x8,0,
0,0x7,0,0,0,0,0x8,0,
0x7,0,0,0,0,0,0x8,0,
0,0,0,0,0,0,0x8,0
},{
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,
0,0,0,0,0,0,0x7,0x8,
0,0,0,0,0,0x7,0,0x8,
0,0,0,0,0x7,0,0,0x8,
0,0,0,0x7,0,0,0,0x8,
0,0,0x7,0,0,0,0,0x8,
0,0x7,0,0,0,0,0,0x8,
0x7,0,0,0,0,0,0,0x8
},{
0xfffffff8,0xfffffff9,0,0,0,0,0,0,
0,0x1,0x1,0x1,0x1,0x1,0x1,0x1,
0x8,0x9,0,0,0,0,0,0,
0x8,0,0x9,0,0,0,0,0,
0x8,0,0,0x9,0,0,0,0,
0x8,0,0,0,0x9,0,0,0,
0x8,0,0,0,0,0x9,0,0,
0x8,0,0,0,0,0,0x9,0
},{
0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,0,0,
0xffffffff,0,0x1,0x1,0x1,0x1,0x1,0x1,
0x7,0x8,0x9,0,0,0,0,0,
0,0x8,0,0x9,0,0,0,0,
0,0x8,0,0,0x9,0,0,0,
0,0x8,0,0,0,0x9,0,0,
0,0x8,0,0,0,0,0x9,0,
0,0x8,0,0,0,0,0,0x9
},{
0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,0,
0xffffffff,0xffffffff,0,0x1,0x1,0x1,0x1,0x1,
0,0x7,0x8,0x9,0,0,0,0,
0x7,0,0x8,0,0x9,0,0,0,
0,0,0x8,0,0,0x9,0,0,
0,0,0x8,0,0,0,0x9,0,
0,0,0x8,0,0,0,0,0x9,
0,0,0x8,0,0,0,0,0
},{
0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,
0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,0x1,0x1,
0,0,0x7,0x8,0x9,0,0,0,
0,0x7,0,0x8,0,0x9,0,0,
0x7,0,0,0x8,0,0,0x9,0,
0,0,0,0x8,0,0,0,0x9,
0,0,0,0x8,0,0,0,0,
0,0,0,0x8,0,0,0,0
},{
0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,0x1,
0,0,0,0x7,0x8,0x9,0,0,
0,0,0x7,0,0x8,0,0x9,0,
0,0x7,0,0,0x8,0,0,0x9,
0x7,0,0,0,0x8,0,0,0,
0,0,0,0,0x8,0,0,0,
0,0,0,0,0x8,0,0,0
},{
0,0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,
0,0,0,0,0x7,0x8,0x9,0,
0,0,0,0x7,0,0x8,0,0x9,
0,0,0x7,0,0,0x8,0,0,
0,0x7,0,0,0,0x8,0,0,
0x7,0,0,0,0,0x8,0,0,
0,0,0,0,0,0x8,0,0
},{
0,0,0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,
0,0,0,0,0,0x7,0x8,0x9,
0,0,0,0,0x7,0,0x8,0,
0,0,0,0x7,0,0,0x8,0,
0,0,0x7,0,0,0,0x8,0,
0,0x7,0,0,0,0,0x8,0,
0x7,0,0,0,0,0,0x8,0
},{
0,0,0,0,0,0,0xfffffff7,0xfffffff8,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,
0,0,0,0,0,0,0x7,0x8,
0,0,0,0,0,0x7,0,0x8,
0,0,0,0,0x7,0,0,0x8,
0,0,0,0x7,0,0,0,0x8,
0,0,0x7,0,0,0,0,0x8,
0,0x7,0,0,0,0,0,0x8
},{
0xfffffff8,0,0xfffffff9,0,0,0,0,0,
0xfffffff8,0xfffffff9,0,0,0,0,0,0,
0,0x1,0x1,0x1,0x1,0x1,0x1,0x1,
0x8,0x9,0,0,0,0,0,0,
0x8,0,0x9,0,0,0,0,0,
0x8,0,0,0x9,0,0,0,0,
0x8,0,0,0,0x9,0,0,0,
0x8,0,0,0,0,0x9,0,0
},{
0,0xfffffff8,0,0xfffffff9,0,0,0,0,
0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,0,0,
0xffffffff,0,0x1,0x1,0x1,0x1,0x1,0x1,
0x7,0x8,0x9,0,0,0,0,0,
0,0x8,0,0x9,0,0,0,0,
0,0x8,0,0,0x9,0,0,0,
0,0x8,0,0,0,0x9,0,0,
0,0x8,0,0,0,0,0x9,0
},{
0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,0,0,
0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,0,
0xffffffff,0xffffffff,0,0x1,0x1,0x1,0x1,0x1,
0,0x7,0x8,0x9,0,0,0,0,
0x7,0,0x8,0,0x9,0,0,0,
0,0,0x8,0,0,0x9,0,0,
0,0,0x8,0,0,0,0x9,0,
0,0,0x8,0,0,0,0,0x9
},{
0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,0,
0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,
0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,0x1,0x1,
0,0,0x7,0x8,0x9,0,0,0,
0,0x7,0,0x8,0,0x9,0,0,
0x7,0,0,0x8,0,0,0x9,0,
0,0,0,0x8,0,0,0,0x9,
0,0,0,0x8,0,0,0,0
},{
0,0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,
0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,0x1,
0,0,0,0x7,0x8,0x9,0,0,
0,0,0x7,0,0x8,0,0x9,0,
0,0x7,0,0,0x8,0,0,0x9,
0x7,0,0,0,0x8,0,0,0,
0,0,0,0,0x8,0,0,0
},{
0,0,0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,
0,0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,
0,0,0,0,0x7,0x8,0x9,0,
0,0,0,0x7,0,0x8,0,0x9,
0,0,0x7,0,0,0x8,0,0,
0,0x7,0,0,0,0x8,0,0,
0x7,0,0,0,0,0x8,0,0
},{
0,0,0,0,0xfffffff7,0,0xfffffff8,0,
0,0,0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,
0,0,0,0,0,0x7,0x8,0x9,
0,0,0,0,0x7,0,0x8,0,
0,0,0,0x7,0,0,0x8,0,
0,0,0x7,0,0,0,0x8,0,
0,0x7,0,0,0,0,0x8,0
},{
0,0,0,0,0,0xfffffff7,0,0xfffffff8,
0,0,0,0,0,0,0xfffffff7,0xfffffff8,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,
0,0,0,0,0,0,0x7,0x8,
0,0,0,0,0,0x7,0,0x8,
0,0,0,0,0x7,0,0,0x8,
0,0,0,0x7,0,0,0,0x8,
0,0,0x7,0,0,0,0,0x8
},{
0xfffffff8,0,0,0xfffffff9,0,0,0,0,
0xfffffff8,0,0xfffffff9,0,0,0,0,0,
0xfffffff8,0xfffffff9,0,0,0,0,0,0,
0,0x1,0x1,0x1,0x1,0x1,0x1,0x1,
0x8,0x9,0,0,0,0,0,0,
0x8,0,0x9,0,0,0,0,0,
0x8,0,0,0x9,0,0,0,0,
0x8,0,0,0,0x9,0,0,0
},{
0,0xfffffff8,0,0,0xfffffff9,0,0,0,
0,0xfffffff8,0,0xfffffff9,0,0,0,0,
0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,0,0,
0xffffffff,0,0x1,0x1,0x1,0x1,0x1,0x1,
0x7,0x8,0x9,0,0,0,0,0,
0,0x8,0,0x9,0,0,0,0,
0,0x8,0,0,0x9,0,0,0,
0,0x8,0,0,0,0x9,0,0
},{
0,0,0xfffffff8,0,0,0xfffffff9,0,0,
0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,0,0,
0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,0,
0xffffffff,0xffffffff,0,0x1,0x1,0x1,0x1,0x1,
0,0x7,0x8,0x9,0,0,0,0,
0x7,0,0x8,0,0x9,0,0,0,
0,0,0x8,0,0,0x9,0,0,
0,0,0x8,0,0,0,0x9,0
},{
0xfffffff7,0,0,0xfffffff8,0,0,0xfffffff9,0,
0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,0,
0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,
0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,0x1,0x1,
0,0,0x7,0x8,0x9,0,0,0,
0,0x7,0,0x8,0,0x9,0,0,
0x7,0,0,0x8,0,0,0x9,0,
0,0,0,0x8,0,0,0,0x9
},{
0,0xfffffff7,0,0,0xfffffff8,0,0,0xfffffff9,
0,0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,
0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,0x1,
0,0,0,0x7,0x8,0x9,0,0,
0,0,0x7,0,0x8,0,0x9,0,
0,0x7,0,0,0x8,0,0,0x9,
0x7,0,0,0,0x8,0,0,0
},{
0,0,0xfffffff7,0,0,0xfffffff8,0,0,
0,0,0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,
0,0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,
0,0,0,0,0x7,0x8,0x9,0,
0,0,0,0x7,0,0x8,0,0x9,
0,0,0x7,0,0,0x8,0,0,
0,0x7,0,0,0,0x8,0,0
},{
0,0,0,0xfffffff7,0,0,0xfffffff8,0,
0,0,0,0,0xfffffff7,0,0xfffffff8,0,
0,0,0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,
0,0,0,0,0,0x7,0x8,0x9,
0,0,0,0,0x7,0,0x8,0,
0,0,0,0x7,0,0,0x8,0,
0,0,0x7,0,0,0,0x8,0
},{
0,0,0,0,0xfffffff7,0,0,0xfffffff8,
0,0,0,0,0,0xfffffff7,0,0xfffffff8,
0,0,0,0,0,0,0xfffffff7,0xfffffff8,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,
0,0,0,0,0,0,0x7,0x8,
0,0,0,0,0,0x7,0,0x8,
0,0,0,0,0x7,0,0,0x8,
0,0,0,0x7,0,0,0,0x8
},{
0xfffffff8,0,0,0,0xfffffff9,0,0,0,
0xfffffff8,0,0,0xfffffff9,0,0,0,0,
0xfffffff8,0,0xfffffff9,0,0,0,0,0,
0xfffffff8,0xfffffff9,0,0,0,0,0,0,
0,0x1,0x1,0x1,0x1,0x1,0x1,0x1,
0x8,0x9,0,0,0,0,0,0,
0x8,0,0x9,0,0,0,0,0,
0x8,0,0,0x9,0,0,0,0
},{
0,0xfffffff8,0,0,0,0xfffffff9,0,0,
0,0xfffffff8,0,0,0xfffffff9,0,0,0,
0,0xfffffff8,0,0xfffffff9,0,0,0,0,
0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,0,0,
0xffffffff,0,0x1,0x1,0x1,0x1,0x1,0x1,
0x7,0x8,0x9,0,0,0,0,0,
0,0x8,0,0x9,0,0,0,0,
0,0x8,0,0,0x9,0,0,0
},{
0,0,0xfffffff8,0,0,0,0xfffffff9,0,
0,0,0xfffffff8,0,0,0xfffffff9,0,0,
0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,0,0,
0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,0,
0xffffffff,0xffffffff,0,0x1,0x1,0x1,0x1,0x1,
0,0x7,0x8,0x9,0,0,0,0,
0x7,0,0x8,0,0x9,0,0,0,
0,0,0x8,0,0,0x9,0,0
},{
0,0,0,0xfffffff8,0,0,0,0xfffffff9,
0xfffffff7,0,0,0xfffffff8,0,0,0xfffffff9,0,
0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,0,
0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,
0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,0x1,0x1,
0,0,0x7,0x8,0x9,0,0,0,
0,0x7,0,0x8,0,0x9,0,0,
0x7,0,0,0x8,0,0,0x9,0
},{
0xfffffff7,0,0,0,0xfffffff8,0,0,0,
0,0xfffffff7,0,0,0xfffffff8,0,0,0xfffffff9,
0,0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,
0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,0x1,
0,0,0,0x7,0x8,0x9,0,0,
0,0,0x7,0,0x8,0,0x9,0,
0,0x7,0,0,0x8,0,0,0x9
},{
0,0xfffffff7,0,0,0,0xfffffff8,0,0,
0,0,0xfffffff7,0,0,0xfffffff8,0,0,
0,0,0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,
0,0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,
0,0,0,0,0x7,0x8,0x9,0,
0,0,0,0x7,0,0x8,0,0x9,
0,0,0x7,0,0,0x8,0,0
},{
0,0,0xfffffff7,0,0,0,0xfffffff8,0,
0,0,0,0xfffffff7,0,0,0xfffffff8,0,
0,0,0,0,0xfffffff7,0,0xfffffff8,0,
0,0,0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,
0,0,0,0,0,0x7,0x8,0x9,
0,0,0,0,0x7,0,0x8,0,
0,0,0,0x7,0,0,0x8,0
},{
0,0,0,0xfffffff7,0,0,0,0xfffffff8,
0,0,0,0,0xfffffff7,0,0,0xfffffff8,
0,0,0,0,0,0xfffffff7,0,0xfffffff8,
0,0,0,0,0,0,0xfffffff7,0xfffffff8,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,
0,0,0,0,0,0,0x7,0x8,
0,0,0,0,0,0x7,0,0x8,
0,0,0,0,0x7,0,0,0x8
},{
0xfffffff8,0,0,0,0,0xfffffff9,0,0,
0xfffffff8,0,0,0,0xfffffff9,0,0,0,
0xfffffff8,0,0,0xfffffff9,0,0,0,0,
0xfffffff8,0,0xfffffff9,0,0,0,0,0,
0xfffffff8,0xfffffff9,0,0,0,0,0,0,
0,0x1,0x1,0x1,0x1,0x1,0x1,0x1,
0x8,0x9,0,0,0,0,0,0,
0x8,0,0x9,0,0,0,0,0
},{
0,0xfffffff8,0,0,0,0,0xfffffff9,0,
0,0xfffffff8,0,0,0,0xfffffff9,0,0,
0,0xfffffff8,0,0,0xfffffff9,0,0,0,
0,0xfffffff8,0,0xfffffff9,0,0,0,0,
0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,0,0,
0xffffffff,0,0x1,0x1,0x1,0x1,0x1,0x1,
0x7,0x8,0x9,0,0,0,0,0,
0,0x8,0,0x9,0,0,0,0
},{
0,0,0xfffffff8,0,0,0,0,0xfffffff9,
0,0,0xfffffff8,0,0,0,0xfffffff9,0,
0,0,0xfffffff8,0,0,0xfffffff9,0,0,
0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,0,0,
0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,0,
0xffffffff,0xffffffff,0,0x1,0x1,0x1,0x1,0x1,
0,0x7,0x8,0x9,0,0,0,0,
0x7,0,0x8,0,0x9,0,0,0
},{
0,0,0,0xfffffff8,0,0,0,0,
0,0,0,0xfffffff8,0,0,0,0xfffffff9,
0xfffffff7,0,0,0xfffffff8,0,0,0xfffffff9,0,
0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,0,
0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,
0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,0x1,0x1,
0,0,0x7,0x8,0x9,0,0,0,
0,0x7,0,0x8,0,0x9,0,0
},{
0,0,0,0,0xfffffff8,0,0,0,
0xfffffff7,0,0,0,0xfffffff8,0,0,0,
0,0xfffffff7,0,0,0xfffffff8,0,0,0xfffffff9,
0,0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,
0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,0x1,
0,0,0,0x7,0x8,0x9,0,0,
0,0,0x7,0,0x8,0,0x9,0
},{
0xfffffff7,0,0,0,0,0xfffffff8,0,0,
0,0xfffffff7,0,0,0,0xfffffff8,0,0,
0,0,0xfffffff7,0,0,0xfffffff8,0,0,
0,0,0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,
0,0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,
0,0,0,0,0x7,0x8,0x9,0,
0,0,0,0x7,0,0x8,0,0x9
},{
0,0xfffffff7,0,0,0,0,0xfffffff8,0,
0,0,0xfffffff7,0,0,0,0xfffffff8,0,
0,0,0,0xfffffff7,0,0,0xfffffff8,0,
0,0,0,0,0xfffffff7,0,0xfffffff8,0,
0,0,0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,
0,0,0,0,0,0x7,0x8,0x9,
0,0,0,0,0x7,0,0x8,0
},{
0,0,0xfffffff7,0,0,0,0,0xfffffff8,
0,0,0,0xfffffff7,0,0,0,0xfffffff8,
0,0,0,0,0xfffffff7,0,0,0xfffffff8,
0,0,0,0,0,0xfffffff7,0,0xfffffff8,
0,0,0,0,0,0,0xfffffff7,0xfffffff8,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,
0,0,0,0,0,0,0x7,0x8,
0,0,0,0,0,0x7,0,0x8
},{
0xfffffff8,0,0,0,0,0,0xfffffff9,0,
0xfffffff8,0,0,0,0,0xfffffff9,0,0,
0xfffffff8,0,0,0,0xfffffff9,0,0,0,
0xfffffff8,0,0,0xfffffff9,0,0,0,0,
0xfffffff8,0,0xfffffff9,0,0,0,0,0,
0xfffffff8,0xfffffff9,0,0,0,0,0,0,
0,0x1,0x1,0x1,0x1,0x1,0x1,0x1,
0x8,0x9,0,0,0,0,0,0
},{
0,0xfffffff8,0,0,0,0,0,0xfffffff9,
0,0xfffffff8,0,0,0,0,0xfffffff9,0,
0,0xfffffff8,0,0,0,0xfffffff9,0,0,
0,0xfffffff8,0,0,0xfffffff9,0,0,0,
0,0xfffffff8,0,0xfffffff9,0,0,0,0,
0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,0,0,
0xffffffff,0,0x1,0x1,0x1,0x1,0x1,0x1,
0x7,0x8,0x9,0,0,0,0,0
},{
0,0,0xfffffff8,0,0,0,0,0,
0,0,0xfffffff8,0,0,0,0,0xfffffff9,
0,0,0xfffffff8,0,0,0,0xfffffff9,0,
0,0,0xfffffff8,0,0,0xfffffff9,0,0,
0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,0,0,
0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,0,
0xffffffff,0xffffffff,0,0x1,0x1,0x1,0x1,0x1,
0,0x7,0x8,0x9,0,0,0,0
},{
0,0,0,0xfffffff8,0,0,0,0,
0,0,0,0xfffffff8,0,0,0,0,
0,0,0,0xfffffff8,0,0,0,0xfffffff9,
0xfffffff7,0,0,0xfffffff8,0,0,0xfffffff9,0,
0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,0,
0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,
0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,0x1,0x1,
0,0,0x7,0x8,0x9,0,0,0
},{
0,0,0,0,0xfffffff8,0,0,0,
0,0,0,0,0xfffffff8,0,0,0,
0xfffffff7,0,0,0,0xfffffff8,0,0,0,
0,0xfffffff7,0,0,0xfffffff8,0,0,0xfffffff9,
0,0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,
0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,0x1,
0,0,0,0x7,0x8,0x9,0,0
},{
0,0,0,0,0,0xfffffff8,0,0,
0xfffffff7,0,0,0,0,0xfffffff8,0,0,
0,0xfffffff7,0,0,0,0xfffffff8,0,0,
0,0,0xfffffff7,0,0,0xfffffff8,0,0,
0,0,0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,
0,0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,
0,0,0,0,0x7,0x8,0x9,0
},{
0xfffffff7,0,0,0,0,0,0xfffffff8,0,
0,0xfffffff7,0,0,0,0,0xfffffff8,0,
0,0,0xfffffff7,0,0,0,0xfffffff8,0,
0,0,0,0xfffffff7,0,0,0xfffffff8,0,
0,0,0,0,0xfffffff7,0,0xfffffff8,0,
0,0,0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,
0,0,0,0,0,0x7,0x8,0x9
},{
0,0xfffffff7,0,0,0,0,0,0xfffffff8,
0,0,0xfffffff7,0,0,0,0,0xfffffff8,
0,0,0,0xfffffff7,0,0,0,0xfffffff8,
0,0,0,0,0xfffffff7,0,0,0xfffffff8,
0,0,0,0,0,0xfffffff7,0,0xfffffff8,
0,0,0,0,0,0,0xfffffff7,0xfffffff8,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,
0,0,0,0,0,0,0x7,0x8
},{
0xfffffff8,0,0,0,0,0,0,0xfffffff9,
0xfffffff8,0,0,0,0,0,0xfffffff9,0,
0xfffffff8,0,0,0,0,0xfffffff9,0,0,
0xfffffff8,0,0,0,0xfffffff9,0,0,0,
0xfffffff8,0,0,0xfffffff9,0,0,0,0,
0xfffffff8,0,0xfffffff9,0,0,0,0,0,
0xfffffff8,0xfffffff9,0,0,0,0,0,0,
0,0x1,0x1,0x1,0x1,0x1,0x1,0x1
},{
0,0xfffffff8,0,0,0,0,0,0,
0,0xfffffff8,0,0,0,0,0,0xfffffff9,
0,0xfffffff8,0,0,0,0,0xfffffff9,0,
0,0xfffffff8,0,0,0,0xfffffff9,0,0,
0,0xfffffff8,0,0,0xfffffff9,0,0,0,
0,0xfffffff8,0,0xfffffff9,0,0,0,0,
0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,0,0,
0xffffffff,0,0x1,0x1,0x1,0x1,0x1,0x1
},{
0,0,0xfffffff8,0,0,0,0,0,
0,0,0xfffffff8,0,0,0,0,0,
0,0,0xfffffff8,0,0,0,0,0xfffffff9,
0,0,0xfffffff8,0,0,0,0xfffffff9,0,
0,0,0xfffffff8,0,0,0xfffffff9,0,0,
0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,0,0,
0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,0,
0xffffffff,0xffffffff,0,0x1,0x1,0x1,0x1,0x1
},{
0,0,0,0xfffffff8,0,0,0,0,
0,0,0,0xfffffff8,0,0,0,0,
0,0,0,0xfffffff8,0,0,0,0,
0,0,0,0xfffffff8,0,0,0,0xfffffff9,
0xfffffff7,0,0,0xfffffff8,0,0,0xfffffff9,0,
0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,0,
0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,0,
0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,0x1,0x1
},{
0,0,0,0,0xfffffff8,0,0,0,
0,0,0,0,0xfffffff8,0,0,0,
0,0,0,0,0xfffffff8,0,0,0,
0xfffffff7,0,0,0,0xfffffff8,0,0,0,
0,0xfffffff7,0,0,0xfffffff8,0,0,0xfffffff9,
0,0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,0,
0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,0,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1,0x1
},{
0,0,0,0,0,0xfffffff8,0,0,
0,0,0,0,0,0xfffffff8,0,0,
0xfffffff7,0,0,0,0,0xfffffff8,0,0,
0,0xfffffff7,0,0,0,0xfffffff8,0,0,
0,0,0xfffffff7,0,0,0xfffffff8,0,0,
0,0,0,0xfffffff7,0,0xfffffff8,0,0xfffffff9,
0,0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,0,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1,0x1
},{
0,0,0,0,0,0,0xfffffff8,0,
0xfffffff7,0,0,0,0,0,0xfffffff8,0,
0,0xfffffff7,0,0,0,0,0xfffffff8,0,
0,0,0xfffffff7,0,0,0,0xfffffff8,0,
0,0,0,0xfffffff7,0,0,0xfffffff8,0,
0,0,0,0,0xfffffff7,0,0xfffffff8,0,
0,0,0,0,0,0xfffffff7,0xfffffff8,0xfffffff9,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0,0x1
},{
0xfffffff7,0,0,0,0,0,0,0xfffffff8,
0,0xfffffff7,0,0,0,0,0,0xfffffff8,
0,0,0xfffffff7,0,0,0,0,0xfffffff8,
0,0,0,0xfffffff7,0,0,0,0xfffffff8,
0,0,0,0,0xfffffff7,0,0,0xfffffff8,
0,0,0,0,0,0xfffffff7,0,0xfffffff8,
0,0,0,0,0,0,0xfffffff7,0xfffffff8,
0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0
}};

uint64 RAYO_N[64] = 
{
0x101010101010100ull,0x202020202020200ull,0x404040404040400ull,0x808080808080800ull,
0x1010101010101000ull,0x2020202020202000ull,0x4040404040404000ull,0x8080808080808000ull,
0x101010101010000ull,0x202020202020000ull,0x404040404040000ull,0x808080808080000ull,
0x1010101010100000ull,0x2020202020200000ull,0x4040404040400000ull,0x8080808080800000ull,
0x101010101000000ull,0x202020202000000ull,0x404040404000000ull,0x808080808000000ull,
0x1010101010000000ull,0x2020202020000000ull,0x4040404040000000ull,0x8080808080000000ull,
0x101010100000000ull,0x202020200000000ull,0x404040400000000ull,0x808080800000000ull,
0x1010101000000000ull,0x2020202000000000ull,0x4040404000000000ull,0x8080808000000000ull,
0x101010000000000ull,0x202020000000000ull,0x404040000000000ull,0x808080000000000ull,
0x1010100000000000ull,0x2020200000000000ull,0x4040400000000000ull,0x8080800000000000ull,
0x101000000000000ull,0x202000000000000ull,0x404000000000000ull,0x808000000000000ull,
0x1010000000000000ull,0x2020000000000000ull,0x4040000000000000ull,0x8080000000000000ull,
0x100000000000000ull,0x200000000000000ull,0x400000000000000ull,0x800000000000000ull,
0x1000000000000000ull,0x2000000000000000ull,0x4000000000000000ull,0x8000000000000000ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull};

 uint64 RAYO_NE[64] =
{
0x8040201008040200ull,0x80402010080400ull,0x804020100800ull,0x8040201000ull,
0x80402000ull,0x804000ull,0x8000ull,0ull,
0x4020100804020000ull,0x8040201008040000ull,0x80402010080000ull,0x804020100000ull,
0x8040200000ull,0x80400000ull,0x800000ull,0ull,
0x2010080402000000ull,0x4020100804000000ull,0x8040201008000000ull,0x80402010000000ull,
0x804020000000ull,0x8040000000ull,0x80000000ull,0ull,
0x1008040200000000ull,0x2010080400000000ull,0x4020100800000000ull,0x8040201000000000ull,
0x80402000000000ull,0x804000000000ull,0x8000000000ull,0ull,
0x804020000000000ull,0x1008040000000000ull,0x2010080000000000ull,0x4020100000000000ull,
0x8040200000000000ull,0x80400000000000ull,0x800000000000ull,0ull,
0x402000000000000ull,0x804000000000000ull,0x1008000000000000ull,0x2010000000000000ull,
0x4020000000000000ull,0x8040000000000000ull,0x80000000000000ull,0ull,
0x200000000000000ull,0x400000000000000ull,0x800000000000000ull,0x1000000000000000ull,
0x2000000000000000ull,0x4000000000000000ull,0x8000000000000000ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull};

 uint64 RAYO_NO[64] =
{
0ull,0x100ull,0x10200ull,0x1020400ull,
0x102040800ull,0x10204081000ull,0x1020408102000ull,0x102040810204000ull,
0ull,0x10000ull,0x1020000ull,0x102040000ull,
0x10204080000ull,0x1020408100000ull,0x102040810200000ull,0x204081020400000ull,
0ull,0x1000000ull,0x102000000ull,0x10204000000ull,
0x1020408000000ull,0x102040810000000ull,0x204081020000000ull,0x408102040000000ull,
0ull,0x100000000ull,0x10200000000ull,0x1020400000000ull,
0x102040800000000ull,0x204081000000000ull,0x408102000000000ull,0x810204000000000ull,
0ull,0x10000000000ull,0x1020000000000ull,0x102040000000000ull,
0x204080000000000ull,0x408100000000000ull,0x810200000000000ull,0x1020400000000000ull,
0ull,0x1000000000000ull,0x102000000000000ull,0x204000000000000ull,
0x408000000000000ull,0x810000000000000ull,0x1020000000000000ull,0x2040000000000000ull,
0ull,0x100000000000000ull,0x200000000000000ull,0x400000000000000ull,
0x800000000000000ull,0x1000000000000000ull,0x2000000000000000ull,0x4000000000000000ull,
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull};

 uint64 RAYO_E[64] = 
{
0xfeull,0xfcull,0xf8ull,0xf0ull,
0xe0ull,0xc0ull,0x80ull,0ull,
0xfe00ull,0xfc00ull,0xf800ull,0xf000ull,
0xe000ull,0xc000ull,0x8000ull,0ull,
0xfe0000ull,0xfc0000ull,0xf80000ull,0xf00000ull,
0xe00000ull,0xc00000ull,0x800000ull,0ull,
0xfe000000ull,0xfc000000ull,0xf8000000ull,0xf0000000ull,
0xe0000000ull,0xc0000000ull,0x80000000ull,0ull,
0xfe00000000ull,0xfc00000000ull,0xf800000000ull,0xf000000000ull,
0xe000000000ull,0xc000000000ull,0x8000000000ull,0ull,
0xfe0000000000ull,0xfc0000000000ull,0xf80000000000ull,0xf00000000000ull,
0xe00000000000ull,0xc00000000000ull,0x800000000000ull,0ull,
0xfe000000000000ull,0xfc000000000000ull,0xf8000000000000ull,0xf0000000000000ull,
0xe0000000000000ull,0xc0000000000000ull,0x80000000000000ull,0ull,
0xfe00000000000000ull,0xfc00000000000000ull,0xf800000000000000ull,0xf000000000000000ull,
0xe000000000000000ull,0xc000000000000000ull,0x8000000000000000ull,0ull};

 uint64 RAYO_O[64] = 
{
0ull,0x1ull,0x3ull,0x7ull,
0xfull,0x1full,0x3full,0x7full,
0ull,0x100ull,0x300ull,0x700ull,
0xf00ull,0x1f00ull,0x3f00ull,0x7f00ull,
0ull,0x10000ull,0x30000ull,0x70000ull,
0xf0000ull,0x1f0000ull,0x3f0000ull,0x7f0000ull,
0ull,0x1000000ull,0x3000000ull,0x7000000ull,
0xf000000ull,0x1f000000ull,0x3f000000ull,0x7f000000ull,
0ull,0x100000000ull,0x300000000ull,0x700000000ull,
0xf00000000ull,0x1f00000000ull,0x3f00000000ull,0x7f00000000ull,
0ull,0x10000000000ull,0x30000000000ull,0x70000000000ull,
0xf0000000000ull,0x1f0000000000ull,0x3f0000000000ull,0x7f0000000000ull,
0ull,0x1000000000000ull,0x3000000000000ull,0x7000000000000ull,
0xf000000000000ull,0x1f000000000000ull,0x3f000000000000ull,0x7f000000000000ull,
0ull,0x100000000000000ull,0x300000000000000ull,0x700000000000000ull,
0xf00000000000000ull,0x1f00000000000000ull,0x3f00000000000000ull,0x7f00000000000000ull};

 uint64 RAYO_S[64] = 
{
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0x1ull,0x2ull,0x4ull,0x8ull,
0x10ull,0x20ull,0x40ull,0x80ull,
0x101ull,0x202ull,0x404ull,0x808ull,
0x1010ull,0x2020ull,0x4040ull,0x8080ull,
0x10101ull,0x20202ull,0x40404ull,0x80808ull,
0x101010ull,0x202020ull,0x404040ull,0x808080ull,
0x1010101ull,0x2020202ull,0x4040404ull,0x8080808ull,
0x10101010ull,0x20202020ull,0x40404040ull,0x80808080ull,
0x101010101ull,0x202020202ull,0x404040404ull,0x808080808ull,
0x1010101010ull,0x2020202020ull,0x4040404040ull,0x8080808080ull,
0x10101010101ull,0x20202020202ull,0x40404040404ull,0x80808080808ull,
0x101010101010ull,0x202020202020ull,0x404040404040ull,0x808080808080ull,
0x1010101010101ull,0x2020202020202ull,0x4040404040404ull,0x8080808080808ull,
0x10101010101010ull,0x20202020202020ull,0x40404040404040ull,0x80808080808080ull};

 uint64 RAYO_SE[64] =
{
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0x2ull,0x4ull,0x8ull,0x10ull,
0x20ull,0x40ull,0x80ull,0ull,
0x204ull,0x408ull,0x810ull,0x1020ull,
0x2040ull,0x4080ull,0x8000ull,0ull,
0x20408ull,0x40810ull,0x81020ull,0x102040ull,
0x204080ull,0x408000ull,0x800000ull,0ull,
0x2040810ull,0x4081020ull,0x8102040ull,0x10204080ull,
0x20408000ull,0x40800000ull,0x80000000ull,0ull,
0x204081020ull,0x408102040ull,0x810204080ull,0x1020408000ull,
0x2040800000ull,0x4080000000ull,0x8000000000ull,0ull,
0x20408102040ull,0x40810204080ull,0x81020408000ull,0x102040800000ull,
0x204080000000ull,0x408000000000ull,0x800000000000ull,0ull,
0x2040810204080ull,0x4081020408000ull,0x8102040800000ull,0x10204080000000ull,
0x20408000000000ull,0x40800000000000ull,0x80000000000000ull,0ull};

 uint64 RAYO_SO[64] =
{
0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,
0ull,0x1ull,0x2ull,0x4ull,
0x8ull,0x10ull,0x20ull,0x40ull,
0ull,0x100ull,0x201ull,0x402ull,
0x804ull,0x1008ull,0x2010ull,0x4020ull,
0ull,0x10000ull,0x20100ull,0x40201ull,
0x80402ull,0x100804ull,0x201008ull,0x402010ull,
0ull,0x1000000ull,0x2010000ull,0x4020100ull,
0x8040201ull,0x10080402ull,0x20100804ull,0x40201008ull,
0ull,0x100000000ull,0x201000000ull,0x402010000ull,
0x804020100ull,0x1008040201ull,0x2010080402ull,0x4020100804ull,
0ull,0x10000000000ull,0x20100000000ull,0x40201000000ull,
0x80402010000ull,0x100804020100ull,0x201008040201ull,0x402010080402ull,
0ull,0x1000000000000ull,0x2010000000000ull,0x4020100000000ull,
0x8040201000000ull,0x10080402010000ull,0x20100804020100ull,0x40201008040201ull};

 uint64 ESCAQUES_INTERMEDIOS[64][64] =
{{
0ull,0ull,0x2ull,0x6ull,0xeull,0x1eull,0x3eull,0x7eull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x100ull,0ull,0x200ull,0ull,0ull,0ull,0ull,0ull,
0x10100ull,0ull,0ull,0x40200ull,0ull,0ull,0ull,0ull,
0x1010100ull,0ull,0ull,0ull,0x8040200ull,0ull,0ull,0ull,
0x101010100ull,0ull,0ull,0ull,0ull,0x1008040200ull,0ull,0ull,
0x10101010100ull,0ull,0ull,0ull,0ull,0ull,0x201008040200ull,0ull,
0x1010101010100ull,0ull,0ull,0ull,0ull,0ull,0ull,0x40201008040200ull
},{
0ull,0ull,0ull,0x4ull,0xcull,0x1cull,0x3cull,0x7cull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0x200ull,0ull,0x400ull,0ull,0ull,0ull,0ull,
0ull,0x20200ull,0ull,0ull,0x80400ull,0ull,0ull,0ull,
0ull,0x2020200ull,0ull,0ull,0ull,0x10080400ull,0ull,0ull,
0ull,0x202020200ull,0ull,0ull,0ull,0ull,0x2010080400ull,0ull,
0ull,0x20202020200ull,0ull,0ull,0ull,0ull,0ull,0x402010080400ull,
0ull,0x2020202020200ull,0ull,0ull,0ull,0ull,0ull,0ull
},{
0x2ull,0ull,0ull,0ull,0x8ull,0x18ull,0x38ull,0x78ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x200ull,0ull,0x400ull,0ull,0x800ull,0ull,0ull,0ull,
0ull,0ull,0x40400ull,0ull,0ull,0x100800ull,0ull,0ull,
0ull,0ull,0x4040400ull,0ull,0ull,0ull,0x20100800ull,0ull,
0ull,0ull,0x404040400ull,0ull,0ull,0ull,0ull,0x4020100800ull,
0ull,0ull,0x40404040400ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x4040404040400ull,0ull,0ull,0ull,0ull,0ull
},{
0x6ull,0x4ull,0ull,0ull,0ull,0x10ull,0x30ull,0x70ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0x400ull,0ull,0x800ull,0ull,0x1000ull,0ull,0ull,
0x20400ull,0ull,0ull,0x80800ull,0ull,0ull,0x201000ull,0ull,
0ull,0ull,0ull,0x8080800ull,0ull,0ull,0ull,0x40201000ull,
0ull,0ull,0ull,0x808080800ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x80808080800ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x8080808080800ull,0ull,0ull,0ull,0ull
},{
0xeull,0xcull,0x8ull,0ull,0ull,0ull,0x20ull,0x60ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x800ull,0ull,0x1000ull,0ull,0x2000ull,0ull,
0ull,0x40800ull,0ull,0ull,0x101000ull,0ull,0ull,0x402000ull,
0x2040800ull,0ull,0ull,0ull,0x10101000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0x1010101000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0x101010101000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0x10101010101000ull,0ull,0ull,0ull
},{
0x1eull,0x1cull,0x18ull,0x10ull,0ull,0ull,0ull,0x40ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x1000ull,0ull,0x2000ull,0ull,0x4000ull,
0ull,0ull,0x81000ull,0ull,0ull,0x202000ull,0ull,0ull,
0ull,0x4081000ull,0ull,0ull,0ull,0x20202000ull,0ull,0ull,
0x204081000ull,0ull,0ull,0ull,0ull,0x2020202000ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0x202020202000ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0x20202020202000ull,0ull,0ull
},{
0x3eull,0x3cull,0x38ull,0x30ull,0x20ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0x2000ull,0ull,0x4000ull,0ull,
0ull,0ull,0ull,0x102000ull,0ull,0ull,0x404000ull,0ull,
0ull,0ull,0x8102000ull,0ull,0ull,0ull,0x40404000ull,0ull,
0ull,0x408102000ull,0ull,0ull,0ull,0ull,0x4040404000ull,0ull,
0x20408102000ull,0ull,0ull,0ull,0ull,0ull,0x404040404000ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0x40404040404000ull,0ull
},{
0x7eull,0x7cull,0x78ull,0x70ull,0x60ull,0x40ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0x4000ull,0ull,0x8000ull,
0ull,0ull,0ull,0ull,0x204000ull,0ull,0ull,0x808000ull,
0ull,0ull,0ull,0x10204000ull,0ull,0ull,0ull,0x80808000ull,
0ull,0ull,0x810204000ull,0ull,0ull,0ull,0ull,0x8080808000ull,
0ull,0x40810204000ull,0ull,0ull,0ull,0ull,0ull,0x808080808000ull,
0x2040810204000ull,0ull,0ull,0ull,0ull,0ull,0ull,0x80808080808000ull
},{
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x200ull,0x600ull,0xe00ull,0x1e00ull,0x3e00ull,0x7e00ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x10000ull,0ull,0x20000ull,0ull,0ull,0ull,0ull,0ull,
0x1010000ull,0ull,0ull,0x4020000ull,0ull,0ull,0ull,0ull,
0x101010000ull,0ull,0ull,0ull,0x804020000ull,0ull,0ull,0ull,
0x10101010000ull,0ull,0ull,0ull,0ull,0x100804020000ull,0ull,0ull,
0x1010101010000ull,0ull,0ull,0ull,0ull,0ull,0x20100804020000ull,0ull
},{
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x400ull,0xc00ull,0x1c00ull,0x3c00ull,0x7c00ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0x20000ull,0ull,0x40000ull,0ull,0ull,0ull,0ull,
0ull,0x2020000ull,0ull,0ull,0x8040000ull,0ull,0ull,0ull,
0ull,0x202020000ull,0ull,0ull,0ull,0x1008040000ull,0ull,0ull,
0ull,0x20202020000ull,0ull,0ull,0ull,0ull,0x201008040000ull,0ull,
0ull,0x2020202020000ull,0ull,0ull,0ull,0ull,0ull,0x40201008040000ull
},{
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x200ull,0ull,0ull,0ull,0x800ull,0x1800ull,0x3800ull,0x7800ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x20000ull,0ull,0x40000ull,0ull,0x80000ull,0ull,0ull,0ull,
0ull,0ull,0x4040000ull,0ull,0ull,0x10080000ull,0ull,0ull,
0ull,0ull,0x404040000ull,0ull,0ull,0ull,0x2010080000ull,0ull,
0ull,0ull,0x40404040000ull,0ull,0ull,0ull,0ull,0x402010080000ull,
0ull,0ull,0x4040404040000ull,0ull,0ull,0ull,0ull,0ull
},{
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x600ull,0x400ull,0ull,0ull,0ull,0x1000ull,0x3000ull,0x7000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0x40000ull,0ull,0x80000ull,0ull,0x100000ull,0ull,0ull,
0x2040000ull,0ull,0ull,0x8080000ull,0ull,0ull,0x20100000ull,0ull,
0ull,0ull,0ull,0x808080000ull,0ull,0ull,0ull,0x4020100000ull,
0ull,0ull,0ull,0x80808080000ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x8080808080000ull,0ull,0ull,0ull,0ull
},{
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0xe00ull,0xc00ull,0x800ull,0ull,0ull,0ull,0x2000ull,0x6000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x80000ull,0ull,0x100000ull,0ull,0x200000ull,0ull,
0ull,0x4080000ull,0ull,0ull,0x10100000ull,0ull,0ull,0x40200000ull,
0x204080000ull,0ull,0ull,0ull,0x1010100000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0x101010100000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0x10101010100000ull,0ull,0ull,0ull
},{
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x1e00ull,0x1c00ull,0x1800ull,0x1000ull,0ull,0ull,0ull,0x4000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x100000ull,0ull,0x200000ull,0ull,0x400000ull,
0ull,0ull,0x8100000ull,0ull,0ull,0x20200000ull,0ull,0ull,
0ull,0x408100000ull,0ull,0ull,0ull,0x2020200000ull,0ull,0ull,
0x20408100000ull,0ull,0ull,0ull,0ull,0x202020200000ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0x20202020200000ull,0ull,0ull
},{
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x3e00ull,0x3c00ull,0x3800ull,0x3000ull,0x2000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0x200000ull,0ull,0x400000ull,0ull,
0ull,0ull,0ull,0x10200000ull,0ull,0ull,0x40400000ull,0ull,
0ull,0ull,0x810200000ull,0ull,0ull,0ull,0x4040400000ull,0ull,
0ull,0x40810200000ull,0ull,0ull,0ull,0ull,0x404040400000ull,0ull,
0x2040810200000ull,0ull,0ull,0ull,0ull,0ull,0x40404040400000ull,0ull
},{
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x7e00ull,0x7c00ull,0x7800ull,0x7000ull,0x6000ull,0x4000ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0x400000ull,0ull,0x800000ull,
0ull,0ull,0ull,0ull,0x20400000ull,0ull,0ull,0x80800000ull,
0ull,0ull,0ull,0x1020400000ull,0ull,0ull,0ull,0x8080800000ull,
0ull,0ull,0x81020400000ull,0ull,0ull,0ull,0ull,0x808080800000ull,
0ull,0x4081020400000ull,0ull,0ull,0ull,0ull,0ull,0x80808080800000ull
},{
0x100ull,0ull,0x200ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x20000ull,0x60000ull,0xe0000ull,0x1e0000ull,0x3e0000ull,0x7e0000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x1000000ull,0ull,0x2000000ull,0ull,0ull,0ull,0ull,0ull,
0x101000000ull,0ull,0ull,0x402000000ull,0ull,0ull,0ull,0ull,
0x10101000000ull,0ull,0ull,0ull,0x80402000000ull,0ull,0ull,0ull,
0x1010101000000ull,0ull,0ull,0ull,0ull,0x10080402000000ull,0ull,0ull
},{
0ull,0x200ull,0ull,0x400ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x40000ull,0xc0000ull,0x1c0000ull,0x3c0000ull,0x7c0000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0x2000000ull,0ull,0x4000000ull,0ull,0ull,0ull,0ull,
0ull,0x202000000ull,0ull,0ull,0x804000000ull,0ull,0ull,0ull,
0ull,0x20202000000ull,0ull,0ull,0ull,0x100804000000ull,0ull,0ull,
0ull,0x2020202000000ull,0ull,0ull,0ull,0ull,0x20100804000000ull,0ull
},{
0x200ull,0ull,0x400ull,0ull,0x800ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x20000ull,0ull,0ull,0ull,0x80000ull,0x180000ull,0x380000ull,0x780000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x2000000ull,0ull,0x4000000ull,0ull,0x8000000ull,0ull,0ull,0ull,
0ull,0ull,0x404000000ull,0ull,0ull,0x1008000000ull,0ull,0ull,
0ull,0ull,0x40404000000ull,0ull,0ull,0ull,0x201008000000ull,0ull,
0ull,0ull,0x4040404000000ull,0ull,0ull,0ull,0ull,0x40201008000000ull
},{
0ull,0x400ull,0ull,0x800ull,0ull,0x1000ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x60000ull,0x40000ull,0ull,0ull,0ull,0x100000ull,0x300000ull,0x700000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0x4000000ull,0ull,0x8000000ull,0ull,0x10000000ull,0ull,0ull,
0x204000000ull,0ull,0ull,0x808000000ull,0ull,0ull,0x2010000000ull,0ull,
0ull,0ull,0ull,0x80808000000ull,0ull,0ull,0ull,0x402010000000ull,
0ull,0ull,0ull,0x8080808000000ull,0ull,0ull,0ull,0ull
},{
0ull,0ull,0x800ull,0ull,0x1000ull,0ull,0x2000ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0xe0000ull,0xc0000ull,0x80000ull,0ull,0ull,0ull,0x200000ull,0x600000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x8000000ull,0ull,0x10000000ull,0ull,0x20000000ull,0ull,
0ull,0x408000000ull,0ull,0ull,0x1010000000ull,0ull,0ull,0x4020000000ull,
0x20408000000ull,0ull,0ull,0ull,0x101010000000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0x10101010000000ull,0ull,0ull,0ull
},{
0ull,0ull,0ull,0x1000ull,0ull,0x2000ull,0ull,0x4000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x1e0000ull,0x1c0000ull,0x180000ull,0x100000ull,0ull,0ull,0ull,0x400000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x10000000ull,0ull,0x20000000ull,0ull,0x40000000ull,
0ull,0ull,0x810000000ull,0ull,0ull,0x2020000000ull,0ull,0ull,
0ull,0x40810000000ull,0ull,0ull,0ull,0x202020000000ull,0ull,0ull,
0x2040810000000ull,0ull,0ull,0ull,0ull,0x20202020000000ull,0ull,0ull
},{
0ull,0ull,0ull,0ull,0x2000ull,0ull,0x4000ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x3e0000ull,0x3c0000ull,0x380000ull,0x300000ull,0x200000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0x20000000ull,0ull,0x40000000ull,0ull,
0ull,0ull,0ull,0x1020000000ull,0ull,0ull,0x4040000000ull,0ull,
0ull,0ull,0x81020000000ull,0ull,0ull,0ull,0x404040000000ull,0ull,
0ull,0x4081020000000ull,0ull,0ull,0ull,0ull,0x40404040000000ull,0ull
},{
0ull,0ull,0ull,0ull,0ull,0x4000ull,0ull,0x8000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x7e0000ull,0x7c0000ull,0x780000ull,0x700000ull,0x600000ull,0x400000ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0x40000000ull,0ull,0x80000000ull,
0ull,0ull,0ull,0ull,0x2040000000ull,0ull,0ull,0x8080000000ull,
0ull,0ull,0ull,0x102040000000ull,0ull,0ull,0ull,0x808080000000ull,
0ull,0ull,0x8102040000000ull,0ull,0ull,0ull,0ull,0x80808080000000ull
},{
0x10100ull,0ull,0ull,0x20400ull,0ull,0ull,0ull,0ull,
0x10000ull,0ull,0x20000ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x2000000ull,0x6000000ull,0xe000000ull,0x1e000000ull,0x3e000000ull,0x7e000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x100000000ull,0ull,0x200000000ull,0ull,0ull,0ull,0ull,0ull,
0x10100000000ull,0ull,0ull,0x40200000000ull,0ull,0ull,0ull,0ull,
0x1010100000000ull,0ull,0ull,0ull,0x8040200000000ull,0ull,0ull,0ull
},{
0ull,0x20200ull,0ull,0ull,0x40800ull,0ull,0ull,0ull,
0ull,0x20000ull,0ull,0x40000ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x4000000ull,0xc000000ull,0x1c000000ull,0x3c000000ull,0x7c000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0x200000000ull,0ull,0x400000000ull,0ull,0ull,0ull,0ull,
0ull,0x20200000000ull,0ull,0ull,0x80400000000ull,0ull,0ull,0ull,
0ull,0x2020200000000ull,0ull,0ull,0ull,0x10080400000000ull,0ull,0ull
},{
0ull,0ull,0x40400ull,0ull,0ull,0x81000ull,0ull,0ull,
0x20000ull,0ull,0x40000ull,0ull,0x80000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x2000000ull,0ull,0ull,0ull,0x8000000ull,0x18000000ull,0x38000000ull,0x78000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x200000000ull,0ull,0x400000000ull,0ull,0x800000000ull,0ull,0ull,0ull,
0ull,0ull,0x40400000000ull,0ull,0ull,0x100800000000ull,0ull,0ull,
0ull,0ull,0x4040400000000ull,0ull,0ull,0ull,0x20100800000000ull,0ull
},{
0x40200ull,0ull,0ull,0x80800ull,0ull,0ull,0x102000ull,0ull,
0ull,0x40000ull,0ull,0x80000ull,0ull,0x100000ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x6000000ull,0x4000000ull,0ull,0ull,0ull,0x10000000ull,0x30000000ull,0x70000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0x400000000ull,0ull,0x800000000ull,0ull,0x1000000000ull,0ull,0ull,
0x20400000000ull,0ull,0ull,0x80800000000ull,0ull,0ull,0x201000000000ull,0ull,
0ull,0ull,0ull,0x8080800000000ull,0ull,0ull,0ull,0x40201000000000ull
},{
0ull,0x80400ull,0ull,0ull,0x101000ull,0ull,0ull,0x204000ull,
0ull,0ull,0x80000ull,0ull,0x100000ull,0ull,0x200000ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0xe000000ull,0xc000000ull,0x8000000ull,0ull,0ull,0ull,0x20000000ull,0x60000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x800000000ull,0ull,0x1000000000ull,0ull,0x2000000000ull,0ull,
0ull,0x40800000000ull,0ull,0ull,0x101000000000ull,0ull,0ull,0x402000000000ull,
0x2040800000000ull,0ull,0ull,0ull,0x10101000000000ull,0ull,0ull,0ull
},{
0ull,0ull,0x100800ull,0ull,0ull,0x202000ull,0ull,0ull,
0ull,0ull,0ull,0x100000ull,0ull,0x200000ull,0ull,0x400000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x1e000000ull,0x1c000000ull,0x18000000ull,0x10000000ull,0ull,0ull,0ull,0x40000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x1000000000ull,0ull,0x2000000000ull,0ull,0x4000000000ull,
0ull,0ull,0x81000000000ull,0ull,0ull,0x202000000000ull,0ull,0ull,
0ull,0x4081000000000ull,0ull,0ull,0ull,0x20202000000000ull,0ull,0ull
},{
0ull,0ull,0ull,0x201000ull,0ull,0ull,0x404000ull,0ull,
0ull,0ull,0ull,0ull,0x200000ull,0ull,0x400000ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x3e000000ull,0x3c000000ull,0x38000000ull,0x30000000ull,0x20000000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0x2000000000ull,0ull,0x4000000000ull,0ull,
0ull,0ull,0ull,0x102000000000ull,0ull,0ull,0x404000000000ull,0ull,
0ull,0ull,0x8102000000000ull,0ull,0ull,0ull,0x40404000000000ull,0ull
},{
0ull,0ull,0ull,0ull,0x402000ull,0ull,0ull,0x808000ull,
0ull,0ull,0ull,0ull,0ull,0x400000ull,0ull,0x800000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x7e000000ull,0x7c000000ull,0x78000000ull,0x70000000ull,0x60000000ull,0x40000000ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0x4000000000ull,0ull,0x8000000000ull,
0ull,0ull,0ull,0ull,0x204000000000ull,0ull,0ull,0x808000000000ull,
0ull,0ull,0ull,0x10204000000000ull,0ull,0ull,0ull,0x80808000000000ull
},{
0x1010100ull,0ull,0ull,0ull,0x2040800ull,0ull,0ull,0ull,
0x1010000ull,0ull,0ull,0x2040000ull,0ull,0ull,0ull,0ull,
0x1000000ull,0ull,0x2000000ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x200000000ull,0x600000000ull,0xe00000000ull,0x1e00000000ull,0x3e00000000ull,0x7e00000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x10000000000ull,0ull,0x20000000000ull,0ull,0ull,0ull,0ull,0ull,
0x1010000000000ull,0ull,0ull,0x4020000000000ull,0ull,0ull,0ull,0ull
},{
0ull,0x2020200ull,0ull,0ull,0ull,0x4081000ull,0ull,0ull,
0ull,0x2020000ull,0ull,0ull,0x4080000ull,0ull,0ull,0ull,
0ull,0x2000000ull,0ull,0x4000000ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x400000000ull,0xc00000000ull,0x1c00000000ull,0x3c00000000ull,0x7c00000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0x20000000000ull,0ull,0x40000000000ull,0ull,0ull,0ull,0ull,
0ull,0x2020000000000ull,0ull,0ull,0x8040000000000ull,0ull,0ull,0ull
},{
0ull,0ull,0x4040400ull,0ull,0ull,0ull,0x8102000ull,0ull,
0ull,0ull,0x4040000ull,0ull,0ull,0x8100000ull,0ull,0ull,
0x2000000ull,0ull,0x4000000ull,0ull,0x8000000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x200000000ull,0ull,0ull,0ull,0x800000000ull,0x1800000000ull,0x3800000000ull,0x7800000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x20000000000ull,0ull,0x40000000000ull,0ull,0x80000000000ull,0ull,0ull,0ull,
0ull,0ull,0x4040000000000ull,0ull,0ull,0x10080000000000ull,0ull,0ull
},{
0ull,0ull,0ull,0x8080800ull,0ull,0ull,0ull,0x10204000ull,
0x4020000ull,0ull,0ull,0x8080000ull,0ull,0ull,0x10200000ull,0ull,
0ull,0x4000000ull,0ull,0x8000000ull,0ull,0x10000000ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x600000000ull,0x400000000ull,0ull,0ull,0ull,0x1000000000ull,0x3000000000ull,0x7000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0x40000000000ull,0ull,0x80000000000ull,0ull,0x100000000000ull,0ull,0ull,
0x2040000000000ull,0ull,0ull,0x8080000000000ull,0ull,0ull,0x20100000000000ull,0ull
},{
0x8040200ull,0ull,0ull,0ull,0x10101000ull,0ull,0ull,0ull,
0ull,0x8040000ull,0ull,0ull,0x10100000ull,0ull,0ull,0x20400000ull,
0ull,0ull,0x8000000ull,0ull,0x10000000ull,0ull,0x20000000ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0xe00000000ull,0xc00000000ull,0x800000000ull,0ull,0ull,0ull,0x2000000000ull,0x6000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x80000000000ull,0ull,0x100000000000ull,0ull,0x200000000000ull,0ull,
0ull,0x4080000000000ull,0ull,0ull,0x10100000000000ull,0ull,0ull,0x40200000000000ull
},{
0ull,0x10080400ull,0ull,0ull,0ull,0x20202000ull,0ull,0ull,
0ull,0ull,0x10080000ull,0ull,0ull,0x20200000ull,0ull,0ull,
0ull,0ull,0ull,0x10000000ull,0ull,0x20000000ull,0ull,0x40000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x1e00000000ull,0x1c00000000ull,0x1800000000ull,0x1000000000ull,0ull,0ull,0ull,0x4000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x100000000000ull,0ull,0x200000000000ull,0ull,0x400000000000ull,
0ull,0ull,0x8100000000000ull,0ull,0ull,0x20200000000000ull,0ull,0ull
},{
0ull,0ull,0x20100800ull,0ull,0ull,0ull,0x40404000ull,0ull,
0ull,0ull,0ull,0x20100000ull,0ull,0ull,0x40400000ull,0ull,
0ull,0ull,0ull,0ull,0x20000000ull,0ull,0x40000000ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x3e00000000ull,0x3c00000000ull,0x3800000000ull,0x3000000000ull,0x2000000000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0x200000000000ull,0ull,0x400000000000ull,0ull,
0ull,0ull,0ull,0x10200000000000ull,0ull,0ull,0x40400000000000ull,0ull
},{
0ull,0ull,0ull,0x40201000ull,0ull,0ull,0ull,0x80808000ull,
0ull,0ull,0ull,0ull,0x40200000ull,0ull,0ull,0x80800000ull,
0ull,0ull,0ull,0ull,0ull,0x40000000ull,0ull,0x80000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x7e00000000ull,0x7c00000000ull,0x7800000000ull,0x7000000000ull,0x6000000000ull,0x4000000000ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0x400000000000ull,0ull,0x800000000000ull,
0ull,0ull,0ull,0ull,0x20400000000000ull,0ull,0ull,0x80800000000000ull
},{
0x101010100ull,0ull,0ull,0ull,0ull,0x204081000ull,0ull,0ull,
0x101010000ull,0ull,0ull,0ull,0x204080000ull,0ull,0ull,0ull,
0x101000000ull,0ull,0ull,0x204000000ull,0ull,0ull,0ull,0ull,
0x100000000ull,0ull,0x200000000ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x20000000000ull,0x60000000000ull,0xe0000000000ull,0x1e0000000000ull,0x3e0000000000ull,0x7e0000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x1000000000000ull,0ull,0x2000000000000ull,0ull,0ull,0ull,0ull,0ull
},{
0ull,0x202020200ull,0ull,0ull,0ull,0ull,0x408102000ull,0ull,
0ull,0x202020000ull,0ull,0ull,0ull,0x408100000ull,0ull,0ull,
0ull,0x202000000ull,0ull,0ull,0x408000000ull,0ull,0ull,0ull,
0ull,0x200000000ull,0ull,0x400000000ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x40000000000ull,0xc0000000000ull,0x1c0000000000ull,0x3c0000000000ull,0x7c0000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0x2000000000000ull,0ull,0x4000000000000ull,0ull,0ull,0ull,0ull
},{
0ull,0ull,0x404040400ull,0ull,0ull,0ull,0ull,0x810204000ull,
0ull,0ull,0x404040000ull,0ull,0ull,0ull,0x810200000ull,0ull,
0ull,0ull,0x404000000ull,0ull,0ull,0x810000000ull,0ull,0ull,
0x200000000ull,0ull,0x400000000ull,0ull,0x800000000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x20000000000ull,0ull,0ull,0ull,0x80000000000ull,0x180000000000ull,0x380000000000ull,0x780000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x2000000000000ull,0ull,0x4000000000000ull,0ull,0x8000000000000ull,0ull,0ull,0ull
},{
0ull,0ull,0ull,0x808080800ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x808080000ull,0ull,0ull,0ull,0x1020400000ull,
0x402000000ull,0ull,0ull,0x808000000ull,0ull,0ull,0x1020000000ull,0ull,
0ull,0x400000000ull,0ull,0x800000000ull,0ull,0x1000000000ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x60000000000ull,0x40000000000ull,0ull,0ull,0ull,0x100000000000ull,0x300000000000ull,0x700000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0x4000000000000ull,0ull,0x8000000000000ull,0ull,0x10000000000000ull,0ull,0ull
},{
0ull,0ull,0ull,0ull,0x1010101000ull,0ull,0ull,0ull,
0x804020000ull,0ull,0ull,0ull,0x1010100000ull,0ull,0ull,0ull,
0ull,0x804000000ull,0ull,0ull,0x1010000000ull,0ull,0ull,0x2040000000ull,
0ull,0ull,0x800000000ull,0ull,0x1000000000ull,0ull,0x2000000000ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0xe0000000000ull,0xc0000000000ull,0x80000000000ull,0ull,0ull,0ull,0x200000000000ull,0x600000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x8000000000000ull,0ull,0x10000000000000ull,0ull,0x20000000000000ull,0ull
},{
0x1008040200ull,0ull,0ull,0ull,0ull,0x2020202000ull,0ull,0ull,
0ull,0x1008040000ull,0ull,0ull,0ull,0x2020200000ull,0ull,0ull,
0ull,0ull,0x1008000000ull,0ull,0ull,0x2020000000ull,0ull,0ull,
0ull,0ull,0ull,0x1000000000ull,0ull,0x2000000000ull,0ull,0x4000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x1e0000000000ull,0x1c0000000000ull,0x180000000000ull,0x100000000000ull,0ull,0ull,0ull,0x400000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x10000000000000ull,0ull,0x20000000000000ull,0ull,0x40000000000000ull
},{
0ull,0x2010080400ull,0ull,0ull,0ull,0ull,0x4040404000ull,0ull,
0ull,0ull,0x2010080000ull,0ull,0ull,0ull,0x4040400000ull,0ull,
0ull,0ull,0ull,0x2010000000ull,0ull,0ull,0x4040000000ull,0ull,
0ull,0ull,0ull,0ull,0x2000000000ull,0ull,0x4000000000ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x3e0000000000ull,0x3c0000000000ull,0x380000000000ull,0x300000000000ull,0x200000000000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0x20000000000000ull,0ull,0x40000000000000ull,0ull
},{
0ull,0ull,0x4020100800ull,0ull,0ull,0ull,0ull,0x8080808000ull,
0ull,0ull,0ull,0x4020100000ull,0ull,0ull,0ull,0x8080800000ull,
0ull,0ull,0ull,0ull,0x4020000000ull,0ull,0ull,0x8080000000ull,
0ull,0ull,0ull,0ull,0ull,0x4000000000ull,0ull,0x8000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x7e0000000000ull,0x7c0000000000ull,0x780000000000ull,0x700000000000ull,0x600000000000ull,0x400000000000ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0x40000000000000ull,0ull,0x80000000000000ull
},{
0x10101010100ull,0ull,0ull,0ull,0ull,0ull,0x20408102000ull,0ull,
0x10101010000ull,0ull,0ull,0ull,0ull,0x20408100000ull,0ull,0ull,
0x10101000000ull,0ull,0ull,0ull,0x20408000000ull,0ull,0ull,0ull,
0x10100000000ull,0ull,0ull,0x20400000000ull,0ull,0ull,0ull,0ull,
0x10000000000ull,0ull,0x20000000000ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x2000000000000ull,0x6000000000000ull,0xe000000000000ull,0x1e000000000000ull,0x3e000000000000ull,0x7e000000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull
},{
0ull,0x20202020200ull,0ull,0ull,0ull,0ull,0ull,0x40810204000ull,
0ull,0x20202020000ull,0ull,0ull,0ull,0ull,0x40810200000ull,0ull,
0ull,0x20202000000ull,0ull,0ull,0ull,0x40810000000ull,0ull,0ull,
0ull,0x20200000000ull,0ull,0ull,0x40800000000ull,0ull,0ull,0ull,
0ull,0x20000000000ull,0ull,0x40000000000ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x4000000000000ull,0xc000000000000ull,0x1c000000000000ull,0x3c000000000000ull,0x7c000000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull
},{
0ull,0ull,0x40404040400ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x40404040000ull,0ull,0ull,0ull,0ull,0x81020400000ull,
0ull,0ull,0x40404000000ull,0ull,0ull,0ull,0x81020000000ull,0ull,
0ull,0ull,0x40400000000ull,0ull,0ull,0x81000000000ull,0ull,0ull,
0x20000000000ull,0ull,0x40000000000ull,0ull,0x80000000000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x2000000000000ull,0ull,0ull,0ull,0x8000000000000ull,0x18000000000000ull,0x38000000000000ull,0x78000000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull
},{
0ull,0ull,0ull,0x80808080800ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x80808080000ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x80808000000ull,0ull,0ull,0ull,0x102040000000ull,
0x40200000000ull,0ull,0ull,0x80800000000ull,0ull,0ull,0x102000000000ull,0ull,
0ull,0x40000000000ull,0ull,0x80000000000ull,0ull,0x100000000000ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x6000000000000ull,0x4000000000000ull,0ull,0ull,0ull,0x10000000000000ull,0x30000000000000ull,0x70000000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull
},{
0ull,0ull,0ull,0ull,0x101010101000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0x101010100000ull,0ull,0ull,0ull,
0x80402000000ull,0ull,0ull,0ull,0x101010000000ull,0ull,0ull,0ull,
0ull,0x80400000000ull,0ull,0ull,0x101000000000ull,0ull,0ull,0x204000000000ull,
0ull,0ull,0x80000000000ull,0ull,0x100000000000ull,0ull,0x200000000000ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0xe000000000000ull,0xc000000000000ull,0x8000000000000ull,0ull,0ull,0ull,0x20000000000000ull,0x60000000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull
},{
0ull,0ull,0ull,0ull,0ull,0x202020202000ull,0ull,0ull,
0x100804020000ull,0ull,0ull,0ull,0ull,0x202020200000ull,0ull,0ull,
0ull,0x100804000000ull,0ull,0ull,0ull,0x202020000000ull,0ull,0ull,
0ull,0ull,0x100800000000ull,0ull,0ull,0x202000000000ull,0ull,0ull,
0ull,0ull,0ull,0x100000000000ull,0ull,0x200000000000ull,0ull,0x400000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x1e000000000000ull,0x1c000000000000ull,0x18000000000000ull,0x10000000000000ull,0ull,0ull,0ull,0x40000000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull
},{
0x201008040200ull,0ull,0ull,0ull,0ull,0ull,0x404040404000ull,0ull,
0ull,0x201008040000ull,0ull,0ull,0ull,0ull,0x404040400000ull,0ull,
0ull,0ull,0x201008000000ull,0ull,0ull,0ull,0x404040000000ull,0ull,
0ull,0ull,0ull,0x201000000000ull,0ull,0ull,0x404000000000ull,0ull,
0ull,0ull,0ull,0ull,0x200000000000ull,0ull,0x400000000000ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x3e000000000000ull,0x3c000000000000ull,0x38000000000000ull,0x30000000000000ull,0x20000000000000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull
},{
0ull,0x402010080400ull,0ull,0ull,0ull,0ull,0ull,0x808080808000ull,
0ull,0ull,0x402010080000ull,0ull,0ull,0ull,0ull,0x808080800000ull,
0ull,0ull,0ull,0x402010000000ull,0ull,0ull,0ull,0x808080000000ull,
0ull,0ull,0ull,0ull,0x402000000000ull,0ull,0ull,0x808000000000ull,
0ull,0ull,0ull,0ull,0ull,0x400000000000ull,0ull,0x800000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x7e000000000000ull,0x7c000000000000ull,0x78000000000000ull,0x70000000000000ull,0x60000000000000ull,0x40000000000000ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull
},{
0x1010101010100ull,0ull,0ull,0ull,0ull,0ull,0ull,0x2040810204000ull,
0x1010101010000ull,0ull,0ull,0ull,0ull,0ull,0x2040810200000ull,0ull,
0x1010101000000ull,0ull,0ull,0ull,0ull,0x2040810000000ull,0ull,0ull,
0x1010100000000ull,0ull,0ull,0ull,0x2040800000000ull,0ull,0ull,0ull,
0x1010000000000ull,0ull,0ull,0x2040000000000ull,0ull,0ull,0ull,0ull,
0x1000000000000ull,0ull,0x2000000000000ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x200000000000000ull,0x600000000000000ull,0xe00000000000000ull,0x1e00000000000000ull,0x3e00000000000000ull,0x7e00000000000000ull
},{
0ull,0x2020202020200ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0x2020202020000ull,0ull,0ull,0ull,0ull,0ull,0x4081020400000ull,
0ull,0x2020202000000ull,0ull,0ull,0ull,0ull,0x4081020000000ull,0ull,
0ull,0x2020200000000ull,0ull,0ull,0ull,0x4081000000000ull,0ull,0ull,
0ull,0x2020000000000ull,0ull,0ull,0x4080000000000ull,0ull,0ull,0ull,
0ull,0x2000000000000ull,0ull,0x4000000000000ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x400000000000000ull,0xc00000000000000ull,0x1c00000000000000ull,0x3c00000000000000ull,0x7c00000000000000ull
},{
0ull,0ull,0x4040404040400ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x4040404040000ull,0ull,0ull,0ull,0ull,0ull,
0ull,0ull,0x4040404000000ull,0ull,0ull,0ull,0ull,0x8102040000000ull,
0ull,0ull,0x4040400000000ull,0ull,0ull,0ull,0x8102000000000ull,0ull,
0ull,0ull,0x4040000000000ull,0ull,0ull,0x8100000000000ull,0ull,0ull,
0x2000000000000ull,0ull,0x4000000000000ull,0ull,0x8000000000000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x200000000000000ull,0ull,0ull,0ull,0x800000000000000ull,0x1800000000000000ull,0x3800000000000000ull,0x7800000000000000ull
},{
0ull,0ull,0ull,0x8080808080800ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x8080808080000ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x8080808000000ull,0ull,0ull,0ull,0ull,
0ull,0ull,0ull,0x8080800000000ull,0ull,0ull,0ull,0x10204000000000ull,
0x4020000000000ull,0ull,0ull,0x8080000000000ull,0ull,0ull,0x10200000000000ull,0ull,
0ull,0x4000000000000ull,0ull,0x8000000000000ull,0ull,0x10000000000000ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x600000000000000ull,0x400000000000000ull,0ull,0ull,0ull,0x1000000000000000ull,0x3000000000000000ull,0x7000000000000000ull
},{
0ull,0ull,0ull,0ull,0x10101010101000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0x10101010100000ull,0ull,0ull,0ull,
0ull,0ull,0ull,0ull,0x10101010000000ull,0ull,0ull,0ull,
0x8040200000000ull,0ull,0ull,0ull,0x10101000000000ull,0ull,0ull,0ull,
0ull,0x8040000000000ull,0ull,0ull,0x10100000000000ull,0ull,0ull,0x20400000000000ull,
0ull,0ull,0x8000000000000ull,0ull,0x10000000000000ull,0ull,0x20000000000000ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0xe00000000000000ull,0xc00000000000000ull,0x800000000000000ull,0ull,0ull,0ull,0x2000000000000000ull,0x6000000000000000ull
},{
0ull,0ull,0ull,0ull,0ull,0x20202020202000ull,0ull,0ull,
0ull,0ull,0ull,0ull,0ull,0x20202020200000ull,0ull,0ull,
0x10080402000000ull,0ull,0ull,0ull,0ull,0x20202020000000ull,0ull,0ull,
0ull,0x10080400000000ull,0ull,0ull,0ull,0x20202000000000ull,0ull,0ull,
0ull,0ull,0x10080000000000ull,0ull,0ull,0x20200000000000ull,0ull,0ull,
0ull,0ull,0ull,0x10000000000000ull,0ull,0x20000000000000ull,0ull,0x40000000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x1e00000000000000ull,0x1c00000000000000ull,0x1800000000000000ull,0x1000000000000000ull,0ull,0ull,0ull,0x4000000000000000ull
},{
0ull,0ull,0ull,0ull,0ull,0ull,0x40404040404000ull,0ull,
0x20100804020000ull,0ull,0ull,0ull,0ull,0ull,0x40404040400000ull,0ull,
0ull,0x20100804000000ull,0ull,0ull,0ull,0ull,0x40404040000000ull,0ull,
0ull,0ull,0x20100800000000ull,0ull,0ull,0ull,0x40404000000000ull,0ull,
0ull,0ull,0ull,0x20100000000000ull,0ull,0ull,0x40400000000000ull,0ull,
0ull,0ull,0ull,0ull,0x20000000000000ull,0ull,0x40000000000000ull,0ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x3e00000000000000ull,0x3c00000000000000ull,0x3800000000000000ull,0x3000000000000000ull,0x2000000000000000ull,0ull,0ull,0ull
},{
0x40201008040200ull,0ull,0ull,0ull,0ull,0ull,0ull,0x80808080808000ull,
0ull,0x40201008040000ull,0ull,0ull,0ull,0ull,0ull,0x80808080800000ull,
0ull,0ull,0x40201008000000ull,0ull,0ull,0ull,0ull,0x80808080000000ull,
0ull,0ull,0ull,0x40201000000000ull,0ull,0ull,0ull,0x80808000000000ull,
0ull,0ull,0ull,0ull,0x40200000000000ull,0ull,0ull,0x80800000000000ull,
0ull,0ull,0ull,0ull,0ull,0x40000000000000ull,0ull,0x80000000000000ull,
0ull,0ull,0ull,0ull,0ull,0ull,0ull,0ull,
0x7e00000000000000ull,0x7c00000000000000ull,0x7800000000000000ull,0x7000000000000000ull,0x6000000000000000ull,0x4000000000000000ull,0ull,0ull
}};

//***************************

uint64 randoms[2][7][64] = {
  {
    { 0x0040201008040200ull, 0x0000402010080400ull, 0x0000004020100A00ull,
      0x0000000040221400ull, 0x0000000002442800ull, 0x0000000204085000ull,
      0x0000020408102000ull, 0x0002040810204000ull, 0x0020100804020000ull,
      0x0040201008040000ull, 0x00004020100A0000ull, 0x0000004022140000ull,
      0x0000000244280000ull, 0x0000020408500000ull, 0x0002040810200000ull,
      0x0004081020400000ull, 0x0010080402000200ull, 0x0020100804000400ull,
      0x004020100A000A00ull, 0x0000402214001400ull, 0x0000024428002800ull,
      0x0002040850005000ull, 0x0004081020002000ull, 0x0008102040004000ull,
      0x0008040200020400ull, 0x0010080400040800ull, 0x0020100A000A1000ull,
      0x0040221400142200ull, 0x0002442800284400ull, 0x0004085000500800ull,
      0x0008102000201000ull, 0x0010204000402000ull, 0x0004020002040800ull,
      0x0008040004081000ull, 0x00100A000A102000ull, 0x0022140014224000ull,
      0x0044280028440200ull, 0x0008500050080400ull, 0x0010200020100800ull,
      0x0020400040201000ull, 0x0002000204081000ull, 0x0004000408102000ull,
      0x000A000A10204000ull, 0x0014001422400000ull, 0x0028002844020000ull,
      0x0050005008040200ull, 0x0020002010080400ull, 0x0040004020100800ull,
      0x0000020408102000ull, 0x0000040810204000ull, 0x00000A1020400000ull,
      0x0000142240000000ull, 0x0000284402000000ull, 0x0000500804020000ull,
      0x0000201008040200ull, 0x0000402010080400ull, 0x0002040810204000ull,
      0x0004081020400000ull, 0x000A102040000000ull, 0x0014224000000000ull,
      0x0028440200000000ull, 0x0050080402000000ull, 0x0020100804020000ull,
      0x0041251008c40200ull },
    { 0x0000404004010200ull, 0x0000840000802000ull, 0x0000404002011000ull,
      0x0000808001041000ull, 0x0000404000820800ull, 0x0001041000202000ull,
      0x0000820800101000ull, 0x0000104400080800ull, 0xd1fc122dd721044cull,
      0xa4159629bd0ce70eull, 0xab5da9e9ae24ad63ull, 0x32e60a2983d1c843ull,
      0x3c3cf99dabf131aaull, 0xd83283085553e1fdull, 0x180370f4abada20full,
      0xa7db417ed5cef0f6ull, 0x8940b08b9b2fc0d4ull, 0x852d84b34edc83d2ull,
      0x068d4a5f2548652full, 0x35ce432f12163d2eull, 0xc9ba66fee4843746ull,
      0xabccc0992b67af9eull, 0x217f1caa6a824b26ull, 0x4a05addc1ea2e944ull,
      0xfe2312497bf4c414ull, 0x8495248ab305ee8full, 0xcb96c4247c24e036ull,
      0xab76533d29e3c6eaull, 0xc0944c15e3c09778ull, 0x1053b4ccf6c024d6ull,
      0x8d96dda010ba133aull, 0x9f59cef04505da02ull, 0x581ae15866c42214ull,
      0x3a61654f9da998bfull, 0x47efd3ec19fb73c0ull, 0x2126b228fdb69cb5ull,
      0xbb2ff9574df0d641ull, 0x32b9d1ed571b84b8ull, 0x4f688c6727828a1full,
      0x576784e75cc9d113ull, 0x15e82e121ffd9115ull, 0xbc0156dbcef2a7deull,
      0x6365ce9628bd842eull, 0x3a898fc4ece11b80ull, 0xa6f7652af004d29full,
      0x5fa9ca7e22d71d72ull, 0x5a06111a2088be1full, 0x05aae96e3384dfe4ull,
      0xe697a8f517ab3d3full, 0x9d3c1d1302e84551ull, 0x6e0b75ab4901a6c9ull,
      0xd35c48fba6cf7eefull, 0xc8ee1ca11e20a35eull, 0x382637115387cc68ull,
      0x8d499580f4544852ull, 0x1e4a273c98576ebdull, 0x0008080808087600ull,
      0x0010101010106E00ull, 0x0020202020205E00ull, 0x0040404040403E00ull,
      0x0080808080807E00ull, 0x00010101017E0100ull, 0x00020202027C0200ull,
      0x00040404047A0400ull },
    { 0x2009a159d9509cb5ull, 0x5fa8c13086419e55ull, 0xea13669343bcd4b9ull,
      0x3e47b851efbef3a4ull, 0x6caa31dec6814cc6ull, 0x992161e6ef2c2919ull,
      0x8bed069c11856a55ull, 0x5c73de210d683e98ull, 0xa7185f2616bd83c1ull,
      0xd7c04ef29cf3751eull, 0x9f46f244eaf78bcfull, 0x38f85c7bcda11a85ull,
      0x22f1e6aabfe845aaull, 0xa8aa67f9237dbb68ull, 0x90e2e582b1c84a64ull,
      0x5c685bafc31b3c9full, 0xc031fe468f6f6967ull, 0x8d75aa382752602aull,
      0x244475599eceffd5ull, 0x0d0cfcd52bb265d4ull, 0xda433164b4750dc1ull,
      0x85dfeab10d5752d6ull, 0x7225a1188a0376ebull, 0xa8be7b123a102607ull,
      0x603b914a4429875eull, 0x399be2aedab54c3bull, 0x58d916991d8a5cc4ull,
      0x35b8f864e4685bdbull, 0x46739c9baf790ac0ull, 0xd1327ef186fb215aull,
      0x140368fd88e26668ull, 0xd38e499b69fa1e25ull, 0xc96f5a7d211f3f9full,
      0x97655506a678b4bcull, 0x7f8ddfb015f07d87ull, 0xbf7bfed396840428ull,
      0xfd2f0668eb41e684ull, 0x24936e7db2759b2dull, 0x267a311ebcd14f08ull,
      0xf5a13e0e1d60b856ull, 0x69f15803d26af16aull, 0x82fac9552fa58953ull,
      0xd71ea59c19c54beaull, 0x62fdb302c66279d4ull, 0xf0c1baa7e1513de5ull,
      0x363454db33ee5ef4ull, 0xab4045843a34f2e0ull, 0x73f10c94a39100fdull,
      0x0a86593ec58517e8ull, 0xae96e568385585deull, 0x608a57252ef6f020ull,
      0x39cac56cc61f3368ull, 0x44a6a43e32a682b4ull, 0xa085261969416c01ull,
      0xbb870177729e6283ull, 0x1276bdc2fc1b7238ull, 0x77bcdc0127c4da80ull,
      0xbf16bb430520dde5ull, 0x153a63a94e385bddull, 0x95104c33771f4a98ull,
      0xb0ff0dfa8ef47265ull, 0xc48762efcfbadae4ull, 0xf70e5b4dae84cfd0ull,
      0x250cabf0859b323bull },
    { 0xf71c3f6b2fd5891cull, 0x5d5675218dd4da7eull, 0xd8e7b9cd991893a1ull,
      0xe4e1af2cf1bcb046ull, 0xa762655491b63283ull, 0xd8dc072d881ba73aull,
      0xdb9cdd7d25570179ull, 0x76618a18da1cfd9aull, 0xe4ed6cee7fb62d0cull,
      0xfebc55cf05ef2fbfull, 0x9a9f5c4a59c51554ull, 0xea91c3d8f98c3ecfull,
      0x2f71c5493a5be25aull, 0x8c4d65413c6bbfe6ull, 0x9f06ed35f9a2eac6ull,
      0x178831e02b8775b2ull, 0x10a3d155d65cd6c1ull, 0x4b7a69b028a0cd53ull,
      0xd7b84fb5e0de02f0ull, 0x9e266498ec93bb5cull, 0xea0e4ad3f773090dull,
      0x4cf4b1acc505eb02ull, 0x11bea6e26eff78fdull, 0x7986363d8e9c8b02ull,
      0xff2ca02deb5af054ull, 0x3ad2351100f322d5ull, 0x24a21f70f0b14613ull,
      0x475dbafc509421a2ull, 0x9e78abd3cd79162cull, 0xe492fd5185f74274ull,
      0xc974fffbb9c5bcbdull, 0x2fdc971bd1756a88ull, 0x7229f20d9ed56e61ull,
      0x724bb3259de1f22full, 0xebdba47c4a9c567aull, 0xf93c634904fe151aull,
      0x051bcfecd0485d42ull, 0x94974a65ffaf78a4ull, 0x1e2e5e3f8b50a25dull,
      0x81b99d563b25e57aull, 0xdae46bb9fceadb75ull, 0xde35e8171244a7b5ull,
      0xf4fc75ad58cca9f2ull, 0x06396ddce8fd9c68ull, 0x9acabf60af793fb6ull,
      0x5329b615e95c5bdfull, 0xd86f5fd82254a62full, 0xf0af6c56a32479b2ull,
      0xca21baeeba56a815ull, 0x0396c3624ca42a50ull, 0xaccae9419d0f493full,
      0x6d148daab4ac1bb7ull, 0xdbd78e8efc177ba2ull, 0xcee72e2a4d16dcc6ull,
      0x4590974f7d6ec962ull, 0xd3b28408305b5764ull, 0x20c201d44df1eb89ull,
      0x0cef72d2cdef5930ull, 0xa9e4ca60ebc9a62aull, 0x8f84dab7d30110cdull,
      0x6803ad1d2c809a22ull, 0x4e3319dcbeefdd75ull, 0xb1c8fe5b88eaedbbull,
      0x3d5ceaecade87f00ull },
    { 0xdb87073201334b8eull, 0x5a37d087e1ae272bull, 0x80b67cc99b9d27a1ull,
      0xd09d5f7db214f4baull, 0x3306a98928d65742ull, 0x65bc1cc4ac254147ull,
      0x92e266c8e0c61bd7ull, 0x3efe1a6dd93a7ea9ull, 0x516008fcc74b5982ull,
      0x7087c00b1219938aull, 0x54ed780d615a4d93ull, 0xf7b393019e97eb56ull,
      0x282b3182cb55067cull, 0xf74719c6e544ea8dull, 0x35629880486810e2ull,
      0xccb4db1f1f298264ull, 0x801d864f04ade5d0ull, 0xe32ae6267b0c6f71ull,
      0xc33dbe2c2656b326ull, 0x8cf005f6aced02b1ull, 0x1f4f622ce80d5b56ull,
      0x5c5166351f09065cull, 0x27ee88da0b3f17f3ull, 0x24342d232e1cc60dull,
      0xe71b0ef73358b399ull, 0x8032078133780469ull, 0xe34b1780fa310f3dull,
      0xcde826ad5c866d50ull, 0x61cbad7ae034ed02ull, 0x7ec80dc7d5443ff8ull,
      0x7552b2e6a70d2fefull, 0xb5c65d387d8a622eull, 0xcb74a3731b1404dfull,
      0x3d17820c84c52320ull, 0x012907839e217ebbull, 0xeb7f86a56d1ae07aull,
      0xf934a28184b8bc95ull, 0xe18c5514a3ffc474ull, 0x81e302d64f1e874aull,
      0x993d2d29543a0051ull, 0x4710980708601e84ull, 0xc7301ea9cc8b59beull,
      0x947c354adc6fc86full, 0xba7443084a3f3d4dull, 0x468112e49b318b2eull,
      0x636e353267f00946ull, 0xae160a34615f3ce7ull, 0xd38ce1fbfa0ae670ull,
      0x183da8dda4081ec1ull, 0xeccb6d0700512aa9ull, 0xafffc8e3770d1024ull,
      0xcc95e0c2786e2d74ull, 0x7a889c70ef7b2d7bull, 0xc1612de64cbd613full,
      0xf102a29abfbadfefull, 0x9aa9300a182763faull, 0x1bc552dcfcfd38a8ull,
      0x0a7b6521e6b8170dull, 0x2ba06c62d6b1efcdull, 0xeea0e6daafd143a8ull,
      0x9d02cbfd6f7cc234ull, 0x8aecebc23d68acb5ull, 0x1d1aa95d783617a7ull,
      0x514e9d5763edb419ull },
    { 0x1e8860e4e8afcffcull, 0x107fb5302e49b653ull, 0x453ca2eb419de2c5ull,
      0xa3094e8eb1649123ull, 0xe850ac9a440dd0afull, 0xe6eb2d90ade835b6ull,
      0x75dfa9af6b2e2517ull, 0x89d272086a4586b0ull, 0x04f2d543b5fdd518ull,
      0xec4c28a9a0d6e1e7ull, 0x17258fcd264c21dbull, 0xf556bc18377a9614ull,
      0x1ed98b8d00ed78d9ull, 0x878cc5541b15235aull, 0xbdaad05ff19daba8ull,
      0x92847c097dfa71e5ull, 0x350e0dd9be966d1full, 0xa6a60d7f6f49639cull,
      0x8e070da95c30c7b1ull, 0x86cfaab004eeb6baull, 0xebaaec50d1c327f4ull,
      0xc2fe1876ab524708ull, 0xc6f6d37551ec8e3dull, 0x64d37e4c261b7ceeull,
      0x5c4238429df044d6ull, 0xffc2dcfba6020f1cull, 0x219884780eb85505ull,
      0x7b344c05cf490f3cull, 0x6357c42cdd1ece03ull, 0xe843f0447fc918ccull,
      0x3f6b9ecca16d6a9cull, 0xcadd7b5fa7f80548ull, 0x99932206ba13d48eull,
      0x2e2c3d8d923d7498ull, 0x313c5a25c7cc37ecull, 0x1ad15364afedeef6ull,
      0xfd191a29a2e31a19ull, 0x260efed6924e37c5ull, 0x59131a8c25dde4d2ull,
      0x7c21c4dec49fcb54ull, 0x7e6ce786fbf85990ull, 0xd9e19bec0755de20ull,
      0xbd6610b15f183afbull, 0x8973e87e3a7c8151ull, 0x08dc85a2ef21e267ull,
      0x8a5d053e38e38217ull, 0x362b10df55d34595ull, 0xec947b5836bd99a6ull,
      0xa86b61318e8e0669ull, 0x77fb8d13554c503bull, 0x7f2e977aecd4b847ull,
      0x1a1209b4297349a0ull, 0x246ef6a2583a91d2ull, 0xe899f0f10718bb1bull,
      0x8caf1fed80b0bf73ull, 0x6692b681b5b0cd56ull, 0x88a59e6e5279a693ull,
      0x2bca6fda2127725bull, 0xde231627953ee461ull, 0xa6a84fe6019b1505ull,
      0x3aa8d5c92821286full, 0x3fc7c4ff83788dc8ull, 0x2f1c86701e11126cull,
      0xbcf523cd44449d04ull },
    { 0xb6bd2e675553abfbull, 0x0e77d5c32d27b9f1ull, 0x514eeb41d9c3d9ffull,
      0x628b101131d29234ull, 0x8ffb7c8ed0e68e19ull, 0x8ae2aad5fb090e47ull,
      0x189f977852a4f512ull, 0x95ca324d8b0efd83ull, 0x738c57e030fdae11ull,
      0x959b0a940dd59306ull, 0x65da2016543c234bull, 0x4b832a3630d9185cull,
      0x0c097ea2fdbf0d2cull, 0xfb4c8e0aa5234704ull, 0x7ac234e158f27179ull,
      0xbac5a1e34be49be8ull, 0x971437a9f55584bbull, 0x0b936a48e3a2ff38ull,
      0xce5064cedf5414ffull, 0xe843d8e0f1a1b404ull, 0x94b3ca3bb9a34c7full,
      0x2ad9eef539a002e0ull, 0x6775351b325f3972ull, 0x73a452a5d7816842ull,
      0x8f820c6a3867e2f5ull, 0x195da076e4eb0c03ull, 0xbf06d1e5880ef7e9ull,
      0x10194dde08d9bfb5ull, 0xc43bf19aac12b322ull, 0xe5574447f21ad4fbull,
      0x0022f70230a30040ull, 0xb92a66f9542cc415ull, 0x8fbcd882499ec90dull,
      0x7d7ee407c482adb5ull, 0xf284329e4afed0eaull, 0xa4a200b66d4b9a8full,
      0x9d579f70abf43ad5ull, 0x6d99c3c17a861697ull, 0xefdfea41ede917ffull,
      0x0dd85b0a545ce9ebull, 0x695f389eb81c31c4ull, 0x3e49b5c0ed676305ull,
      0x4c0792eaab653521ull, 0xae7febb40ef265f8ull, 0x735fd7bae0b300b6ull,
      0x5cd2f906d01617fdull, 0xe425e6a2194f35b8ull, 0x5e454d35558f736full,
      0xd6f7a25040a80510ull, 0x9ff8fd33a560058cull, 0xc7615283555e4d1aull,
      0x46403dffc8013c90ull, 0x4e4a44a1479e3e2eull, 0xc658ada906c5037bull,
      0x54e1529f6a6c0706ull, 0x5a929ed61f0bb3d6ull, 0x657aacb5a4eef250ull,
      0x8d75f946b56d5c44ull, 0x3852aab719722cbaull, 0xa7e416420eb9da68ull,
      0x9b7a5005d064dd92ull, 0xeaf7ce1d22dee993ull, 0x34aced1247e27fb8ull,
      0xf23478d46ca33d46ull }},
   {{ 0x0080001021400080ull, 0x0040101000200040ull, 0x0081081000200080ull,
      0x0080040800120080ull, 0x0080020430080080ull, 0x0080210200040080ull,
      0x0080008001030200ull, 0x0080003040800100ull, 0x1020800020400080ull,
      0x0000400020005000ull, 0x0000801000200080ull, 0x1010800800100080ull,
      0x0000800400080080ull, 0x0000800200040080ull, 0x1110800100020080ull,
      0x0000850040800100ull, 0x0004208000400080ull, 0x0310404000201000ull,
      0x0000898910002000ull, 0x1020808008001000ull, 0x0405808004000800ull,
      0x00a0808002000400ull, 0x1040010100020004ull, 0xff20620000408104ull,
      0x00c0208080004000ull, 0x0010200040005000ull, 0xcc00010008020080ull,
      0x00e0080080100080ull, 0x0020040080080080ull, 0xba00002008040080ull,
      0x0040010080800200ull, 0x0030800080004100ull, 0xab00204000800080ull,
      0x00f0200040401000ull, 0x0040100080802000ull, 0xaa00080080801000ull,
      0x0a00040080800800ull, 0x0050020080800400ull, 0x9900020001010004ull,
      0x0b00800040800100ull, 0x0060204000808000ull, 0x8800200040008080ull,
      0x0c00100020008080ull, 0x0070080010008080ull, 0x7700040008008080ull,
      0x0d00020004008080ull, 0x0080010002008080ull, 0x6600004081020004ull,
      0x0e00204000800080ull, 0x0090200040008080ull, 0x5500100020008080ull,
      0x0f00080010008080ull, 0x0a00040008008080ull, 0x4400020004008080ull,
      0x1000800100020080ull, 0x0b00800041000080ull, 0x33FFFCDDFCED714Aull,
      0xa07FFCDDFCED714Aull, 0x0c3FFFCDFFD88096ull, 0x2200040810002101ull,
      0xc001000204080011ull, 0x0f01000204000801ull, 0x1101000082000401ull,
      0x1201FFFAABFAD1A2ull },
    { 0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
      0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
      0x0000000000000000ull, 0x0000000000000000ull, 0x6b90680243c4b54cull,
      0x044703d57fb1e299ull, 0x8a3c60812c08665aull, 0x32dc7de4cae88a7bull,
      0x6e3060c4bbed7feeull, 0x09a012c21457c46full, 0x713f791a21ad43caull,
      0x5a4d0ec873244cdfull, 0x59a713355c986f8full, 0xa347356dba0fbfadull,
      0x6650c485ba5b1243ull, 0x2d86094817cc64f2ull, 0x20fdc446a93f6201ull,
      0x1db9308f0d27dbdfull, 0x98f63ae9645b1111ull, 0x03415b7672cca0bdull,
      0x910f4a575767cff3ull, 0x5182927aff4f928cull, 0xdde2b660565a30dcull,
      0x3f42ec666558c5b3ull, 0xce05da712568cac7ull, 0xfd9326b46e518555ull,
      0x9334d36563994ecdull, 0x3bd434362a7b358cull, 0x14b4d64afc2171bbull,
      0x8332f03346030a46ull, 0x56300105aba021c0ull, 0x470610c2fb63b7b5ull,
      0x10c12cf0c2f837f5ull, 0x7d8af8d403969661ull, 0xa8cb40dbe096915dull,
      0xfb306c5498354397ull, 0xe25d9ee093992b8bull, 0x1f406a7e77f19817ull,
      0x06592044d4d8c7e7ull, 0x986ca3c584c84454ull, 0xcec495f755c884f0ull,
      0x3d8e0276e94a3fb3ull, 0x6dfc65f711f0e645ull, 0xf04572c328e9c0fdull,
      0x1de908cfe3f5fc3bull, 0xe1e609e5214fc6f0ull, 0x1b97e198798ccc46ull,
      0x52983c479b769f0dull, 0xe1ad316c24a875e2ull, 0x759a9b5ac9742a91ull,
      0x6bb1e5f7b2bb7e47ull, 0xbdd56e8cc40b30baull, 0xdf1987363fabc640ull,
      0xde000000fffaa112ull, 0xd015861ac0001200ull, 0xdc0123675385d000ull,
      0xd814437701001230ull, 0xd83044603aa10000ull, 0xd81475089600ff00ull,
      0xd820300500abcf10ull},
    { 0xe543c7cd3569a2d2ull, 0x56312cb746ff2365ull, 0x03e7298e5b86bf22ull,
      0x516e9a17bf3b9d0eull, 0xb507b363062bfe41ull, 0x7600192a061dd0e5ull,
      0x1d3fdfd7ab7ed9eeull, 0x422f696efd2a98f8ull, 0x4d3652c8c76f687cull,
      0x9f7711eae210b999ull, 0x3fe55a4a3db93342ull, 0xf9867077d2c22292ull,
      0x06938ebd5352aba1ull, 0xcfbdf8fd28e52d4aull, 0x9f5dc89b771ea0baull,
      0x76170ff911d3d955ull, 0x7e7bddf4e7d92fadull, 0x28bb97717bb86c3full,
      0xe14b10911730bfe5ull, 0x65fdc8cfbb000784ull, 0x3413b92f048583c8ull,
      0x449ccb9483380adcull, 0xa4a34f7dd630cec5ull, 0xf23142fcbf290710ull,
      0xab1645e0b73ebeb6ull, 0x9f7ac648b66b58efull, 0x81da786a8e1a3a07ull,
      0xab80b2cb27644d91ull, 0xc57b0159cd1cf77aull, 0x84425693d1e998f6ull,
      0xa086ad9f1b17e973ull, 0x6c29c7100c6ea19bull, 0x3a318a14b98d372bull,
      0xf01ba582f9382406ull, 0xa1cde875f370ae9cull, 0xb9a0ab780158707eull,
      0x8d26ff790475117eull, 0xdd33f98a55e26ad9ull, 0x549c9afccdff9451ull,
      0xfed35e6c20eabe08ull, 0xee602ea3d3b08637ull, 0xfb60f74da1a791f3ull,
      0xb25a86f4ba75b20eull, 0x5402f6bd8285b194ull, 0xb5e9f6533809151full,
      0x074c656721f3bb77ull, 0x5ccdeff9d4bbbf2dull, 0xbe262f406756394dull,
      0x105f0a553888caadull, 0xb364c84f9a7f366dull, 0x13c5a20c72a2e3ceull,
      0xb6121d22131c0104ull, 0xa4cb87927ec6cc17ull, 0x897b31544122583bull,
      0xd9bed4853c502a78ull, 0x211fee372e06645full, 0x87d38f49fd841678ull,
      0x22644edaa636120aull, 0x693c919475426cccull, 0x77b3666bd380005dull,
      0x09972e5b72ba54c1ull, 0xa6d576eb8a9adbefull, 0x151e128a1470cc43ull,
      0xba872ea0ccbcac7cull },
    { 0xfaadf26b0bedcb90ull, 0x577ac5a51e5651c5ull, 0xfaa9928d90ecc574ull,
      0xf4d0746e2cd9c2cbull, 0x297b213cebe4451bull, 0xdcda00e8a1970957ull,
      0xebc24328279cf3c0ull, 0xafbc7b8a2782f71aull, 0x2b8ae9d228a44b14ull,
      0x7b91361891e74156ull, 0x7c744bd7713ebc3cull, 0xf30ff94d8ae2dbbcull,
      0x952d28d81c4cd5e5ull, 0xca1da973d1bb1a14ull, 0x0dc59391a4b26780ull,
      0x73974085e2ebdfedull, 0x6a9d797790afccadull, 0x192a2b602b123aabull,
      0x19c8a787015bc845ull, 0xad40920248a2e551ull, 0xd1c0fbdcb077da5dull,
      0xf0d3a2e4b44b9030ull, 0x4ff44c34da7b4dd0ull, 0x65ca4e0e02964227ull,
      0x1fc804c725e40440ull, 0xde8e75b6789090ffull, 0xda82400db9d07a0aull,
      0x7f850c159d730e8dull, 0x88f3cb3c8b5dbf18ull, 0xaa16f0d4828d0050ull,
      0x46a26a52fc055ad2ull, 0x9924d71d3d7359bfull, 0x73580533d9f2fb99ull,
      0x187096a491259118ull, 0x7777434ec63d90f8ull, 0x8e6e9922b252bdb1ull,
      0xb1af461d516eee12ull, 0x4fcd31f2f421c717ull, 0x65651bc93644c5e1ull,
      0x9bd1e1fa908307daull, 0x5aaee550208ae7f0ull, 0x4ec958544caaa9c3ull,
      0x298e4a3f09caee63ull, 0x29d4a3cab10a9a44ull, 0x9e6a3fde44907510ull,
      0x19cc5ee9aa4fbc78ull, 0xc01a289fe006387full, 0x3ee6737f5f934fb3ull,
      0x65fad64d232fe9eeull, 0x2a487fc2e4f569fbull, 0x67fb5df086391215ull,
      0xc1b5e63af64d55e8ull, 0xd33f764f4052ecb7ull, 0x0899d25e2b391f79ull,
      0xc70158cce44d2e70ull, 0xb53262e2308fa659ull, 0x20f7402ecd84404cull,
      0x15d1b9bb5466ad4cull, 0xfd8d825e26a8a2d1ull, 0x18d96f18f8b826d0ull,
      0xf72067659687ef21ull, 0xf08610bafd66009full, 0x1a4e1ba1fdb05563ull,
      0x1324d44c84bbef0aull },
    { 0xc7613d66f20232d4ull, 0x3ede983f7b06516bull, 0x578460a649b24a39ull,
      0xd5bd4ad2cc618853ull, 0x6da1e9f12833259cull, 0x1f9ca81ea33005a0ull,
      0xae981ca25036ed10ull, 0x5d69e428228cca9aull, 0xa17023dd34f22effull,
      0xd08c493917325f88ull, 0x79e16b54bdca7e02ull, 0x3654be3ac3a26289ull,
      0xac56a76157fd0921ull, 0xc517aa54a54ed12dull, 0x4dd1b68eb1ada829ull,
      0x161037898e176e8dull, 0x98db096afb729bebull, 0x03e9d68eabc9d7feull,
      0xdf27c2fb173845dcull, 0x2aee2474d7bf2d7cull, 0xf5d6d12955e96f2dull,
      0xf734ec0a2d041943ull, 0x72999224bb580060ull, 0xccdcad5bdc7bd1a1ull,
      0xa9bca8004f1d7086ull, 0xc2c7ffb795d4e1e7ull, 0xd28da598cbfbc3caull,
      0x08126a5da13c42d9ull, 0x13e15ad5c2d3d951ull, 0x4d9c20c7eaa8703dull,
      0xab894b4e6ebca682ull, 0x53214a10ad7c784eull, 0x9906d6c9c38b591eull,
      0x476bd91a4ca0c161ull, 0x95265cbe69f01d02ull, 0x01cedc5a39e5b5c9ull,
      0xc0ef0788f08d9463ull, 0x80927db966612b20ull, 0x9630082145dd2f1eull,
      0x600f737ed7910113ull, 0xb9302c026f2a80b2ull, 0xff49c8f0afc01a91ull,
      0x39a0b9dbbc8e5d10ull, 0x4e93e5fbc38cafd7ull, 0x44d0aec75c666288ull,
      0x5ea41ef6508a97efull, 0x6ce58a3a4917dffdull, 0x57b84b8764d3da3dull,
      0xedf320cbe664658cull, 0x3bea7e195d96172aull, 0x72abd9c2b876c142ull,
      0xaf2ce404a46dae6eull, 0x4f050de918e728b2ull, 0xcb458cba72881a48ull,
      0xdadcfcb48f1c02a8ull, 0x1167bf4ccb9f1a34ull, 0x2f791f047047bd5dull,
      0xcd60c5789e26b8b6ull, 0x1a620288f4a12b4bull, 0x1b43a4a5b7f5244dull,
      0x3a93e22c7f6b3c55ull, 0xa5da9b1ba501f044ull, 0xac918f8b4d9d1e00ull,
      0x9fba7867a63c8ac8ull },
    { 0xb5663909d9d6303aull, 0x1122bbd8f31a9801ull, 0xb26dfdc7254c0ac9ull,
      0x80923ffe2bae8db2ull, 0xdf3939952977e95full, 0x89ef22889d7081a6ull,
      0xddeeb25f2e41e526ull, 0x77aa072d06890a48ull, 0x8b1e7a1bc43beb1cull,
      0xeef27b1803a60f3aull, 0x116569c8ba82a83aull, 0x861eddf3fdf4d64full,
      0x12fc5033c7c95105ull, 0xc9997d1a2f05161aull, 0x56dbac3597f7e48bull,
      0x997968b0dadb71b6ull, 0x51c153dd787cf748ull, 0x190b253068b60e60ull,
      0xa98dcc93091ee1daull, 0xe7f1c48a17f0c994ull, 0x294532d1f3b50a20ull,
      0xe393a663d106d4b2ull, 0xc95a8e15d4e4aac2ull, 0x058a1a4819387af4ull,
      0xb7fe4077025d3331ull, 0x17369b1ad4dfb135ull, 0xfd1836fd44897416ull,
      0x734f98ea7a95ea1dull, 0x44dbebde2de33051ull, 0x3e572ff979d8ca38ull,
      0xd53c5a45bb8cdfa1ull, 0x1169ade998830992ull, 0xc6b5b477d2ee43b5ull,
      0x11d58b895af5f73aull, 0xcfe3985db2d35d21ull, 0xc9c6056490e28221ull,
      0xbba44fb18d7bad4cull, 0xd1b94354c3d22c4dull, 0xfb0d0d4c55eedddeull,
      0x3b18e9ef00b4c810ull, 0x73e101f840df8084ull, 0xd64f148443724752ull,
      0xb017cbfb12688bd6ull, 0x89e6a53131fc7242ull, 0x2f6bc2d724af9792ull,
      0x1af46d6374011c6aull, 0xe7d461f15c6129b4ull, 0xbd7b0f8478d446abull,
      0x8cab2463b6c0e01dull, 0xa69dee16a765d2b0ull, 0x144588401f496bf3ull,
      0x3d761d20063ee258ull, 0x48c0b32df8ddc0fbull, 0x1ad8889a5aa8e26cull,
      0x2aadb6180f80c2d3ull, 0xb7c9d582a54c0b2cull, 0xa9448d0f698b8370ull,
      0xd6814d04b2584c63ull, 0x80576b83319d83f9ull, 0x906953398a3df494ull,
      0xe7a11b9d7d769494ull, 0x59714b37b93b5e39ull, 0xa5280a61ef2d0450ull,
      0xcaf1ca6cd004e7bcull },
    { 0x0c92df7ab48210acull, 0x70c766782c6225c0ull, 0x2b627e280a8dd01full,
      0xf8a95606e064f51bull, 0xecb6d461dd6c8568ull, 0xe8e9d8da88a760e7ull,
      0xb253ddc5e1b54ff4ull, 0xb518eacb142499c5ull, 0x5ba23807ace2576bull,
      0xb5d274ebd42fcb9cull, 0x1dfc510cd7016641ull, 0x81b2aa898d7ff740ull,
      0xb3f8b22a412d350full, 0x9010d26bd30013d6ull, 0x31a160801ed3585full,
      0xf18717011ddb123bull, 0x475fb6cd262d3895ull, 0xf86a9bada37fe981ull,
      0x579fe8f10c63060cull, 0x1ea46e3bcbee6f47ull, 0x0dfa846a5626e47aull,
      0xe76ff8e4aab118a0ull, 0xa83a45a05758d1c4ull, 0xff293f1d1de94a79ull,
      0x6d34106328ce50acull, 0x7f3dd6bb2c715f0dull, 0x01a6483cc3fb62c0ull,
      0xa60927ade8ccdca7ull, 0x73c1dc8d32c0180full, 0x02f86bcc14474ff9ull,
      0x3804de0c37c58434ull, 0xfc10f3a3c497c54dull, 0x96a1e55142ddb8dbull,
      0xc92548d8939af17aull, 0xbc5edf6509acaf89ull, 0xac0b9688d3023544ull,
      0x4163dbff847088b3ull, 0x563f3cfce243d3f8ull, 0x8f263f7ce1f7b3ccull,
      0xe7365cbc6a7f8730ull, 0x46c1f063e6b8ca39ull, 0x21cbc42ba4582264ull,
      0x55dff0476966e4b4ull, 0x223e2c38b61edc4eull, 0x3a21ced28a3d6fa8ull,
      0xd5884ee48c058d27ull, 0x884d4eac614c987aull, 0x02327b02f1a6a37full,
      0xec14f49f926b0d1dull, 0xad980ec0c9b3ccdcull, 0xad0f89f58a31f96cull,
      0x1004ad6869a8c64dull, 0x73334f7053ecda9cull, 0xe5c726eb2395f91full,
      0x3eacccee6b0d2cf0ull, 0x54fe44475c2803fbull, 0x4e691ecbfdff4c35ull,
      0x0d4dd3188efdf8f3ull, 0x4ce513f999517686ull, 0x451033ddedb79722ull,
      0x7fafe619290cf26eull, 0xb744be4992d915b4ull, 0x8011bf394690d8d1ull,
      0x9475361b15b45cd5ull },
  },
};
uint64 castle_random[2][2] = {
  { 0x557723689550b69bull, 0xa92c541efa336c6cull },
  { 0xc7bedab779d5361bull, 0x3bb70e80435e60b7ull }

};
uint64 enpassant_random[65] = {
  0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
  0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
  0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
  0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
  0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
  0x0000000000000000ull, 0xf2c1412f44c13c98ull, 0x76b4b7ccb0c9bd1eull,
  0x0303f047ef3166cdull, 0xcf4da3850ff5c35aull, 0x0bb57340632ec140ull,
  0x189156c368616498ull, 0x71b862b8cede277dull, 0x26e0433817e6d7d7ull,
  0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
  0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
  0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
  0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
  0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
  0x0000000000000000ull, 0x1f2af0448165ab3aull, 0x51f0d423276d44dbull,
  0x12d51a6ba742f661ull, 0x8fa3e91c53630e1full, 0x16573a4eb7f48c08ull,
  0xe1c1e4bc9690e409ull, 0x5f2bf4422dde33bbull, 0xcd4cefba64f407a1ull,
  0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
  0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
  0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
  0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
  0x0000000000000000ull, 0x0000000000000000ull, 0x0000000000000000ull,
  0x0000000000000000ull, 0x0000000000000000ull
};


#endif
